/* /work2/ssa/pgplot/src/grbpic.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__11 = 11;
static integer c__15 = 15;
static integer c__22 = 22;
static integer c__19 = 19;

/* *GRBPIC -- begin picture */
/* + */
/*<       SUBROUTINE GRBPIC >*/
/* Subroutine */ int grbpic_()
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[2];
    extern /* Subroutine */ int grexec_();
    static char chr[20];


/* GRPCKG (internal routine). Send a "begin picture" command to the */
/* device driver, and send commands to set deferred attributes (color, */
/* line width, etc.) */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       REAL RBUF(2) >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER NBUF, LCHR >*/
/*<       CHARACTER*20 CHR >*/

/*<       GRPLTD(GRCIDE) = .TRUE. >*/
    grcm00_1.grpltd[grcm00_1.grcide - 1] = TRUE_;
/*<       IF (GRGTYP.GT.0) THEN >*/
    if (grcm00_1.grgtyp > 0) {
/*         -- begin picture */
/*<           RBUF(1) = GRXMXA(GRCIDE) >*/
	rbuf[0] = (real) grcm00_1.grxmxa[grcm00_1.grcide - 1];
/*<           RBUF(2) = GRYMXA(GRCIDE) >*/
	rbuf[1] = (real) grcm00_1.grymxa[grcm00_1.grcide - 1];
/*<           NBUF = 2 >*/
	nbuf = 2;
/*<           CALL GREXEC(GRGTYP,11,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__11, rbuf, &nbuf, chr, &lchr, (ftnlen)20)
		;
/*         -- set color index */
/*<           RBUF(1) = GRCCOL(GRCIDE) >*/
	rbuf[0] = (real) grcm00_1.grccol[grcm00_1.grcide - 1];
/*<           NBUF = 1 >*/
	nbuf = 1;
/*<           CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__15, rbuf, &nbuf, chr, &lchr, (ftnlen)20)
		;
/*         -- set line width */
/*<           IF (GRGCAP(GRCIDE)(5:5).EQ.'T') THEN >*/
	if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 4]
		 == 'T') {
/*<               RBUF(1) = ABS(GRWIDT(GRCIDE)) >*/
	    rbuf[0] = (i__1 = grcm00_1.grwidt[grcm00_1.grcide - 1], (real) 
		    abs(i__1));
/*<               NBUF = 1 >*/
	    nbuf = 1;
/*<               CALL GREXEC(GRGTYP,22,RBUF,NBUF,CHR,LCHR) >*/
	    grexec_(&grcm00_1.grgtyp, &c__22, rbuf, &nbuf, chr, &lchr, (
		    ftnlen)20);
/*<           END IF >*/
	}
/*         -- set hardware dashing */
/*<           IF (GRGCAP(GRCIDE)(3:3).EQ.'D') THEN >*/
	if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 2]
		 == 'D') {
/*<               RBUF(1) = GRSTYL(GRCIDE) >*/
	    rbuf[0] = (real) grcm00_1.grstyl[grcm00_1.grcide - 1];
/*<               NBUF = 1 >*/
	    nbuf = 1;
/*<               CALL GREXEC(GRGTYP,19,RBUF,NBUF,CHR,LCHR) >*/
	    grexec_(&grcm00_1.grgtyp, &c__19, rbuf, &nbuf, chr, &lchr, (
		    ftnlen)20);
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/*<       END >*/
} /* grbpic_ */

