/* /work2/ssa/pgplot/src/grcurs.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__17 = 17;
static integer c__1 = 1;
static integer c__2 = 2;

/* *GRCURS -- read cursor position */
/* + */
/*<       INTEGER FUNCTION GRCURS (IDENT,IX,IY,IXREF,IYREF,MODE,POSN,CH) >*/
integer grcurs_(ident, ix, iy, ixref, iyref, mode, posn, ch, ch_len)
integer *ident, *ix, *iy, *ixref, *iyref, *mode, *posn;
char *ch;
ftnlen ch_len;
{
    /* Initialized data */

    static integer errcnt = 0;

    /* System generated locals */
    address a__1[2];
    integer ret_val, i__1, i__2, i__3, i__4[2];
    char ch__1[45];

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer i_indx();
    /* Subroutine */ int s_cat();

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[6];
    static char c__[1];
    static integer icurs;
    extern /* Subroutine */ int grbpic_(), grexec_(), grslct_(), grterm_(), 
	    grwarn_();
    static char chr[16];

/*<       INTEGER IDENT, IX, IY, IXREF, IYREF, MODE, POSN >*/
/*<       CHARACTER*(*) CH >*/

/* GRPCKG: Read the cursor position and a character typed by the user. */
/* The position is returned in absolute device coordinates (pixels). */
/* GRCURS positions the cursor at the position specified, and */
/* allows the user to move the cursor using the joystick or */
/* arrow keys or whatever is available on the device. When he has */
/* positioned the cursor, the user types a single character on his */
/* keyboard; GRCURS then returns this character and the new cursor */
/* position. */

/* "Rubber band" feedback of cursor movement can be requested (although */
/* it may not be supported on some devices). If MODE=1, a line from */
/* the anchor point to the current cursor position is displayed as */
/* the cursor is moved. If MODE=2, a rectangle with vertical and */
/* horizontal sides and one vertex at the anchor point and the opposite */
/* vertex at the current cursor position is displayed as the cursor is */
/* moved. */

/* Returns: */

/* GRCURS (integer): 1 if the call was successful; 0 if the device */
/*      has no cursor or some other error occurs. */

/* Arguments: */

/* IDENT (integer, input):  GRPCKG plot identifier (from GROPEN). */
/* IX    (integer, in/out): the device x-coordinate of the cursor. */
/* IY    (integer, in/out): the device y-coordinate of the cursor. */
/* IXREF (integer, input):  x-coordinate of anchor point. */
/* IYREF (integer, input):  y-coordinate of anchor point. */
/* MODE  (integer, input):  type of rubber-band feedback. */
/* CH    (char,    output): the character typed by the user; if the device */
/*      has no cursor or if some other error occurs, the value CHAR(0) */
/*      [ASCII NUL character] is returned. */
/* -- */
/*  1-Aug-1984 - extensively revised [TJP]. */
/* 29-Jan-1985 - add ARGS and HP2648 devices (?) [KS/TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 11-Jun-1987 - remove built-ins [TJP]. */
/* 15-Feb-1988 - remove test for batch jobs; leave this to the device */
/*               handler [TJP]. */
/* 13-Dec-1990 - remove code to abort after 10 cursor errors [TJP]. */
/*  7-Sep-1994 - add support for rubber-band modes [TJP]. */
/* 17-Jan-1995 - start picture if necessary [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       REAL           RBUF(6) >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER        NBUF, LCHR, ICURS, ERRCNT >*/
/*<       CHARACTER*16   CHR >*/
/*<       CHARACTER      C >*/
/*<       SAVE           ERRCNT >*/
/*<       DATA           ERRCNT/0/ >*/

/* Validate identifier, and select device. */

/*<       CALL GRSLCT(IDENT) >*/
    grslct_(ident);
/*<       CALL GRTERM >*/
    grterm_();

/* Begin picture if necessary. */

/*<       IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
    if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	grbpic_();
    }

/* Make sure cursor is on view surface. (It does not */
/* have to be in the viewport.) */

/*<       IX = MAX(0,MIN(GRXMXA(GRCIDE),IX)) >*/
/* Computing MAX */
/* Computing MIN */
    i__3 = grcm00_1.grxmxa[grcm00_1.grcide - 1];
    i__1 = 0, i__2 = min(i__3,*ix);
    *ix = max(i__1,i__2);
/*<       IY = MAX(0,MIN(GRYMXA(GRCIDE),IY)) >*/
/* Computing MAX */
/* Computing MIN */
    i__3 = grcm00_1.grymxa[grcm00_1.grcide - 1];
    i__1 = 0, i__2 = min(i__3,*iy);
    *iy = max(i__1,i__2);

/* Does the device have a cursor? */

/*<       C = GRGCAP(GRCIDE)(2:2) >*/
    *(unsigned char *)c__ = *(unsigned char *)&grcm01_1.grgcap[(
	    grcm00_1.grcide - 1) * 11 + 1];
/*<       ICURS = 0 >*/
    icurs = 0;
/*<       IF (C.EQ.'C' .OR. C.EQ.'X') ICURS=1 >*/
    if (*(unsigned char *)c__ == 'C' || *(unsigned char *)c__ == 'X') {
	icurs = 1;
    }

/* Device does have a cursor. */

/*<       IF (ICURS.GT.0) THEN >*/
    if (icurs > 0) {
/*         -- initial position of cursor */
/*<           RBUF(1) = IX >*/
	rbuf[0] = (real) (*ix);
/*<           RBUF(2) = IY >*/
	rbuf[1] = (real) (*iy);
/*         -- reference point for rubber band */
/*<           RBUF(3) = IXREF >*/
	rbuf[2] = (real) (*ixref);
/*<           RBUF(4) = IYREF >*/
	rbuf[3] = (real) (*iyref);
/*         -- rubber band mode */
/*<           RBUF(5) = MODE >*/
	rbuf[4] = (real) (*mode);
/*         -- position cursor? */
/*<           RBUF(6) = POSN >*/
	rbuf[5] = (real) (*posn);
/*<           NBUF = 6 >*/
	nbuf = 6;
/*<           LCHR = 0 >*/
	lchr = 0;
/*<           CALL GREXEC(GRGTYP,17,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__17, rbuf, &nbuf, chr, &lchr, (ftnlen)16)
		;
/*<           IX = RBUF(1) >*/
	*ix = rbuf[0];
/*<           IY = RBUF(2) >*/
	*iy = rbuf[1];
/*<           CH = CHR(1:1) >*/
	s_copy(ch, chr, ch_len, (ftnlen)1);
/*<           GRCURS = 1 >*/
	ret_val = 1;
/*         -- error if driver returns NUL */
/*<           IF (ICHAR(CHR(1:1)).EQ.0) GRCURS = 0 >*/
	if (*(unsigned char *)chr == 0) {
	    ret_val = 0;
	}

/* Other devices are illegal. */

/*<       ELSE >*/
    } else {
/*<           CALL GREXEC(GRGTYP, 1,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__1, rbuf, &nbuf, chr, &lchr, (ftnlen)16);
/*<           LCHR = INDEX(CHR,' ') >*/
	lchr = i_indx(chr, " ", (ftnlen)16, (ftnlen)1);
/*<    >*/
	if (errcnt <= 10) {
/* Writing concatenation */
	    i__4[0] = 29, a__1[0] = "output device has no cursor: ";
	    i__4[1] = lchr, a__1[1] = chr;
	    s_cat(ch__1, a__1, i__4, &c__2, (ftnlen)45);
	    grwarn_(ch__1, lchr + 29);
	}
/*<           CH = CHAR(0) >*/
	s_copy(ch, "\000", ch_len, (ftnlen)1);
/*<           GRCURS = 0 >*/
	ret_val = 0;
/*<           ERRCNT = ERRCNT+1 >*/
	++errcnt;
/*<       END IF >*/
    }

/*<       END >*/
    return ret_val;
} /* grcurs_ */

