/* /work2/ssa/pgplot/src/grimg1.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__26 = 26;

/* *GRIMG1 -- image of a 2D data array (image-primitive devices) */
/* + */
/*<    >*/
/* Subroutine */ int grimg1_(a, idim, jdim, i1, i2, j1, j2, a1, a2, pa, 
	minind, maxind, mode)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *a1, *a2, *pa;
integer *minind, *maxind, *mode;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    double log();
    integer i_nint();
    double sqrt();

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[21];
    static integer i__, j;
    static real sfacl;
    static integer ii;
    static real av;
    static integer iv;
    extern /* Subroutine */ int grbpic_(), grexec_(), grterm_();
    static real fac;
    static char chr[1];
    static integer nxp, nyp;

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE >*/
/*<       REAL    A(IDIM,JDIM), A1, A2, PA(6) >*/

/* (This routine is called by GRIMG0.) */
/* -- */
/* 7-Sep-1994  New routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER NBUF, LCHR >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL    RBUF(21), FAC, AV, SFAC, SFACL >*/
/*<       CHARACTER*1 CHR >*/
/*<       INTEGER  I, J, II, NXP, NYP, IV >*/
/*<       INTRINSIC NINT, LOG >*/
/*<       PARAMETER (SFAC=65000.0) >*/
/* ----------------------------------------------------------------------- */
/* Size of image. */

/*<       NXP = I2 - I1 + 1 >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --pa;

    /* Function Body */
    nxp = *i2 - *i1 + 1;
/*<       NYP = J2 - J1 + 1 >*/
    nyp = *j2 - *j1 + 1;
/*<       RBUF(1) = 0.0 >*/
    rbuf[0] = (float)0.;
/*<       RBUF(2) = NXP >*/
    rbuf[1] = (real) nxp;
/*<       RBUF(3) = NYP >*/
    rbuf[2] = (real) nyp;

/* Clipping rectangle. */

/*<       RBUF(4) = GRXMIN(GRCIDE) >*/
    rbuf[3] = grcm00_1.grxmin[grcm00_1.grcide - 1];
/*<       RBUF(5) = GRXMAX(GRCIDE) >*/
    rbuf[4] = grcm00_1.grxmax[grcm00_1.grcide - 1];
/*<       RBUF(6) = GRYMIN(GRCIDE) >*/
    rbuf[5] = grcm00_1.grymin[grcm00_1.grcide - 1];
/*<       RBUF(7) = GRYMAX(GRCIDE) >*/
    rbuf[6] = grcm00_1.grymax[grcm00_1.grcide - 1];

/* Image transformation matrix. */

/*<       FAC = PA(2)*PA(6) - PA(3)*PA(5) >*/
    fac = pa[2] * pa[6] - pa[3] * pa[5];
/*<       RBUF(8)  =  PA(6)/FAC >*/
    rbuf[7] = pa[6] / fac;
/*<       RBUF(9)  = (-PA(5))/FAC >*/
    rbuf[8] = -pa[5] / fac;
/*<       RBUF(10) = (-PA(3))/FAC >*/
    rbuf[9] = -pa[3] / fac;
/*<       RBUF(11) =  PA(2)/FAC >*/
    rbuf[10] = pa[2] / fac;
/*<       RBUF(12) = (PA(3)*PA(4) - PA(1)*PA(6))/FAC - (I1-0.5) >*/
    rbuf[11] = (pa[3] * pa[4] - pa[1] * pa[6]) / fac - (*i1 - (float).5);
/*<       RBUF(13) = (PA(5)*PA(1) - PA(4)*PA(2))/FAC - (J1-0.5) >*/
    rbuf[12] = (pa[5] * pa[1] - pa[4] * pa[2]) / fac - (*j1 - (float).5);

/* Send setup info to driver. */

/*<       IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
    if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	grbpic_();
    }
/*<       CALL GRTERM >*/
    grterm_();
/*<       NBUF = 13 >*/
    nbuf = 13;
/*<       LCHR = 0 >*/
    lchr = 0;
/*<       CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (ftnlen)1);

/* Convert image array to color indices and send to driver. */

/*<       SFACL = LOG(1.0+SFAC) >*/
    sfacl = log((float)65001.);
/*<       II = 0 >*/
    ii = 0;
/*<       DO 20 J = J1,J2 >*/
    i__1 = *j2;
    for (j = *j1; j <= i__1; ++j) {
/*<           DO 10 I = I1,I2 >*/
	i__2 = *i2;
	for (i__ = *i1; i__ <= i__2; ++i__) {
/*<               AV = A(I,J) >*/
	    av = a[i__ + j * a_dim1];
/*<               IF (A2.GT.A1) THEN >*/
	    if (*a2 > *a1) {
/*<                   AV = MIN(A2, MAX(A1,AV)) >*/
/* Computing MIN */
		r__1 = *a2, r__2 = dmax(*a1,av);
		av = dmin(r__1,r__2);
/*<               ELSE >*/
	    } else {
/*<                   AV = MIN(A1, MAX(A2,AV)) >*/
/* Computing MIN */
		r__1 = *a1, r__2 = dmax(*a2,av);
		av = dmin(r__1,r__2);
/*<               END IF >*/
	    }
/*<               IF (MODE.EQ.0) THEN >*/
	    if (*mode == 0) {
/*<                 IV = NINT((MININD*(A2-AV) + MAXIND*(AV-A1))/(A2-A1)) >*/
		r__1 = (*minind * (*a2 - av) + *maxind * (av - *a1)) / (*a2 - 
			*a1);
		iv = i_nint(&r__1);
/*<               ELSE IF (MODE.EQ.1) THEN >*/
	    } else if (*mode == 1) {
/*<    >*/
		r__2 = (*maxind - *minind) * log((r__1 = (av - *a1) / (*a2 - *
			a1), dabs(r__1)) * (float)6.5e4 + (float)1.) / sfacl;
		iv = *minind + i_nint(&r__2);
/*<               ELSE IF (MODE.EQ.2) THEN >*/
	    } else if (*mode == 2) {
/*<    >*/
		r__2 = (*maxind - *minind) * sqrt((r__1 = (av - *a1) / (*a2 - 
			*a1), dabs(r__1)));
		iv = *minind + i_nint(&r__2);
/*<               ELSE >*/
	    } else {
/*<                 IV = MININD >*/
		iv = *minind;
/*<               END IF >*/
	    }
/*<               II = II + 1 >*/
	    ++ii;
/*<               RBUF(II+1) = IV >*/
	    rbuf[ii] = (real) iv;
/*<               IF (II.EQ.20) THEN >*/
	    if (ii == 20) {
/*<                   NBUF = II + 1 >*/
		nbuf = ii + 1;
/*<                   RBUF(1) = II >*/
		rbuf[0] = (real) ii;
/*<                   CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR) >*/
		grexec_(&grcm00_1.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (
			ftnlen)1);
/*<                   II = 0 >*/
		ii = 0;
/*<               END IF >*/
	    }
/*<    10     CONTINUE >*/
/* L10: */
	}
/*<    20 CONTINUE >*/
/* L20: */
    }
/*<       IF (II.GT.0) THEN >*/
    if (ii > 0) {
/*<           NBUF = II + 1 >*/
	nbuf = ii + 1;
/*<           RBUF(1) = II >*/
	rbuf[0] = (real) ii;
/*<           CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*<           II = 0 >*/
	ii = 0;
/*<       END IF >*/
    }

/* Send termination code to driver. */

/*<       NBUF = 1 >*/
    nbuf = 1;
/*<       RBUF(1) = -1 >*/
    rbuf[0] = (float)-1.;
/*<       CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grimg1_ */

