/* /work2/ssa/pgplot/src/grimg2.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__26 = 26;

/* *GRIMG2 -- image of a 2D data array (pixel-primitive devices) */
/* + */
/*<    >*/
/* Subroutine */ int grimg2_(a, idim, jdim, i1, i2, j1, j2, a1, a2, pa, 
	minind, maxind, mode)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *a1, *a2, *pa;
integer *minind, *maxind, *mode;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    integer i_nint();
    double log(), sqrt();

    /* Local variables */
    static integer lchr;
    static real xxaa, xyaa, xxbb, yyaa, yybb, xybb, yxaa, yxbb;
    static integer npix, i__, j;
    static real sfacl, av;
    static integer iv, ix, iy;
    extern /* Subroutine */ int grbpic_();
    static real buffer[1026];
    extern /* Subroutine */ int grexec_();
    static integer ix1, ix2, iy1, iy2;
    static real xyaaiy, yxaaiy, den;
    static char chr[1];

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE >*/
/*<       REAL    A(IDIM,JDIM) >*/
/*<       REAL    A1, A2 >*/
/*<       REAL    PA(6) >*/

/* (This routine is called by GRIMG0.) */
/* -- */
/* 7-Sep-1994  New routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER  I,IV,IX,IX1,IX2,IY,IY1,IY2,J, NPIX, LCHR >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     DEN, AV, SFAC, SFACL >*/
/*<       REAL     XXAA,XXBB,YYAA,YYBB,XYAA,XYBB,YXAA,YXBB,XYAAIY,YXAAIY >*/
/*<       REAL     BUFFER(1026) >*/
/*<       CHARACTER*1 CHR >*/
/*<       INTRINSIC NINT, LOG >*/
/*<       PARAMETER (SFAC=65000.0) >*/
/* ----------------------------------------------------------------------- */

/* Location of current window in device coordinates. */

/*<       IX1 = NINT(GRXMIN(GRCIDE))+1 >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --pa;

    /* Function Body */
    ix1 = i_nint(&grcm00_1.grxmin[grcm00_1.grcide - 1]) + 1;
/*<       IX2 = NINT(GRXMAX(GRCIDE))-1 >*/
    ix2 = i_nint(&grcm00_1.grxmax[grcm00_1.grcide - 1]) - 1;
/*<       IY1 = NINT(GRYMIN(GRCIDE))+1 >*/
    iy1 = i_nint(&grcm00_1.grymin[grcm00_1.grcide - 1]) + 1;
/*<       IY2 = NINT(GRYMAX(GRCIDE))-1 >*/
    iy2 = i_nint(&grcm00_1.grymax[grcm00_1.grcide - 1]) - 1;

/* Transformation from array coordinates to device coordinates. */

/*<       DEN = PA(2)*PA(6)-PA(3)*PA(5) >*/
    den = pa[2] * pa[6] - pa[3] * pa[5];
/*<       XXAA = (-PA(6))*PA(1)/DEN >*/
    xxaa = -pa[6] * pa[1] / den;
/*<       XXBB = PA(6)/DEN >*/
    xxbb = pa[6] / den;
/*<       XYAA = (-PA(3))*PA(4)/DEN >*/
    xyaa = -pa[3] * pa[4] / den;
/*<       XYBB = PA(3)/DEN >*/
    xybb = pa[3] / den;
/*<       YYAA = (-PA(2))*PA(4)/DEN >*/
    yyaa = -pa[2] * pa[4] / den;
/*<       YYBB = PA(2)/DEN >*/
    yybb = pa[2] / den;
/*<       YXAA = (-PA(5))*PA(1)/DEN >*/
    yxaa = -pa[5] * pa[1] / den;
/*<       YXBB = PA(5)/DEN >*/
    yxbb = pa[5] / den;

/* Start a new page if necessary. */

/*<       IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
    if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	grbpic_();
    }

/* Run through every device pixel (IX, IY) in the current window and */
/* determine which array pixel (I,J) it falls in. */

/*<       SFACL = LOG(1.0+SFAC) >*/
    sfacl = log((float)65001.);
/*<       DO 120 IY=IY1,IY2 >*/
    i__1 = iy2;
    for (iy = iy1; iy <= i__1; ++iy) {
/*<           XYAAIY = XXAA-XYAA-XYBB*IY >*/
	xyaaiy = xxaa - xyaa - xybb * iy;
/*<           YXAAIY = YYAA+YYBB*IY-YXAA >*/
	yxaaiy = yyaa + yybb * iy - yxaa;
/*<           NPIX = 0 >*/
	npix = 0;
/*<           BUFFER(2) = IY >*/
	buffer[1] = (real) iy;
/*<           DO 110 IX=IX1,IX2 >*/
	i__2 = ix2;
	for (ix = ix1; ix <= i__2; ++ix) {
/*<             I = NINT(XYAAIY+XXBB*IX) >*/
	    r__1 = xyaaiy + xxbb * ix;
	    i__ = i_nint(&r__1);
/*<             IF (I.LT.I1.OR.I.GT.I2) GOTO 110 >*/
	    if (i__ < *i1 || i__ > *i2) {
		goto L110;
	    }
/*<             J = NINT(YXAAIY-YXBB*IX) >*/
	    r__1 = yxaaiy - yxbb * ix;
	    j = i_nint(&r__1);
/*<             IF (J.LT.J1.OR.J.GT.J2) GOTO 110 >*/
	    if (j < *j1 || j > *j2) {
		goto L110;
	    }

/*           -- determine color index IV of this pixel */

/*<             AV = A(I,J) >*/
	    av = a[i__ + j * a_dim1];
/*<             IF (A2.GT.A1) THEN >*/
	    if (*a2 > *a1) {
/*<                 AV = MIN(A2, MAX(A1,AV)) >*/
/* Computing MIN */
		r__1 = *a2, r__2 = dmax(*a1,av);
		av = dmin(r__1,r__2);
/*<             ELSE >*/
	    } else {
/*<                 AV = MIN(A1, MAX(A2,AV)) >*/
/* Computing MIN */
		r__1 = *a1, r__2 = dmax(*a2,av);
		av = dmin(r__1,r__2);
/*<             END IF >*/
	    }
/*<             IF (MODE.EQ.0) THEN >*/
	    if (*mode == 0) {
/*<                 IV = NINT((MININD*(A2-AV) + MAXIND*(AV-A1))/(A2-A1)) >*/
		r__1 = (*minind * (*a2 - av) + *maxind * (av - *a1)) / (*a2 - 
			*a1);
		iv = i_nint(&r__1);
/*<             ELSE IF (MODE.EQ.1) THEN >*/
	    } else if (*mode == 1) {
/*<    >*/
		r__2 = (*maxind - *minind) * log((r__1 = (av - *a1) / (*a2 - *
			a1), dabs(r__1)) * (float)6.5e4 + (float)1.) / sfacl;
		iv = *minind + i_nint(&r__2);
/*<             ELSE IF (MODE.EQ.2) THEN >*/
	    } else if (*mode == 2) {
/*<    >*/
		r__2 = (*maxind - *minind) * sqrt((r__1 = (av - *a1) / (*a2 - 
			*a1), dabs(r__1)));
		iv = *minind + i_nint(&r__2);
/*<             ELSE >*/
	    } else {
/*<                 IV = MININD >*/
		iv = *minind;
/*<             END IF >*/
	    }

/*<             IF (NPIX.LE.1024) THEN >*/
	    if (npix <= 1024) {
/*               -- drop pixels if buffer too small (to be fixed!) */
/*<                 NPIX = NPIX+1 >*/
		++npix;
/*<                 IF (NPIX.EQ.1) BUFFER(1) = IX >*/
		if (npix == 1) {
		    buffer[0] = (real) ix;
		}
/*<                 BUFFER(NPIX+2) = IV >*/
		buffer[npix + 1] = (real) iv;
/*<             END IF >*/
	    }
/*<   110     CONTINUE >*/
L110:
	    ;
	}
/*<    >*/
	if (npix > 0) {
	    i__2 = npix + 2;
	    grexec_(&grcm00_1.grgtyp, &c__26, buffer, &i__2, chr, &lchr, (
		    ftnlen)1);
	}
/*<   120 CONTINUE >*/
/* L120: */
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grimg2_ */

