/* /work2/ssa/pgplot/src/grimg3.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* *GRIMG3 -- gray-scale map of a 2D data array, using dither */
/* + */
/*<    >*/
/* Subroutine */ int grimg3_(a, idim, jdim, i1, i2, j1, j2, black, white, pa, 
	mode)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *black, *white, *pa;
integer *mode;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2, i__3, i__4;
    real r__1, r__2;

    /* Builtin functions */
    integer i_nint();
    double log(), sqrt();

    /* Local variables */
    static real facl, rand;
    static integer jran;
    static real xxaa, xyaa, xxbb, yyaa, yybb, xybb, yxaa, yxbb;
    static integer i__, j;
    static real value;
    static integer ilast, jlast;
    extern /* Subroutine */ int grdot0_();
    static real bw;
    static integer ix, iy, ix1, ix2, iy1, iy2;
    static real xyaaiy, yxaaiy;
    static integer ixstep, iystep;
    static real den;

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2, MODE >*/
/*<       REAL    A(IDIM,JDIM) >*/
/*<       REAL    BLACK, WHITE >*/
/*<       REAL    PA(6) >*/
/* -- */
/* 2-Sep-1994 - moved from GRGRAY [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER  I,IX,IX1,IX2,IY,IY1,IY2,J >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     DEN,VALUE,BW >*/
/*<       REAL     XXAA,XXBB,YYAA,YYBB,XYAA,XYBB,YXAA,YXBB,XYAAIY,YXAAIY >*/
/*<       INTEGER  M, IAA, ICC, JRAN, ILAST, JLAST, IXSTEP, IYSTEP >*/
/*<       REAL     RAND, RM, FAC, FACL >*/
/*<       PARAMETER (M=714025, IAA=1366, ICC=150889, RM=1.0/M) >*/
/*<       PARAMETER (FAC=65000.0) >*/
/*<       INTRINSIC MOD, NINT, REAL, LOG >*/
/* ----------------------------------------------------------------------- */

/*<       IF (MODE.LT.0 .OR. MODE.GT.2) RETURN >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --pa;

    /* Function Body */
    if (*mode < 0 || *mode > 2) {
	return 0;
    }

/* Initialize random-number generator (based on RAN2 of Press et al., */
/* Numerical Recipes) */

/*<       JRAN = 76773 >*/
    jran = 76773;

/*<       IX1 = NINT(GRXMIN(GRCIDE))+1 >*/
    ix1 = i_nint(&grcm00_1.grxmin[grcm00_1.grcide - 1]) + 1;
/*<       IX2 = NINT(GRXMAX(GRCIDE))-1 >*/
    ix2 = i_nint(&grcm00_1.grxmax[grcm00_1.grcide - 1]) - 1;
/*<       IY1 = NINT(GRYMIN(GRCIDE))+1 >*/
    iy1 = i_nint(&grcm00_1.grymin[grcm00_1.grcide - 1]) + 1;
/*<       IY2 = NINT(GRYMAX(GRCIDE))-1 >*/
    iy2 = i_nint(&grcm00_1.grymax[grcm00_1.grcide - 1]) - 1;
/*<       DEN = PA(2)*PA(6)-PA(3)*PA(5) >*/
    den = pa[2] * pa[6] - pa[3] * pa[5];

/* Calculate constants. */

/*<       BW   = ABS(BLACK-WHITE) >*/
    bw = (r__1 = *black - *white, dabs(r__1));
/*<       FACL = LOG(1.0+FAC) >*/
    facl = log((float)65001.);
/*<       XXAA = (-PA(6))*PA(1)/DEN >*/
    xxaa = -pa[6] * pa[1] / den;
/*<       XXBB = PA(6)/DEN >*/
    xxbb = pa[6] / den;
/*<       XYAA = (-PA(3))*PA(4)/DEN >*/
    xyaa = -pa[3] * pa[4] / den;
/*<       XYBB = PA(3)/DEN >*/
    xybb = pa[3] / den;
/*<       YYAA = (-PA(2))*PA(4)/DEN >*/
    yyaa = -pa[2] * pa[4] / den;
/*<       YYBB = PA(2)/DEN >*/
    yybb = pa[2] / den;
/*<       YXAA = (-PA(5))*PA(1)/DEN >*/
    yxaa = -pa[5] * pa[1] / den;
/*<       YXBB = PA(5)/DEN >*/
    yxbb = pa[5] / den;

/* Choose step size: at least 1/200 inch, assuming the line-width */
/* unit is 1/200 inch. */

/*<       IXSTEP = MAX(1,NINT(GRWIDT(GRCIDE)*GRPXPI(GRCIDE)/200.0)) >*/
/* Computing MAX */
    r__1 = grcm00_1.grwidt[grcm00_1.grcide - 1] * grcm00_1.grpxpi[
	    grcm00_1.grcide - 1] / (float)200.;
    i__1 = 1, i__2 = i_nint(&r__1);
    ixstep = max(i__1,i__2);
/*<       IYSTEP = MAX(1,NINT(GRWIDT(GRCIDE)*GRPYPI(GRCIDE)/200.0)) >*/
/* Computing MAX */
    r__1 = grcm00_1.grwidt[grcm00_1.grcide - 1] * grcm00_1.grpypi[
	    grcm00_1.grcide - 1] / (float)200.;
    i__1 = 1, i__2 = i_nint(&r__1);
    iystep = max(i__1,i__2);

/* Draw dots. */

/*<       ILAST = 0 >*/
    ilast = 0;
/*<       JLAST = 0 >*/
    jlast = 0;
/*<       DO 120 IY=IY1,IY2,IYSTEP >*/
    i__1 = iy2;
    i__2 = iystep;
    for (iy = iy1; i__2 < 0 ? iy >= i__1 : iy <= i__1; iy += i__2) {
/*<           XYAAIY = XXAA-XYAA-XYBB*IY >*/
	xyaaiy = xxaa - xyaa - xybb * iy;
/*<           YXAAIY = YYAA+YYBB*IY-YXAA >*/
	yxaaiy = yyaa + yybb * iy - yxaa;
/*<           DO 110 IX=IX1,IX2,IXSTEP >*/
	i__3 = ix2;
	i__4 = ixstep;
	for (ix = ix1; i__4 < 0 ? ix >= i__3 : ix <= i__3; ix += i__4) {
/*<               I = NINT(XYAAIY+XXBB*IX) >*/
	    r__1 = xyaaiy + xxbb * ix;
	    i__ = i_nint(&r__1);
/*<               IF (I.LT.I1.OR.I.GT.I2) GOTO 110 >*/
	    if (i__ < *i1 || i__ > *i2) {
		goto L110;
	    }
/*<               J = NINT(YXAAIY-YXBB*IX) >*/
	    r__1 = yxaaiy - yxbb * ix;
	    j = i_nint(&r__1);
/*<               IF (J.LT.J1.OR.J.GT.J2) GOTO 110 >*/
	    if (j < *j1 || j > *j2) {
		goto L110;
	    }
/*<               IF (I.NE.ILAST .OR. J.NE.JLAST) THEN >*/
	    if (i__ != ilast || j != jlast) {
/*<                   ILAST = I >*/
		ilast = i__;
/*<                   JLAST = J >*/
		jlast = j;
/*<                   VALUE = ABS(A(I,J)-WHITE)/BW >*/
		value = (r__1 = a[i__ + j * a_dim1] - *white, dabs(r__1)) / 
			bw;
/*<                   IF (MODE.EQ.0) THEN >*/
		if (*mode == 0) {
/*                     -- "linear" */
/*<                       CONTINUE >*/
/*<                   ELSE IF (MODE.EQ.1) THEN >*/
		} else if (*mode == 1) {
/*                     -- "logarithmic" */
/*<                       VALUE = LOG(1.0+FAC*VALUE)/FACL >*/
		    value = log(value * (float)6.5e4 + (float)1.) / facl;
/*<                   ELSE IF (MODE.EQ.2) THEN >*/
		} else if (*mode == 2) {
/*                     -- "square root" */
/*<                       VALUE = SQRT(VALUE) >*/
		    value = sqrt(value);
/*<                   END IF >*/
		}
/*<               END IF >*/
	    }
/*<               JRAN = MOD(JRAN*IAA+ICC, M) >*/
	    jran = (jran * 1366 + 150889) % 714025;
/*<               RAND = JRAN*RM >*/
	    rand = jran * (float)1.4005111865831029e-6;
/*<               IF (VALUE.GT.RAND) CALL GRDOT0(REAL(IX),REAL(IY)) >*/
	    if (value > rand) {
		r__1 = (real) ix;
		r__2 = (real) iy;
		grdot0_(&r__1, &r__2);
	    }
/*<   110     CONTINUE >*/
L110:
	    ;
	}
/*<   120  CONTINUE >*/
/* L120: */
    }
/* ----------------------------------------------------------------------- */
/*<        END >*/
} /* grimg3_ */

