/* /work2/ssa/pgplot/src/grlen.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static real c_b3 = (float).6;

/* *GRLEN -- inquire plotted length of character string */
/* + */
/*<       SUBROUTINE GRLEN (STRING, D) >*/
/* Subroutine */ int grlen_(string, d__, string_len)
char *string;
real *d__;
ftnlen string_len;
{
    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    integer i_len();
    double pow_ri();

    /* Local variables */
    static real cosa, sina;
    static integer list[256], i__;
    static real ratio;
    static integer nlist;
    static real dx, fntfac;
    static integer lx;
    static real factor, fntbas;
    static logical unused;
    static integer xygrid[300], ifntlv;
    extern /* Subroutine */ int grsyds_(), grsyxd_();


/* GRPCKG: length of text string (absolute units) */
/* -- */
/* (3-Mar-1983) */
/* 19-Jan-1988 - remove unused label [TJP]. */
/*  9-Sep-1989 - standardize [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       LOGICAL UNUSED >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER XYGRID(300) >*/
/*<       INTEGER LIST(256) >*/
/*<       CHARACTER*(*) STRING >*/
/*<       REAL FACTOR, COSA, SINA, DX, D, RATIO, FNTBAS, FNTFAC >*/
/*<       INTEGER I, IFNTLV, LX, NLIST >*/
/*<       INTRINSIC ABS, LEN >*/

/*<       D = 0.0 >*/
    *d__ = (float)0.;
/*<       IF (LEN(STRING).LE.0) RETURN >*/
    if (i_len(string, string_len) <= 0) {
	return 0;
    }
/* ----------------------------------------------------------------------- */
/*               Compute scaling and orientation */
/* ----------------------------------------------------------------------- */
/*<       FACTOR = GRCFAC(GRCIDE)/2.5 >*/
    factor = grcm00_1.grcfac[grcm00_1.grcide - 1] / (float)2.5;
/*<       RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE) >*/
    ratio = grcm00_1.grpxpi[grcm00_1.grcide - 1] / grcm00_1.grpypi[
	    grcm00_1.grcide - 1];
/*<       COSA = FACTOR >*/
    cosa = factor;
/*<       SINA = 0.0 >*/
    sina = (float)0.;
/*<       FNTBAS = 0.0 >*/
    fntbas = (float)0.;
/*<       FNTFAC = 1.0 >*/
    fntfac = (float)1.;
/*<       IFNTLV = 0 >*/
    ifntlv = 0;

/*               Convert string to symbol numbers: */
/*               \u and \d escape sequences are converted to -1,-2 */

/*<       CALL GRSYDS(LIST,NLIST,STRING,GRCFNT(GRCIDE)) >*/
    grsyds_(list, &nlist, string, &grcm00_1.grcfnt[grcm00_1.grcide - 1], 
	    string_len);

/*               Plot the string of characters */

/*<       DO 380 I = 1,NLIST >*/
    i__1 = nlist;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           IF (LIST(I).LT.0) THEN >*/
	if (list[i__ - 1] < 0) {
/*<               IF (LIST(I).EQ.-1) THEN >*/
	    if (list[i__ - 1] == -1) {
/*<                   IFNTLV = IFNTLV+1 >*/
		++ifntlv;
/*<                   FNTBAS = FNTBAS + 16.0*FNTFAC >*/
		fntbas += fntfac * (float)16.;
/*<                   FNTFAC = 0.6**ABS(IFNTLV) >*/
		i__2 = abs(ifntlv);
		fntfac = pow_ri(&c_b3, &i__2);
/*<               ELSE IF (LIST(I).EQ.-2) THEN >*/
	    } else if (list[i__ - 1] == -2) {
/*<                   IFNTLV = IFNTLV-1 >*/
		--ifntlv;
/*<                   FNTFAC = 0.6**ABS(IFNTLV) >*/
		i__2 = abs(ifntlv);
		fntfac = pow_ri(&c_b3, &i__2);
/*<                   FNTBAS = FNTBAS - 16.0*FNTFAC >*/
		fntbas -= fntfac * (float)16.;
/*<               END IF >*/
	    }
/*<               GOTO 380 >*/
	    goto L380;
/*<           END IF >*/
	}
/*<           CALL GRSYXD(LIST(I),XYGRID,UNUSED) >*/
	grsyxd_(&list[i__ - 1], xygrid, &unused);
/*<           LX = XYGRID(5)-XYGRID(4) >*/
	lx = xygrid[4] - xygrid[3];
/*<           DX = COSA*LX*RATIO >*/
	dx = cosa * lx * ratio;
/*<           D = D + DX*FNTFAC >*/
	*d__ += dx * fntfac;
/*<   380 CONTINUE >*/
L380:
	;
    }

/*<       END >*/
} /* grlen_ */

