/* /work2/ssa/pgplot/src/grlin0.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static logical c_false = FALSE_;

/* *GRLIN0 -- draw a line */
/* + */
/*<       SUBROUTINE GRLIN0 (XP,YP) >*/
/* Subroutine */ int grlin0_(xp, yp)
real *xp, *yp;
{
    /* System generated locals */
    real r__1, r__2;

    /* Local variables */
    static real x0, y0, x1, y1;
    extern /* Subroutine */ int grlin1_(), grlin2_(), grlin3_(), grclpl_();
    static logical vis;


/* GRPCKG (internal routine): draw a line from the current position to a */
/* specified position, which becomes the new current position. This */
/* routine takes care of clipping at the viewport boundary, dashed and */
/* thick lines. */

/* Arguments: */

/* XP, YP (input, real): absolute device coordinates of the end-point of */
/*       the line. */
/* -- */
/* 13-Jul-1984 */
/*  7-May-1985 - add MIN/MAX kluge to prevent integer overflow [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       LOGICAL  VIS >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     XP,YP, X0,Y0, X1,Y1 >*/

/* End-points of line are (X0,Y0), (X1,Y1). */

/*<       X0 = GRXPRE(GRCIDE) >*/
    x0 = grcm00_1.grxpre[grcm00_1.grcide - 1];
/*<       Y0 = GRYPRE(GRCIDE) >*/
    y0 = grcm00_1.grypre[grcm00_1.grcide - 1];
/*<       X1 = MIN(2E9,MAX(-2E9,XP)) >*/
/* Computing MIN */
    r__1 = (float)2e9, r__2 = dmax((float)-2e9,*xp);
    x1 = dmin(r__1,r__2);
/*<       Y1 = MIN(2E9,MAX(-2E9,YP)) >*/
/* Computing MIN */
    r__1 = (float)2e9, r__2 = dmax((float)-2e9,*yp);
    y1 = dmin(r__1,r__2);
/*<       GRXPRE(GRCIDE) = X1 >*/
    grcm00_1.grxpre[grcm00_1.grcide - 1] = x1;
/*<       GRYPRE(GRCIDE) = Y1 >*/
    grcm00_1.grypre[grcm00_1.grcide - 1] = y1;

/* Change the end-points of the line (X0,Y0) - (X1,Y1) */
/* to clip the line at the window boundary. */

/*<       CALL GRCLPL(X0,Y0,X1,Y1,VIS) >*/
    grclpl_(&x0, &y0, &x1, &y1, &vis);
/*<       IF (.NOT.VIS) RETURN >*/
    if (! vis) {
	return 0;
    }

/* Draw the line in the appropriate style. */

/*<       IF (GRDASH(GRCIDE)) THEN >*/
    if (grcm00_1.grdash[grcm00_1.grcide - 1]) {
/*         ! dashed line */
/*<          CALL GRLIN1(X0,Y0,X1,Y1,.FALSE.) >*/
	grlin1_(&x0, &y0, &x1, &y1, &c_false);
/*<       ELSE IF (GRWIDT(GRCIDE).GT.1) THEN >*/
    } else if (grcm00_1.grwidt[grcm00_1.grcide - 1] > 1) {
/*         ! heavy line */
/*<          CALL GRLIN3(X0,Y0,X1,Y1) >*/
	grlin3_(&x0, &y0, &x1, &y1);
/*<       ELSE >*/
    } else {
/*         ! full line */
/*<          CALL GRLIN2(X0,Y0,X1,Y1) >*/
	grlin2_(&x0, &y0, &x1, &y1);
/*<       END IF >*/
    }
/*<       END >*/
} /* grlin0_ */

