/* /work2/ssa/pgplot/src/grlin3.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* *GRLIN3 -- draw a thick line (multiple strokes) */
/* + */
/*<       SUBROUTINE GRLIN3 (X0,Y0,X1,Y1) >*/
/* Subroutine */ int grlin3_(x0, y0, x1, y1)
real *x0, *y0, *x1, *y1;
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static real vlen, spix, spiy;
    static integer k;
    extern /* Subroutine */ int grlin2_();
    static real hk, dx, dy, vx, vy;
    extern /* Subroutine */ int grclpl_();
    static integer linewt;
    static real rsqurd, xs0, xs1, ys0, ys1, off;
    static logical vis;
    static real pxk, pyk, vxk, vyk;


/* GRPCKG: draw a heavy line from (X0,Y0) to (X1,Y1) by making multiple */
/* strokes.  In order to simulate a thick pen, the line drawn has */
/* circular, rather than square, end points.  If this is not done, */
/* thick letters and other figures have an abnormal and unpleasant */
/* appearance. */

/* Vocabulary: */

/* LINEWT: the number of strokes required to draw the line; if */
/*       this is odd, one stroke will lie along the requested vector. */
/*       The nominal line thickness is (LINEWT-1)*0.005 in. */
/* RSQURD: the square of the semi-line thickness. */
/* (DX,DY): the vector length of the line. */
/* (VX,VY): a vector of length 1 pixel in the direction of the line. */
/* (VY,-VX): a vector of length 1 pixel perpendicular to (VX,VY). */
/* OFF: the offset parallel to (VY,-VX) of the K'th stroke. */
/* (VXK,VYK): the vector increment of the K'th stroke to allow for the */
/*       semi-circular terminal on the line. */
/* (PXK,PYK): the vector offset of the K'th stroke perpendicular to the */
/*       line vector. */
/* -- */
/* (1-Feb-1983) */
/* 23-Nov-1994 - change algorithm so that the unit of line-width is */
/*               0.005 inch instead of 1 pixel [TJP]. */
/* March 1995 - added ABS to prevent domain error in SQRT (CTD) */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER  K,LINEWT >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     DX,DY, HK, OFF, PXK,PYK, RSQURD, VLEN,VX,VY,VXK,VYK >*/
/*<       REAL     X0,X1,Y0,Y1 >*/
/*<       REAL     XS0,XS1, YS0,YS1, SPIX,SPIY >*/
/*<       LOGICAL  VIS >*/

/* Determine number of strokes and line thickness. */

/*<       LINEWT = GRWIDT(GRCIDE) >*/
    linewt = grcm00_1.grwidt[grcm00_1.grcide - 1];
/*<       RSQURD = ((LINEWT-1)**2)*0.25 >*/
/* Computing 2nd power */
    i__1 = linewt - 1;
    rsqurd = i__1 * i__1 * (float).25;

/* Determine the vectors (VX,VY), (VY,-VX). If the line-length is zero, */
/* pretend it is a very short horizontal line. */

/*<       DX = X1 - X0 >*/
    dx = *x1 - *x0;
/*<       DY = Y1 - Y0 >*/
    dy = *y1 - *y0;
/*<       VLEN = SQRT(DX**2 + DY**2) >*/
/* Computing 2nd power */
    r__1 = dx;
/* Computing 2nd power */
    r__2 = dy;
    vlen = sqrt(r__1 * r__1 + r__2 * r__2);
/*<       SPIX = GRPXPI(GRCIDE)*0.005 >*/
    spix = grcm00_1.grpxpi[grcm00_1.grcide - 1] * (float).005;
/*<       SPIY = GRPYPI(GRCIDE)*0.005 >*/
    spiy = grcm00_1.grpypi[grcm00_1.grcide - 1] * (float).005;

/*<       IF (VLEN .EQ. 0.0) THEN >*/
    if (vlen == (float)0.) {
/*<           VX = SPIX >*/
	vx = spix;
/*<           VY = 0.0 >*/
	vy = (float)0.;
/*<       ELSE >*/
    } else {
/*<           VX = DX/VLEN*SPIX >*/
	vx = dx / vlen * spix;
/*<           VY = DY/VLEN*SPIY >*/
	vy = dy / vlen * spiy;
/*<       END IF >*/
    }

/* Draw LINEWT strokes. We have to clip again in case thickening the */
/* line has taken us outside the window. */

/*<       OFF = (LINEWT-1)*0.5 >*/
    off = (linewt - 1) * (float).5;
/*<       DO 10 K=1,LINEWT >*/
    i__1 = linewt;
    for (k = 1; k <= i__1; ++k) {
/*<           PXK = VY*OFF >*/
	pxk = vy * off;
/*<           PYK = -(VX*OFF) >*/
	pyk = -(vx * off);
/*<           HK  = SQRT(ABS(RSQURD - OFF**2)) >*/
/* Computing 2nd power */
	r__2 = off;
	hk = sqrt((r__1 = rsqurd - r__2 * r__2, dabs(r__1)));
/*<           VXK = VX*HK >*/
	vxk = vx * hk;
/*<           VYK = VY*HK >*/
	vyk = vy * hk;
/*<           XS1 = X1+PXK+VXK >*/
	xs1 = *x1 + pxk + vxk;
/*<           YS1 = Y1+PYK+VYK >*/
	ys1 = *y1 + pyk + vyk;
/*<           XS0 = X0+PXK-VXK >*/
	xs0 = *x0 + pxk - vxk;
/*<           YS0 = Y0+PYK-VYK >*/
	ys0 = *y0 + pyk - vyk;
/*<           CALL GRCLPL(XS1,YS1,XS0,YS0,VIS) >*/
	grclpl_(&xs1, &ys1, &xs0, &ys0, &vis);
/*<           IF (VIS) CALL GRLIN2(XS1, YS1, XS0, YS0) >*/
	if (vis) {
	    grlin2_(&xs1, &ys1, &xs0, &ys0);
	}
/*<           OFF = OFF - 1.0 >*/
	off += (float)-1.;
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       END >*/
} /* grlin3_ */

