/* /work2/ssa/pgplot/src/grmker.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__28 = 28;
static integer c__1 = 1;
static real c_b7 = (float)0.;

/* *GRMKER -- draw graph markers */
/* + */
/*<       SUBROUTINE GRMKER (SYMBOL,ABSXY,N,X,Y) >*/
/* Subroutine */ int grmker_(symbol, absxy, n, x, y)
integer *symbol;
logical *absxy;
integer *n;
real *x, *y;
{
    /* System generated locals */
    integer i__1, i__2, i__3, i__4;

    /* Builtin functions */
    double cos(), sin();

    /* Local variables */
    extern /* Subroutine */ int grfa_();
    static real cosa;
    static integer lchr;
    static real sina;
    static integer nbuf;
    static real rbuf[4], xoff[40], yoff[40], xmin, ymin, xmax, ymax, xorg, 
	    yorg, xcur, ycur;
    static integer c__, i__, k;
    static real angle, theta, ratio;
    extern /* Subroutine */ int grqls_(), grsls_();
    static real xminx, yminx, xmaxx, ymaxx;
    extern /* Subroutine */ int grlin0_(), grtxy0_(), grarea_();
    static integer lx, ly, nv;
    extern /* Subroutine */ int grbpic_();
    static real xp[40], factor, yp[40];
    extern /* Subroutine */ int grclip_(), grexec_();
    static logical visble, unused;
    static integer lstyle, lxlast, lylast, symnum, xygrid[300];
    extern /* Subroutine */ int grwarn_(), grsymk_(), grsyxd_();
    static char chr[32];


/* GRPCKG: Draw a graph marker at a set of points in the current */
/* window. Line attributes (color, intensity, and  thickness) */
/* apply to markers, but line-style is ignored. After the call to */
/* GRMKER, the current pen position will be the center of the last */
/* marker plotted. */

/* Arguments: */

/* SYMBOL (input, integer): the marker number to be drawn. Numbers */
/*       0-31 are special marker symbols; numbers 32-127 are the */
/*       corresponding ASCII characters (in the current font). If the */
/*       number is >127, it is taken to be a Hershey symbol number. */
/*       If -ve, a regular polygon is drawn. */
/* ABSXY (input, logical): if .TRUE., the input corrdinates (X,Y) are */
/*       taken to be absolute device coordinates; if .FALSE., they are */
/*       taken to be world coordinates. */
/* N (input, integer): the number of points to be plotted. */
/* X, Y (input, real arrays, dimensioned at least N): the (X,Y) */
/*       coordinates of the points to be plotted. */
/* -- */
/* (19-Mar-1983) */
/* 20-Jun-1985 - revise to window markers whole [TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/*  1-Aug-1988 - add direct use of Hershey number [TJP]. */
/* 15-Dec-1988 - standardize [TJP]. */
/* 17-Dec-1990 - add polygons [PAH/TJP]. */
/* 12-Jun-1992 - [TJP] */
/* 22-Sep-1992 - add support for hardware markers [TJP]. */
/*  1-Sep-1994 - suppress driver call [TJP]. */
/* 15-Feb-1994 - fix bug (expanding viewport!) [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER  SYMBOL >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER  C  >*/
/*<       LOGICAL  ABSXY, UNUSED, VISBLE >*/
/*<       INTEGER  I, K, LSTYLE, LX, LY, LXLAST, LYLAST, N, SYMNUM, NV >*/
/*<       INTEGER  XYGRID(300) >*/
/*<       REAL     ANGLE, COSA, SINA, FACTOR, RATIO, X(*), Y(*) >*/
/*<       REAL     XCUR, YCUR, XORG, YORG >*/
/*<       REAL     THETA, XOFF(40), YOFF(40), XP(40), YP(40) >*/
/*<       REAL     XMIN, XMAX, YMIN, YMAX >*/
/*<       REAL     XMINX, XMAXX, YMINX, YMAXX >*/
/*<       REAL     RBUF(4) >*/
/*<       INTEGER  NBUF,LCHR >*/
/*<       CHARACTER*32 CHR >*/

/* Check that there is something to be plotted. */

/*<       IF (N.LE.0) RETURN >*/
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (*n <= 0) {
	return 0;
    }

/* Check that a device is selected. */

/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*<           CALL GRWARN('GRMKER - no graphics device is active.') >*/
	grwarn_("GRMKER - no graphics device is active.", (ftnlen)38);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/*<       XMIN = GRXMIN(GRCIDE) >*/
    xmin = grcm00_1.grxmin[grcm00_1.grcide - 1];
/*<       XMAX = GRXMAX(GRCIDE) >*/
    xmax = grcm00_1.grxmax[grcm00_1.grcide - 1];
/*<       YMIN = GRYMIN(GRCIDE) >*/
    ymin = grcm00_1.grymin[grcm00_1.grcide - 1];
/*<       YMAX = GRYMAX(GRCIDE) >*/
    ymax = grcm00_1.grymax[grcm00_1.grcide - 1];
/*<       XMINX = XMIN-0.01 >*/
    xminx = xmin - (float).01;
/*<       XMAXX = XMAX+0.01 >*/
    xmaxx = xmax + (float).01;
/*<       YMINX = YMIN-0.01 >*/
    yminx = ymin - (float).01;
/*<       YMAXX = YMAX+0.01 >*/
    ymaxx = ymax + (float).01;

/* Does the device driver do markers (only markers 0-31 at present)? */

/*<    >*/
    if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 9] == 
	    'M' && *symbol >= 0 && *symbol <= 31) {
/*<           IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
	if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	    grbpic_();
	}
/*         -- symbol number */
/*<           RBUF(1) = SYMBOL >*/
	rbuf[0] = (real) (*symbol);
/*          -- scale factor */
/*<           RBUF(4) = GRCFAC(GRCIDE)/2.5 >*/
	rbuf[3] = grcm00_1.grcfac[grcm00_1.grcide - 1] / (float)2.5;
/*<           NBUF = 4 >*/
	nbuf = 4;
/*<           LCHR = 0 >*/
	lchr = 0;
/*<           DO 10 K=1,N >*/
	i__1 = *n;
	for (k = 1; k <= i__1; ++k) {
/*             -- convert to device coordinates */
/*<               CALL GRTXY0(ABSXY, X(K), Y(K), XORG, YORG) >*/
	    grtxy0_(absxy, &x[k], &y[k], &xorg, &yorg);
/*             -- is the marker visible? */
/*<               CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C) >*/
	    grclip_(&xorg, &yorg, &xminx, &xmaxx, &yminx, &ymaxx, &c__);
/*<               IF (C.EQ.0) THEN >*/
	    if (c__ == 0) {
/*<                   RBUF(2) = XORG >*/
		rbuf[1] = xorg;
/*<                   RBUF(3) = YORG >*/
		rbuf[2] = yorg;
/*<                   CALL GREXEC(GRGTYP,28,RBUF,NBUF,CHR,LCHR) >*/
		grexec_(&grcm00_1.grgtyp, &c__28, rbuf, &nbuf, chr, &lchr, (
			ftnlen)32);
/*<               END IF >*/
	    }
/*<    10     CONTINUE >*/
/* L10: */
	}
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Otherwise, draw the markers here. */

/* Save current line-style, and set style "normal". */

/*<       CALL GRQLS(LSTYLE) >*/
    grqls_(&lstyle);
/*<       CALL GRSLS(1) >*/
    grsls_(&c__1);

/* Save current viewport, and open the viewport to include the full */
/* view surface. */

/*<       CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0) >*/
    grarea_(&grcm00_1.grcide, &c_b7, &c_b7, &c_b7, &c_b7);

/* Compute scaling and orientation. */

/*<       ANGLE = 0.0 >*/
    angle = (float)0.;
/*<       FACTOR = GRCFAC(GRCIDE)/2.5 >*/
    factor = grcm00_1.grcfac[grcm00_1.grcide - 1] / (float)2.5;
/*<       RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE) >*/
    ratio = grcm00_1.grpxpi[grcm00_1.grcide - 1] / grcm00_1.grpypi[
	    grcm00_1.grcide - 1];
/*<       COSA = FACTOR * COS(ANGLE) >*/
    cosa = factor * cos(angle);
/*<       SINA = FACTOR * SIN(ANGLE) >*/
    sina = factor * sin(angle);

/* Convert the supplied marker number SYMBOL to a symbol number and */
/* obtain the digitization. */

/*<       IF (SYMBOL.GE.0) THEN >*/
    if (*symbol >= 0) {
/*<           IF (SYMBOL.GT.127) THEN >*/
	if (*symbol > 127) {
/*<               SYMNUM = SYMBOL >*/
	    symnum = *symbol;
/*<           ELSE >*/
	} else {
/*<               CALL GRSYMK(SYMBOL,GRCFNT(GRCIDE),SYMNUM) >*/
	    grsymk_(symbol, &grcm00_1.grcfnt[grcm00_1.grcide - 1], &symnum);
/*<           END IF >*/
	}
/*<           CALL GRSYXD(SYMNUM, XYGRID, UNUSED) >*/
	grsyxd_(&symnum, xygrid, &unused);

/* Positive symbols. */

/*<       DO 380 I=1,N >*/
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<           CALL GRTXY0(ABSXY, X(I), Y(I), XORG, YORG) >*/
	    grtxy0_(absxy, &x[i__], &y[i__], &xorg, &yorg);
/*<           CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C) >*/
	    grclip_(&xorg, &yorg, &xminx, &xmaxx, &yminx, &ymaxx, &c__);
/*<           IF (C.NE.0) GOTO 380 >*/
	    if (c__ != 0) {
		goto L380;
	    }
/*<           VISBLE = .FALSE. >*/
	    visble = FALSE_;
/*<           K = 4 >*/
	    k = 4;
/*<           LXLAST = -64 >*/
	    lxlast = -64;
/*<           LYLAST = -64 >*/
	    lylast = -64;
/*<   320       K = K+2 >*/
L320:
	    k += 2;
/*<             LX = XYGRID(K) >*/
	    lx = xygrid[k - 1];
/*<             LY = XYGRID(K+1) >*/
	    ly = xygrid[k];
/*<             IF (LY.EQ.-64) GOTO 380 >*/
	    if (ly == -64) {
		goto L380;
	    }
/*<             IF (LX.EQ.-64) THEN >*/
	    if (lx == -64) {
/*<                 VISBLE = .FALSE. >*/
		visble = FALSE_;
/*<             ELSE >*/
	    } else {
/*<                 IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN >*/
		if (lx != lxlast || ly != lylast) {
/*<                     XCUR = XORG + (COSA*LX - SINA*LY)*RATIO >*/
		    xcur = xorg + (cosa * lx - sina * ly) * ratio;
/*<                     YCUR = YORG + (SINA*LX + COSA*LY) >*/
		    ycur = yorg + (sina * lx + cosa * ly);
/*<                     IF (VISBLE) THEN >*/
		    if (visble) {
/*<                         CALL GRLIN0(XCUR,YCUR) >*/
			grlin0_(&xcur, &ycur);
/*<                     ELSE >*/
		    } else {
/*<                         GRXPRE(GRCIDE) = XCUR >*/
			grcm00_1.grxpre[grcm00_1.grcide - 1] = xcur;
/*<                         GRYPRE(GRCIDE) = YCUR >*/
			grcm00_1.grypre[grcm00_1.grcide - 1] = ycur;
/*<                     END IF >*/
		    }
/*<                 END IF >*/
		}
/*<                 VISBLE = .TRUE. >*/
		visble = TRUE_;
/*<                 LXLAST = LX >*/
		lxlast = lx;
/*<                 LYLAST = LY >*/
		lylast = ly;
/*<             END IF >*/
	    }
/*<             GOTO 320 >*/
	    goto L320;
/*<   380 CONTINUE >*/
L380:
	    ;
	}

/* Negative symbols. */

/*<       ELSE >*/
    } else {
/*         ! negative symbol: filled polygon of radius 8 */
/*<           NV = MIN(31,MAX(3,ABS(SYMBOL))) >*/
/* Computing MIN */
/* Computing MAX */
	i__3 = 3, i__4 = abs(*symbol);
	i__1 = 31, i__2 = max(i__3,i__4);
	nv = min(i__1,i__2);
/*<           DO 400 I=1,NV >*/
	i__1 = nv;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<               THETA = 3.14159265359*(REAL(2*(I-1))/REAL(NV)+0.5) - ANGLE >*/
	    theta = ((real) (i__ - 1 << 1) / (real) nv + (float).5) * (float)
		    3.14159265359 - angle;
/*<               XOFF(I) = COS(THETA)*FACTOR*RATIO/GRXSCL(GRCIDE)*8.0 >*/
	    xoff[i__ - 1] = cos(theta) * factor * ratio / grcm00_1.grxscl[
		    grcm00_1.grcide - 1] * (float)8.;
/*<               YOFF(I) = SIN(THETA)*FACTOR/GRYSCL(GRCIDE)*8.0 >*/
	    yoff[i__ - 1] = sin(theta) * factor / grcm00_1.gryscl[
		    grcm00_1.grcide - 1] * (float)8.;
/*<   400     CONTINUE >*/
/* L400: */
	}
/*<           DO 420 K=1,N >*/
	i__1 = *n;
	for (k = 1; k <= i__1; ++k) {
/*<               CALL GRTXY0(ABSXY, X(K), Y(K), XORG, YORG) >*/
	    grtxy0_(absxy, &x[k], &y[k], &xorg, &yorg);
/*<               CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C) >*/
	    grclip_(&xorg, &yorg, &xminx, &xmaxx, &yminx, &ymaxx, &c__);
/*<               IF (C.EQ.0) THEN >*/
	    if (c__ == 0) {
/*<                   DO 410 I=1,NV >*/
		i__2 = nv;
		for (i__ = 1; i__ <= i__2; ++i__) {
/*<                       XP(I) = X(K)+XOFF(I) >*/
		    xp[i__ - 1] = x[k] + xoff[i__ - 1];
/*<                       YP(I) = Y(K)+YOFF(I) >*/
		    yp[i__ - 1] = y[k] + yoff[i__ - 1];
/*<   410             CONTINUE >*/
/* L410: */
		}
/*<                   CALL GRFA(NV, XP, YP) >*/
		grfa_(&nv, xp, yp);
/*<               END IF >*/
	    }
/*<   420     CONTINUE >*/
/* L420: */
	}
/*<       END IF >*/
    }

/* Set current pen position. */

/*<       GRXPRE(GRCIDE) = XORG >*/
    grcm00_1.grxpre[grcm00_1.grcide - 1] = xorg;
/*<       GRYPRE(GRCIDE) = YORG >*/
    grcm00_1.grypre[grcm00_1.grcide - 1] = yorg;

/* Restore the viewport and line-style, and return. */

/*<       GRXMIN(GRCIDE) = XMIN >*/
    grcm00_1.grxmin[grcm00_1.grcide - 1] = xmin;
/*<       GRXMAX(GRCIDE) = XMAX >*/
    grcm00_1.grxmax[grcm00_1.grcide - 1] = xmax;
/*<       GRYMIN(GRCIDE) = YMIN >*/
    grcm00_1.grymin[grcm00_1.grcide - 1] = ymin;
/*<       GRYMAX(GRCIDE) = YMAX >*/
    grcm00_1.grymax[grcm00_1.grcide - 1] = ymax;
/*<       CALL GRSLS(LSTYLE) >*/
    grsls_(&lstyle);

/*<       END >*/
} /* grmker_ */

