/* /work2/ssa/pgplot/src/grqcr.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__29 = 29;

/* *GRQCR -- inquire color representation */
/* + */
/*<       SUBROUTINE GRQCR (CI, CR, CG, CB) >*/
/* Subroutine */ int grqcr_(ci, cr, cg, cb)
integer *ci;
real *cr, *cg, *cb;
{
    static integer lchr, nbuf;
    static real rbuf[6];
    static integer k;
    extern /* Subroutine */ int grexec_(), grwarn_();
    static char chr[1];

/*<       INTEGER  CI >*/
/*<       REAL     CR, CG, CB >*/

/* Return the color representation (red, green, blue intensities) */
/* currently associated with the specified color index. This may be */
/* different from that requested on some devices. */

/* Arguments: */

/* CI (integer, input): color index. */
/* CR, CG, CB (real, output): red, green, and blue intensities, */
/*       in range 0.0 to 1.0. */
/* -- */
/*  7-Sep-1994 - rewrite [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER   NBUF, LCHR, K >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL      RBUF(6) >*/
/*<       CHARACTER CHR >*/

/*<       CR = 1.0 >*/
    *cr = (float)1.;
/*<       CG = 1.0 >*/
    *cg = (float)1.;
/*<       CB = 1.0 >*/
    *cb = (float)1.;
/*<       K  = CI >*/
    k = *ci;
/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*         -- no device open: return white */
/*<           CALL GRWARN('GRQCR: no plot device is open.') >*/
	grwarn_("GRQCR: no plot device is open.", (ftnlen)30);
/*<       ELSE IF (GRGCAP(GRCIDE)(9:9).NE.'Y') THEN >*/
    } else if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 
	    + 8] != 'Y') {
/*         -- devices that don't allow query color representation: */
/*            return black for ci 0, white for all others */
/*<           IF (K.EQ.0) THEN >*/
	if (k == 0) {
/*<              CR = 0.0 >*/
	    *cr = (float)0.;
/*<              CG = 0.0 >*/
	    *cg = (float)0.;
/*<              CB = 0.0 >*/
	    *cb = (float)0.;
/*<           END IF >*/
	}
/*<       ELSE >*/
    } else {
/*         -- query device driver; treat invalid ci as 1 */
/*<           IF (K.LT.GRMNCI(GRCIDE) .OR. CI.GT.GRMXCI(GRCIDE)) THEN >*/
	if (k < grcm00_1.grmnci[grcm00_1.grcide - 1] || *ci > grcm00_1.grmxci[
		grcm00_1.grcide - 1]) {
/*<              CALL GRWARN('GRQCR: invalid color index.') >*/
	    grwarn_("GRQCR: invalid color index.", (ftnlen)27);
/*<              K = 1 >*/
	    k = 1;
/*<           END IF >*/
	}
/*<           RBUF(1) = K >*/
	rbuf[0] = (real) k;
/*<           NBUF = 1 >*/
	nbuf = 1;
/*<           LCHR = 0 >*/
	lchr = 0;
/*<           CALL GREXEC(GRGTYP,29,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__29, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*<           IF (NBUF.LT.4) THEN >*/
	if (nbuf < 4) {
/*<              CALL GRWARN('GRSCR: device driver error') >*/
	    grwarn_("GRSCR: device driver error", (ftnlen)26);
/*<           ELSE >*/
	} else {
/*<               CR = RBUF(2) >*/
	    *cr = rbuf[1];
/*<               CG = RBUF(3) >*/
	    *cg = rbuf[2];
/*<               CB = RBUF(4) >*/
	    *cb = rbuf[3];
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/*<       END >*/
} /* grqcr_ */

