/* /work2/ssa/pgplot/src/grqtxt.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static real c_b5 = (float).75;

/* *GRQTXT -- get text bounding box */
/* + */
/*<       SUBROUTINE GRQTXT (ORIENT,X0,Y0,STRING, XBOX, YBOX) >*/
/* Subroutine */ int grqtxt_(orient, x0, y0, string, xbox, ybox, string_len)
real *orient, *x0, *y0;
char *string;
real *xbox, *ybox;
ftnlen string_len;
{
    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    integer i_len();
    double cos(), sin(), pow_ri();

    /* Local variables */
    static real cosa, sina;
    static integer list[256];
    static logical plot;
    static real xorg, yorg;
    static integer i__, k;
    static real angle, ratio, xgmin, ygmin, xgmax, ygmax;
    static integer nlist;
    static real dx, dy, xg, yg, fntfac;
    static integer lx, ly;
    static real factor, fntbas;
    static logical visble, unused;
    static integer xygrid[300], ifntlv, lxlast, lylast;
    extern /* Subroutine */ int grwarn_(), grsyds_(), grsyxd_();
    static real rlx, rly;


/* GRPCKG: get the bounding box of a string drawn by GRTEXT. */
/* -- */
/* 12-Sep-1993 - [TJP]. */
/*  8-Nov-1994 - return something even if string is blank [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       LOGICAL UNUSED, VISBLE, PLOT >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER XYGRID(300) >*/
/*<       INTEGER LIST(256) >*/
/*<       CHARACTER*(*) STRING >*/
/*<       REAL XBOX(4), YBOX(4) >*/
/*<       REAL ANGLE, FACTOR, FNTBAS, FNTFAC, COSA, SINA, DX, DY, XORG, YORG >*/
/*<       REAL ORIENT, RATIO, X0, Y0, RLX, RLY >*/
/*<       REAL XG, YG, XGMIN, XGMAX, YGMIN, YGMAX >*/
/*<       INTEGER I, IFNTLV,NLIST,LX,LY, K, LXLAST,LYLAST >*/
/*<       INTRINSIC ABS, COS, LEN, MAX, MIN, SIN >*/

/* Default return values. */

/*<       DO 10 I=1,4 >*/
    /* Parameter adjustments */
    --ybox;
    --xbox;

    /* Function Body */
    for (i__ = 1; i__ <= 4; ++i__) {
/*<          XBOX(I) = X0 >*/
	xbox[i__] = *x0;
/*<          YBOX(I) = Y0 >*/
	ybox[i__] = *y0;
/*<  10   CONTINUE >*/
/* L10: */
    }

/* Check that there is something to be plotted. */

/*<       IF (LEN(STRING).LE.0) RETURN >*/
    if (i_len(string, string_len) <= 0) {
	return 0;
    }

/* Check that a device is selected. */

/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*<           CALL GRWARN('GRQTXT - no graphics device is active.') >*/
	grwarn_("GRQTXT - no graphics device is active.", (ftnlen)38);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/*<       XORG = GRXPRE(GRCIDE) >*/
    xorg = grcm00_1.grxpre[grcm00_1.grcide - 1];
/*<       YORG = GRYPRE(GRCIDE) >*/
    yorg = grcm00_1.grypre[grcm00_1.grcide - 1];

/* Compute scaling and orientation. */

/*<       ANGLE = ORIENT*(3.14159265359/180.) >*/
    angle = *orient * (float).017453292519944444;
/*<       FACTOR = GRCFAC(GRCIDE)/2.5 >*/
    factor = grcm00_1.grcfac[grcm00_1.grcide - 1] / (float)2.5;
/*<       RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE) >*/
    ratio = grcm00_1.grpxpi[grcm00_1.grcide - 1] / grcm00_1.grpypi[
	    grcm00_1.grcide - 1];
/*<       COSA = FACTOR * COS(ANGLE) >*/
    cosa = factor * cos(angle);
/*<       SINA = FACTOR * SIN(ANGLE) >*/
    sina = factor * sin(angle);
/*<       XORG = X0 >*/
    xorg = *x0;
/*<       YORG = Y0 >*/
    yorg = *y0;

/* Convert the string to a list of symbol numbers; to prevent overflow */
/* of array LIST, the length of STRING is limited to 256 characters. */

/*<    >*/
/* Computing MIN */
    i__1 = 256, i__2 = i_len(string, string_len);
    grsyds_(list, &nlist, string, &grcm00_1.grcfnt[grcm00_1.grcide - 1], (min(
	    i__1,i__2)));

/* Run through the string of characters, getting bounding box */
/* in character coordinates. (XG, YG) is the starting point */
/* of the current character. The x/y limits of the bbox are */
/* XGMIN...XGMAX, YGMIN...YGMAX. */

/*<       FNTBAS = 0.0 >*/
    fntbas = (float)0.;
/*<       FNTFAC = 1.0 >*/
    fntfac = (float)1.;
/*<       IFNTLV = 0 >*/
    ifntlv = 0;
/*<       DX = 0.0 >*/
    dx = (float)0.;
/*<       DY = 0.0 >*/
    dy = (float)0.;
/*<       XG = 0.0 >*/
    xg = (float)0.;
/*<       YG = 0.0 >*/
    yg = (float)0.;
/*<       XGMIN = 1E30 >*/
    xgmin = (float)1e30;
/*<       XGMAX = -1E30 >*/
    xgmax = (float)-1e30;
/*<       YGMIN = 1E30 >*/
    ygmin = (float)1e30;
/*<       YGMAX = -1E30 >*/
    ygmax = (float)-1e30;
/*<       PLOT  = .FALSE. >*/
    plot = FALSE_;
/*<       DO 380 I=1,NLIST >*/
    i__1 = nlist;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           IF (LIST(I).LT.0) THEN >*/
	if (list[i__ - 1] < 0) {
/*<               IF (LIST(I).EQ.-1) THEN >*/
	    if (list[i__ - 1] == -1) {
/*                 ! up */
/*<                   IFNTLV = IFNTLV+1 >*/
		++ifntlv;
/*<                   FNTBAS = FNTBAS + 16.0*FNTFAC >*/
		fntbas += fntfac * (float)16.;
/*<                   FNTFAC = 0.75**ABS(IFNTLV) >*/
		i__2 = abs(ifntlv);
		fntfac = pow_ri(&c_b5, &i__2);
/*<               ELSE IF (LIST(I).EQ.-2) THEN >*/
	    } else if (list[i__ - 1] == -2) {
/*                 ! down */
/*<                   IFNTLV = IFNTLV-1 >*/
		--ifntlv;
/*<                   FNTFAC = 0.75**ABS(IFNTLV) >*/
		i__2 = abs(ifntlv);
		fntfac = pow_ri(&c_b5, &i__2);
/*<                   FNTBAS = FNTBAS - 16.0*FNTFAC >*/
		fntbas -= fntfac * (float)16.;
/*<               ELSE IF (LIST(I).EQ.-3) THEN >*/
	    } else if (list[i__ - 1] == -3) {
/*                 ! backspace */
/*<                   XG = XG - DX*FNTFAC >*/
		xg -= dx * fntfac;
/*<               END IF >*/
	    }
/*<               GOTO 380 >*/
	    goto L380;
/*<           END IF >*/
	}
/*<           CALL GRSYXD(LIST(I),XYGRID,UNUSED) >*/
	grsyxd_(&list[i__ - 1], xygrid, &unused);
/*<           VISBLE = .FALSE. >*/
	visble = FALSE_;
/*<           DX = XYGRID(5)-XYGRID(4) >*/
	dx = (real) (xygrid[4] - xygrid[3]);
/*<           K = 4 >*/
	k = 4;
/*<           LXLAST = -64 >*/
	lxlast = -64;
/*<           LYLAST = -64 >*/
	lylast = -64;
/*<   320     K = K+2 >*/
L320:
	k += 2;
/*<           LX = XYGRID(K) >*/
	lx = xygrid[k - 1];
/*<           LY = XYGRID(K+1) >*/
	ly = xygrid[k];
/*<           IF (LY.EQ.-64) GOTO 330 >*/
	if (ly == -64) {
	    goto L330;
	}
/*<           IF (LX.EQ.-64) THEN >*/
	if (lx == -64) {
/*<               VISBLE = .FALSE. >*/
	    visble = FALSE_;
/*<           ELSE >*/
	} else {
/*<               RLX = (LX - XYGRID(4))*FNTFAC >*/
	    rlx = (lx - xygrid[3]) * fntfac;
/*<               RLY = (LY - XYGRID(2))*FNTFAC + FNTBAS >*/
	    rly = (ly - xygrid[1]) * fntfac + fntbas;
/*<               IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN >*/
	    if (lx != lxlast || ly != lylast) {
/*<                   XGMIN = MIN(XGMIN,XG+RLX) >*/
/* Computing MIN */
		r__1 = xgmin, r__2 = xg + rlx;
		xgmin = dmin(r__1,r__2);
/*<                   XGMAX = MAX(XGMAX,XG+RLX) >*/
/* Computing MAX */
		r__1 = xgmax, r__2 = xg + rlx;
		xgmax = dmax(r__1,r__2);
/*<                   YGMIN = MIN(YGMIN,RLY) >*/
		ygmin = dmin(ygmin,rly);
/*<                   YGMAX = MAX(YGMAX,RLY) >*/
		ygmax = dmax(ygmax,rly);
/*<                   PLOT = .TRUE. >*/
		plot = TRUE_;
/*<               END IF >*/
	    }
/*<               VISBLE = .TRUE. >*/
	    visble = TRUE_;
/*<               LXLAST = LX >*/
	    lxlast = lx;
/*<               LYLAST = LY >*/
	    lylast = ly;
/*<           END IF >*/
	}
/*<           GOTO 320 >*/
	goto L320;
/*<   330     XG = XG + DX*FNTFAC >*/
L330:
	xg += dx * fntfac;
/*<   380 CONTINUE >*/
L380:
	;
    }

/* Check whether anything was plotted. */

/*<       IF (.NOT.PLOT) RETURN >*/
    if (! plot) {
	return 0;
    }

/* Expand the box a bit to allow for line-width. */

/*<       XGMIN = XGMIN - 5.0 >*/
    xgmin += (float)-5.;
/*<       XGMAX = XGMAX + 5.0 >*/
    xgmax += (float)5.;
/*<       YGMIN = YGMIN - 4.0 >*/
    ygmin += (float)-4.;
/*<       YGMAX = YGMAX + 4.0 >*/
    ygmax += (float)4.;

/* Convert bounding box to device coordinates. */

/*     WRITE (*,*) XGMIN, XGMAX, YGMIN, YGMAX */
/*<       XBOX(1) = XORG + (COSA*XGMIN - SINA*YGMIN)*RATIO >*/
    xbox[1] = xorg + (cosa * xgmin - sina * ygmin) * ratio;
/*<       YBOX(1) = YORG + (SINA*XGMIN + COSA*YGMIN) >*/
    ybox[1] = yorg + (sina * xgmin + cosa * ygmin);
/*<       XBOX(2) = XORG + (COSA*XGMIN - SINA*YGMAX)*RATIO >*/
    xbox[2] = xorg + (cosa * xgmin - sina * ygmax) * ratio;
/*<       YBOX(2) = YORG + (SINA*XGMIN + COSA*YGMAX) >*/
    ybox[2] = yorg + (sina * xgmin + cosa * ygmax);
/*<       XBOX(3) = XORG + (COSA*XGMAX - SINA*YGMAX)*RATIO >*/
    xbox[3] = xorg + (cosa * xgmax - sina * ygmax) * ratio;
/*<       YBOX(3) = YORG + (SINA*XGMAX + COSA*YGMAX) >*/
    ybox[3] = yorg + (sina * xgmax + cosa * ygmax);
/*<       XBOX(4) = XORG + (COSA*XGMAX - SINA*YGMIN)*RATIO >*/
    xbox[4] = xorg + (cosa * xgmax - sina * ygmin) * ratio;
/*<       YBOX(4) = YORG + (SINA*XGMAX + COSA*YGMIN) >*/
    ybox[4] = yorg + (sina * xgmax + cosa * ygmin);

/*<       END >*/
} /* grqtxt_ */

