/* /work2/ssa/pgplot/src/grsci.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__15 = 15;

/* *GRSCI -- set color index */
/* + */
/*<       SUBROUTINE GRSCI (IC) >*/
/* Subroutine */ int grsci_(ic)
integer *ic;
{
    static integer lchr, nbuf;
    static real rbuf[6];
    static integer color;
    extern /* Subroutine */ int grexec_();
    static integer ic1, ic2;
    extern /* Subroutine */ int grwarn_();
    static char chr[1];


/* GRPCKG: Set the color index for subsequent plotting. Calls to GRSCI */
/* are ignored for monochrome devices. The default color index is 1, */
/* usually white on a black background for video displays or black on a */
/* white background for printer plots. The color index is an integer in */
/* the range 0 to a device-dependent maximum. Color index 0 corresponds */
/* to the background color; lines may be "erased" by overwriting them */
/* with color index 0. */

/* Color indices 0-7 are predefined as follows: 0 = black (background */
/* color), 1 = white (default), 2 = red, 3 = green, 4 = blue, 5 = cyan */
/* (blue + green), 6 = magenta (red + blue), 7 = yellow (red + green). */
/* The assignment of colors to color indices can be changed with */
/* subroutine GRSCR (set color representation). */

/* Argument: */

/* IC (integer, input): the color index to be used for subsequent */
/*       plotting on the current device (in range 0-255). If the */
/*       index exceeds the device-dependent maximum, the result is */
/*       device-dependent. */
/* -- */
/* 11-Apr-1983 - [TJP]. */
/*  3-Jun-1984 - add GMFILE device [TJP]. */
/* 13-Jun-1984 - add code for TK4100 devices [TJP]. */
/*  2-Jul-1984 - add code for RETRO and VT125 (REGIS) devices [TJP]. */
/*  2-Oct-1984 - change REGIS to improve VT240 behavior [TJP]. */
/* 22-Dec-1984 - add PRTX, TRILOG, VERS and VV devices [TJP]. */
/* 29-Jan-1985 - add HP2648 device [KS/TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 21-Feb-1987 - delays setting color if picture not open [AFT]. */
/* 11-Jun-1987 - remove built-in devices [TJP]. */
/* 31-May-1989 - add check for valid color index [TJP]. */
/*  1-Sep-1994 - use common data [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER  IC, COLOR, IC1, IC2, NBUF,LCHR >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     RBUF(6) >*/
/*<       CHARACTER*1 CHR >*/

/* Error if no workstation is open. */

/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*<           CALL GRWARN('GRSCI - no graphics device is active.') >*/
	grwarn_("GRSCI - no graphics device is active.", (ftnlen)37);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Use color index 1 if out of range. */

/*<       IC1 = GRMNCI(GRCIDE) >*/
    ic1 = grcm00_1.grmnci[grcm00_1.grcide - 1];
/*<       IC2 = GRMXCI(GRCIDE) >*/
    ic2 = grcm00_1.grmxci[grcm00_1.grcide - 1];
/*<       COLOR = IC >*/
    color = *ic;
/*<       IF (COLOR.LT.IC1 .OR. COLOR.GT.IC2) COLOR = 1 >*/
    if (color < ic1 || color > ic2) {
	color = 1;
    }

/* If no change to color index is requested, take no action. */

/*<       IF (COLOR.EQ.GRCCOL(GRCIDE)) RETURN >*/
    if (color == grcm00_1.grccol[grcm00_1.grcide - 1]) {
	return 0;
    }

/* If the workstation is in "picture open" state, send command to */
/* driver. */

/*<       IF (GRPLTD(GRCIDE)) THEN >*/
    if (grcm00_1.grpltd[grcm00_1.grcide - 1]) {
/*<           RBUF(1) = COLOR >*/
	rbuf[0] = (real) color;
/*<           CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__15, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*<       END IF >*/
    }

/* Set the current color index. */

/*<       GRCCOL(GRCIDE)=COLOR >*/
    grcm00_1.grccol[grcm00_1.grcide - 1] = color;

/*<       END >*/
} /* grsci_ */

