/* /work2/ssa/pgplot/src/grsets.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__6 = 6;
static integer c__2 = 2;

/* *GRSETS -- change size of view surface */
/* + */
/*<       SUBROUTINE GRSETS (IDENT,XSIZE,YSIZE) >*/
/* Subroutine */ int grsets_(ident, xsize, ysize)
integer *ident;
real *xsize, *ysize;
{
    /* Builtin functions */
    integer i_nint();

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[6];
    static integer i__, j, ix, iy;
    extern /* Subroutine */ int grpage_(), grexec_(), grslct_();
    static char chr[1];


/* GRPCKG : change size of plotting area. The requested dimensions */
/* will be reduced to the absolute maximum of the plot device if */
/* necessary. */

/* Arguments: */

/* IDENT (input, integer): plot identifier from GROPEN. */
/* XSIZE (input, real): new x dimension of plot area (absolute */
/*               units); if less than zero, the default dimension */
/*               will be used. */
/* YSIZE (input, real): new y dimension of plot area (absolute */
/*               units); if less than zero, the default dimension */
/*               will be used. */
/* -- */
/* (1-Feb-1983) */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/*  5-Jan-1993 - set GRADJU [TJP]. */
/* ------------------------------------------------------------------------ */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER  I, IDENT, J, IX, IY, NBUF,LCHR >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     RBUF(6) >*/
/*<       CHARACTER CHR >*/
/*<       REAL     XSIZE,YSIZE >*/

/*<       CALL GRSLCT(IDENT) >*/
    grslct_(ident);
/*     write (*,*) 'GRSETS: old size', GRXMXA(IDENT), GRYMXA(IDENT) */
/*<       CALL GRPAGE >*/
    grpage_();
/*<       IF ((XSIZE .LT. 0.0) .OR. (YSIZE .LT. 0.0)) THEN >*/
    if (*xsize < (float)0. || *ysize < (float)0.) {
/*<           CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__6, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*<           GRXMXA(IDENT) = RBUF(2) >*/
	grcm00_1.grxmxa[*ident - 1] = rbuf[1];
/*<           GRYMXA(IDENT) = RBUF(4) >*/
	grcm00_1.grymxa[*ident - 1] = rbuf[3];
/*<       ELSE >*/
    } else {
/*<           I = NINT(XSIZE) >*/
	i__ = i_nint(xsize);
/*<           J = NINT(YSIZE) >*/
	j = i_nint(ysize);
/*<           CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__2, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*<           IX=RBUF(2) >*/
	ix = rbuf[1];
/*<           IY=RBUF(4) >*/
	iy = rbuf[3];
/*<           IF (IX.GT.0) I = MIN(I,IX) >*/
	if (ix > 0) {
	    i__ = min(i__,ix);
	}
/*<           IF (IY.GT.0) J = MIN(J,IY) >*/
	if (iy > 0) {
	    j = min(j,iy);
	}
/*<           GRXMXA(IDENT) = I >*/
	grcm00_1.grxmxa[*ident - 1] = i__;
/*<           GRYMXA(IDENT) = J >*/
	grcm00_1.grymxa[*ident - 1] = j;
/*<       END IF >*/
    }
/*     write (*,*) 'GRSETS: new size', GRXMXA(IDENT), GRYMXA(IDENT) */
/*<       GRXMIN(IDENT) = 0 >*/
    grcm00_1.grxmin[*ident - 1] = (float)0.;
/*<       GRXMAX(IDENT) = GRXMXA(IDENT) >*/
    grcm00_1.grxmax[*ident - 1] = (real) grcm00_1.grxmxa[*ident - 1];
/*<       GRYMIN(IDENT) = 0 >*/
    grcm00_1.grymin[*ident - 1] = (float)0.;
/*<       GRYMAX(IDENT) = GRYMXA(IDENT) >*/
    grcm00_1.grymax[*ident - 1] = (real) grcm00_1.grymxa[*ident - 1];
/*<       GRADJU(IDENT) = .TRUE. >*/
    grcm00_1.gradju[*ident - 1] = TRUE_;

/*<       END >*/
} /* grsets_ */

