/* /work2/ssa/pgplot/src/grskpb.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRSKPB -- skip blanks in character string */
/* + */
/*<       SUBROUTINE GRSKPB (S, I) >*/
/* Subroutine */ int grskpb_(s, i__, s_len)
char *s;
integer *i__;
ftnlen s_len;
{
    /* Builtin functions */
    integer i_len();

/*<       CHARACTER*(*) S >*/
/*<       INTEGER I >*/

/* GRSKPB: increment I so that it points to the next non-blank */
/* character in string S.  'Blank' characters are space and tab (ASCII */
/* character value 9). */

/* Arguments: */
/*  S      (input)  : character string to be parsed. */
/*  I      (in/out) : on input, I is the index of the first character */
/*                    in S to be examined; on output, either it points */
/*                    to the next non-blank character, or it is equal */
/*                    to LEN(S)+1 (if all the rest of the string is */
/*                    blank). */
/* -- */
/*  1985 Oct 8 - New routine, based on SKIPBL (T. J. Pearson). */
/* ----------------------------------------------------------------------- */

/*<    10 IF (I.GT.LEN(S)) RETURN >*/
L10:
    if (*i__ > i_len(s, s_len)) {
	return 0;
    }
/*<       IF (S(I:I).NE.' ' .AND. S(I:I).NE.CHAR(9)) RETURN >*/
    if (*(unsigned char *)&s[*i__ - 1] != ' ' && *(unsigned char *)&s[*i__ - 
	    1] != '\t') {
	return 0;
    }
/*<       I = I+1 >*/
    ++(*i__);
/*<       GOTO 10 >*/
    goto L10;
/*<       END >*/
} /* grskpb_ */

