/* /work2/ssa/pgplot/src/grslct.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__8 = 8;

/* *GRSLCT -- select active output device */
/* + */
/*<       SUBROUTINE GRSLCT (IDENT) >*/
/* Subroutine */ int grslct_(ident)
integer *ident;
{
    static integer lchr, nbuf;
    static real rbuf[6];
    extern /* Subroutine */ int grexec_(), grwarn_();
    static char chr[1];


/* GRPCKG: Check that IDENT is a valid plot identifier, and select the */
/* corresponding plot as the current plot. All subsequent plotting will */
/* be directed to this device until the assignment is changed by another */
/* call to GRSLCT. */

/* Argument: */

/* IDENT (input, integer): the identifier of the plot to be selected, as */
/*       returned by GROPEN. */
/* -- */
/* (1-Feb-1983) */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/*  4-Jun-1987 - skip action if no change in ID [TJP]. */
/* 26-Nov-1990 - [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       REAL     RBUF(6) >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER  IDENT, NBUF,LCHR >*/
/*<       CHARACTER CHR >*/

/*<    >*/
    if (*ident <= 0 || *ident > 8 || grcm00_1.grstat[*ident - 1] == 0) {
/*<          CALL GRWARN('GRSLCT - invalid plot identifier.') >*/
	grwarn_("GRSLCT - invalid plot identifier.", (ftnlen)33);
/*<       ELSE IF (IDENT.EQ.GRCIDE) THEN >*/
    } else if (*ident == grcm00_1.grcide) {
/*<          GRGTYP = GRTYPE(IDENT) >*/
	grcm00_1.grgtyp = grcm00_1.grtype[*ident - 1];
/*<          RETURN >*/
	return 0;
/*<       ELSE >*/
    } else {
/*<          GRCIDE = IDENT >*/
	grcm00_1.grcide = *ident;
/*<          GRGTYP = GRTYPE(IDENT) >*/
	grcm00_1.grgtyp = grcm00_1.grtype[*ident - 1];
/*<          RBUF(1)= GRCIDE >*/
	rbuf[0] = (real) grcm00_1.grcide;
/*<          RBUF(2)= GRUNIT(GRCIDE) >*/
	rbuf[1] = (real) grcm00_1.grunit[grcm00_1.grcide - 1];
/*<          NBUF   = 2 >*/
	nbuf = 2;
/*<          CALL GREXEC(GRGTYP, 8,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__8, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*<       END IF >*/
    }
/*<       END >*/
} /* grslct_ */

