/* /work2/ssa/pgplot/src/grslw.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__22 = 22;

/* *GRSLW -- set line width */
/* + */
/*<       SUBROUTINE GRSLW (IW) >*/
/* Subroutine */ int grslw_(iw)
integer *iw;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[1];
    static integer i__, ithick;
    extern /* Subroutine */ int grexec_(), grwarn_();
    static char chr[32];

/*<       INTEGER IW >*/

/* GRPCKG: Set the line width for subsequent plotting on the current */
/* device. If the hardware does not support thick lines, they are */
/* simulated by tracing each line with multiple strokes offset in the */
/* direction perpendicular to the line. The line width is specified by */
/* the number of strokes to be used, which must be in the range 1-201. */
/* The actual line width obtained depends on the device resolution. */
/* If the hardware does support thick lines, the width of the line */
/* is approximately 0.005 inches times the value of argument IW. */

/* Argument: */

/* IW (integer, input): the number of strokes to be used for subsequent */
/*       plotting on the current device (in range 1-201). */
/* -- */
/*  1-Feb-1983 [TJP]. */
/*  3-Jun-1984 [TJP] - add GMFILE device. */
/* 28-Aug-1984 [TJP] - correct bug in GMFILE: redundant SET_LINEWIDTH */
/*                     commands were not being filtered out. */
/* 26-May-1987 [TJP] - add GREXEC support. */
/* 11-Jun-1987 [TJP] - remove built-in devices. */
/* 31-May-1989 [TJP] - increase maximum width from 21 to 201. */
/*  1-Sep-1994 [TJP] */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER I, ITHICK >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL    RBUF(1) >*/
/*<       INTEGER NBUF,LCHR >*/
/*<       CHARACTER*32 CHR >*/

/* Check that graphics is active. */

/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*<           CALL GRWARN('GRSLW - no graphics device is active.') >*/
	grwarn_("GRSLW - no graphics device is active.", (ftnlen)37);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Check that requested line-width is valid. */

/*<       I = IW >*/
    i__ = *iw;
/*<       IF (I.LT.1 .OR. I.GT.201) THEN >*/
    if (i__ < 1 || i__ > 201) {
/*<           CALL GRWARN('GRSLW - invalid line-width requested.') >*/
	grwarn_("GRSLW - invalid line-width requested.", (ftnlen)37);
/*<           I = 1 >*/
	i__ = 1;
/*<       END IF >*/
    }

/* Ignore the request if the linewidth is unchanged. */

/*<       IF (I.EQ.ABS(GRWIDT(GRCIDE))) RETURN >*/
    if (i__ == (i__1 = grcm00_1.grwidt[grcm00_1.grcide - 1], abs(i__1))) {
	return 0;
    }

/* Inquire if hardware supports thick lines. */

/*<       ITHICK = 0 >*/
    ithick = 0;
/*<       IF (GRGCAP(GRCIDE)(5:5).EQ.'T') ITHICK = 1 >*/
    if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 4] == 
	    'T') {
	ithick = 1;
    }

/* For devices with hardware support of thick lines, send the */
/* appropriate commands to the device driver, and give the "current */
/* linewidth" parameter a negative value to suppress software linewidth */
/* emulation. */

/*<       IF (ITHICK.EQ.1 .AND. GRPLTD(GRCIDE)) THEN >*/
    if (ithick == 1 && grcm00_1.grpltd[grcm00_1.grcide - 1]) {
/*<           RBUF(1) = I >*/
	rbuf[0] = (real) i__;
/*<           CALL GREXEC(GRGTYP,22,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__22, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<       END IF >*/
    }

/* Save the current linewidth. */

/*<       GRWIDT(GRCIDE) = I >*/
    grcm00_1.grwidt[grcm00_1.grcide - 1] = i__;
/*<       IF (ITHICK.EQ.1) GRWIDT(GRCIDE) = -I >*/
    if (ithick == 1) {
	grcm00_1.grwidt[grcm00_1.grcide - 1] = -i__;
    }

/*<       END >*/
} /* grslw_ */

