/* /work2/ssa/pgplot/sys_linux/f77_src/grsy00.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer nc1, nc2, index[3000];
    char buffer[54000];
} grsymb_;

#define grsymb_1 grsymb_

/* Table of constant values */

static integer c__1 = 1;
static integer c__3000 = 3000;
static integer c__27000 = 27000;
static integer c__2 = 2;

/* *GRSY00 -- initialize font definition */
/* + */
/*<       SUBROUTINE GRSY00 >*/
/* Subroutine */ int grsy00_()
{
    /* System generated locals */
    address a__1[2];
    integer i__1[2];
    char ch__1[154];
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    integer f_open(), s_rsue(), do_uio(), e_rsue(), f_clos();
    /* Subroutine */ int s_cat();

    /* Local variables */
    static integer l;
    static char ff[128];
    extern /* Subroutine */ int grgfil_();
    static integer fntfil;
    extern /* Subroutine */ int grflun_(), grglun_(), grwarn_();
    static integer nc3;
    extern integer grtrim_();
    static integer ier;

    /* Fortran I/O blocks */
    static cilist io___5 = { 1, 0, 1, 0, 0 };



/* This routine must be called once in order to initialize the tables */
/* defining the symbol numbers to be used for ASCII characters in each */
/* font, and to read the character digitization from a file. */

/* Arguments: none. */

/* Implicit input: */
/*  The file with name specified in environment variable PGPLOT_FONT */
/*  is read, if it is available. */
/*  This is a binary file containing two arrays INDEX and BUFFER. */
/*  The digitization of each symbol occupies a number of words in */
/*  the INTEGER*2 array BUFFER; the start of the digitization */
/*  for symbol number N is in BUFFER(INDEX(N)), where INDEX is an */
/*  integer array of 3000 elements. Not all symbols 1...3000 have */
/*  a representation; if INDEX(N) = 0, the symbol is undefined. */

/*  PGPLOT uses the Hershey symbols for two `primitive' operations: */
/*  graph markers and text.  The Hershey symbol set includes several */
/*  hundred different symbols in a digitized form that allows them to */
/*  be drawn with a series of vectors (polylines). */

/*  The digital representation of all the symbols is stored in common */
/*  block /GRSYMB/.  This is read from a disk file at run time. The */
/*  name of the disk file is specified in environment variable */
/*  PGPLOT_FONT. */

/* Modules: */

/* GRSY00 -- initialize font definition */
/* GRSYDS -- decode character string into list of symbol numbers */
/* GRSYMK -- convert marker number into symbol number */
/* GRSYXD -- obtain the polyline representation of a given symbol */

/* PGPLOT calls these routines as follows: */

/* Routine          Called by */

/* GRSY00          GROPEN */
/* GRSYDS          GRTEXT, GRLEN */
/* GRSYMK          GRMKER, */
/* GRSYXD          GRTEXT, GRLEN, GRMKER */
/* ********************************************************************** */
/* -- */
/* (2-Jan-1984) */
/* 22-Jul-1984 - revise to use DATA statements [TJP]. */
/*  5-Jan-1985 - make missing font file non-fatal [TJP]. */
/*  9-Feb-1988 - change default file name to Unix name; overridden */
/*               by environment variable PGPLOT_FONT [TJP]. */
/* 29-Nov-1990 - move font assignment to GRSYMK. */
/*  7-Nov-1994 - look for font file in PGPLOT_DIR if PGPLOT_FONT is */
/*               undefined [TJP]. */
/* Hacked version -- uses CHARACTER*2 since G77 does not support INTEGER*2 */
/*   B. Toby 11/18/95 */
/* ----------------------------------------------------------------------- */
/*      INTEGER*2  BUFFER(27000) */
/*<       CHARACTER*2  BUFFER(27000) >*/
/*<       INTEGER    FNTFIL, IER, INDEX(3000), NC1, NC2, NC3 >*/
/*<       INTEGER    L, GRTRIM >*/
/*<       COMMON     /GRSYMB/ NC1, NC2, INDEX, BUFFER >*/
/*<       CHARACTER*128 FF >*/

/* Read the font file. If an I/O error occurs, it is ignored; the */
/* effect will be that all symbols will be undefined (treated as */
/* blank spaces). */

/*<       CALL GRGFIL('FONT', FF) >*/
    grgfil_("FONT", ff, (ftnlen)4, (ftnlen)128);
/*<       L = GRTRIM(FF) >*/
    l = grtrim_(ff, (ftnlen)128);
/*<       IF (L.LT.1) L = 1 >*/
    if (l < 1) {
	l = 1;
    }
/*<       CALL GRGLUN(FNTFIL) >*/
    grglun_(&fntfil);
/*<    >*/
    o__1.oerr = 1;
    o__1.ounit = fntfil;
    o__1.ofnmlen = l;
    o__1.ofnm = ff;
    o__1.orl = 0;
    o__1.osta = "OLD";
    o__1.oacc = 0;
    o__1.ofm = "UNFORMATTED";
    o__1.oblnk = 0;
    ier = f_open(&o__1);
/*<    >*/
    if (ier == 0) {
	io___5.ciunit = fntfil;
	ier = s_rsue(&io___5);
	if (ier != 0) {
	    goto L100001;
	}
	ier = do_uio(&c__1, (char *)&grsymb_1.nc1, (ftnlen)sizeof(integer));
	if (ier != 0) {
	    goto L100001;
	}
	ier = do_uio(&c__1, (char *)&grsymb_1.nc2, (ftnlen)sizeof(integer));
	if (ier != 0) {
	    goto L100001;
	}
	ier = do_uio(&c__1, (char *)&nc3, (ftnlen)sizeof(integer));
	if (ier != 0) {
	    goto L100001;
	}
	ier = do_uio(&c__3000, (char *)&grsymb_1.index[0], (ftnlen)sizeof(
		integer));
	if (ier != 0) {
	    goto L100001;
	}
	ier = do_uio(&c__27000, grsymb_1.buffer, (ftnlen)2);
	if (ier != 0) {
	    goto L100001;
	}
	ier = e_rsue();
L100001:
	;
    }
/*<       IF (IER.EQ.0) CLOSE (UNIT=FNTFIL, IOSTAT=IER) >*/
    if (ier == 0) {
	cl__1.cerr = 1;
	cl__1.cunit = fntfil;
	cl__1.csta = 0;
	ier = f_clos(&cl__1);
    }
/*<       CALL GRFLUN(FNTFIL) >*/
    grflun_(&fntfil);
/*<       IF (IER.NE.0) THEN >*/
    if (ier != 0) {
/*<           CALL GRWARN('Unable to read font file: '//FF(:L)) >*/
/* Writing concatenation */
	i__1[0] = 26, a__1[0] = "Unable to read font file: ";
	i__1[1] = l, a__1[1] = ff;
	s_cat(ch__1, a__1, i__1, &c__2, (ftnlen)154);
	grwarn_(ch__1, l + 26);
/*<    >*/
	grwarn_("Use environment variable PGPLOT_FONT to specify the locatio\
n of the PGPLOT grfont.dat file.", (ftnlen)91);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* grsy00_ */

