/* /work2/ssa/pgplot/drivers/nudriv.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__2 = 2;
static integer c__0 = 0;

/* *NUDRIV -- PGPLOT Null device driver */
/* + */
/*<       SUBROUTINE NUDRIV (IFUNC, RBUF, NBUF, CHR, LCHR) >*/
/* Subroutine */ int nudriv_(ifunc, rbuf, nbuf, chr, lchr, chr_len)
integer *ifunc;
real *rbuf;
integer *nbuf;
char *chr;
integer *lchr;
ftnlen chr_len;
{
    /* Initialized data */

    static integer active = -1;
    static integer state[9] = { 0,0,0,0,0,0,0,0,0 };
    static integer count[29] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	    0,0,0,0,0,0,0 };
    static logical debug = FALSE_;
    static char lab[8*29+1] = "qdev    qmaxsizeqscale  qcapab  qdefnam qdefs\
izeqmisc   select  open    close   beginpicline    dot     endpic  set CI  f\
lush   cursor  eralpha set LS  polygon set CR  set LW  escape  rectanglset p\
attpix/imagscaling marker  query CR";
    static integer cdeflt[48]	/* was [3][16] */ = { 0,0,0,255,255,255,255,0,
	    0,0,255,0,0,0,255,0,255,255,255,0,255,255,255,0,255,128,0,128,255,
	    0,0,255,128,0,128,255,128,0,255,255,0,128,85,85,85,170,170,170 };

    /* System generated locals */
    address a__1[2];
    integer i__1[2];
    real r__1;
    char ch__1[56];

    /* Builtin functions */
    integer s_wsfi(), do_fio(), e_wsfi();
    /* Subroutine */ int s_cat(), s_copy();
    integer i_len(), i_nint();

    /* Local variables */
    static integer npic[8];
    static char text[32];
    static integer i__, l;
    extern /* Subroutine */ int grfao_(), grnu00_();
    static integer ctable[768]	/* was [3][256] */;
    extern /* Subroutine */ int grgenv_(), grwarn_();
    static char msg[10];

    /* Fortran I/O blocks */
    static icilist io___10 = { 0, msg, 0, "(I10)", 10, 1 };
    static icilist io___14 = { 0, text, 0, "(3X,I2,1X,A8,I10)", 32, 1 };


/*<       INTEGER IFUNC, NBUF, LCHR >*/
/*<       REAL    RBUF(*) >*/
/*<       CHARACTER*(*) CHR >*/

/* PGPLOT driver for Null device (no graphical output) */

/* Version 1.0  - 1987 May 26 - T. J. Pearson. */
/* Version 1.1  - 1988 Mar 23 - add rectangle fill. */
/* Version 1.2  - 1992 Sep  3 - add line-of-pixels. */
/* Version 1.3  - 1992 Sep 21 - add markers. */
/* Version 1.4  - 1993 Apr 22 - add optional debugging. */
/* Version 1.5  - 1994 Aug 31 - use image primitives. */
/* Version 2.0  - 1996 Jan 22 - allow multiple active devices; */
/*                              add QCR primitive. */
/* Version 2.1  - 1997 Jun 13 - correctly initialize STATE. */

/* Supported device: The ``null'' device can be used to suppress */
/* all graphic output from a program.  If environment variable */
/* PGPLOT_DEBUG is defined, some debugging information is */
/* reported on standard output. */

/* Device type code: /NULL. */

/* Default device name: None (the device name, if specified, is */
/* ignored). */

/* Default view surface dimensions: Undefined (The device pretends to */
/* be a hardcopy device with 1000 pixels/inch and a view surface 8in */
/* high by 10.5in wide.) */

/* Resolution: Undefined. */

/* Color capability: Color indices 0--255 are accepted. */

/* Input capability: None. */

/* File format: None. */

/* Obtaining hardcopy: Not possible. */
/* ----------------------------------------------------------------------- */
/* Notes: */
/*  Up to MAXDEV "devices" may be open at once. ACTIVE is the number */
/*  of the currently selected device, or 0 if no devices are open. */
/*  STATE(i) is 0 if device i is not open, 1 if it is open but with */
/*  no current picture, or 2 if it is open with a current picture. */

/*  When debugging is enabled, open/close device and begin/end picture */
/*  calls are reported on stdout, and a cumulative count of all */
/*  driver calls is kept. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*(*) DEVICE >*/
/*<       PARAMETER (DEVICE='NULL  (Null device, no output)') >*/
/*<       INTEGER MAXDEV, MAXD1 >*/
/*<       PARAMETER (MAXDEV=8) >*/
/*<       PARAMETER (MAXD1=MAXDEV+1) >*/
/*<       INTEGER NOPCOD >*/
/*<       PARAMETER (NOPCOD=29) >*/
/*<       CHARACTER*10 MSG >*/
/*<       CHARACTER*32 TEXT >*/
/*<       CHARACTER*8  LAB(NOPCOD) >*/
/*<       INTEGER COUNT(NOPCOD), I, STATE(0:MAXDEV), L, NPIC(MAXDEV) >*/
/*<       INTEGER ACTIVE >*/
/*<       LOGICAL DEBUG >*/
/*<       INTEGER CTABLE(3,0:255), CDEFLT(3,0:15) >*/
/*<       SAVE COUNT, STATE, NPIC, DEBUG, CTABLE, CDEFLT, ACTIVE >*/

/*<       DATA ACTIVE/-1/ >*/
    /* Parameter adjustments */
    --rbuf;

    /* Function Body */
/*<       DATA STATE/MAXD1*0/ >*/
/*<       DATA COUNT/NOPCOD*0/ >*/
/*<       DATA DEBUG/.FALSE./ >*/
/*<    >*/
/*<    >*/
/* ----------------------------------------------------------------------- */

/*<       IF (ACTIVE.EQ.-1) THEN >*/
    if (active == -1) {
/*<            CALL GRGENV('DEBUG', TEXT, L) >*/
	grgenv_("DEBUG", text, &l, (ftnlen)5, (ftnlen)32);
/*<            DEBUG = L.GT.0 >*/
	debug = l > 0;
/*<            ACTIVE = 0 >*/
	active = 0;
/*<       END IF >*/
    }

/*<       IF (IFUNC.LT.1 .OR. IFUNC.GT.NOPCOD) GOTO 900 >*/
    if (*ifunc < 1 || *ifunc > 29) {
	goto L900;
    }
/*<       COUNT(IFUNC) = COUNT(IFUNC) + 1 >*/
    ++count[*ifunc - 1];
/*<    >*/
    switch ((int)*ifunc) {
	case 1:  goto L10;
	case 2:  goto L20;
	case 3:  goto L30;
	case 4:  goto L40;
	case 5:  goto L50;
	case 6:  goto L60;
	case 7:  goto L70;
	case 8:  goto L80;
	case 9:  goto L90;
	case 10:  goto L100;
	case 11:  goto L110;
	case 12:  goto L120;
	case 13:  goto L130;
	case 14:  goto L140;
	case 15:  goto L150;
	case 16:  goto L160;
	case 17:  goto L170;
	case 18:  goto L180;
	case 19:  goto L190;
	case 20:  goto L200;
	case 21:  goto L210;
	case 22:  goto L220;
	case 23:  goto L230;
	case 24:  goto L240;
	case 25:  goto L250;
	case 26:  goto L260;
	case 27:  goto L270;
	case 28:  goto L280;
	case 29:  goto L290;
    }
/*<   900 WRITE (MSG, '(I10)') IFUNC >*/
L900:
    s_wsfi(&io___10);
    do_fio(&c__1, (char *)&(*ifunc), (ftnlen)sizeof(integer));
    e_wsfi();
/*<       CALL GRWARN('Unimplemented function in NULL device driver: '//MSG) >*/
/* Writing concatenation */
    i__1[0] = 46, a__1[0] = "Unimplemented function in NULL device driver: ";
    i__1[1] = 10, a__1[1] = msg;
    s_cat(ch__1, a__1, i__1, &c__2, (ftnlen)56);
    grwarn_(ch__1, (ftnlen)56);
/*<       NBUF = -1 >*/
    *nbuf = -1;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 1, Return device name.------------------------------------- */

/*<    10 CHR = DEVICE >*/
L10:
    s_copy(chr, "NULL  (Null device, no output)", chr_len, (ftnlen)30);
/*<       LCHR = LEN(DEVICE) >*/
    *lchr = i_len("NULL  (Null device, no output)", (ftnlen)30);
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 2, Return physical min and max for plot device, and range */
/*               of color indices.--------------------------------------- */

/*<    20 RBUF(1) = 0 >*/
L20:
    rbuf[1] = (float)0.;
/*<       RBUF(2) = 65535 >*/
    rbuf[2] = (float)65535.;
/*<       RBUF(3) = 0 >*/
    rbuf[3] = (float)0.;
/*<       RBUF(4) = 65535 >*/
    rbuf[4] = (float)65535.;
/*<       RBUF(5) = 0 >*/
    rbuf[5] = (float)0.;
/*<       RBUF(6) = 255 >*/
    rbuf[6] = (float)255.;
/*<       NBUF = 6 >*/
    *nbuf = 6;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 3, Return device resolution. ------------------------------ */

/*<    30 RBUF(1) = 1000.0 >*/
L30:
    rbuf[1] = (float)1e3;
/*<       RBUF(2) = 1000.0 >*/
    rbuf[2] = (float)1e3;
/*<       RBUF(3) = 1 >*/
    rbuf[3] = (float)1.;
/*<       NBUF = 3 >*/
    *nbuf = 3;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 4, Return misc device info. ------------------------------- */
/*    (This device is Hardcopy, No cursor, Dashed lines, Area fill, Thick */
/*    lines, Rectangle fill, Images, , , Markers, query color rep) */

/*<    40 CHR = 'HNDATRQNYM' >*/
L40:
    s_copy(chr, "HNDATRQNYM", chr_len, (ftnlen)10);
/*<       LCHR = 10 >*/
    *lchr = 10;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 5, Return default file name. ------------------------------ */

/*<    50 CHR = 'NL:' >*/
L50:
    s_copy(chr, "NL:", chr_len, (ftnlen)3);
/*<       LCHR = 3 >*/
    *lchr = 3;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 6, Return default physical size of plot. ------------------ */

/*<    60 RBUF(1) = 0 >*/
L60:
    rbuf[1] = (float)0.;
/*<       RBUF(2) = 10499 >*/
    rbuf[2] = (float)10499.;
/*<       RBUF(3) = 0 >*/
    rbuf[3] = (float)0.;
/*<       RBUF(4) = 7999 >*/
    rbuf[4] = (float)7999.;
/*<       NBUF = 4 >*/
    *nbuf = 4;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 7, Return misc defaults. ---------------------------------- */

/*<    70 RBUF(1) = 1 >*/
L70:
    rbuf[1] = (float)1.;
/*<       NBUF = 1 >*/
    *nbuf = 1;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 8, Select plot. ------------------------------------------- */

/*<    80 CONTINUE >*/
L80:
/*<       I = RBUF(2) - 67890 >*/
    i__ = rbuf[2] - 67890;
/*<       IF (I.LT.1 .OR. I.GT.MAXDEV) THEN >*/
    if (i__ < 1 || i__ > 8) {
/*<          CALL GRWARN('internal error: NULL opcode 8') >*/
	grwarn_("internal error: NULL opcode 8", (ftnlen)29);
/*<       ELSE IF (STATE(I).GT.0) THEN >*/
    } else if (state[i__] > 0) {
/*<          ACTIVE = I >*/
	active = i__;
/*<       ELSE >*/
    } else {
/*<          CALL GRNU00(IFUNC,0) >*/
	grnu00_(ifunc, &c__0);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 9, Open workstation. -------------------------------------- */

/*<    90 CONTINUE >*/
L90:
/*     -- Find an inactive device, and select it */
/*<       DO 91 I=1,MAXDEV >*/
    for (i__ = 1; i__ <= 8; ++i__) {
/*<          IF (STATE(I).EQ.0) THEN >*/
	if (state[i__] == 0) {
/*<             ACTIVE = I >*/
	    active = i__;
/*<             STATE(ACTIVE) = 1 >*/
	    state[active] = 1;
/*<             GOTO 92 >*/
	    goto L92;
/*<          END IF >*/
	}
/*<  91   CONTINUE >*/
/* L91: */
    }
/*<       IF (DEBUG) CALL GRWARN ('09 Open workstation') >*/
    if (debug) {
	grwarn_("09 Open workstation", (ftnlen)19);
    }
/*<       CALL GRWARN('maximum number of devices of type NULL exceeded') >*/
    grwarn_("maximum number of devices of type NULL exceeded", (ftnlen)47);
/*<       RBUF(1) = 0 >*/
    rbuf[1] = (float)0.;
/*<       RBUF(2) = 0  >*/
    rbuf[2] = (float)0.;
/*<       NBUF = 2 >*/
    *nbuf = 2;
/*<       RETURN >*/
    return 0;
/*     -- Initialize the new device */
/*<  92   CONTINUE >*/
L92:
/*<       RBUF(1) = ACTIVE + 67890 >*/
    rbuf[1] = (real) (active + 67890);
/*<       RBUF(2) = 1 >*/
    rbuf[2] = (float)1.;
/*<       NBUF = 2 >*/
    *nbuf = 2;
/*<       NPIC(ACTIVE) = 0 >*/
    npic[active - 1] = 0;
/*     -- Initialize color table */
/*<       DO 95 I=0,15 >*/
    for (i__ = 0; i__ <= 15; ++i__) {
/*<          CTABLE(1,I) = CDEFLT(1,I) >*/
	ctable[i__ * 3] = cdeflt[i__ * 3];
/*<          CTABLE(2,I) = CDEFLT(2,I) >*/
	ctable[i__ * 3 + 1] = cdeflt[i__ * 3 + 1];
/*<          CTABLE(3,I) = CDEFLT(3,I) >*/
	ctable[i__ * 3 + 2] = cdeflt[i__ * 3 + 2];
/*<  95   CONTINUE >*/
/* L95: */
    }
/*<       DO 96 I=16,255 >*/
    for (i__ = 16; i__ <= 255; ++i__) {
/*<          CTABLE(1,I) = 128 >*/
	ctable[i__ * 3] = 128;
/*<          CTABLE(2,I) = 128 >*/
	ctable[i__ * 3 + 1] = 128;
/*<          CTABLE(3,I) = 128 >*/
	ctable[i__ * 3 + 2] = 128;
/*<  96   CONTINUE >*/
/* L96: */
    }
/*<       IF (DEBUG) THEN >*/
    if (debug) {
/*<    >*/
	grfao_("09 Open workstation: device #", &l, text, &active, &c__0, &
		c__0, &c__0, (ftnlen)29, (ftnlen)32);
/*<          CALL GRWARN(TEXT(1:L)) >*/
	grwarn_(text, l);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=10, Close workstation. -------------------------------------- */

/*<   100 CONTINUE >*/
L100:
/*<       IF (STATE(ACTIVE).NE.1) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 1) {
	grnu00_(ifunc, &state[active]);
    }
/*<       STATE(ACTIVE) = 0 >*/
    state[active] = 0;
/*<       IF (DEBUG) THEN >*/
    if (debug) {
/*<    >*/
	grfao_("10 Close workstation: device #", &l, text, &active, &c__0, &
		c__0, &c__0, (ftnlen)30, (ftnlen)32);
/*<          CALL GRWARN(TEXT(1:L)) >*/
	grwarn_(text, l);
/*<          CALL GRWARN('Device driver calls:') >*/
	grwarn_("Device driver calls:", (ftnlen)20);
/*<          DO 101 I=1,NOPCOD >*/
	for (i__ = 1; i__ <= 29; ++i__) {
/*<             IF (COUNT(I).GT.0) THEN >*/
	    if (count[i__ - 1] > 0) {
/*<                WRITE (TEXT,'(3X,I2,1X,A8,I10)') I, LAB(I), COUNT(I) >*/
		s_wsfi(&io___14);
		do_fio(&c__1, (char *)&i__, (ftnlen)sizeof(integer));
		do_fio(&c__1, lab + (i__ - 1 << 3), (ftnlen)8);
		do_fio(&c__1, (char *)&count[i__ - 1], (ftnlen)sizeof(integer)
			);
		e_wsfi();
/*<                CALL GRWARN(TEXT) >*/
		grwarn_(text, (ftnlen)32);
/*<             END IF >*/
	    }
/*<  101     CONTINUE >*/
/* L101: */
	}
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=11, Begin picture. ------------------------------------------ */

/*<   110 CONTINUE >*/
L110:
/*<       IF (STATE(ACTIVE).NE.1) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 1) {
	grnu00_(ifunc, &state[active]);
    }
/*<       STATE(ACTIVE) = 2 >*/
    state[active] = 2;
/*<       NPIC(ACTIVE) = NPIC(ACTIVE)+1 >*/
    ++npic[active - 1];
/*<       IF (DEBUG) THEN >*/
    if (debug) {
/*<    >*/
	grfao_("11   Begin picture # on device #", &l, text, &npic[active - 1]
		, &active, &c__0, &c__0, (ftnlen)32, (ftnlen)32);
/*<          CALL GRWARN(TEXT(:L)) >*/
	grwarn_(text, l);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=12, Draw line. ---------------------------------------------- */

/*<   120 CONTINUE >*/
L120:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=13, Draw dot. ----------------------------------------------- */

/*<   130 CONTINUE >*/
L130:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=14, End picture. -------------------------------------------- */

/*<   140 CONTINUE >*/
L140:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       STATE(ACTIVE) = 1 >*/
    state[active] = 1;
/*<       IF (DEBUG) THEN >*/
    if (debug) {
/*<    >*/
	grfao_("14   End picture   # on device #", &l, text, &npic[active - 1]
		, &active, &c__0, &c__0, (ftnlen)32, (ftnlen)32);
/*<          CALL GRWARN(TEXT(:L)) >*/
	grwarn_(text, l);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=15, Select color index. ------------------------------------- */

/*<   150 CONTINUE >*/
L150:
/*<       IF (STATE(ACTIVE).LT.1) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] < 1) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=16, Flush buffer. ------------------------------------------- */

/*<   160 CONTINUE >*/
L160:
/*<       IF (STATE(ACTIVE).LT.1) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] < 1) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=17, Read cursor. -------------------------------------------- */
/*    (Not implemented: should not be called.) */

/*<   170 GOTO 900 >*/
L170:
    goto L900;

/* --- IFUNC=18, Erase alpha screen. ------------------------------------- */

/*<   180 CONTINUE >*/
L180:
/*<       IF (STATE(ACTIVE).LT.1) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] < 1) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=19, Set line style. ----------------------------------------- */

/*<   190 CONTINUE >*/
L190:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=20, Polygon fill. ------------------------------------------- */

/*<   200 CONTINUE >*/
L200:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=21, Set color representation. ------------------------------- */

/*<   210 CONTINUE >*/
L210:
/*<       IF (STATE(ACTIVE).LT.1) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] < 1) {
	grnu00_(ifunc, &state[active]);
    }
/*<       I = RBUF(1) >*/
    i__ = rbuf[1];
/*<       CTABLE(1, I) = NINT(RBUF(2)*255) >*/
    r__1 = rbuf[2] * 255;
    ctable[i__ * 3] = i_nint(&r__1);
/*<       CTABLE(2, I) = NINT(RBUF(3)*255) >*/
    r__1 = rbuf[3] * 255;
    ctable[i__ * 3 + 1] = i_nint(&r__1);
/*<       CTABLE(3, I) = NINT(RBUF(4)*255) >*/
    r__1 = rbuf[4] * 255;
    ctable[i__ * 3 + 2] = i_nint(&r__1);
/*<       RETURN >*/
    return 0;

/* --- IFUNC=22, Set line width. ----------------------------------------- */

/*<   220 CONTINUE >*/
L220:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=23, Escape. ------------------------------------------------- */

/*<   230 CONTINUE >*/
L230:
/*<       RETURN >*/
    return 0;

/* --- IFUNC=24, Rectangle fill. ----------------------------------------- */

/*<   240 CONTINUE >*/
L240:
/*<       IF (DEBUG.AND.STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (debug && state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=25, Not implemented ----------------------------------------- */

/*<   250 CONTINUE >*/
L250:
/*<       RETURN >*/
    return 0;

/* --- IFUNC=26, Line of pixels ------------------------------------------ */

/*<   260 CONTINUE >*/
L260:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=27, Scaling info -- ----------------------------------------- */

/*<   270 CONTINUE >*/
L270:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=28, Draw marker --------------------------------------------- */

/*<   280 CONTINUE >*/
L280:
/*<       IF (STATE(ACTIVE).NE.2) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] != 2) {
	grnu00_(ifunc, &state[active]);
    }
/*     WRITE (*,'(1X,A,I4,1X,3F10.1)') 'MARKER', NINT(RBUF(1)), RBUF(2), */
/*    1      RBUF(3), RBUF(4) */
/*<       RETURN >*/
    return 0;

/* --- IFUNC=29, Query color representation. ----------------------------- */

/*<   290 CONTINUE >*/
L290:
/*<       IF (STATE(ACTIVE).LT.1) CALL GRNU00(IFUNC,STATE(ACTIVE)) >*/
    if (state[active] < 1) {
	grnu00_(ifunc, &state[active]);
    }
/*<       I = RBUF(1) >*/
    i__ = rbuf[1];
/*<       RBUF(2) = CTABLE(1,I)/255.0 >*/
    rbuf[2] = ctable[i__ * 3] / (float)255.;
/*<       RBUF(3) = CTABLE(2,I)/255.0 >*/
    rbuf[3] = ctable[i__ * 3 + 1] / (float)255.;
/*<       RBUF(4) = CTABLE(3,I)/255.0 >*/
    rbuf[4] = ctable[i__ * 3 + 2] / (float)255.;
/*<       NBUF = 4 >*/
    *nbuf = 4;
/*<       RETURN >*/
    return 0;
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* nudriv_ */

/*<       SUBROUTINE GRNU00(IFUNC, STATE) >*/
/* Subroutine */ int grnu00_(ifunc, state)
integer *ifunc, *state;
{
    static integer l;
    extern /* Subroutine */ int grfao_(), grwarn_();
    static char msg[80];

/*<       INTEGER IFUNC, STATE >*/

/* PGPLOT NULL device driver: report error */
/* ----------------------------------------------------------------------- */
/*<       INTEGER L >*/
/*<       CHARACTER*80 MSG >*/

/*<    >*/
    grfao_("++ internal error: driver in state # for opcode #", &l, msg, 
	    state, ifunc, &c__0, &c__0, (ftnlen)49, (ftnlen)80);
/*<       CALL GRWARN(MSG(1:L)) >*/
    grwarn_(msg, l);
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* grnu00_ */

