/* /work2/ssa/pgplot/src/pgarro.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__4 = 4;

/* *PGARRO -- draw an arrow */
/* %void cpgarro(float x1, float y1, float x2, float y2); */
/* + */
/*<       SUBROUTINE PGARRO (X1, Y1, X2, Y2) >*/
/* Subroutine */ int pgarro_(x1, y1, x2, y2)
real *x1, *y1, *x2, *y2;
{
    /* System generated locals */
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    double sqrt(), sin(), cos();

    /* Local variables */
    static integer ahfs;
    extern /* Subroutine */ int pgqah_(), pgqch_();
    static real rinch, dindx, dindy, xinch, yinch;
    extern /* Subroutine */ int pgqfs_(), pgsfs_(), pgqvp_();
    static real ca, ch, dh, co, sa;
    static integer fs;
    static real ahangl, yb, dx, dy, so, xl, xm, ym;
    extern /* Subroutine */ int pgbbuf_();
    static real xp, yp, xr, px[4], py[4], yt, semang;
    extern /* Subroutine */ int pgebuf_(), pgdraw_();
    static real ahvent;
    extern /* Subroutine */ int pgmove_(), pgqwin_(), pgpoly_(), pgqvsz_();
    static real xs1, xs2, ys1, xv1, xv2, yv1, yv2, ys2, dhx, dhy;

/*<       REAL X1, Y1, X2, Y2 >*/

/* Draw an arrow from the point with world-coordinates (X1,Y1) to */
/* (X2,Y2). The size of the arrowhead at (X2,Y2) is determined by */
/* the current character size set by routine PGSCH. The default size */
/* is 1/40th of the smaller of the width or height of the view surface. */
/* The appearance of the arrowhead (shape and solid or open) is */
/* controlled by routine PGSAH. */

/* Arguments: */
/*  X1, Y1 (input)  : world coordinates of the tail of the arrow. */
/*  X2, Y2 (input)  : world coordinates of the head of the arrow. */
/* -- */
/*  7-Feb-92 Keith Horne @ STScI / TJP. */
/* 13-Oct-92 - use arrowhead attributes; scale (TJP). */
/* ----------------------------------------------------------------------- */
/*<       INTEGER AHFS, FS >*/
/*<       REAL DX, DY, XV1, XV2, YV1, YV2, XL, XR, YB, YT, DINDX, DINDY >*/
/*<       REAL XINCH, YINCH, RINCH, CA, SA, SO, CO, YP, XP, YM, XM, DHX, DHY >*/
/*<       REAL PX(4), PY(4) >*/
/*<       REAL AHANGL, AHVENT, SEMANG, CH, DH, XS1, XS2, YS1, YS2 >*/

/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       CALL PGQAH(AHFS, AHANGL, AHVENT) >*/
    pgqah_(&ahfs, &ahangl, &ahvent);
/*<       CALL PGQFS(FS) >*/
    pgqfs_(&fs);
/*<       CALL PGSFS(AHFS) >*/
    pgsfs_(&ahfs);
/*<       DX = X2 - X1 >*/
    dx = *x2 - *x1;
/*<       DY = Y2 - Y1 >*/
    dy = *y2 - *y1;
/*<       CALL PGQCH(CH) >*/
    pgqch_(&ch);
/*<       CALL PGQVSZ(1, XS1, XS2, YS1, YS2) >*/
    pgqvsz_(&c__1, &xs1, &xs2, &ys1, &ys2);
/*     -- length of arrowhead: 1 40th of the smaller of the height or */
/*        width of the view surface, scaled by character height. */
/*<       DH = CH*MIN(ABS(XS2-XS1),ABS(YS2-YS1))/40.0 >*/
/* Computing MIN */
    r__3 = (r__1 = xs2 - xs1, dabs(r__1)), r__4 = (r__2 = ys2 - ys1, dabs(
	    r__2));
    dh = ch * dmin(r__3,r__4) / (float)40.;
/*<       CALL PGMOVE(X2, Y2) >*/
    pgmove_(x2, y2);
/*     -- Is there to be an arrowhead ? */
/*<       IF (DH.GT.0.) THEN >*/
    if (dh > (float)0.) {
/*<           IF (DX.NE.0. .OR. DY.NE.0.) THEN >*/
	if (dx != (float)0. || dy != (float)0.) {
/*             -- Get x and y scales */
/*<               CALL PGQVP(1, XV1, XV2, YV1, YV2) >*/
	    pgqvp_(&c__1, &xv1, &xv2, &yv1, &yv2);
/*<               CALL PGQWIN(XL, XR, YB, YT) >*/
	    pgqwin_(&xl, &xr, &yb, &yt);
/*<               IF (XR.NE.XL .AND. YT.NE.YB) THEN >*/
	    if (xr != xl && yt != yb) {
/*<                   DINDX = (XV2 - XV1) / (XR - XL) >*/
		dindx = (xv2 - xv1) / (xr - xl);
/*<                   DINDY = (YV2 - YV1) / (YT - YB) >*/
		dindy = (yv2 - yv1) / (yt - yb);
/*<                   DHX = DH / DINDX >*/
		dhx = dh / dindx;
/*<                   DHY = DH / DINDY >*/
		dhy = dh / dindy;
/*                 -- Unit vector in direction of the arrow */
/*<                   XINCH = DX * DINDX >*/
		xinch = dx * dindx;
/*<                   YINCH = DY * DINDY >*/
		yinch = dy * dindy;
/*<                   RINCH = SQRT(XINCH*XINCH + YINCH*YINCH) >*/
		rinch = sqrt(xinch * xinch + yinch * yinch);
/*<                   CA = XINCH / RINCH >*/
		ca = xinch / rinch;
/*<                   SA = YINCH / RINCH >*/
		sa = yinch / rinch;
/*                 -- Semiangle in radians */
/*<                   SEMANG = AHANGL/2.0/57.296 >*/
		semang = ahangl / (float)2. / (float)57.296;
/*<                   SO = SIN(SEMANG) >*/
		so = sin(semang);
/*<                   CO = -COS(SEMANG) >*/
		co = -cos(semang);
/*                 -- Vector back along one edge of the arrow */
/*<                   XP = DHX * (CA*CO - SA*SO) >*/
		xp = dhx * (ca * co - sa * so);
/*<                   YP = DHY * (SA*CO + CA*SO) >*/
		yp = dhy * (sa * co + ca * so);
/*                 -- Vector back along other edge of the arrow */
/*<                   XM = DHX * (CA*CO + SA*SO) >*/
		xm = dhx * (ca * co + sa * so);
/*<                   YM = DHY * (SA*CO - CA*SO) >*/
		ym = dhy * (sa * co - ca * so);
/*                 -- Draw the arrowhead */
/*<                   PX(1) = X2 >*/
		px[0] = *x2;
/*<                   PY(1) = Y2 >*/
		py[0] = *y2;
/*<                   PX(2) = X2 + XP >*/
		px[1] = *x2 + xp;
/*<                   PY(2) = Y2 + YP >*/
		py[1] = *y2 + yp;
/*<                   PX(3) = X2 + 0.5*(XP+XM)*(1.0-AHVENT) >*/
		px[2] = *x2 + (xp + xm) * (float).5 * ((float)1. - ahvent);
/*<                   PY(3) = Y2 + 0.5*(YP+YM)*(1.0-AHVENT) >*/
		py[2] = *y2 + (yp + ym) * (float).5 * ((float)1. - ahvent);
/*<                   PX(4) = X2 + XM >*/
		px[3] = *x2 + xm;
/*<                   PY(4) = Y2 + YM >*/
		py[3] = *y2 + ym;
/*<                   CALL PGPOLY(4, PX, PY) >*/
		pgpoly_(&c__4, px, py);
/*<                   CALL PGMOVE(PX(3), PY(3)) >*/
		pgmove_(&px[2], &py[2]);
/*<               END IF >*/
	    }
/*<           END IF >*/
	}
/*<       END IF >*/
    }
/*<       CALL PGDRAW(X1, Y1) >*/
    pgdraw_(x1, y1);
/*<       CALL PGMOVE(X2,Y2) >*/
    pgmove_(x2, y2);
/*<       CALL PGSFS(FS) >*/
    pgsfs_(&fs);
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgarro_ */

