/* /work2/ssa/pgplot/src/pgaxis.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b8 = (float)10.;
static integer c__0 = 0;
static real c_b13 = (float)0.;

/* *PGAXIS -- draw an axis */
/* %void cpgaxis(const char *opt, float x1, float y1, float x2, float y2, \ */
/* %             float v1, float v2, float step, int nsub, float dmajl, \ */
/* %             float dmajr, float fmin, float disp, float orient); */
/* + */
/*<    >*/
/* Subroutine */ int pgaxis_(opt, x1, y1, x2, y2, v1, v2, step, nsub, dmajl, 
	dmajr, fmin, disp, orient, opt_len)
char *opt;
real *x1, *y1, *x2, *y2, *v1, *v2, *step;
integer *nsub;
real *dmajl, *dmajr, *fmin, *disp, *orient;
ftnlen opt_len;
{
    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    integer i_len();
    double r_lg10(), pow_ri();
    integer i_nint();
    /* Subroutine */ int s_copy();

    /* Local variables */
    static integer llab, clip, form;
    static real vmin, vmax;
    static logical optn;
    static integer i__, k;
    static char label[32];
    static real v, dvmaj;
    extern doublereal pgrnd_();
    static real dvmin;
    static integer nsubt, k1, k2;
    static char ch[1];
    static integer np, nv;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), pgtick_(), pgaxlg_(), 
	    pgdraw_(), pgqclp_(), pgsclp_(), pgnumb_(), pgmove_();
    extern logical pgnoto_();
    extern /* Subroutine */ int grtoup_();

/*<       CHARACTER*(*) OPT >*/
/*<       REAL X1, Y1, X2, Y2, V1, V2, STEP, DMAJL, DMAJR, FMIN, DISP >*/
/*<       REAL ORIENT >*/
/*<       INTEGER NSUB >*/

/* Draw a labelled graph axis from world-coordinate position (X1,Y1) to */
/* (X2,Y2). */

/* Normally, this routine draws a standard LINEAR axis with equal */
/* subdivisions.   The quantity described by the axis runs from V1 to V2; */
/* this may be, but need not be, the same as X or Y. */

/* If the 'L' option is specified, the routine draws a LOGARITHMIC axis. */
/* In this case, the quantity described by the axis runs from 10**V1 to */
/* 10**V2. A logarithmic axis always has major, labeled, tick marks */
/* spaced by one or more decades. If the major tick marks are spaced */
/* by one decade (as specified by the STEP argument), then minor */
/* tick marks are placed at 2, 3, .., 9 times each power of 10; */
/* otherwise minor tick marks are spaced by one decade. If the axis */
/* spans less than two decades, numeric labels are placed at 1, 2, and */
/* 5 times each power of ten. */

/* If the axis spans less than one decade, or if it spans many decades, */
/* it is preferable to use a linear axis labeled with the logarithm of */
/* the quantity of interest. */

/* Arguments: */
/*  OPT    (input)  : a string containing single-letter codes for */
/*                    various options. The options currently */
/*                    recognized are: */
/*                    L : draw a logarithmic axis */
/*                    N : write numeric labels */
/*                    1 : force decimal labelling, instead of automatic */
/*                        choice (see PGNUMB). */
/*                    2 : force exponential labelling, instead of */
/*                        automatic. */
/*  X1, Y1 (input)  : world coordinates of one endpoint of the axis. */
/*  X2, Y2 (input)  : world coordinates of the other endpoint of the axis. */
/*  V1     (input)  : axis value at first endpoint. */
/*  V2     (input)  : axis value at second endpoint. */
/*  STEP   (input)  : major tick marks are drawn at axis value 0.0 plus */
/*                    or minus integer multiples of STEP. If STEP=0.0, */
/*                    a value is chosen automatically. */
/*  NSUB   (input)  : minor tick marks are drawn to divide the major */
/*                    divisions into NSUB equal subdivisions (ignored if */
/*                    STEP=0.0). If NSUB <= 1, no minor tick marks are */
/*                    drawn. NSUB is ignored for a logarithmic axis. */
/*  DMAJL  (input)  : length of major tick marks drawn to left of axis */
/*                    (as seen looking from first endpoint to second), in */
/*                    units of the character height. */
/*  DMAJR  (input)  : length of major tick marks drawn to right of axis, */
/*                    in units of the character height. */
/*  FMIN   (input)  : length of minor tick marks, as fraction of major. */
/*  DISP   (input)  : displacement of baseline of tick labels to */
/*                    right of axis, in units of the character height. */
/*  ORIENT (input)  : orientation of label text, in degrees; angle between */
/*                    baseline of text and direction of axis (0-360). */
/* -- */
/* 25-Mar-1997 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       REAL V, VMIN, VMAX, DVMAJ, DVMIN >*/
/*<       REAL PGRND >*/
/*<       INTEGER I, K, K1, K2, NSUBT, NV, NP, LLAB, CLIP, FORM >*/
/*<       LOGICAL OPTN, PGNOTO >*/
/*<       CHARACTER CH, LABEL*32 >*/

/* Check arguments. */

/*<       IF (PGNOTO('PGAXIS')) RETURN >*/
    if (pgnoto_("PGAXIS", (ftnlen)6)) {
	return 0;
    }
/*<       IF (X1.EQ.X2 .AND. Y1.EQ.Y2) RETURN >*/
    if (*x1 == *x2 && *y1 == *y2) {
	return 0;
    }
/*<       IF (V1.EQ.V2) RETURN >*/
    if (*v1 == *v2) {
	return 0;
    }

/* Decode options. */

/*<       FORM = 0 >*/
    form = 0;
/*<       OPTN = .FALSE. >*/
    optn = FALSE_;
/*<       DO 10 I=1,LEN(OPT) >*/
    i__1 = i_len(opt, opt_len);
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<          CH = OPT(I:I) >*/
	*(unsigned char *)ch = *(unsigned char *)&opt[i__ - 1];
/*<          CALL GRTOUP(CH, CH) >*/
	grtoup_(ch, ch, (ftnlen)1, (ftnlen)1);
/*<          IF (CH.EQ.'N') THEN >*/
	if (*(unsigned char *)ch == 'N') {
/*           -- numeric labels requested */
/*<             OPTN = .TRUE. >*/
	    optn = TRUE_;
/*<          ELSE IF (CH.EQ.'L') THEN >*/
	} else if (*(unsigned char *)ch == 'L') {
/*           -- logarithmic axis requested */
/*<    >*/
	    pgaxlg_(opt, x1, y1, x2, y2, v1, v2, step, dmajl, dmajr, fmin, 
		    disp, orient, opt_len);
/*<             RETURN >*/
	    return 0;
/*<          ELSE IF (CH.EQ.'1') THEN >*/
	} else if (*(unsigned char *)ch == '1') {
/*           -- decimal labels requested */
/*<             FORM = 1 >*/
	    form = 1;
/*<          ELSE IF (CH.EQ.'2') THEN >*/
	} else if (*(unsigned char *)ch == '2') {
/*           -- exponential labels requested */
/*<             FORM = 2 >*/
	    form = 2;
/*<          END IF >*/
	}
/*<  10   CONTINUE >*/
/* L10: */
    }

/* Choose major interval if defaulted. Requested interval = STEP, */
/* with NSUB subdivisions. We will use interval = DVMAJ with NSUBT */
/* subdivisions of size DVMIN. Note that DVMAJ is always positive. */

/*<       IF (STEP.EQ.0.0) THEN >*/
    if (*step == (float)0.) {
/*<           DVMAJ = PGRND(0.20*ABS(V1-V2),NSUBT) >*/
	r__2 = (r__1 = *v1 - *v2, dabs(r__1)) * (float).2;
	dvmaj = pgrnd_(&r__2, &nsubt);
/*<       ELSE >*/
    } else {
/*<           DVMAJ = ABS(STEP) >*/
	dvmaj = dabs(*step);
/*<           NSUBT = MAX(NSUB,1) >*/
	nsubt = max(*nsub,1);
/*<       END IF >*/
    }
/*<       DVMIN = DVMAJ/NSUBT >*/
    dvmin = dvmaj / nsubt;

/* For labelling, we need to express DVMIN as an integer times a */
/* power of 10, NV*(10**NP). */

/*<       NP = INT(LOG10(ABS(DVMIN)))-4 >*/
    r__1 = dabs(dvmin);
    np = (integer) r_lg10(&r__1) - 4;
/*<       NV = NINT(DVMIN/10.0**NP) >*/
    r__1 = dvmin / pow_ri(&c_b8, &np);
    nv = i_nint(&r__1);
/*<       DVMIN = REAL(NV)*(10.0**NP) >*/
    dvmin = (real) nv * pow_ri(&c_b8, &np);

/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       CALL PGQCLP(CLIP) >*/
    pgqclp_(&clip);
/*<       CALL PGSCLP(0) >*/
    pgsclp_(&c__0);

/* Draw the axis. */

/*<       CALL PGMOVE(X1, Y1) >*/
    pgmove_(x1, y1);
/*<       CALL PGDRAW(X2, Y2) >*/
    pgdraw_(x2, y2);

/* Draw the tick marks. Minor ticks are drawn at V = K*DVMIN, */
/* major (labelled) ticks where K is a multiple of NSUBT. */

/*<       VMIN = MIN(V1, V2) >*/
    vmin = dmin(*v1,*v2);
/*<       VMAX = MAX(V1, V2) >*/
    vmax = dmax(*v1,*v2);
/*<       K1 = INT(VMIN/DVMIN) >*/
    k1 = (integer) (vmin / dvmin);
/*<       IF (DVMIN*K1.LT.VMIN) K1 = K1+1 >*/
    if (dvmin * k1 < vmin) {
	++k1;
    }
/*<       K2 = INT(VMAX/DVMIN) >*/
    k2 = (integer) (vmax / dvmin);
/*<       IF (DVMIN*K2.GT.VMAX) K2 = K2-1 >*/
    if (dvmin * k2 > vmax) {
	--k2;
    }
/*<       DO 20 K=K1,K2 >*/
    i__1 = k2;
    for (k = k1; k <= i__1; ++k) {
/*<          V = (K*DVMIN-V1)/(V2-V1) >*/
	v = (k * dvmin - *v1) / (*v2 - *v1);
/*<          IF (MOD(K,NSUBT).EQ.0) THEN >*/
	if (k % nsubt == 0) {
/*             -- major tick mark */
/*<             IF (OPTN) THEN >*/
	    if (optn) {
/*<                CALL PGNUMB(K*NV, NP, FORM, LABEL, LLAB) >*/
		i__2 = k * nv;
		pgnumb_(&i__2, &np, &form, label, &llab, (ftnlen)32);
/*<             ELSE >*/
	    } else {
/*<                LABEL = ' ' >*/
		s_copy(label, " ", (ftnlen)32, (ftnlen)1);
/*<                LLAB = 1 >*/
		llab = 1;
/*<             END IF >*/
	    }
/*<    >*/
	    pgtick_(x1, y1, x2, y2, &v, dmajl, dmajr, disp, orient, label, 
		    llab);
/*<          ELSE >*/
	} else {
/*             -- minor tick mark */
/*<    >*/
	    r__1 = *dmajl * *fmin;
	    r__2 = *dmajr * *fmin;
	    pgtick_(x1, y1, x2, y2, &v, &r__1, &r__2, &c_b13, orient, " ", (
		    ftnlen)1);
/*<          END IF >*/
	}
/*<  20   CONTINUE >*/
/* L20: */
    }

/*<       CALL PGSCLP(CLIP) >*/
    pgsclp_(&clip);
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgaxis_ */

