/* /work2/ssa/pgplot/src/pgbox.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static real c_b4 = (float)0.;
static integer c__0 = 0;
static real c_b37 = (float)1.;
static real c_b39 = (float)10.;
static integer c__1 = 1;
static real c_b50 = (float).5;

/* *PGBOX -- draw labeled frame around viewport */
/* %void cpgbox(const char *xopt, float xtick, int nxsub, \ */
/* % const char *yopt, float ytick, int nysub); */
/* + */
/*<       SUBROUTINE PGBOX (XOPT, XTICK, NXSUB, YOPT, YTICK, NYSUB) >*/
/* Subroutine */ int pgbox_(xopt, xtick, nxsub, yopt, ytick, nysub, xopt_len, 
	yopt_len)
char *xopt;
real *xtick;
integer *nxsub;
char *yopt;
real *ytick;
integer *nysub;
ftnlen xopt_len;
ftnlen yopt_len;
{
    /* Initialized data */

    static real tab[9] = { (float)0.,(float).30103,(float).47712,(float)
	    .60206,(float).69897,(float).77815,(float).8451,(float).90309,(
	    float).95424 };

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2, r__3;

    /* Builtin functions */
    integer i_indx();
    double r_sign(), r_lg10(), pow_ri();
    integer i_nint();

    /* Local variables */
    static char clbl[20];
    static integer clip;
    static real xblc, yblc, utab[9];
    static integer jmax;
    static real tikl, xval, yval, xtrc, ytrc, xint, yint, tikl1, tikl2, xint2,
	     yint2;
    static integer i__, j;
    static logical major;
    extern doublereal pgrnd_();
    static integer i1;
    static logical xopta, xoptb, xoptc, yopta, xoptg, yoptb, xoptm, xoptn, 
	    yoptc, yoptg, xopts, xoptt, yoptn, yoptm, yoptt, yopts, xopti, 
	    yopti, yoptv, xoptl, yoptl, xoptp, yoptp;
    static integer i2, nsubx, nsuby;
    static real xndsp, xmdsp, yndsp, ymdsp;
    extern /* Subroutine */ int pgbox1_();
    static integer nc, ki;
    static real xc, yc;
    static integer np, nv;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grlina_(), pgqclp_(), 
	    pgsclp_(), grmova_(), pgnumb_();
    extern logical pgnoto_();
    static integer xnform, ynform;
    extern /* Subroutine */ int pgqwin_(), grtoup_();
    static real ymvdsp, ynvdsp;
    extern /* Subroutine */ int pgmtxt_();
    static logical xoptls, yoptls;
    static char opt[64];

/*<       CHARACTER*(*) XOPT, YOPT >*/
/*<       REAL XTICK, YTICK >*/
/*<       INTEGER NXSUB, NYSUB >*/

/* Annotate the viewport with frame, axes, numeric labels, etc. */
/* PGBOX is called by on the user's behalf by PGENV, but may also be */
/* called explicitly. */

/* Arguments: */
/*  XOPT   (input)  : string of options for X (horizontal) axis of */
/*                    plot. Options are single letters, and may be in */
/*                    any order (see below). */
/*  XTICK  (input)  : world coordinate interval between major tick marks */
/*                    on X axis. If XTICK=0.0, the interval is chosen by */
/*                    PGBOX, so that there will be at least 3 major tick */
/*                    marks along the axis. */
/*  NXSUB  (input)  : the number of subintervals to divide the major */
/*                    coordinate interval into. If XTICK=0.0 or NXSUB=0, */
/*                    the number is chosen by PGBOX. */
/*  YOPT   (input)  : string of options for Y (vertical) axis of plot. */
/*                    Coding is the same as for XOPT. */
/*  YTICK  (input)  : like XTICK for the Y axis. */
/*  NYSUB  (input)  : like NXSUB for the Y axis. */

/* Options (for parameters XOPT and YOPT): */
/*  A : draw Axis (X axis is horizontal line Y=0, Y axis is vertical */
/*      line X=0). */
/*  B : draw bottom (X) or left (Y) edge of frame. */
/*  C : draw top (X) or right (Y) edge of frame. */
/*  G : draw Grid of vertical (X) or horizontal (Y) lines. */
/*  I : Invert the tick marks; ie draw them outside the viewport */
/*      instead of inside. */
/*  L : label axis Logarithmically (see below). */
/*  N : write Numeric labels in the conventional location below the */
/*      viewport (X) or to the left of the viewport (Y). */
/*  P : extend ("Project") major tick marks outside the box (ignored if */
/*      option I is specified). */
/*  M : write numeric labels in the unconventional location above the */
/*      viewport (X) or to the right of the viewport (Y). */
/*  T : draw major Tick marks at the major coordinate interval. */
/*  S : draw minor tick marks (Subticks). */
/*  V : orient numeric labels Vertically. This is only applicable to Y. */
/*      The default is to write Y-labels parallel to the axis. */
/*  1 : force decimal labelling, instead of automatic choice (see PGNUMB). */
/*  2 : force exponential labelling, instead of automatic. */

/* To get a complete frame, specify BC in both XOPT and YOPT. */
/* Tick marks, if requested, are drawn on the axes or frame */
/* or both, depending which are requested. If none of ABC is specified, */
/* tick marks will not be drawn. When PGENV calls PGBOX, it sets both */
/* XOPT and YOPT according to the value of its parameter AXIS: */
/* -1: 'BC', 0: 'BCNST', 1: 'ABCNST', 2: 'ABCGNST'. */

/* For a logarithmic axis, the major tick interval is always 1.0. The */
/* numeric label is 10**(x) where x is the world coordinate at the */
/* tick mark. If subticks are requested, 8 subticks are drawn between */
/* each major tick at equal logarithmic intervals. */

/* To label an axis with time (days, hours, minutes, seconds) or */
/* angle (degrees, arcmin, arcsec), use routine PGTBOX. */
/* -- */
/* 19-Oct-1983 */
/* 23-Sep-1984 - fix bug in labelling reversed logarithmic axes. */
/*  6-May-1985 - improve behavior for pen plotters [TJP]. */
/* 23-Nov-1985 - add 'P' option [TJP]. */
/* 14-Jan-1986 - use new routine PGBOX1 to fix problem of missing */
/*               labels at end of axis [TJP]. */
/*  8-Apr-1987 - improve automatic choice of tick interval; improve */
/*               erroneous rounding of tick interval to 1 digit [TJP]. */
/* 23-Apr-1987 - fix bug: limit max number of ticks to ~10 [TJP]. */
/*  7-Nov-1987 - yet another change to algorithm for choosing tick */
/*               interval; maximum tick interval is now 0.2*range of */
/*               axis, which may round up to 0.5 [TJP]. */
/* 15-Dec-1988 - correct declaration of MAJOR [TJP]. */
/*  6-Sep-1989 - use Fortran generic intrinsic functions [TJP]. */
/* 18-Oct-1990 - correctly initialize UTAB(1) [AFT]. */
/* 19-Oct-1990 - do all plotting in world coordinates [TJP]. */
/*  6-Nov-1991 - label logarithmic subticks when necessary [TJP]. */
/*  4-Jul-1994 - add '1' and '2' options [TJP]. */
/* 20-Apr-1995 - adjust position of labels slightly, and move out */
/*               when ticks are inverted [TJP]. */
/* 26-Feb-1997 - use new routine pgclp [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       CHARACTER*20  CLBL >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*64  OPT >*/
/*<       LOGICAL  XOPTA, XOPTB, XOPTC, XOPTG, XOPTN, XOPTM, XOPTT, XOPTS >*/
/*<       LOGICAL  YOPTA, YOPTB, YOPTC, YOPTG, YOPTN, YOPTM, YOPTT, YOPTS >*/
/*<       LOGICAL  XOPTI, YOPTI, YOPTV, XOPTL, YOPTL, XOPTP, YOPTP, RANGE >*/
/*<       LOGICAL  IRANGE, MAJOR, XOPTLS, YOPTLS, PGNOTO >*/
/*<       REAL     TAB(9), UTAB(9) >*/
/*<       INTEGER  I, I1, I2, J, NC, NP, NV, KI, CLIP >*/
/*<       INTEGER  NSUBX, NSUBY, JMAX, XNFORM, YNFORM >*/
/*<       REAL     TIKL, TIKL1, TIKL2, XC, YC >*/
/*<       REAL     XINT, XINT2, XVAL, YINT, YINT2, YVAL >*/
/*<       REAL     PGRND >*/
/*<       REAL     A, B, C >*/
/*<       REAL     XNDSP, XMDSP, YNDSP, YMDSP, YNVDSP, YMVDSP >*/
/*<       REAL     XBLC, XTRC, YBLC, YTRC >*/
/*<       INTRINSIC ABS, INDEX, INT, LOG10, MAX, MIN, MOD, NINT, SIGN, REAL >*/

/* Table of logarithms 1..9 */

/*<    >*/

/*<       RANGE(A,B,C) = (A.LT.B.AND.B.LT.C) .OR. (C.LT.B.AND.B.LT.A) >*/
/*<       IRANGE(A,B,C) = (A.LE.B.AND.B.LE.C) .OR. (C.LE.B.AND.B.LE.A) >*/

/*<       IF (PGNOTO('PGBOX')) RETURN >*/
    if (pgnoto_("PGBOX", (ftnlen)5)) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       CALL PGQWIN(XBLC, XTRC, YBLC, YTRC) >*/
    pgqwin_(&xblc, &xtrc, &yblc, &ytrc);

/* Decode options. */

/*<       CALL GRTOUP(OPT,XOPT) >*/
    grtoup_(opt, xopt, (ftnlen)64, xopt_len);
/*<       XOPTA = INDEX(OPT,'A').NE.0 .AND. RANGE(YBLC,0.0,YTRC) >*/
    xopta = i_indx(opt, "A", (ftnlen)64, (ftnlen)1) != 0 && (yblc < c_b4 && 
	    c_b4 < ytrc || ytrc < c_b4 && c_b4 < yblc);
/*<       XOPTB = INDEX(OPT,'B').NE.0 >*/
    xoptb = i_indx(opt, "B", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTC = INDEX(OPT,'C').NE.0 >*/
    xoptc = i_indx(opt, "C", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTG = INDEX(OPT,'G').NE.0 >*/
    xoptg = i_indx(opt, "G", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTI = INDEX(OPT,'I').NE.0 >*/
    xopti = i_indx(opt, "I", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTL = INDEX(OPT,'L').NE.0 >*/
    xoptl = i_indx(opt, "L", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTM = INDEX(OPT,'M').NE.0 >*/
    xoptm = i_indx(opt, "M", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTN = INDEX(OPT,'N').NE.0 >*/
    xoptn = i_indx(opt, "N", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTS = INDEX(OPT,'S').NE.0 >*/
    xopts = i_indx(opt, "S", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTT = INDEX(OPT,'T').NE.0 >*/
    xoptt = i_indx(opt, "T", (ftnlen)64, (ftnlen)1) != 0;
/*<       XOPTP = INDEX(OPT,'P').NE.0 .AND. (.NOT.XOPTI) >*/
    xoptp = i_indx(opt, "P", (ftnlen)64, (ftnlen)1) != 0 && ! xopti;
/*<       XNFORM = 0 >*/
    xnform = 0;
/*<       IF (INDEX(OPT,'1').NE.0) XNFORM = 1 >*/
    if (i_indx(opt, "1", (ftnlen)64, (ftnlen)1) != 0) {
	xnform = 1;
    }
/*<       IF (INDEX(OPT,'2').NE.0) XNFORM = 2 >*/
    if (i_indx(opt, "2", (ftnlen)64, (ftnlen)1) != 0) {
	xnform = 2;
    }
/*<       CALL GRTOUP(OPT,YOPT) >*/
    grtoup_(opt, yopt, (ftnlen)64, yopt_len);
/*<       YOPTA = INDEX(OPT,'A').NE.0 .AND. RANGE(XBLC,0.0,XTRC) >*/
    yopta = i_indx(opt, "A", (ftnlen)64, (ftnlen)1) != 0 && (xblc < c_b4 && 
	    c_b4 < xtrc || xtrc < c_b4 && c_b4 < xblc);
/*<       YOPTB = INDEX(OPT,'B').NE.0 >*/
    yoptb = i_indx(opt, "B", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTC = INDEX(OPT,'C').NE.0 >*/
    yoptc = i_indx(opt, "C", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTG = INDEX(OPT,'G').NE.0 >*/
    yoptg = i_indx(opt, "G", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTI = INDEX(OPT,'I').NE.0 >*/
    yopti = i_indx(opt, "I", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTL = INDEX(OPT,'L').NE.0 >*/
    yoptl = i_indx(opt, "L", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTN = INDEX(OPT,'N').NE.0 >*/
    yoptn = i_indx(opt, "N", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTM = INDEX(OPT,'M').NE.0 >*/
    yoptm = i_indx(opt, "M", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTS = INDEX(OPT,'S').NE.0 >*/
    yopts = i_indx(opt, "S", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTT = INDEX(OPT,'T').NE.0 >*/
    yoptt = i_indx(opt, "T", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTV = INDEX(OPT,'V').NE.0 >*/
    yoptv = i_indx(opt, "V", (ftnlen)64, (ftnlen)1) != 0;
/*<       YOPTP = INDEX(OPT,'P').NE.0 .AND. (.NOT.YOPTI) >*/
    yoptp = i_indx(opt, "P", (ftnlen)64, (ftnlen)1) != 0 && ! yopti;
/*<       YNFORM = 0 >*/
    ynform = 0;
/*<       IF (INDEX(OPT,'1').NE.0) YNFORM = 1 >*/
    if (i_indx(opt, "1", (ftnlen)64, (ftnlen)1) != 0) {
	ynform = 1;
    }
/*<       IF (INDEX(OPT,'2').NE.0) YNFORM = 2 >*/
    if (i_indx(opt, "2", (ftnlen)64, (ftnlen)1) != 0) {
	ynform = 2;
    }

/* Displacement of labels from edge of box */
/* (for X bottom/top, Y left/right, and Y left/right with V option). */

/*<       XNDSP = 1.2 >*/
    xndsp = (float)1.2;
/*<       XMDSP = 0.7 >*/
    xmdsp = (float).7;
/*<       YNDSP = 0.7 >*/
    yndsp = (float).7;
/*<       YMDSP = 1.2 >*/
    ymdsp = (float)1.2;
/*<       YNVDSP = 0.7 >*/
    ynvdsp = (float).7;
/*<       YMVDSP = 0.7 >*/
    ymvdsp = (float).7;
/*<       IF (XOPTI) THEN >*/
    if (xopti) {
/*<          XNDSP = XNDSP + 0.3 >*/
	xndsp += (float).3;
/*<          XMDSP = XMDSP + 0.3 >*/
	xmdsp += (float).3;
/*<       END IF >*/
    }
/*<       IF (YOPTI) THEN >*/
    if (yopti) {
/*<          YNDSP = YNDSP + 0.3 >*/
	yndsp += (float).3;
/*<          YMDSP = YMDSP + 0.3 >*/
	ymdsp += (float).3;
/*<          YNVDSP = YNVDSP + 0.3 >*/
	ynvdsp += (float).3;
/*<          YMVDSP = YMVDSP + 0.3 >*/
	ymvdsp += (float).3;
/*<       END IF >*/
    }

/* Disable clipping. */

/*<       CALL PGQCLP(CLIP) >*/
    pgqclp_(&clip);
/*<       CALL PGSCLP(0) >*/
    pgsclp_(&c__0);

/* Draw box. */

/*<       IF (XOPTB) THEN >*/
    if (xoptb) {
/*<           CALL GRMOVA(XBLC, YBLC) >*/
	grmova_(&xblc, &yblc);
/*<           CALL GRLINA(XTRC, YBLC) >*/
	grlina_(&xtrc, &yblc);
/*<       END IF >*/
    }
/*<       IF (YOPTC) THEN >*/
    if (yoptc) {
/*<           CALL GRMOVA(XTRC, YBLC) >*/
	grmova_(&xtrc, &yblc);
/*<           CALL GRLINA(XTRC, YTRC) >*/
	grlina_(&xtrc, &ytrc);
/*<       END IF >*/
    }
/*<       IF (XOPTC) THEN >*/
    if (xoptc) {
/*<           CALL GRMOVA(XTRC, YTRC) >*/
	grmova_(&xtrc, &ytrc);
/*<           CALL GRLINA(XBLC, YTRC) >*/
	grlina_(&xblc, &ytrc);
/*<       END IF >*/
    }
/*<       IF (YOPTB) THEN >*/
    if (yoptb) {
/*<           CALL GRMOVA(XBLC, YTRC) >*/
	grmova_(&xblc, &ytrc);
/*<           CALL GRLINA(XBLC, YBLC) >*/
	grlina_(&xblc, &yblc);
/*<       END IF >*/
    }

/* Draw axes if required. */

/*<       IF (XOPTA.AND..NOT.XOPTG) THEN >*/
    if (xopta && ! xoptg) {
/*<           CALL GRMOVA(XBLC, 0.0) >*/
	grmova_(&xblc, &c_b4);
/*<           CALL GRLINA(XTRC, 0.0) >*/
	grlina_(&xtrc, &c_b4);
/*<       END IF >*/
    }
/*<       IF (YOPTA.AND..NOT.YOPTG) THEN >*/
    if (yopta && ! yoptg) {
/*<           CALL GRMOVA(0.0, YBLC) >*/
	grmova_(&c_b4, &yblc);
/*<           CALL GRLINA(0.0, YTRC) >*/
	grlina_(&c_b4, &ytrc);
/*<       END IF >*/
    }

/* Length of X tick marks. */

/*<       TIKL1 = PGXSP(PGID)*0.6*(YTRC-YBLC)/PGYLEN(PGID) >*/
    tikl1 = pgplt1_1.pgxsp[pgplt1_1.pgid - 1] * (float).6 * (ytrc - yblc) / 
	    pgplt1_1.pgylen[pgplt1_1.pgid - 1];
/*<       IF (XOPTI) TIKL1 = -TIKL1 >*/
    if (xopti) {
	tikl1 = -tikl1;
    }
/*<       TIKL2 = TIKL1*0.5 >*/
    tikl2 = tikl1 * (float).5;

/* Choose X tick intervals. Major interval = XINT, */
/* minor interval = XINT2 = XINT/NSUBX. */

/*<       UTAB(1) = 0.0 >*/
    utab[0] = (float)0.;
/*<       IF (XOPTL) THEN >*/
    if (xoptl) {
/*<           XINT = SIGN(1.0,XTRC-XBLC) >*/
	r__1 = xtrc - xblc;
	xint = r_sign(&c_b37, &r__1);
/*<           NSUBX = 1 >*/
	nsubx = 1;
/*<           DO 10 J=2,9 >*/
	for (j = 2; j <= 9; ++j) {
/*<               UTAB(J) = TAB(J) >*/
	    utab[j - 1] = tab[j - 1];
/*<               IF (XINT.LT.0.0) UTAB(J) = 1.0-TAB(J) >*/
	    if (xint < (float)0.) {
		utab[j - 1] = (float)1. - tab[j - 1];
	    }
/*<    10     CONTINUE >*/
/* L10: */
	}
/*<       ELSE IF (XTICK.EQ.0.0) THEN >*/
    } else if (*xtick == (float)0.) {
/*<    >*/
/* Computing MAX */
/* Computing MIN */
	r__3 = pgplt1_1.pgxsp[pgplt1_1.pgid - 1] * (float)7. / 
		pgplt1_1.pgxlen[pgplt1_1.pgid - 1];
	r__1 = (float).05, r__2 = dmin(r__3,(float).2);
	xint = dmax(r__1,r__2) * (xtrc - xblc);
/*<           XINT = PGRND(XINT,NSUBX) >*/
	xint = pgrnd_(&xint, &nsubx);
/*<       ELSE >*/
    } else {
/*<           XINT = SIGN(XTICK,XTRC-XBLC) >*/
	r__1 = xtrc - xblc;
	xint = r_sign(xtick, &r__1);
/*<           NSUBX = MAX(NXSUB,1) >*/
	nsubx = max(*nxsub,1);
/*<       END IF >*/
    }
/*<       IF (.NOT.XOPTS) NSUBX = 1 >*/
    if (! xopts) {
	nsubx = 1;
    }
/*<       NP = INT(LOG10(ABS(XINT)))-4 >*/
    r__1 = dabs(xint);
    np = (integer) r_lg10(&r__1) - 4;
/*<       NV = NINT(XINT/10.**NP) >*/
    r__1 = xint / pow_ri(&c_b39, &np);
    nv = i_nint(&r__1);
/*<       XINT2 = XINT/NSUBX >*/
    xint2 = xint / nsubx;
/*<       XOPTLS = XOPTL .AND. XOPTS .AND. (ABS(XTRC-XBLC).LT.2.0) >*/
    xoptls = xoptl && xopts && (r__1 = xtrc - xblc, dabs(r__1)) < (float)2.;

/* Draw X grid. */

/*<       IF (XOPTG) THEN >*/
    if (xoptg) {
/*<           CALL PGBOX1(XBLC, XTRC, XINT, I1, I2) >*/
	pgbox1_(&xblc, &xtrc, &xint, &i1, &i2);
/*<           DO 20 I=I1,I2 >*/
	i__1 = i2;
	for (i__ = i1; i__ <= i__1; ++i__) {
/*<               CALL GRMOVA(REAL(I)*XINT, YBLC) >*/
	    r__1 = (real) i__ * xint;
	    grmova_(&r__1, &yblc);
/*<               CALL GRLINA(REAL(I)*XINT, YTRC) >*/
	    r__1 = (real) i__ * xint;
	    grlina_(&r__1, &ytrc);
/*<    20     CONTINUE >*/
/* L20: */
	}
/*<       END IF >*/
    }

/* Draw X ticks. */

/*<       IF (XOPTT.OR.XOPTS) THEN >*/
    if (xoptt || xopts) {
/*<           CALL PGBOX1(XBLC, XTRC, XINT2, I1, I2) >*/
	pgbox1_(&xblc, &xtrc, &xint2, &i1, &i2);
/*<           JMAX = 1 >*/
	jmax = 1;
/*<           IF (XOPTL.AND.XOPTS) JMAX=9 >*/
	if (xoptl && xopts) {
	    jmax = 9;
	}

/*         Bottom ticks. */

/*<           IF (XOPTB) THEN >*/
	if (xoptb) {
/*<             DO 40 I=I1-1,I2 >*/
	    i__1 = i2;
	    for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<             DO 30 J=1,JMAX >*/
		i__2 = jmax;
		for (j = 1; j <= i__2; ++j) {
/*<                 MAJOR = (MOD(I,NSUBX).EQ.0).AND.XOPTT.AND.J.EQ.1 >*/
		    major = i__ % nsubx == 0 && xoptt && j == 1;
/*<                 TIKL = TIKL2 >*/
		    tikl = tikl2;
/*<                 IF (MAJOR) TIKL = TIKL1 >*/
		    if (major) {
			tikl = tikl1;
		    }
/*<                 XVAL = (I+UTAB(J))*XINT2 >*/
		    xval = (i__ + utab[j - 1]) * xint2;
/*<                 IF (IRANGE(XBLC,XVAL,XTRC)) THEN >*/
		    if (xblc <= xval && xval <= xtrc || xtrc <= xval && xval 
			    <= xblc) {
/*<                     IF (XOPTP.AND.MAJOR) THEN >*/
			if (xoptp && major) {
/*<                         CALL GRMOVA(XVAL, YBLC-TIKL2) >*/
			    r__1 = yblc - tikl2;
			    grmova_(&xval, &r__1);
/*<                     ELSE >*/
			} else {
/*<                         CALL GRMOVA(XVAL, YBLC) >*/
			    grmova_(&xval, &yblc);
/*<                     END IF >*/
			}
/*<                     CALL GRLINA(XVAL, YBLC+TIKL) >*/
			r__1 = yblc + tikl;
			grlina_(&xval, &r__1);
/*<                 END IF >*/
		    }
/*<    30        CONTINUE >*/
/* L30: */
		}
/*<    40       CONTINUE >*/
/* L40: */
	    }
/*<           END IF >*/
	}

/*         Axis ticks. */

/*<           IF (XOPTA) THEN >*/
	if (xopta) {
/*<             DO 60 I=I1-1,I2 >*/
	    i__1 = i2;
	    for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<             DO 50 J=1,JMAX >*/
		i__2 = jmax;
		for (j = 1; j <= i__2; ++j) {
/*<                 MAJOR = (MOD(I,NSUBX).EQ.0).AND.XOPTT.AND.J.EQ.1 >*/
		    major = i__ % nsubx == 0 && xoptt && j == 1;
/*<                 TIKL = TIKL2 >*/
		    tikl = tikl2;
/*<                 IF (MAJOR) TIKL = TIKL1 >*/
		    if (major) {
			tikl = tikl1;
		    }
/*<                 XVAL = (I+UTAB(J))*XINT2 >*/
		    xval = (i__ + utab[j - 1]) * xint2;
/*<                 IF (IRANGE(XBLC,XVAL,XTRC)) THEN >*/
		    if (xblc <= xval && xval <= xtrc || xtrc <= xval && xval 
			    <= xblc) {
/*<                     CALL GRMOVA(XVAL, -TIKL) >*/
			r__1 = -tikl;
			grmova_(&xval, &r__1);
/*<                     CALL GRLINA(XVAL, TIKL) >*/
			grlina_(&xval, &tikl);
/*<                 END IF >*/
		    }
/*<    50       CONTINUE >*/
/* L50: */
		}
/*<    60       CONTINUE >*/
/* L60: */
	    }
/*<           END IF >*/
	}

/*         Top ticks. */

/*<           IF (XOPTC) THEN >*/
	if (xoptc) {
/*<             DO 80 I=I1-1,I2 >*/
	    i__1 = i2;
	    for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<             DO 70 J=1,JMAX >*/
		i__2 = jmax;
		for (j = 1; j <= i__2; ++j) {
/*<                 MAJOR = (MOD(I,NSUBX).EQ.0).AND.XOPTT.AND.J.EQ.1 >*/
		    major = i__ % nsubx == 0 && xoptt && j == 1;
/*<                 TIKL = TIKL2 >*/
		    tikl = tikl2;
/*<                 IF (MAJOR) TIKL = TIKL1 >*/
		    if (major) {
			tikl = tikl1;
		    }
/*<                 XVAL = (I+UTAB(J))*XINT2 >*/
		    xval = (i__ + utab[j - 1]) * xint2;
/*<                 IF (IRANGE(XBLC,XVAL,XTRC)) THEN >*/
		    if (xblc <= xval && xval <= xtrc || xtrc <= xval && xval 
			    <= xblc) {
/*<                     CALL GRMOVA(XVAL, YTRC-TIKL) >*/
			r__1 = ytrc - tikl;
			grmova_(&xval, &r__1);
/*<                     CALL GRLINA(XVAL, YTRC) >*/
			grlina_(&xval, &ytrc);
/*<                 END IF >*/
		    }
/*<    70       CONTINUE >*/
/* L70: */
		}
/*<    80       CONTINUE >*/
/* L80: */
	    }
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/* Write X labels. */

/*<       IF (XOPTN .OR. XOPTM) THEN >*/
    if (xoptn || xoptm) {
/*<           CALL PGBOX1(XBLC, XTRC, XINT, I1, I2) >*/
	pgbox1_(&xblc, &xtrc, &xint, &i1, &i2);
/*<           DO 90 I=I1,I2 >*/
	i__1 = i2;
	for (i__ = i1; i__ <= i__1; ++i__) {
/*<               XC = (I*XINT-XBLC)/(XTRC-XBLC) >*/
	    xc = (i__ * xint - xblc) / (xtrc - xblc);
/*<               IF (XOPTL) THEN >*/
	    if (xoptl) {
/*<                   CALL PGNUMB(1,NINT(I*XINT),XNFORM,CLBL,NC) >*/
		r__1 = i__ * xint;
		i__2 = i_nint(&r__1);
		pgnumb_(&c__1, &i__2, &xnform, clbl, &nc, (ftnlen)20);
/*<               ELSE >*/
	    } else {
/*<                   CALL PGNUMB(I*NV,NP,XNFORM,CLBL,NC) >*/
		i__2 = i__ * nv;
		pgnumb_(&i__2, &np, &xnform, clbl, &nc, (ftnlen)20);
/*<               END IF >*/
	    }
/*<               IF (XOPTN) CALL PGMTXT('B', XNDSP, XC, 0.5, CLBL(1:NC)) >*/
	    if (xoptn) {
		pgmtxt_("B", &xndsp, &xc, &c_b50, clbl, (ftnlen)1, nc);
	    }
/*<               IF (XOPTM) CALL PGMTXT('T', XMDSP, XC, 0.5, CLBL(1:NC)) >*/
	    if (xoptm) {
		pgmtxt_("T", &xmdsp, &xc, &c_b50, clbl, (ftnlen)1, nc);
	    }
/*<    90     CONTINUE >*/
/* L90: */
	}
/*<       END IF >*/
    }

/* Extra X labels for log axes. */

/*<       IF (XOPTLS) THEN >*/
    if (xoptls) {
/*<           CALL PGBOX1(XBLC, XTRC, XINT2, I1, I2) >*/
	pgbox1_(&xblc, &xtrc, &xint2, &i1, &i2);
/*<           DO 401 I=I1-1,I2 >*/
	i__1 = i2;
	for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<              DO 301 J=2,5,3 >*/
	    for (j = 2; j <= 5; j += 3) {
/*<                 XVAL = (I+UTAB(J))*XINT2 >*/
		xval = (i__ + utab[j - 1]) * xint2;
/*<                 XC = (XVAL-XBLC)/(XTRC-XBLC) >*/
		xc = (xval - xblc) / (xtrc - xblc);
/*<                 KI = I >*/
		ki = i__;
/*<                 IF (XTRC.LT.XBLC) KI = KI+1 >*/
		if (xtrc < xblc) {
		    ++ki;
		}
/*<                 IF (IRANGE(XBLC,XVAL,XTRC)) THEN >*/
		if (xblc <= xval && xval <= xtrc || xtrc <= xval && xval <= 
			xblc) {
/*<                     CALL PGNUMB(J,NINT(KI*XINT2),XNFORM,CLBL,NC) >*/
		    r__1 = ki * xint2;
		    i__2 = i_nint(&r__1);
		    pgnumb_(&j, &i__2, &xnform, clbl, &nc, (ftnlen)20);
/*<    >*/
		    if (xoptn) {
			pgmtxt_("B", &xndsp, &xc, &c_b50, clbl, (ftnlen)1, nc)
				;
		    }
/*<    >*/
		    if (xoptm) {
			pgmtxt_("T", &xmdsp, &xc, &c_b50, clbl, (ftnlen)1, nc)
				;
		    }
/*<                 END IF >*/
		}
/*<   301       CONTINUE >*/
/* L301: */
	    }
/*<   401     CONTINUE >*/
/* L401: */
	}
/*<       END IF >*/
    }

/* Length of Y tick marks. */

/*<       TIKL1 = PGXSP(PGID)*0.6*(XTRC-XBLC)/PGXLEN(PGID) >*/
    tikl1 = pgplt1_1.pgxsp[pgplt1_1.pgid - 1] * (float).6 * (xtrc - xblc) / 
	    pgplt1_1.pgxlen[pgplt1_1.pgid - 1];
/*<       IF (YOPTI) TIKL1 = -TIKL1 >*/
    if (yopti) {
	tikl1 = -tikl1;
    }
/*<       TIKL2 = TIKL1*0.5 >*/
    tikl2 = tikl1 * (float).5;

/* Choose Y tick intervals. Major interval = YINT, */
/* minor interval = YINT2 = YINT/NSUBY. */

/*<       UTAB(1) = 0.0 >*/
    utab[0] = (float)0.;
/*<       IF (YOPTL) THEN >*/
    if (yoptl) {
/*<           YINT = SIGN(1.0,YTRC-YBLC) >*/
	r__1 = ytrc - yblc;
	yint = r_sign(&c_b37, &r__1);
/*<           NSUBY = 1 >*/
	nsuby = 1;
/*<           DO 100 J=2,9 >*/
	for (j = 2; j <= 9; ++j) {
/*<               UTAB(J) = TAB(J) >*/
	    utab[j - 1] = tab[j - 1];
/*<               IF (YINT.LT.0.0) UTAB(J) = 1.0-TAB(J) >*/
	    if (yint < (float)0.) {
		utab[j - 1] = (float)1. - tab[j - 1];
	    }
/*<   100     CONTINUE >*/
/* L100: */
	}
/*<       ELSE IF (YTICK.EQ.0.0) THEN >*/
    } else if (*ytick == (float)0.) {
/*<    >*/
/* Computing MAX */
/* Computing MIN */
	r__3 = pgplt1_1.pgxsp[pgplt1_1.pgid - 1] * (float)7. / 
		pgplt1_1.pgylen[pgplt1_1.pgid - 1];
	r__1 = (float).05, r__2 = dmin(r__3,(float).2);
	yint = dmax(r__1,r__2) * (ytrc - yblc);
/*<           YINT = PGRND(YINT,NSUBY) >*/
	yint = pgrnd_(&yint, &nsuby);
/*<       ELSE >*/
    } else {
/*<           YINT  = SIGN(YTICK,YTRC-YBLC) >*/
	r__1 = ytrc - yblc;
	yint = r_sign(ytick, &r__1);
/*<           NSUBY = MAX(NYSUB,1) >*/
	nsuby = max(*nysub,1);
/*<       END IF >*/
    }
/*<       IF (.NOT.YOPTS) NSUBY = 1 >*/
    if (! yopts) {
	nsuby = 1;
    }
/*<       NP = INT(LOG10(ABS(YINT)))-4 >*/
    r__1 = dabs(yint);
    np = (integer) r_lg10(&r__1) - 4;
/*<       NV = NINT(YINT/10.**NP) >*/
    r__1 = yint / pow_ri(&c_b39, &np);
    nv = i_nint(&r__1);
/*<       YINT2 = YINT/NSUBY >*/
    yint2 = yint / nsuby;
/*<       YOPTLS = YOPTL .AND. YOPTS .AND. (ABS(YTRC-YBLC).LT.2.0) >*/
    yoptls = yoptl && yopts && (r__1 = ytrc - yblc, dabs(r__1)) < (float)2.;

/* Draw Y grid. */

/*<       IF (YOPTG) THEN >*/
    if (yoptg) {
/*<           CALL PGBOX1(YBLC, YTRC, YINT, I1, I2) >*/
	pgbox1_(&yblc, &ytrc, &yint, &i1, &i2);
/*<           DO 110 I=I1,I2 >*/
	i__1 = i2;
	for (i__ = i1; i__ <= i__1; ++i__) {
/*<               CALL GRMOVA(XBLC, REAL(I)*YINT) >*/
	    r__1 = (real) i__ * yint;
	    grmova_(&xblc, &r__1);
/*<               CALL GRLINA(XTRC, REAL(I)*YINT) >*/
	    r__1 = (real) i__ * yint;
	    grlina_(&xtrc, &r__1);
/*<   110     CONTINUE >*/
/* L110: */
	}
/*<       END IF >*/
    }

/* Draw Y ticks. */

/*<       IF (YOPTT.OR.YOPTS) THEN >*/
    if (yoptt || yopts) {
/*<           CALL PGBOX1(YBLC, YTRC, YINT2, I1, I2) >*/
	pgbox1_(&yblc, &ytrc, &yint2, &i1, &i2);
/*<           JMAX = 1 >*/
	jmax = 1;
/*<           IF (YOPTL.AND.YOPTS) JMAX = 9 >*/
	if (yoptl && yopts) {
	    jmax = 9;
	}

/*               Left ticks. */

/*<             IF (YOPTB) THEN >*/
	if (yoptb) {
/*<             DO 130 I=I1-1,I2 >*/
	    i__1 = i2;
	    for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<             DO 120 J=1,JMAX >*/
		i__2 = jmax;
		for (j = 1; j <= i__2; ++j) {
/*<                 MAJOR = (MOD(I,NSUBY).EQ.0).AND.YOPTT.AND.J.EQ.1 >*/
		    major = i__ % nsuby == 0 && yoptt && j == 1;
/*<                 TIKL = TIKL2 >*/
		    tikl = tikl2;
/*<                 IF (MAJOR) TIKL = TIKL1 >*/
		    if (major) {
			tikl = tikl1;
		    }
/*<                 YVAL = (I+UTAB(J))*YINT2 >*/
		    yval = (i__ + utab[j - 1]) * yint2;
/*<                 IF (IRANGE(YBLC,YVAL,YTRC)) THEN >*/
		    if (yblc <= yval && yval <= ytrc || ytrc <= yval && yval 
			    <= yblc) {
/*<                     IF (YOPTP.AND.MAJOR) THEN >*/
			if (yoptp && major) {
/*<                         CALL GRMOVA(XBLC-TIKL2, YVAL) >*/
			    r__1 = xblc - tikl2;
			    grmova_(&r__1, &yval);
/*<                     ELSE >*/
			} else {
/*<                         CALL GRMOVA(XBLC, YVAL) >*/
			    grmova_(&xblc, &yval);
/*<                     END IF >*/
			}
/*<                     CALL GRLINA(XBLC+TIKL, YVAL) >*/
			r__1 = xblc + tikl;
			grlina_(&r__1, &yval);
/*<                 END IF >*/
		    }
/*<   120       CONTINUE >*/
/* L120: */
		}
/*<   130       CONTINUE >*/
/* L130: */
	    }
/*<             END IF >*/
	}

/*               Axis ticks. */

/*<             IF (YOPTA) THEN >*/
	if (yopta) {
/*<             DO 150 I=I1-1,I2 >*/
	    i__1 = i2;
	    for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<             DO 140 J=1,JMAX >*/
		i__2 = jmax;
		for (j = 1; j <= i__2; ++j) {
/*<                 MAJOR = (MOD(I,NSUBY).EQ.0).AND.YOPTT.AND.J.EQ.1 >*/
		    major = i__ % nsuby == 0 && yoptt && j == 1;
/*<                 TIKL = TIKL2 >*/
		    tikl = tikl2;
/*<                 IF (MAJOR) TIKL = TIKL1 >*/
		    if (major) {
			tikl = tikl1;
		    }
/*<                 YVAL = (I+UTAB(J))*YINT2 >*/
		    yval = (i__ + utab[j - 1]) * yint2;
/*<                 IF (IRANGE(YBLC,YVAL,YTRC)) THEN >*/
		    if (yblc <= yval && yval <= ytrc || ytrc <= yval && yval 
			    <= yblc) {
/*<                     CALL GRMOVA(-TIKL, YVAL) >*/
			r__1 = -tikl;
			grmova_(&r__1, &yval);
/*<                     CALL GRLINA(TIKL, YVAL) >*/
			grlina_(&tikl, &yval);
/*<                 END IF >*/
		    }
/*<   140       CONTINUE >*/
/* L140: */
		}
/*<   150       CONTINUE >*/
/* L150: */
	    }
/*<             END IF >*/
	}

/*               Right ticks. */

/*<             IF (YOPTC) THEN >*/
	if (yoptc) {
/*<             DO 170 I=I1-1,I2 >*/
	    i__1 = i2;
	    for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<             DO 160 J=1,JMAX >*/
		i__2 = jmax;
		for (j = 1; j <= i__2; ++j) {
/*<                 MAJOR = (MOD(I,NSUBY).EQ.0).AND.YOPTT.AND.J.EQ.1 >*/
		    major = i__ % nsuby == 0 && yoptt && j == 1;
/*<                 TIKL = TIKL2 >*/
		    tikl = tikl2;
/*<                 IF (MAJOR) TIKL = TIKL1 >*/
		    if (major) {
			tikl = tikl1;
		    }
/*<                 YVAL = (I+UTAB(J))*YINT2 >*/
		    yval = (i__ + utab[j - 1]) * yint2;
/*<                 IF (IRANGE(YBLC,YVAL,YTRC)) THEN >*/
		    if (yblc <= yval && yval <= ytrc || ytrc <= yval && yval 
			    <= yblc) {
/*<                     CALL GRMOVA(XTRC-TIKL, YVAL) >*/
			r__1 = xtrc - tikl;
			grmova_(&r__1, &yval);
/*<                     CALL GRLINA(XTRC, YVAL) >*/
			grlina_(&xtrc, &yval);
/*<                 END IF >*/
		    }
/*<   160       CONTINUE >*/
/* L160: */
		}
/*<   170       CONTINUE >*/
/* L170: */
	    }
/*<             END IF >*/
	}
/*<         END IF >*/
    }

/* Write Y labels. */

/*<       IF (YOPTN.OR.YOPTM) THEN >*/
    if (yoptn || yoptm) {
/*<           CALL PGBOX1(YBLC, YTRC, YINT, I1, I2) >*/
	pgbox1_(&yblc, &ytrc, &yint, &i1, &i2);
/*<           DO 180 I=I1,I2 >*/
	i__1 = i2;
	for (i__ = i1; i__ <= i__1; ++i__) {
/*<               YC = (I*YINT-YBLC)/(YTRC-YBLC) >*/
	    yc = (i__ * yint - yblc) / (ytrc - yblc);
/*<               IF (YOPTL) THEN >*/
	    if (yoptl) {
/*<                   CALL PGNUMB(1,NINT(I*YINT),YNFORM,CLBL,NC) >*/
		r__1 = i__ * yint;
		i__2 = i_nint(&r__1);
		pgnumb_(&c__1, &i__2, &ynform, clbl, &nc, (ftnlen)20);
/*<               ELSE >*/
	    } else {
/*<                   CALL PGNUMB(I*NV,NP,YNFORM,CLBL,NC) >*/
		i__2 = i__ * nv;
		pgnumb_(&i__2, &np, &ynform, clbl, &nc, (ftnlen)20);
/*<               END IF >*/
	    }
/*<               IF (YOPTV) THEN >*/
	    if (yoptv) {
/*<                   IF (YOPTN) CALL PGMTXT('LV',YNVDSP,YC,1.0,CLBL(1:NC)) >*/
		if (yoptn) {
		    pgmtxt_("LV", &ynvdsp, &yc, &c_b37, clbl, (ftnlen)2, nc);
		}
/*<                   IF (YOPTM) CALL PGMTXT('RV',YMVDSP,YC,0.0,CLBL(1:NC)) >*/
		if (yoptm) {
		    pgmtxt_("RV", &ymvdsp, &yc, &c_b4, clbl, (ftnlen)2, nc);
		}
/*<               ELSE >*/
	    } else {
/*<                   IF (YOPTN) CALL PGMTXT('L',YNDSP,YC,0.5,CLBL(1:NC)) >*/
		if (yoptn) {
		    pgmtxt_("L", &yndsp, &yc, &c_b50, clbl, (ftnlen)1, nc);
		}
/*<                   IF (YOPTM) CALL PGMTXT('R',YMDSP,YC,0.5,CLBL(1:NC)) >*/
		if (yoptm) {
		    pgmtxt_("R", &ymdsp, &yc, &c_b50, clbl, (ftnlen)1, nc);
		}
/*<               END IF >*/
	    }
/*<   180     CONTINUE >*/
/* L180: */
	}
/*<       END IF >*/
    }

/* Extra Y labels for log axes. */

/*<       IF (YOPTLS) THEN >*/
    if (yoptls) {
/*<           CALL PGBOX1(YBLC, YTRC, YINT2, I1, I2) >*/
	pgbox1_(&yblc, &ytrc, &yint2, &i1, &i2);
/*<           DO 402 I=I1-1,I2 >*/
	i__1 = i2;
	for (i__ = i1 - 1; i__ <= i__1; ++i__) {
/*<             DO 302 J=2,5,3 >*/
	    for (j = 2; j <= 5; j += 3) {
/*<                 YVAL = (I+UTAB(J))*YINT2 >*/
		yval = (i__ + utab[j - 1]) * yint2;
/*<                 YC = (YVAL-YBLC)/(YTRC-YBLC) >*/
		yc = (yval - yblc) / (ytrc - yblc);
/*<                 KI = I >*/
		ki = i__;
/*<                 IF (YBLC.GT.YTRC) KI = KI+1 >*/
		if (yblc > ytrc) {
		    ++ki;
		}
/*<                 IF (IRANGE(YBLC,YVAL,YTRC)) THEN >*/
		if (yblc <= yval && yval <= ytrc || ytrc <= yval && yval <= 
			yblc) {
/*<                     CALL PGNUMB(J,NINT(KI*YINT2),YNFORM,CLBL,NC) >*/
		    r__1 = ki * yint2;
		    i__2 = i_nint(&r__1);
		    pgnumb_(&j, &i__2, &ynform, clbl, &nc, (ftnlen)20);
/*<                     IF (YOPTV) THEN >*/
		    if (yoptv) {
/*<    >*/
			if (yoptn) {
			    pgmtxt_("LV", &ynvdsp, &yc, &c_b37, clbl, (ftnlen)
				    2, nc);
			}
/*<    >*/
			if (yoptm) {
			    pgmtxt_("RV", &ymvdsp, &yc, &c_b4, clbl, (ftnlen)
				    2, nc);
			}
/*<                     ELSE >*/
		    } else {
/*<    >*/
			if (yoptn) {
			    pgmtxt_("L", &yndsp, &yc, &c_b50, clbl, (ftnlen)1,
				     nc);
			}
/*<    >*/
			if (yoptm) {
			    pgmtxt_("R", &ymdsp, &yc, &c_b50, clbl, (ftnlen)1,
				     nc);
			}
/*<                     END IF >*/
		    }
/*<                 END IF >*/
		}
/*<   302       CONTINUE >*/
/* L302: */
	    }
/*<   402     CONTINUE >*/
/* L402: */
	}
/*<       END IF >*/
    }

/* Enable clipping. */

/*<       CALL PGSCLP(CLIP) >*/
    pgsclp_(&clip);

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgbox_ */

