/* /work2/ssa/pgplot/src/pgbox1.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* PGBOX1 -- support routine for PGBOX */

/*<       SUBROUTINE PGBOX1 (XA, XB, XD, I1, I2) >*/
/* Subroutine */ int pgbox1_(xa, xb, xd, i1, i2)
real *xa, *xb, *xd;
integer *i1, *i2;
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    integer i_nint();

    /* Local variables */
    static real xhi, xlo;

/*<       REAL XA, XB, XD >*/
/*<       INTEGER I1, I2 >*/

/* This routine is used to determine where to draw the tick marks on */
/* an axis. The input arguments XA and XB are the world-coordinate */
/* end points of the axis; XD is the tick interval. PGBOX1 returns */
/* two integers, I1 and I2, such that the required tick marks are */
/* to be placed at world-coordinates (I*XD), for I=I1,...,I2. */
/* Normally I2 is greater than or equal to I1, but if there are no */
/* values of I such that I*XD lies in the inclusive range (XA, XB), */
/* then I2 will be 1 less than I1. */

/* Arguments: */
/*  XA, XB (input)  : world-coordinate end points of the axis. XA must */
/*                    not be equal to XB; otherwise, there are no */
/*                    restrictions. */
/*  XD     (input)  : world-coordinate tick interval. XD may be positive */
/*                    or negative, but may not be zero. */
/*  I1, I2 (output) : tick marks should be drawn at world */
/*                    coordinates I*XD for I in the inclusive range */
/*                    I1...I2 (see above). */

/* 14-Jan-1986 - new routine [TJP]. */
/* 13-Dec-1990 - remove rror check [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       REAL XLO, XHI >*/

/*<       XLO = MIN(XA/XD, XB/XD) >*/
/* Computing MIN */
    r__1 = *xa / *xd, r__2 = *xb / *xd;
    xlo = dmin(r__1,r__2);
/*<       XHI = MAX(XA/XD, XB/XD) >*/
/* Computing MAX */
    r__1 = *xa / *xd, r__2 = *xb / *xd;
    xhi = dmax(r__1,r__2);
/*<       I1 = NINT(XLO) >*/
    *i1 = i_nint(&xlo);
/*<       IF (I1.LT.XLO) I1 = I1+1 >*/
    if ((real) (*i1) < xlo) {
	++(*i1);
    }
/*<       I2 = NINT(XHI) >*/
    *i2 = i_nint(&xhi);
/*<       IF (I2.GT.XHI) I2 = I2-1 >*/
    if ((real) (*i2) > xhi) {
	--(*i2);
    }
/*<       END >*/
} /* pgbox1_ */

