/* /work2/ssa/pgplot/src/pgconf.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGCONF -- fill between two contours */
/* %void cpgconf(const float *a, int idim, int jdim, int i1, int i2, \ */
/* % int j1, int j2, float c1, float c2, const float *tr); */
/* + */
/*<       SUBROUTINE PGCONF (A, IDIM, JDIM, I1, I2, J1, J2, C1, C2, TR) >*/
/* Subroutine */ int pgconf_(a, idim, jdim, i1, i2, j1, j2, c1, c2, tr)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *c1, *c2, *tr;
{
    /* Initialized data */

    static integer idelt[6] = { 0,-1,-1,0,0,-1 };

    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;

    /* Local variables */
    static real dval[5], c__;
    static integer i__, j;
    static real r__, x[8], y[8], delta;
    static integer ic;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_();
    static real xx, yy;
    extern logical pgnoto_();
    extern /* Subroutine */ int pgpoly_();
    static integer lev, npt;

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2 >*/
/*<       REAL    A(IDIM,JDIM), C1, C2, TR(6) >*/

/* Shade the region between two contour levels of a function defined on */
/* the nodes of a rectangular grid. The routine uses the current fill */
/* attributes, hatching style (if appropriate), and color index. */

/* If you want to both shade between contours and draw the contour */
/* lines, call this routine first (once for each pair of levels) and */
/* then CALL PGCONT (or PGCONS) to draw the contour lines on top of the */
/* shading. */

/* Note 1: This routine is not very efficient: it generates a polygon */
/* fill command for each cell of the mesh that intersects the desired */
/* area, rather than consolidating adjacent cells into a single polygon. */

/* Note 2: If both contours intersect all four edges of a particular */
/* mesh cell, the program behaves badly and may consider some parts */
/* of the cell to lie in more than one contour range. */

/* Note 3: If a contour crosses all four edges of a cell, this */
/* routine may not generate the same contours as PGCONT or PGCONS */
/* (these two routines may not agree either). Such cases are always */
/* ambiguous and the routines use different approaches to resolving */
/* the ambiguity. */

/* Arguments: */
/*  A      (input)  : data array. */
/*  IDIM   (input)  : first dimension of A. */
/*  JDIM   (input)  : second dimension of A. */
/*  I1,I2  (input)  : range of first index to be contoured (inclusive). */
/*  J1,J2  (input)  : range of second index to be contoured (inclusive). */
/*  C1, C2 (input)  : contour levels; note that C1 must be less than C2. */
/*  TR     (input)  : array defining a transformation between the I,J */
/*                    grid of the array and the world coordinates. The */
/*                    world coordinates of the array point A(I,J) are */
/*                    given by: */
/*                      X = TR(1) + TR(2)*I + TR(3)*J */
/*                      Y = TR(4) + TR(5)*I + TR(6)*J */
/*                    Usually TR(3) and TR(5) are zero - unless the */
/*                    coordinate transformation involves a rotation */
/*                    or shear. */
/* -- */
/* 03-Oct-1996 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I, J, IC, NPT, LEV >*/
/*<       LOGICAL  PGNOTO >*/
/*<       REAL     DVAL(5), X(8), Y(8), DELTA, XX, YY, C, R >*/
/*<       INTEGER  IDELT(6) >*/
/*<       DATA     IDELT/0,-1,-1,0,0,-1/ >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --tr;

    /* Function Body */

/* Check arguments. */

/*<       IF (PGNOTO('PGCONF')) RETURN >*/
    if (pgnoto_("PGCONF", (ftnlen)6)) {
	return 0;
    }
/*<    >*/
    if (*i1 < 1 || *i2 > *idim || *i1 >= *i2 || *j1 < 1 || *j2 > *jdim || *j1 
	    >= *j2) {
	return 0;
    }
/*<       IF (C1.GE.C2) RETURN >*/
    if (*c1 >= *c2) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/*<       DO 140 J=J1+1,J2 >*/
    i__1 = *j2;
    for (j = *j1 + 1; j <= i__1; ++j) {
/*<          DO 130 I=I1+1,I2 >*/
	i__2 = *i2;
	for (i__ = *i1 + 1; i__ <= i__2; ++i__) {
/*<             DVAL(1) = A(I-1,J) >*/
	    dval[0] = a[i__ - 1 + j * a_dim1];
/*<             DVAL(2) = A(I-1,J-1) >*/
	    dval[1] = a[i__ - 1 + (j - 1) * a_dim1];
/*<             DVAL(3) = A(I,J-1) >*/
	    dval[2] = a[i__ + (j - 1) * a_dim1];
/*<             DVAL(4) = A(I,J) >*/
	    dval[3] = a[i__ + j * a_dim1];
/*<             DVAL(5) = DVAL(1) >*/
	    dval[4] = dval[0];

/*<             NPT = 0 >*/
	    npt = 0;
/*<             DO 120 IC=1,4 >*/
	    for (ic = 1; ic <= 4; ++ic) {
/*<                IF (DVAL(IC).GE.C1 .AND. DVAL(IC).LT.C2) THEN >*/
		if (dval[ic - 1] >= *c1 && dval[ic - 1] < *c2) {
/*<                   NPT = NPT+1 >*/
		    ++npt;
/*<                   XX = I+IDELT(IC+1) >*/
		    xx = (real) (i__ + idelt[ic]);
/*<                   YY = J+IDELT(IC) >*/
		    yy = (real) (j + idelt[ic - 1]);
/*<                   X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY >*/
		    x[npt - 1] = tr[1] + tr[2] * xx + tr[3] * yy;
/*<                   Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY >*/
		    y[npt - 1] = tr[4] + tr[5] * xx + tr[6] * yy;
/*<                END IF >*/
		}
/*<                R = DVAL(IC+1)-DVAL(IC) >*/
		r__ = dval[ic] - dval[ic - 1];
/*<                IF (R.EQ.0.0) GOTO 120 >*/
		if (r__ == (float)0.) {
		    goto L120;
		}
/*<                DO 110 LEV=1,2 >*/
		for (lev = 1; lev <= 2; ++lev) {
/*<                   IF (R.GT.0.0) THEN >*/
		    if (r__ > (float)0.) {
/*<                      C = C1 >*/
			c__ = *c1;
/*<                      IF (LEV.EQ.2) C = C2 >*/
			if (lev == 2) {
			    c__ = *c2;
			}
/*<                   ELSE >*/
		    } else {
/*<                      C = C2 >*/
			c__ = *c2;
/*<                      IF (LEV.EQ.2) C = C1 >*/
			if (lev == 2) {
			    c__ = *c1;
			}
/*<                   END IF >*/
		    }
/*<                   DELTA = (C-DVAL(IC))/R >*/
		    delta = (c__ - dval[ic - 1]) / r__;
/*<                   IF (DELTA.GT.0.0 .AND. DELTA.LT.1.0) THEN >*/
		    if (delta > (float)0. && delta < (float)1.) {
/*<                      IF (IC.EQ.1 .OR. IC.EQ.3) THEN >*/
			if (ic == 1 || ic == 3) {
/*<                         XX = I+IDELT(IC+1) >*/
			    xx = (real) (i__ + idelt[ic]);
/*<    >*/
			    yy = (real) (j + idelt[ic - 1]) + delta * (real) (
				    idelt[ic] - idelt[ic - 1]);
/*<                      ELSE >*/
			} else {
/*<    >*/
			    xx = (real) (i__ + idelt[ic]) + delta * (real) (
				    idelt[ic + 1] - idelt[ic]);
/*<                         YY = J+IDELT(IC) >*/
			    yy = (real) (j + idelt[ic - 1]);
/*<                      END IF >*/
			}
/*<                      NPT = NPT+1 >*/
			++npt;
/*<                      X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY >*/
			x[npt - 1] = tr[1] + tr[2] * xx + tr[3] * yy;
/*<                      Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY >*/
			y[npt - 1] = tr[4] + tr[5] * xx + tr[6] * yy;
/*<                   END IF >*/
		    }
/*<  110           CONTINUE >*/
/* L110: */
		}
/*<  120        CONTINUE >*/
L120:
		;
	    }
/*<             IF (NPT.GE.3) CALL PGPOLY(NPT, X, Y) >*/
	    if (npt >= 3) {
		pgpoly_(&npt, x, y);
	    }
/*<  130     CONTINUE >*/
/* L130: */
	}
/*<  140  CONTINUE >*/
/* L140: */
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgconf_ */

