/* /work2/ssa/pgplot/src/pgconl.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__1 = 1;

/* *PGCONL -- label contour map of a 2D data array */
/* %void cpgconl(const float *a, int idim, int jdim, int i1, int i2, \ */
/* % int j1, int j2, float c, const float *tr, const char *label, \ */
/* % int intval, int minint); */
/* + */
/*<    >*/
/* Subroutine */ int pgconl_(a, idim, jdim, i1, i2, j1, j2, c__, tr, label, 
	intval, minint, label_len)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *c__, *tr;
char *label;
integer *intval, *minint;
ftnlen label_len;
{
    /* System generated locals */
    integer a_dim1, a_offset;

    /* Builtin functions */
    /* Subroutine */ int s_copy();

    /* Local variables */
    extern /* Subroutine */ int pgcl_();
    static integer i__;
    static real cl[1];
    extern logical pgnoto_();
    extern /* Subroutine */ int pgconx_();

/*<       INTEGER IDIM, JDIM, I1, J1, I2, J2, INTVAL, MININT >*/
/*<       REAL A(IDIM,JDIM), C, TR(6) >*/
/*<       CHARACTER*(*) LABEL >*/

/* Label a contour map drawn with routine PGCONT. Routine PGCONT should */
/* be called first to draw the contour lines, then this routine should be */
/* called to add the labels. Labels are written at intervals along the */
/* contour lines, centered on the contour lines with lettering aligned */
/* in the up-hill direction. Labels are opaque, so a part of the under- */
/* lying contour line is obscured by the label. Labels use the current */
/* attributes (character height, line width, color index, character */
/* font). */

/* The first 9 arguments are the same as those supplied to PGCONT, and */
/* should normally be identical to those used with PGCONT. Note that */
/* only one contour level can be specified; tolabel more contours, call */
/* PGCONL for each level. */

/* The Label is supplied as a character string in argument LABEL. */

/* The spacing of labels along the contour is specified by parameters */
/* INTVAL and MININT. The routine follows the contour through the */
/* array, counting the number of cells that the contour crosses. The */
/* first label will be written in the MININT'th cell, and additional */
/* labels will be written every INTVAL cells thereafter. A contour */
/* that crosses less than MININT cells will not be labelled. Some */
/* experimentation may be needed to get satisfactory results; a good */
/* place to start is INTVAL=20, MININT=10. */

/* Arguments: */
/*  A      (input) : data array. */
/*  IDIM   (input) : first dimension of A. */
/*  JDIM   (input) : second dimension of A. */
/*  I1, I2 (input) : range of first index to be contoured (inclusive). */
/*  J1, J2 (input) : range of second index to be contoured (inclusive). */
/*  C      (input) : the level of the contour to be labelled (one of the */
/*                   values given to PGCONT). */
/*  TR     (input) : array defining a transformation between the I,J */
/*                   grid of the array and the world coordinates. */
/*                   The world coordinates of the array point A(I,J) */
/*                   are given by: */
/*                     X = TR(1) + TR(2)*I + TR(3)*J */
/*                     Y = TR(4) + TR(5)*I + TR(6)*J */
/*                   Usually TR(3) and TR(5) are zero - unless the */
/*                   coordinate transformation involves a rotation or */
/*                   shear. */
/*  LABEL  (input) : character strings to be used to label the specified */
/*                   contour. Leading and trailing blank spaces are */
/*                   ignored. */
/*  INTVAL (input) : spacing along the contour between labels, in */
/*                   grid cells. */
/*  MININT (input) : contours that cross less than MININT cells */
/*                   will not be labelled. */
/* -- */
/*  5-May-1994 - New routine; this routine is virtually identical to */
/*               PGCONT, but calls PGCONX with a different external */
/*               routine [TJP]. */
/*  4-Feb-1997 - PGCONX requires an array argument, not scalar [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       INTEGER  I >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL  PGNOTO >*/
/*<       REAL     CL(1) >*/
/*<       EXTERNAL PGCL >*/

/*<       IF (PGNOTO('PGCONL')) RETURN >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --tr;

    /* Function Body */
    if (pgnoto_("PGCONL", (ftnlen)6)) {
	return 0;
    }

/* Save TRANS matrix and other parameters. */

/*<       DO 10 I=1,6 >*/
    for (i__ = 1; i__ <= 6; ++i__) {
/*<           TRANS(I) = TR(I) >*/
	pgplt1_1.trans[i__ - 1] = tr[i__];
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       PGCINT = INTVAL >*/
    pgplt1_1.pgcint = *intval;
/*<       PGCMIN = MININT >*/
    pgplt1_1.pgcmin = *minint;
/*<       PGCLAB = LABEL >*/
    s_copy(pgplt2_1.pgclab, label, (ftnlen)32, label_len);

/* Use PGCONX with external function PGCL. */

/*<       CL(1) = C >*/
    cl[0] = *c__;
/*<       CALL PGCONX (A, IDIM, JDIM, I1, I2, J1, J2, CL, 1, PGCL) >*/
    pgconx_(&a[a_offset], idim, jdim, i1, i2, j1, j2, cl, &c__1, pgcl_);

/*<       END >*/
} /* pgconl_ */

