/* /work2/ssa/pgplot/src/pghis1.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/*<       REAL FUNCTION PGHIS1 (X, NELMX, CENTER, IXV) >*/
doublereal pghis1_(x, nelmx, center, ixv)
real *x;
integer *nelmx;
logical *center;
integer *ixv;
{
    /* System generated locals */
    real ret_val;

    /* Local variables */
    static real xn;

/*<       LOGICAL CENTER >*/
/*<       INTEGER NELMX, IXV >*/
/*<       REAL X(NELMX) >*/

/* PGPLOT Internal routine used by PGHI2D.  Calculates the X-value for */
/* the left hand edge of a given element of the array being plotted. */

/* Arguments - */

/* X (input, real array): abscissae of bins */
/* NELMX (input, integer): number of bins */
/* CENTER (Input, logical): if .true., X values denote the center of */
/*       the bin; if .false., the X values denote the lower edge (in X) */
/*       of the bin. */
/* IXV (input, integer): the bin number in question.  Note IXV may be */
/*       outside the range 1..NELMX, in which case an interpolated */
/*       value is returned. */

/* 21-Feb-1984 - Keith Shortridge. */
/*  6-Sep-1989 - Changes for standard Fortran-77 [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       REAL XN >*/
/*<       INTRINSIC REAL >*/

/*<       IF (CENTER) THEN >*/
    /* Parameter adjustments */
    --x;

    /* Function Body */
    if (*center) {
/*<           IF ((IXV.GT.1).AND.(IXV.LE.NELMX)) THEN >*/
	if (*ixv > 1 && *ixv <= *nelmx) {
/*<             XN = ( X(IXV-1) + X(IXV) ) * .5 >*/
	    xn = (x[*ixv - 1] + x[*ixv]) * (float).5;
/*<           ELSE IF (IXV.LE.1) THEN >*/
	} else if (*ixv <= 1) {
/*<             XN = X(1) - .5 * (X(2) - X(1)) * REAL(3 - 2 * IXV) >*/
	    xn = x[1] - (x[2] - x[1]) * (float).5 * (real) (3 - (*ixv << 1));
/*<           ELSE IF (IXV.GT.NELMX) THEN >*/
	} else if (*ixv > *nelmx) {
/*<    >*/
	    xn = x[*nelmx] + (x[*nelmx] - x[*nelmx - 1]) * (float).5 * (real) 
		    ((*ixv - *nelmx << 1) - 1);
/*<           END IF >*/
	}
/*<       ELSE >*/
    } else {
/*<           IF ((IXV.GE.1).AND.(IXV.LE.NELMX)) THEN >*/
	if (*ixv >= 1 && *ixv <= *nelmx) {
/*<             XN = X(IXV) >*/
	    xn = x[*ixv];
/*<           ELSE IF (IXV.LT.1) THEN >*/
	} else if (*ixv < 1) {
/*<             XN = X(1) - ( X(2) - X(1) ) * REAL( 1 - IXV ) >*/
	    xn = x[1] - (x[2] - x[1]) * (real) (1 - *ixv);
/*<           ELSE IF (IXV.GT.NELMX) THEN >*/
	} else if (*ixv > *nelmx) {
/*<    >*/
	    xn = x[*nelmx] + (x[*nelmx] - x[*nelmx - 1]) * (real) (*ixv - *
		    nelmx);
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/*<       PGHIS1 = XN >*/
    ret_val = xn;
/*<       END >*/
    return ret_val;
} /* pghis1_ */

