/* /work2/ssa/pgplot/src/pglen.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGLEN -- find length of a string in a variety of units */
/* %void cpglen(int units, const char *string, float *xl, float *yl); */
/* + */
/*<       SUBROUTINE PGLEN (UNITS, STRING, XL, YL) >*/
/* Subroutine */ int pglen_(units, string, xl, yl, string_len)
integer *units;
char *string;
real *xl, *yl;
ftnlen string_len;
{
    /* System generated locals */
    real r__1;

    /* Local variables */
    static real d__;
    extern /* Subroutine */ int grlen_(), grwarn_();
    extern logical pgnoto_();

/*<       REAL XL, YL >*/
/*<       INTEGER UNITS >*/
/*<       CHARACTER*(*) STRING >*/

/* Work out length of a string in x and y directions */

/* Input */
/*  UNITS    :  0 => answer in normalized device coordinates */
/*              1 => answer in inches */
/*              2 => answer in mm */
/*              3 => answer in absolute device coordinates (dots) */
/*              4 => answer in world coordinates */
/*              5 => answer as a fraction of the current viewport size */

/*  STRING   :  String of interest */
/* Output */
/*  XL       :  Length of string in x direction */
/*  YL       :  Length of string in y direction */

/* -- */
/* 15-Sep-1989 - new routine (Neil Killeen) */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       LOGICAL PGNOTO >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL    D >*/

/*<       IF (PGNOTO('PGLEN')) RETURN >*/
    if (pgnoto_("PGLEN", (ftnlen)5)) {
	return 0;
    }

/*   Work out length of a string in absolute device coordinates (dots) */
/*   and then convert */

/*<       CALL GRLEN (STRING, D) >*/
    grlen_(string, &d__, string_len);

/*<       IF (UNITS.EQ.0) THEN >*/
    if (*units == 0) {
/*<         XL = D / PGXSZ(PGID) >*/
	*xl = d__ / pgplt1_1.pgxsz[pgplt1_1.pgid - 1];
/*<         YL = D / PGYSZ(PGID) >*/
	*yl = d__ / pgplt1_1.pgysz[pgplt1_1.pgid - 1];
/*<       ELSE IF (UNITS.EQ.1) THEN >*/
    } else if (*units == 1) {
/*<         XL = D / PGXPIN(PGID) >*/
	*xl = d__ / pgplt1_1.pgxpin[pgplt1_1.pgid - 1];
/*<         YL = D / PGYPIN(PGID) >*/
	*yl = d__ / pgplt1_1.pgypin[pgplt1_1.pgid - 1];
/*<       ELSE IF (UNITS.EQ.2) THEN >*/
    } else if (*units == 2) {
/*<         XL = 25.4 * D / PGXPIN(PGID) >*/
	*xl = d__ * (float)25.4 / pgplt1_1.pgxpin[pgplt1_1.pgid - 1];
/*<         YL = 25.4 * D / PGYPIN(PGID) >*/
	*yl = d__ * (float)25.4 / pgplt1_1.pgypin[pgplt1_1.pgid - 1];
/*<       ELSE IF (UNITS.EQ.3) THEN >*/
    } else if (*units == 3) {
/*<         XL = D >*/
	*xl = d__;
/*<         YL = D >*/
	*yl = d__;
/*<       ELSE IF (UNITS.EQ.4) THEN >*/
    } else if (*units == 4) {
/*<         XL = D / ABS(PGXSCL(PGID)) >*/
	*xl = d__ / (r__1 = pgplt1_1.pgxscl[pgplt1_1.pgid - 1], dabs(r__1));
/*<         YL = D / ABS(PGYSCL(PGID)) >*/
	*yl = d__ / (r__1 = pgplt1_1.pgyscl[pgplt1_1.pgid - 1], dabs(r__1));
/*<       ELSE IF (UNITS.EQ.5) THEN >*/
    } else if (*units == 5) {
/*<         XL = D / PGXLEN(PGID) >*/
	*xl = d__ / pgplt1_1.pgxlen[pgplt1_1.pgid - 1];
/*<         YL = D / PGYLEN(PGID) >*/
	*yl = d__ / pgplt1_1.pgylen[pgplt1_1.pgid - 1];
/*<       ELSE >*/
    } else {
/*<         CALL GRWARN('Illegal value for UNITS in routine PGLEN') >*/
	grwarn_("Illegal value for UNITS in routine PGLEN", (ftnlen)40);
/*<       END IF >*/
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pglen_ */

