/* /work2/ssa/pgplot/src/pgncur.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__1 = 1;
static integer c__0 = 0;

/* *PGNCUR -- mark a set of points using the cursor */
/* %void cpgncur(int maxpt, int *npt, float *x, float *y, int symbol); */
/* + */
/*<       SUBROUTINE PGNCUR (MAXPT, NPT, X, Y, SYMBOL) >*/
/* Subroutine */ int pgncur_(maxpt, npt, x, y, symbol)
integer *maxpt, *npt;
real *x, *y;
integer *symbol;
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static real xblc, yblc;
    extern /* Subroutine */ int pgpt_();
    static real xmin, xtrc, ytrc;
    static integer i__, j;
    static real delta;
    extern /* Subroutine */ int grqci_(), grsci_(), grmsg_();
    static real xphys, yphys, xp, yp;
    static integer savcol;
    static char letter[1];
    extern logical pgnoto_();
    extern integer pgcurs_();
    extern /* Subroutine */ int pgqwin_(), grtoup_(), grterm_(), gretxt_();
    static real xip, yip;

/*<       INTEGER MAXPT, NPT >*/
/*<       REAL    X(*), Y(*) >*/
/*<       INTEGER SYMBOL >*/

/* Interactive routine for user to enter data points by use of */
/* the cursor.  Routine allows user to Add and Delete points.  The */
/* points are returned in order of increasing x-coordinate, not in the */
/* order they were entered. */

/* Arguments: */
/*  MAXPT  (input)  : maximum number of points that may be accepted. */
/*  NPT    (in/out) : number of points entered; should be zero on */
/*                    first call. */
/*  X      (in/out) : array of x-coordinates. */
/*  Y      (in/out) : array of y-coordinates. */
/*  SYMBOL (input)  : code number of symbol to use for marking */
/*                    entered points (see PGPT). */

/* Note (1): The dimension of arrays X and Y must be greater than or */
/* equal to MAXPT. */

/* Note (2): On return from the program, cursor points are returned in */
/* increasing order of X. Routine may be (re-)called with points */
/* already defined in X,Y (number in NPT), and they will be plotted */
/* first, before editing. */

/* Note (3): User commands: the user types single-character commands */
/* after positioning the cursor: the following are accepted: */
/* A (Add)    - add point at current cursor location. */
/* D (Delete) - delete nearest point to cursor. */
/* X (eXit)   - leave subroutine. */
/* -- */
/* 27-Nov-1983 */
/*  9-Jul-1983 - modified to use GRSCI instead of GRSETLI [TJP]. */
/* 13-Dec-1990 - changed warnings to messages [TJP]. */
/*  2-Aug-1995 - [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       CHARACTER*1 LETTER >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL  PGNOTO >*/
/*<       INTEGER  PGCURS, I, J, SAVCOL >*/
/*<       REAL     DELTA, XP, YP, XPHYS, YPHYS >*/
/*<       REAL     XMIN, XIP, YIP >*/
/*<       REAL     XBLC, XTRC, YBLC, YTRC >*/

/* Check that PGPLOT is in the correct state. */

/*<       IF (PGNOTO('PGNCUR')) RETURN >*/
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (pgnoto_("PGNCUR", (ftnlen)6)) {
	return 0;
    }

/* Save current color. */

/*<       CALL GRQCI(SAVCOL) >*/
    grqci_(&savcol);

/* Put current points on screen. */

/*<       IF (NPT.NE.0) CALL PGPT(NPT,X,Y,SYMBOL) >*/
    if (*npt != 0) {
	pgpt_(npt, &x[1], &y[1], symbol);
    }

/* Start with the cursor in the middle of the viewport. */

/*<       CALL PGQWIN(XBLC, XTRC, YBLC, YTRC) >*/
    pgqwin_(&xblc, &xtrc, &yblc, &ytrc);
/*<       XP = 0.5*(XBLC+XTRC) >*/
    xp = (xblc + xtrc) * (float).5;
/*<       YP = 0.5*(YBLC+YTRC) >*/
    yp = (yblc + ytrc) * (float).5;

/* Loop over cursor inputs. */

/*<   100 IF (PGCURS(XP,YP,LETTER).NE.1) RETURN >*/
L100:
    if (pgcurs_(&xp, &yp, letter, (ftnlen)1) != 1) {
	return 0;
    }
/*<       IF (LETTER.EQ.CHAR(0)) RETURN >*/
    if (*(unsigned char *)letter == '\0') {
	return 0;
    }
/*<       CALL GRTOUP(LETTER,LETTER) >*/
    grtoup_(letter, letter, (ftnlen)1, (ftnlen)1);

/* A (ADD) command: */

/*<       IF (LETTER .EQ. 'A') THEN >*/
    if (*(unsigned char *)letter == 'A') {
/*<           IF (NPT.GE.MAXPT) THEN >*/
	if (*npt >= *maxpt) {
/*<               CALL GRMSG('ADD ignored (too many points).') >*/
	    grmsg_("ADD ignored (too many points).", (ftnlen)30);
/*<               GOTO 100 >*/
	    goto L100;
/*<           END IF >*/
	}
/*         ! Find what current points new point is between. */
/*<           DO 120 J=1,NPT >*/
	i__1 = *npt;
	for (j = 1; j <= i__1; ++j) {
/*<               IF (XP.LT.X(J)) GOTO 122 >*/
	    if (xp < x[j]) {
		goto L122;
	    }
/*<   120     CONTINUE >*/
/* L120: */
	}
/*<           J = NPT + 1 >*/
	j = *npt + 1;
/*         ! New point is beyond last current */
/*<   122     CONTINUE >*/
L122:
/*         ! J is vector location where new point should be included. */
/*<           DO 140 I=NPT,J,-1 >*/
	i__1 = j;
	for (i__ = *npt; i__ >= i__1; --i__) {
/*<               X(I+1) = X(I) >*/
	    x[i__ + 1] = x[i__];
/*<               Y(I+1) = Y(I) >*/
	    y[i__ + 1] = y[i__];
/*<   140     CONTINUE >*/
/* L140: */
	}
/*<           NPT = NPT + 1 >*/
	++(*npt);
/*         ! Add new point to point array. */
/*<           X(J) = XP >*/
	x[j] = xp;
/*<           Y(J) = YP >*/
	y[j] = yp;
/*<           CALL PGPT(1,X(J),Y(J),SYMBOL) >*/
	pgpt_(&c__1, &x[j], &y[j], symbol);
/*<           CALL GRTERM >*/
	grterm_();

/* D (DELETE) command: */

/*<       ELSE IF (LETTER.EQ.'D') THEN >*/
    } else if (*(unsigned char *)letter == 'D') {
/*<           IF (NPT.LE.0) THEN >*/
	if (*npt <= 0) {
/*<               CALL GRMSG('DELETE ignored (there are no points left).') >*/
	    grmsg_("DELETE ignored (there are no points left).", (ftnlen)42);
/*<               GOTO 100 >*/
	    goto L100;
/*<           END IF >*/
	}
/*<           XMIN = 1.E+08 >*/
	xmin = (float)1e8;
/*         ! Look for point closest in radius. */
/*         ! Convert cursor points to physical. */
/*<           XPHYS = PGXORG(PGID) + XP*PGXSCL(PGID) >*/
	xphys = pgplt1_1.pgxorg[pgplt1_1.pgid - 1] + xp * pgplt1_1.pgxscl[
		pgplt1_1.pgid - 1];
/*<           YPHYS = PGYORG(PGID) + YP*PGYSCL(PGID) >*/
	yphys = pgplt1_1.pgyorg[pgplt1_1.pgid - 1] + yp * pgplt1_1.pgyscl[
		pgplt1_1.pgid - 1];
/*<           DO 220 I=1,NPT >*/
	i__1 = *npt;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*             ! Convert array points to physical. */
/*<               XIP = PGXORG(PGID) + X(I)*PGXSCL(PGID) >*/
	    xip = pgplt1_1.pgxorg[pgplt1_1.pgid - 1] + x[i__] * 
		    pgplt1_1.pgxscl[pgplt1_1.pgid - 1];
/*<               YIP = PGYORG(PGID) + Y(I)*PGYSCL(PGID) >*/
	    yip = pgplt1_1.pgyorg[pgplt1_1.pgid - 1] + y[i__] * 
		    pgplt1_1.pgyscl[pgplt1_1.pgid - 1];
/*<               DELTA = SQRT( (XIP-XPHYS)**2 + (YIP-YPHYS)**2 ) >*/
/* Computing 2nd power */
	    r__1 = xip - xphys;
/* Computing 2nd power */
	    r__2 = yip - yphys;
	    delta = sqrt(r__1 * r__1 + r__2 * r__2);
/*<               IF (DELTA.LT.XMIN) THEN >*/
	    if (delta < xmin) {
/*<                  XMIN = DELTA >*/
		xmin = delta;
/*<                  J = I >*/
		j = i__;
/*<               END IF >*/
	    }
/*<   220     CONTINUE >*/
/* L220: */
	}
/*         ! Remove point from screen by writing in background color. */
/*<           CALL GRSCI(0) >*/
	grsci_(&c__0);
/*<           CALL PGPT(1,X(J),Y(J),SYMBOL) >*/
	pgpt_(&c__1, &x[j], &y[j], symbol);
/*<           CALL GRSCI(SAVCOL) >*/
	grsci_(&savcol);
/*<           CALL GRTERM >*/
	grterm_();
/*         ! Remove point from cursor array. */
/*<           NPT = NPT-1 >*/
	--(*npt);
/*<           DO 240 I=J,NPT >*/
	i__1 = *npt;
	for (i__ = j; i__ <= i__1; ++i__) {
/*<               X(I) = X(I+1) >*/
	    x[i__] = x[i__ + 1];
/*<               Y(I) = Y(I+1) >*/
	    y[i__] = y[i__ + 1];
/*<   240     CONTINUE >*/
/* L240: */
	}

/* X (EXIT) command: */

/*<       ELSE IF (LETTER.EQ.'X') THEN >*/
    } else if (*(unsigned char *)letter == 'X') {
/*<           CALL GRETXT >*/
	gretxt_();
/*<           RETURN >*/
	return 0;

/* Illegal command: */

/*<       ELSE >*/
    } else {
/*<           CALL GRMSG('Commands are A (add), D (delete), X (exit).') >*/
	grmsg_("Commands are A (add), D (delete), X (exit).", (ftnlen)43);
/*<       END IF >*/
    }

/*<       GOTO 100 >*/
    goto L100;
/*<       END >*/
} /* pgncur_ */

