/* /work2/ssa/pgplot/src/pgopen.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__3 = 3;
static logical c_true = TRUE_;
static integer c__0 = 0;
static integer c__1 = 1;
static real c_b25 = (float)1.;
static real c_b29 = (float)45.;
static real c_b30 = (float).3;
static integer c_n1 = -1;
static real c_b34 = (float)0.;

/* *PGOPEN -- open a graphics device */
/* %int cpgopen(const char *device); */
/* + */
/*<       INTEGER FUNCTION PGOPEN (DEVICE) >*/
integer pgopen_(device, device_len)
char *device;
ftnlen device_len;
{
    /* System generated locals */
    address a__1[3];
    integer ret_val, i__1[3];

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer s_cmp();
    /* Subroutine */ int s_cat();
    integer i_len();

    /* Local variables */
    static logical junk;
    static integer unit;
    static real xcsz;
    static integer l;
    extern /* Subroutine */ int pgsch_(), pgask_(), pgsci_(), pgscf_(), 
	    pgsah_(), pgsfs_();
    static integer istat;
    extern /* Subroutine */ int pgshs_(), pgsls_();
    static real dummy;
    extern /* Subroutine */ int pgslw_();
    static real dummy2;
    static integer ldefde;
    static char defdev[128];
    static integer lr;
    extern /* Subroutine */ int pgbbuf_();
    extern integer grgcom_();
    extern /* Subroutine */ int pgldev_();
    static integer deftyp;
    extern integer gropen_();
    static integer ic1;
    extern integer grdtyp_();
    static integer lpromp;
    static char defstr[20];
    extern /* Subroutine */ int pginit_(), grgenv_();
    static char prompt[128];
    extern /* Subroutine */ int grtoup_(), grwarn_(), grsize_(), grchsz_(), 
	    grqtyp_(), pgscrn_(), pgstbg_(), pgsclp_(), grqcol_(), pgvstd_();
    static integer ier;
    static char req[256];
    static real xsz, ysz;

/*<       CHARACTER*(*) DEVICE >*/

/* Open a graphics device for PGPLOT output. If the device is */
/* opened successfully, it becomes the selected device to which */
/* graphics output is directed until another device is selected */
/* with PGSLCT or the device is closed with PGCLOS. */

/* The value returned by PGOPEN should be tested to ensure that */
/* the device was opened successfully, e.g., */

/*       ISTAT = PGOPEN('plot.ps/PS') */
/*       IF (ISTAT .LE. 0 ) STOP */

/* Note that PGOPEN must be declared INTEGER in the calling program. */

/* The DEVICE argument is a character constant or variable; its value */
/* should be one of the following: */

/* (1) A complete device specification of the form 'device/type' or */
/*     'file/type', where 'type' is one of the allowed PGPLOT device */
/*     types (installation-dependent) and 'device' or 'file' is the */
/*     name of a graphics device or disk file appropriate for this type. */
/*     The 'device' or 'file' may contain '/' characters; the final */
/*     '/' delimits the 'type'. If necessary to avoid ambiguity, */
/*     the 'device' part of the string may be enclosed in double */
/*     quotation marks. */
/* (2) A device specification of the form '/type', where 'type' is one */
/*     of the allowed PGPLOT device types. PGPLOT supplies a default */
/*     file or device name appropriate for this device type. */
/* (3) A device specification with '/type' omitted; in this case */
/*     the type is taken from the environment variable PGPLOT_TYPE, */
/*     if defined (e.g., setenv PGPLOT_TYPE PS). Because of possible */
/*     confusion with '/' in file-names, omitting the device type */
/*     in this way is not recommended. */
/* (4) A blank string (' '); in this case, PGOPEN will use the value */
/*     of environment variable PGPLOT_DEV as the device specification, */
/*     or '/NULL' if the environment variable is undefined. */
/* (5) A single question mark, with optional trailing spaces ('?'); in */
/*     this case, PGPLOT will prompt the user to supply the device */
/*     specification, with a prompt string of the form */
/*         'Graphics device/type (? to see list, default XXX):' */
/*     where 'XXX' is the default (value of environment variable */
/*     PGPLOT_DEV). */
/* (6) A non-blank string in which the first character is a question */
/*     mark (e.g., '?Device: '); in this case, PGPLOT will prompt the */
/*     user to supply the device specification, using the supplied */
/*     string as the prompt (without the leading question mark but */
/*     including any trailing spaces). */

/* In cases (5) and (6), the device specification is read from the */
/* standard input. The user should respond to the prompt with a device */
/* specification of the form (1), (2), or (3). If the user types a */
/* question-mark in response to the prompt, a list of available device */
/* types is displayed and the prompt is re-issued. If the user supplies */
/* an invalid device specification, the prompt is re-issued. If the user */
/* responds with an end-of-file character, e.g., ctrl-D in UNIX, program */
/* execution is aborted; this  avoids the possibility of an infinite */
/* prompting loop.  A programmer should avoid use of PGPLOT-prompting */
/* if this behavior is not desirable. */

/* The device type is case-insensitive (e.g., '/ps' and '/PS' are */
/* equivalent). The device or file name may be case-sensitive in some */
/* operating systems. */

/* Examples of valid DEVICE arguments: */

/* (1)  'plot.ps/ps', 'dir/plot.ps/ps', '"dir/plot.ps"/ps', */
/*      'user:[tjp.plots]plot.ps/PS' */
/* (2)  '/ps'      (PGPLOT interprets this as 'pgplot.ps/ps') */
/* (3)  'plot.ps'  (if PGPLOT_TYPE is defined as 'ps', PGPLOT */
/*                  interprets this as 'plot.ps/ps') */
/* (4)  '   '      (if PGPLOT_DEV is defined) */
/* (5)  '?  ' */
/* (6)  '?Device specification for PGPLOT: ' */

/* [This routine was added to PGPLOT in Version 5.1.0. Older programs */
/* use PGBEG instead.] */

/* Returns: */
/*  PGOPEN          : returns either a positive value, the */
/*                    identifier of the graphics device for use with */
/*                    PGSLCT, or a 0 or negative value indicating an */
/*                    error. In the event of error a message is */
/*                    written on the standard error unit. */
/* Arguments: */
/*  DEVICE  (input) : the 'device specification' for the plot device */
/*                    (see above). */
/* -- */
/* 22-Dec-1995 - new routine [TJP]. */
/* 14-May-1996 - device '? ' should not give a blank prompt [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE       'pgplot.inc' >*/
/*<       INTEGER       DEFTYP,GRDTYP,GROPEN,L,LR,IC1, LPROMP >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER       GRGCOM, IER, LDEFDE, UNIT, ISTAT >*/
/*<       REAL          DUMMY,DUMMY2,XCSZ, XSZ, YSZ >*/
/*<       CHARACTER*128 DEFDEV, PROMPT >*/
/*<       CHARACTER*20  DEFSTR >*/
/*<       CHARACTER*256 REQ >*/
/*<       LOGICAL JUNK >*/

/* Initialize PGPLOT if necessary. */

/*<       CALL PGINIT >*/
    pginit_();

/* Get the default device/type (environment variable PGPLOT_DEV). */

/*<       CALL GRGENV('DEV', DEFDEV, LDEFDE) >*/
    grgenv_("DEV", defdev, &ldefde, (ftnlen)3, (ftnlen)128);
/*<       IF (LDEFDE.EQ.0) THEN >*/
    if (ldefde == 0) {
/*<          DEFDEV = '/NULL' >*/
	s_copy(defdev, "/NULL", (ftnlen)128, (ftnlen)5);
/*<          LDEFDE = 5 >*/
	ldefde = 5;
/*<       END IF >*/
    }

/* Open the plot file; default type is given by environment variable */
/* PGPLOT_TYPE. */

/*<       CALL GRGENV('TYPE', DEFSTR, L) >*/
    grgenv_("TYPE", defstr, &l, (ftnlen)4, (ftnlen)20);
/*<       IF (L.EQ.0) THEN >*/
    if (l == 0) {
/*<           DEFTYP = 0 >*/
	deftyp = 0;
/*<       ELSE >*/
    } else {
/*<           CALL GRTOUP(DEFSTR, DEFSTR) >*/
	grtoup_(defstr, defstr, (ftnlen)20, (ftnlen)20);
/*<           DEFTYP = GRDTYP(DEFSTR(1:L)) >*/
	deftyp = grdtyp_(defstr, l);
/*<       END IF >*/
    }
/*<       IF (DEVICE.EQ.' ') THEN >*/
    if (s_cmp(device, " ", device_len, (ftnlen)1) == 0) {
/*        -- Blank device string: use default device and type. */
/*<          ISTAT = GROPEN(DEFTYP,UNIT,DEFDEV(1:LDEFDE),PGID) >*/
	istat = gropen_(&deftyp, &unit, defdev, &pgplt1_1.pgid, ldefde);
/*<       ELSE IF (DEVICE(1:1).EQ.'?') THEN >*/
    } else if (*(unsigned char *)device == '?') {
/*<          IF (DEVICE.EQ.'?') THEN >*/
	if (s_cmp(device, "?", device_len, (ftnlen)1) == 0) {
/*           -- Device string is a ingle question mark: prompt user */
/*           -- for device/type */
/*<    >*/
/* Writing concatenation */
	    i__1[0] = 45, a__1[0] = "Graphics device/type (? to see list, de\
fault ";
	    i__1[1] = ldefde, a__1[1] = defdev;
	    i__1[2] = 3, a__1[2] = "): ";
	    s_cat(prompt, a__1, i__1, &c__3, (ftnlen)128);
/*<             LPROMP = LDEFDE + 48 >*/
	    lpromp = ldefde + 48;
/*<          ELSE >*/
	} else {
/*           -- Device string starts with a question mark: use it */
/*           -- as a prompt */
/*<             PROMPT = DEVICE(2:) >*/
	    s_copy(prompt, device + 1, (ftnlen)128, device_len - 1);
/*<             LPROMP = LEN(DEVICE)-1 >*/
	    lpromp = i_len(device, device_len) - 1;
/*<          END IF >*/
	}
/*<    10    IER = GRGCOM(REQ, PROMPT(1:LPROMP), LR) >*/
L10:
	ier = grgcom_(req, prompt, &lr, (ftnlen)256, lpromp);
/*<          IF (IER.NE.1) THEN >*/
	if (ier != 1) {
/*<             CALL GRWARN('Error reading device specification') >*/
	    grwarn_("Error reading device specification", (ftnlen)34);
/*<             PGOPEN = -1 >*/
	    ret_val = -1;
/*<             RETURN >*/
	    return ret_val;
/*<          END IF >*/
	}
/*<          IF (LR.LT.1 .OR. REQ.EQ.' ') THEN >*/
	if (lr < 1 || s_cmp(req, " ", (ftnlen)256, (ftnlen)1) == 0) {
/*<             REQ = DEFDEV(1:LDEFDE) >*/
	    s_copy(req, defdev, (ftnlen)256, ldefde);
/*<          ELSE IF (REQ(1:1).EQ.'?') THEN >*/
	} else if (*(unsigned char *)req == '?') {
/*<             CALL PGLDEV >*/
	    pgldev_();
/*<             GOTO 10 >*/
	    goto L10;
/*<          END IF >*/
	}
/*<          ISTAT = GROPEN(DEFTYP,UNIT,REQ,PGID) >*/
	istat = gropen_(&deftyp, &unit, req, &pgplt1_1.pgid, (ftnlen)256);
/*<          IF (ISTAT.NE.1) GOTO 10 >*/
	if (istat != 1) {
	    goto L10;
	}
/*<       ELSE >*/
    } else {
/*<           ISTAT = GROPEN(DEFTYP,UNIT,DEVICE,PGID) >*/
	istat = gropen_(&deftyp, &unit, device, &pgplt1_1.pgid, device_len);
/*<       END IF >*/
    }

/* Failed to open plot file? */

/*<       IF (ISTAT.NE.1) THEN >*/
    if (istat != 1) {
/*<          PGOPEN = - 1 >*/
	ret_val = -1;
/*<          RETURN >*/
	return ret_val;
/*<       END IF >*/
    }

/* Success: determine device characteristics. */

/*<    >*/
    if (pgplt1_1.pgid < 0 || pgplt1_1.pgid > 8) {
	grwarn_("Something terribly wrong in PGOPEN", (ftnlen)34);
    }
/*<       PGDEVS(PGID) = 1 >*/
    pgplt1_1.pgdevs[pgplt1_1.pgid - 1] = 1;
/*<       PGADVS(PGID) = 0 >*/
    pgplt1_1.pgadvs[pgplt1_1.pgid - 1] = 0;
/*<       PGPFIX(PGID) = .FALSE. >*/
    pgplt1_1.pgpfix[pgplt1_1.pgid - 1] = FALSE_;
/*<    >*/
    grsize_(&pgplt1_1.pgid, &xsz, &ysz, &dummy, &dummy2, &pgplt1_1.pgxpin[
	    pgplt1_1.pgid - 1], &pgplt1_1.pgypin[pgplt1_1.pgid - 1]);
/*<       CALL GRCHSZ(PGID,XCSZ,DUMMY,PGXSP(PGID),PGYSP(PGID)) >*/
    grchsz_(&pgplt1_1.pgid, &xcsz, &dummy, &pgplt1_1.pgxsp[pgplt1_1.pgid - 1],
	     &pgplt1_1.pgysp[pgplt1_1.pgid - 1]);
/*<       PGROWS(PGID)= .TRUE. >*/
    pgplt1_1.pgrows[pgplt1_1.pgid - 1] = TRUE_;
/*<       PGNX(PGID)  = 1 >*/
    pgplt1_1.pgnx[pgplt1_1.pgid - 1] = 1;
/*<       PGNY(PGID)  = 1 >*/
    pgplt1_1.pgny[pgplt1_1.pgid - 1] = 1;
/*<       PGXSZ(PGID) = XSZ >*/
    pgplt1_1.pgxsz[pgplt1_1.pgid - 1] = xsz;
/*<       PGYSZ(PGID) = YSZ >*/
    pgplt1_1.pgysz[pgplt1_1.pgid - 1] = ysz;
/*<       PGNXC(PGID) = 1 >*/
    pgplt1_1.pgnxc[pgplt1_1.pgid - 1] = 1;
/*<       PGNYC(PGID) = 1 >*/
    pgplt1_1.pgnyc[pgplt1_1.pgid - 1] = 1;
/*<       CALL GRQTYP(DEFSTR,JUNK) >*/
    grqtyp_(defstr, &junk, (ftnlen)20);

/* Set the prompt state to ON, so that terminal devices pause between */
/* pages; this can be changed with PGASK. */

/*<       CALL PGASK(.TRUE.) >*/
    pgask_(&c_true);

/* If environment variable PGPLOT_BUFFER is defined (any value), */
/* start buffering output. */

/*<       PGBLEV(PGID) = 0 >*/
    pgplt1_1.pgblev[pgplt1_1.pgid - 1] = 0;
/*<       CALL GRGENV('BUFFER', DEFSTR, L) >*/
    grgenv_("BUFFER", defstr, &l, (ftnlen)6, (ftnlen)20);
/*<       IF (L.GT.0) CALL PGBBUF >*/
    if (l > 0) {
	pgbbuf_();
    }

/* Set background and foreground colors if requested. */

/*<       CALL GRGENV('BACKGROUND', DEFSTR, L) >*/
    grgenv_("BACKGROUND", defstr, &l, (ftnlen)10, (ftnlen)20);
/*<       IF (L.GT.0) CALL PGSCRN(0, DEFSTR(1:L), IER) >*/
    if (l > 0) {
	pgscrn_(&c__0, defstr, &ier, l);
    }
/*<       CALL GRGENV('FOREGROUND', DEFSTR, L) >*/
    grgenv_("FOREGROUND", defstr, &l, (ftnlen)10, (ftnlen)20);
/*<       IF (L.GT.0) CALL PGSCRN(1, DEFSTR(1:L), IER) >*/
    if (l > 0) {
	pgscrn_(&c__1, defstr, &ier, l);
    }

/* Set default attributes. */

/*<       CALL PGSCI(1) >*/
    pgsci_(&c__1);
/*<       CALL PGSLS(1) >*/
    pgsls_(&c__1);
/*<       CALL PGSLW(1) >*/
    pgslw_(&c__1);
/*<       CALL PGSCH(1.0) >*/
    pgsch_(&c_b25);
/*<       CALL PGSCF(1) >*/
    pgscf_(&c__1);
/*<       CALL PGSFS(1) >*/
    pgsfs_(&c__1);
/*<       CALL PGSAH(1, 45.0, 0.3) >*/
    pgsah_(&c__1, &c_b29, &c_b30);
/*<       CALL PGSTBG(-1) >*/
    pgstbg_(&c_n1);
/*<       CALL PGSHS(45.0, 1.0, 0.0) >*/
    pgshs_(&c_b29, &c_b25, &c_b34);
/*<       CALL PGSCLP(1) >*/
    pgsclp_(&c__1);

/* Set the default range of color indices available for images (16 to */
/* device maximum, if device maximum >= 16; otherwise not possible). */
/* Select linear transfer function. */

/*<       CALL GRQCOL(IC1, PGMXCI(PGID)) >*/
    grqcol_(&ic1, &pgplt1_1.pgmxci[pgplt1_1.pgid - 1]);
/*<       PGMNCI(PGID) = 16 >*/
    pgplt1_1.pgmnci[pgplt1_1.pgid - 1] = 16;
/*<       IF (PGMXCI(PGID).LT.16) PGMXCI(PGID) = 0 >*/
    if (pgplt1_1.pgmxci[pgplt1_1.pgid - 1] < 16) {
	pgplt1_1.pgmxci[pgplt1_1.pgid - 1] = 0;
    }
/*<       PGITF(PGID) = 0 >*/
    pgplt1_1.pgitf[pgplt1_1.pgid - 1] = 0;

/* Set the default window (unit square). */

/*<       PGXBLC(PGID) = 0.0 >*/
    pgplt1_1.pgxblc[pgplt1_1.pgid - 1] = (float)0.;
/*<       PGXTRC(PGID) = 1.0 >*/
    pgplt1_1.pgxtrc[pgplt1_1.pgid - 1] = (float)1.;
/*<       PGYBLC(PGID) = 0.0 >*/
    pgplt1_1.pgyblc[pgplt1_1.pgid - 1] = (float)0.;
/*<       PGYTRC(PGID) = 1.0 >*/
    pgplt1_1.pgytrc[pgplt1_1.pgid - 1] = (float)1.;

/* Set the default viewport. */

/*<       CALL PGVSTD >*/
    pgvstd_();

/*<       PGOPEN = PGID >*/
    ret_val = pgplt1_1.pgid;
/*<       RETURN >*/
    return ret_val;
/*<       END >*/
} /* pgopen_ */

