/* /work2/ssa/pgplot/src/pgpage.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__0 = 0;

/* *PGPAGE -- advance to new page */
/* %void cpgpage(void); */
/* + */
/*<       SUBROUTINE PGPAGE >*/
/* Subroutine */ int pgpage_()
{
    static real yvp1, yvp2;
    extern /* Subroutine */ int pgvw_(), pgsch_();
    static logical inter;
    extern /* Subroutine */ int pgqvp_(), pgsvp_(), grpage_(), grbpic_();
    static real xs, ys;
    extern /* Subroutine */ int grterm_(), grsize_();
    extern logical pgnoto_();
    extern /* Subroutine */ int grprom_(), grqtyp_();
    static char str[16];
    static real dum1, dum2, xvp1, xvp2;


/* Advance plotter to a new page or panel, clearing the screen if */
/* necessary. If the "prompt state" is ON (see PGASK), confirmation is */
/* requested from the user before clearing the screen. If the view */
/* surface has been subdivided into panels with PGBEG or PGSUBP, then */
/* PGPAGE advances to the next panel, and if the current panel is the */
/* last on the page, PGPAGE clears the screen or starts a new sheet of */
/* paper.  PGPAGE does not change the PGPLOT window or the viewport */
/* (in normalized device coordinates); but note that if the size of the */
/* view-surface is changed externally (e.g., by a workstation window */
/* manager) the size of the viewport is changed in proportion. */

/* Arguments: none */
/* -- */
/*  7-Feb-1983 */
/* 23-Sep-1984 - correct bug: call GRTERM at end (if flush mode set). */
/* 31-Jan-1985 - make closer to Fortran-77. */
/* 19-Nov-1987 - explicitly clear the screen if device is interactive; */
/*               this restores the behavior obtained with older versions */
/*               of GRPCKG. */
/*  9-Feb-1988 - move prompting into routine GRPROM. */
/* 11-Apr-1989 - change name to PGPAGE. */
/* 10-Sep-1990 - add identification labelling. */
/* 11-Feb-1992 - check if device size has changed. */
/*  3-Sep-1992 - allow column ordering of panels. */
/* 17-Nov-1994 - move identification to drivers. */
/* 23-Nov-1994 - fix bug: character size not getting reset. */
/* 23-Jan-1995 - rescale viewport if size of view surface  has changed. */
/*  4-Feb-1997 - bug fix; character size was not correctly indexed by */
/*               device ID. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE      'pgplot.inc' >*/
/*<       CHARACTER*16 STR >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL      INTER, PGNOTO >*/
/*<       REAL DUM1, DUM2, XS, YS, XVP1, XVP2, YVP1, YVP2 >*/

/*<       IF (PGNOTO('PGPAGE')) RETURN >*/
    if (pgnoto_("PGPAGE", (ftnlen)6)) {
	return 0;
    }

/*<       IF (PGROWS(PGID)) THEN >*/
    if (pgplt1_1.pgrows[pgplt1_1.pgid - 1]) {
/*<         PGNXC(PGID) = PGNXC(PGID) + 1 >*/
	++pgplt1_1.pgnxc[pgplt1_1.pgid - 1];
/*<         IF (PGNXC(PGID).GT.PGNX(PGID)) THEN >*/
	if (pgplt1_1.pgnxc[pgplt1_1.pgid - 1] > pgplt1_1.pgnx[pgplt1_1.pgid - 
		1]) {
/*<           PGNXC(PGID) = 1 >*/
	    pgplt1_1.pgnxc[pgplt1_1.pgid - 1] = 1;
/*<           PGNYC(PGID) = PGNYC(PGID) + 1 >*/
	    ++pgplt1_1.pgnyc[pgplt1_1.pgid - 1];
/*<           IF (PGNYC(PGID).GT.PGNY(PGID)) PGNYC(PGID) = 1 >*/
	    if (pgplt1_1.pgnyc[pgplt1_1.pgid - 1] > pgplt1_1.pgny[
		    pgplt1_1.pgid - 1]) {
		pgplt1_1.pgnyc[pgplt1_1.pgid - 1] = 1;
	    }
/*<         END IF >*/
	}
/*<       ELSE >*/
    } else {
/*<         PGNYC(PGID) = PGNYC(PGID) + 1 >*/
	++pgplt1_1.pgnyc[pgplt1_1.pgid - 1];
/*<         IF (PGNYC(PGID).GT.PGNY(PGID)) THEN >*/
	if (pgplt1_1.pgnyc[pgplt1_1.pgid - 1] > pgplt1_1.pgny[pgplt1_1.pgid - 
		1]) {
/*<           PGNYC(PGID) = 1 >*/
	    pgplt1_1.pgnyc[pgplt1_1.pgid - 1] = 1;
/*<           PGNXC(PGID) = PGNXC(PGID) + 1 >*/
	    ++pgplt1_1.pgnxc[pgplt1_1.pgid - 1];
/*<           IF (PGNXC(PGID).GT.PGNX(PGID)) PGNXC(PGID) = 1 >*/
	    if (pgplt1_1.pgnxc[pgplt1_1.pgid - 1] > pgplt1_1.pgnx[
		    pgplt1_1.pgid - 1]) {
		pgplt1_1.pgnxc[pgplt1_1.pgid - 1] = 1;
	    }
/*<         END IF >*/
	}
/*<       END IF >*/
    }
/*<       IF (PGNXC(PGID).EQ.1 .AND. PGNYC(PGID).EQ.1) THEN >*/
    if (pgplt1_1.pgnxc[pgplt1_1.pgid - 1] == 1 && pgplt1_1.pgnyc[
	    pgplt1_1.pgid - 1] == 1) {
/*<           IF (PGADVS(PGID).EQ.1 .AND. PGPRMP(PGID)) THEN >*/
	if (pgplt1_1.pgadvs[pgplt1_1.pgid - 1] == 1 && pgplt1_1.pgprmp[
		pgplt1_1.pgid - 1]) {
/*<               CALL GRTERM >*/
	    grterm_();
/*<               CALL GRPROM >*/
	    grprom_();
/*<           END IF >*/
	}
/*<           CALL GRPAGE >*/
	grpage_();
/*<           IF (.NOT.PGPFIX(PGID)) THEN >*/
	if (! pgplt1_1.pgpfix[pgplt1_1.pgid - 1]) {
/*             -- Get current viewport in NDC. */
/*<               CALL PGQVP(0, XVP1, XVP2, YVP1, YVP2) >*/
	    pgqvp_(&c__0, &xvp1, &xvp2, &yvp1, &yvp2);
/*             -- Reset view surface size if it has changed */
/*<    >*/
	    grsize_(&pgplt1_1.pgid, &xs, &ys, &dum1, &dum2, &pgplt1_1.pgxpin[
		    pgplt1_1.pgid - 1], &pgplt1_1.pgypin[pgplt1_1.pgid - 1]);
/*<               PGXSZ(PGID) = XS/PGNX(PGID) >*/
	    pgplt1_1.pgxsz[pgplt1_1.pgid - 1] = xs / pgplt1_1.pgnx[
		    pgplt1_1.pgid - 1];
/*<               PGYSZ(PGID) = YS/PGNY(PGID) >*/
	    pgplt1_1.pgysz[pgplt1_1.pgid - 1] = ys / pgplt1_1.pgny[
		    pgplt1_1.pgid - 1];
/*             -- and character size */
/*<               CALL PGSCH(PGCHSZ(PGID)) >*/
	    pgsch_(&pgplt1_1.pgchsz[pgplt1_1.pgid - 1]);
/*             -- and viewport */
/*<               CALL PGSVP(XVP1, XVP2, YVP1, YVP2) >*/
	    pgsvp_(&xvp1, &xvp2, &yvp1, &yvp2);
/*<           END IF >*/
	}

/* If the device is interactive, call GRBPIC to clear the page. */
/* (If the device is not interactive, GRBPIC will be called */
/* automatically before the first output; omitting the call here */
/* ensures that a blank page is not output.) */

/*<           CALL GRQTYP(STR,INTER) >*/
	grqtyp_(str, &inter, (ftnlen)16);
/*<           IF (INTER) CALL GRBPIC >*/
	if (inter) {
	    grbpic_();
	}
/*<       END IF >*/
    }
/*<       PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID) >*/
    pgplt1_1.pgxoff[pgplt1_1.pgid - 1] = pgplt1_1.pgxvp[pgplt1_1.pgid - 1] + (
	    pgplt1_1.pgnxc[pgplt1_1.pgid - 1] - 1) * pgplt1_1.pgxsz[
	    pgplt1_1.pgid - 1];
/*<    >*/
    pgplt1_1.pgyoff[pgplt1_1.pgid - 1] = pgplt1_1.pgyvp[pgplt1_1.pgid - 1] + (
	    pgplt1_1.pgny[pgplt1_1.pgid - 1] - pgplt1_1.pgnyc[pgplt1_1.pgid - 
	    1]) * pgplt1_1.pgysz[pgplt1_1.pgid - 1];

/* Window the plot in the new viewport. */

/*<       CALL PGVW >*/
    pgvw_();
/*<       PGADVS(PGID) = 1 >*/
    pgplt1_1.pgadvs[pgplt1_1.pgid - 1] = 1;
/*<       CALL GRTERM >*/
    grterm_();
/*<       END >*/
} /* pgpage_ */

