/* /work2/ssa/pgplot/src/pgpixl.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGPIXL -- draw pixels */
/* %void cpgpixl(const int *ia, int idim, int jdim, int i1, int i2, \ */
/* % int j1, int j2, float x1, float x2, float y1, float y2); */
/* + */
/*<    >*/
/* Subroutine */ int pgpixl_(ia, idim, jdim, i1, i2, j1, j2, x1, x2, y1, y2)
integer *ia, *idim, *jdim, *i1, *i2, *j1, *j2;
real *x1, *x2, *y1, *y2;
{
    /* System generated locals */
    integer ia_dim1, ia_offset;

    /* Local variables */
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grwarn_(), grpixl_();
    extern logical pgnoto_();

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2 >*/
/*<       INTEGER IA(IDIM,JDIM) >*/
/*<       REAL    X1, X2, Y1, Y2 >*/

/* Draw lots of solid-filled (tiny) rectangles aligned with the */
/* coordinate axes. Best performance is achieved when output is */
/* directed to a pixel-oriented device and the rectangles coincide */
/* with the pixels on the device. In other cases, pixel output is */
/* emulated. */

/* The subsection of the array IA defined by indices (I1:I2, J1:J2) */
/* is mapped onto world-coordinate rectangle defined by X1, X2, Y1 */
/* and Y2. This rectangle is divided into (I2 - I1 + 1) * (J2 - J1 + 1) */
/* small rectangles. Each of these small rectangles is solid-filled */
/* with the color index specified by the corresponding element of */
/* IA. */

/* On most devices, the output region is "opaque", i.e., it obscures */
/* all graphical elements previously drawn in the region. But on */
/* devices that do not have erase capability, the background shade */
/* is "transparent" and allows previously-drawn graphics to show */
/* through. */

/* Arguments: */
/*  IA     (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  X1, Y1 (input)  : world coordinates of one corner of the output */
/*                    region */
/*  X2, Y2 (input)  : world coordinates of the opposite corner of the */
/*                    output region */
/* -- */
/* 16-Jan-1991 - [GvG] */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL PGNOTO >*/

/* Check inputs. */

/*<       IF (PGNOTO('PGPIXL')) RETURN >*/
    /* Parameter adjustments */
    ia_dim1 = *idim;
    ia_offset = 1 + ia_dim1 * 1;
    ia -= ia_offset;

    /* Function Body */
    if (pgnoto_("PGPIXL", (ftnlen)6)) {
	return 0;
    }
/*<    >*/
    if (*i1 < 1 || *i2 > *idim || *i1 > *i2 || *j1 < 1 || *j2 > *jdim || *j1 
	    > *j2) {
/*<          CALL GRWARN('PGPIXL: invalid range I1:I2, J1:J2') >*/
	grwarn_("PGPIXL: invalid range I1:I2, J1:J2", (ftnlen)34);
/*<       ELSE >*/
    } else {

/* Call lower-level routine to do the work. */

/*<          CALL PGBBUF >*/
	pgbbuf_();
/*<          CALL GRPIXL(IA, IDIM, JDIM, I1, I2, J1, J2, X1, X2, Y1, Y2) >*/
	grpixl_(&ia[ia_offset], idim, jdim, i1, i2, j1, j2, x1, x2, y1, y2);
/*<          CALL PGEBUF >*/
	pgebuf_();
/*<       END IF >*/
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* pgpixl_ */

