/* /work2/ssa/pgplot/src/pgpt.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static logical c_false = FALSE_;

/* *PGPT -- draw several graph markers */
/* %void cpgpt(int n, const float *xpts, const float *ypts, int symbol); */
/* + */
/*<       SUBROUTINE PGPT (N, XPTS, YPTS, SYMBOL) >*/
/* Subroutine */ int pgpt_(n, xpts, ypts, symbol)
integer *n;
real *xpts, *ypts;
integer *symbol;
{
    extern /* Subroutine */ int grdot1_(), pgbbuf_(), pgebuf_(), grmker_();
    extern logical pgnoto_();

/*<       INTEGER N >*/
/*<       REAL XPTS(*), YPTS(*) >*/
/*<       INTEGER SYMBOL >*/

/* Primitive routine to draw Graph Markers (polymarker). The markers */
/* are drawn using the current values of attributes color-index, */
/* line-width, and character-height (character-font applies if the symbol */
/* number is >31).  If the point to be marked lies outside the window, */
/* no marker is drawn.  The "pen position" is changed to */
/* (XPTS(N),YPTS(N)) in world coordinates (if N > 0). */

/* Arguments: */
/*  N      (input)  : number of points to mark. */
/*  XPTS   (input)  : world x-coordinates of the points. */
/*  YPTS   (input)  : world y-coordinates of the points. */
/*  SYMBOL (input)  : code number of the symbol to be drawn at each */
/*                    point: */
/*                    -1, -2  : a single dot (diameter = current */
/*                              line width). */
/*                    -3..-31 : a regular polygon with ABS(SYMBOL) */
/*                              edges (style set by current fill style). */
/*                    0..31   : standard marker symbols. */
/*                    32..127 : ASCII characters (in current font). */
/*                              e.g. to use letter F as a marker, let */
/*                              SYMBOL = ICHAR('F'). */
/*                    > 127  :  a Hershey symbol number. */

/* Note: the dimension of arrays X and Y must be greater than or equal */
/* to N. If N is 1, X and Y may be scalars (constants or variables). If */
/* N is less than 1, nothing is drawn. */
/* -- */
/* 27-Nov-1986 */
/* 17-Dec-1990 - add polygons [PAH]. */
/* 14-Mar-1997 - optimization: use GRDOT1 [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL PGNOTO >*/

/*<       IF (N.LT.1) RETURN >*/
    /* Parameter adjustments */
    --ypts;
    --xpts;

    /* Function Body */
    if (*n < 1) {
	return 0;
    }
/*<       IF (PGNOTO('PGPT')) RETURN >*/
    if (pgnoto_("PGPT", (ftnlen)4)) {
	return 0;
    }

/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       IF (SYMBOL.GE.0 .OR. SYMBOL.LE.-3) THEN >*/
    if (*symbol >= 0 || *symbol <= -3) {
/*<           CALL GRMKER(SYMBOL,.FALSE.,N,XPTS,YPTS) >*/
	grmker_(symbol, &c_false, n, &xpts[1], &ypts[1]);
/*<       ELSE >*/
    } else {
/*<           CALL GRDOT1(N,XPTS,YPTS) >*/
	grdot1_(n, &xpts[1], &ypts[1]);
/*<       END IF >*/
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgpt_ */

