/* /work2/ssa/pgplot/src/pgscr.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGSCR -- set color representation */
/* %void cpgscr(int ci, float cr, float cg, float cb); */
/* + */
/*<       SUBROUTINE PGSCR (CI, CR, CG, CB) >*/
/* Subroutine */ int pgscr_(ci, cr, cg, cb)
integer *ci;
real *cr, *cg, *cb;
{
    extern /* Subroutine */ int grscr_();
    extern logical pgnoto_();

/*<       INTEGER CI >*/
/*<       REAL    CR, CG, CB >*/

/* Set color representation: i.e., define the color to be */
/* associated with a color index.  Ignored for devices which do not */
/* support variable color or intensity.  Color indices 0-15 */
/* have predefined color representations (see the PGPLOT manual), but */
/* these may be changed with PGSCR.  Color indices 16-maximum have no */
/* predefined representations: if these indices are used, PGSCR must */
/* be called to define the representation. On monochrome output */
/* devices (e.g. VT125 terminals with monochrome monitors), the */
/* monochrome intensity is computed from the specified Red, Green, Blue */
/* intensities as 0.30*R + 0.59*G + 0.11*B, as in US color television */
/* systems, NTSC encoding.  Note that most devices do not have an */
/* infinite range of colors or monochrome intensities available; */
/* the nearest available color is used.  Examples: for black, */
/* set CR=CG=CB=0.0; for white, set CR=CG=CB=1.0; for medium gray, */
/* set CR=CG=CB=0.5; for medium yellow, set CR=CG=0.5, CB=0.0. */

/* Argument: */
/*  CI     (input)  : the color index to be defined, in the range 0-max. */
/*                    If the color index greater than the device */
/*                    maximum is specified, the call is ignored. Color */
/*                    index 0 applies to the background color. */
/*  CR     (input)  : red, green, and blue intensities, */
/*  CG     (input)    in range 0.0 to 1.0. */
/*  CB     (input) */
/* -- */
/* 5-Nov-1985 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL PGNOTO >*/

/*<       IF (PGNOTO('PGSCR')) RETURN >*/
    if (pgnoto_("PGSCR", (ftnlen)5)) {
	return 0;
    }
/*<       CALL GRSCR(CI,CR,CG,CB) >*/
    grscr_(ci, cr, cg, cb);
/*<       END >*/
} /* pgscr_ */

