/* /work2/ssa/pgplot/src/pgwedg.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static real c_b18 = (float)1.;
static real c_b23 = (float).9;
static real c_b24 = (float)1.1;
static real c_b25 = (float)100.;
static integer c__100 = 100;
static integer c__1 = 1;
static real c_b38 = (float)0.;
static real c_b83 = (float)2.2;

/* *PGWEDG -- annotate an image plot with a wedge */
/* %void cpgwedg(const char *side, float disp, float width, \ */
/* % float fg, float bg, const char *label); */
/* + */
/*<       SUBROUTINE PGWEDG(SIDE, DISP, WIDTH, FG, BG, LABEL) >*/
/* Subroutine */ int pgwedg_(side, disp, width, fg, bg, label, side_len, 
	label_len)
char *side;
real *disp, *width, *fg, *bg;
char *label;
ftnlen side_len;
ftnlen label_len;
{
    /* Initialized data */

    static real tr[6] = { (float)0.,(float)1.,(float)0.,(float)0.,(float)0.,(
	    float)1. };

    /* Builtin functions */
    integer i_len(), s_cmp();

    /* Local variables */
    static integer i__;
    static logical image;
    static real oldch;
    static integer nside;
    extern /* Subroutine */ int pgqch_();
    static real newch;
    extern /* Subroutine */ int pgsch_(), pgqcs_(), pgbox_();
    static real vdisp;
    static logical horiz;
    extern /* Subroutine */ int pgqvp_(), pgsvp_();
    static real xa, xb, ya, yb, labwid;
    extern /* Subroutine */ int pgimag_(), pgbbuf_(), pgebuf_();
    static real wdginc, wedwid, wdgarr[100];
    extern /* Subroutine */ int pggray_();
    static real ndcsiz, bg1, fg1;
    extern /* Subroutine */ int grwarn_();
    static real vwidth;
    extern logical pgnoto_();
    extern /* Subroutine */ int pgqwin_(), pgswin_(), pgmtxt_();
    static real xch, ych, vxa, wxa, wxb, wya, wyb, vxb, vya, vyb;

/*<       CHARACTER *(*) SIDE,LABEL >*/
/*<       REAL DISP, WIDTH, FG, BG >*/

/* Plot an annotated grey-scale or color wedge parallel to a given axis */
/* of the the current viewport. This routine is designed to provide a */
/* brightness/color scale for an image drawn with PGIMAG or PGGRAY. */
/* The wedge will be drawn with the transfer function set by PGSITF */
/* and using the color index range set by PGSCIR. */

/* Arguments: */
/*  SIDE   (input)  : The first character must be one of the characters */
/*                    'B', 'L', 'T', or 'R' signifying the Bottom, Left, */
/*                    Top, or Right edge of the viewport. */
/*                    The second character should be 'I' to use PGIMAG */
/*                    to draw the wedge, or 'G' to use PGGRAY. */
/*  DISP   (input)  : the displacement of the wedge from the specified */
/*                    edge of the viewport, measured outwards from the */
/*                    viewport in units of the character height. Use a */
/*                    negative value to write inside the viewport, a */
/*                    positive value to write outside. */
/*  WIDTH  (input)  : The total width of the wedge including annotation, */
/*                    in units of the character height. */
/*  FG     (input)  : The value which is to appear with shade */
/*                    1 ("foreground"). Use the values of FG and BG */
/*                    that were supplied to PGGRAY or PGIMAG. */
/*  BG     (input)  : the value which is to appear with shade */
/*                    0 ("background"). */
/*  LABEL  (input)  : Optional units label. If no label is required */
/*                    use ' '. */
/* -- */
/*  15-Oct-1992: New routine (MCS) */
/*   2-Aug-1995: no longer needs common (TJP). */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL PGNOTO >*/
/*                                        Temporary window coord storage. */
/*<       REAL WXA,WXB,WYA,WYB, XA,XB,YA,YB >*/
/*                                        Viewport coords of wedge. */
/*<       REAL VXA,VXB,VYA,VYB >*/
/*                          Original and anotation character heights. */
/*<       REAL OLDCH, NEWCH >*/
/*                          Size of unit character height (NDC units). */
/*<       REAL NDCSIZ >*/
/*                          True if wedge plotted horizontally. */
/*<       LOGICAL HORIZ >*/
/*                          Use PGIMAG (T) or PGGRAY (F). */
/*<       LOGICAL IMAGE >*/
/*                          Symbolic version of SIDE. */
/*<       INTEGER NSIDE,BOT,TOP,LFT,RGT >*/
/*<       PARAMETER (BOT=1,TOP=2,LFT=3,RGT=4) >*/
/*<       INTEGER I >*/
/*<       REAL WEDWID, WDGINC, VWIDTH, VDISP, XCH, YCH, LABWID, FG1, BG1 >*/
/*                          Set the fraction of WIDTH used for anotation. */
/*<       REAL TXTFRC >*/
/*<       PARAMETER (TXTFRC=0.6) >*/
/*                          Char separation between numbers and LABEL. */
/*<       REAL TXTSEP >*/
/*<       PARAMETER (TXTSEP=2.2) >*/
/*                          Array to draw wedge in. */
/*<       INTEGER WDGPIX >*/
/*<       PARAMETER (WDGPIX=100) >*/
/*<       REAL WDGARR(WDGPIX) >*/
/*                          Define the coordinate-mapping function. */
/*<       REAL TR(6) >*/
/*<       SAVE TR >*/
/*<       DATA TR /0.0,1.0,0.0,0.0,0.0,1.0/ >*/
/* ----------------------------------------------------------------------- */
/*<       IF(PGNOTO('PGWEDG')) RETURN >*/
    if (pgnoto_("PGWEDG", (ftnlen)6)) {
	return 0;
    }

/* Get a numeric version of SIDE. */

/*<       IF(SIDE(1:1).EQ.'B' .OR. SIDE(1:1).EQ.'b') THEN >*/
    if (*(unsigned char *)side == 'B' || *(unsigned char *)side == 'b') {
/*<         NSIDE = BOT >*/
	nside = 1;
/*<         HORIZ = .TRUE. >*/
	horiz = TRUE_;
/*<       ELSE IF(SIDE(1:1).EQ.'T' .OR. SIDE(1:1).EQ.'t') THEN >*/
    } else if (*(unsigned char *)side == 'T' || *(unsigned char *)side == 't')
	     {
/*<         NSIDE = TOP >*/
	nside = 2;
/*<         HORIZ = .TRUE. >*/
	horiz = TRUE_;
/*<       ELSE IF(SIDE(1:1).EQ.'L' .OR. SIDE(1:1).EQ.'l') THEN >*/
    } else if (*(unsigned char *)side == 'L' || *(unsigned char *)side == 'l')
	     {
/*<         NSIDE = LFT >*/
	nside = 3;
/*<         HORIZ = .FALSE. >*/
	horiz = FALSE_;
/*<       ELSE IF(SIDE(1:1).EQ.'R' .OR. SIDE(1:1).EQ.'r') THEN >*/
    } else if (*(unsigned char *)side == 'R' || *(unsigned char *)side == 'r')
	     {
/*<         NSIDE = RGT >*/
	nside = 4;
/*<         HORIZ = .FALSE. >*/
	horiz = FALSE_;
/*<       ELSE >*/
    } else {
/*<         CALL GRWARN('Invalid "SIDE" argument in PGWEDG.') >*/
	grwarn_("Invalid \"SIDE\" argument in PGWEDG.", (ftnlen)34);
/*<         RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Determine which routine to use. */

/*<       IF (LEN(SIDE).LT.2) THEN >*/
    if (i_len(side, side_len) < 2) {
/*<          IMAGE = .FALSE. >*/
	image = FALSE_;
/*<       ELSE IF(SIDE(2:2).EQ.'I' .OR. SIDE(2:2).EQ.'i') THEN >*/
    } else if (*(unsigned char *)&side[1] == 'I' || *(unsigned char *)&side[1]
	     == 'i') {
/*<          IMAGE = .TRUE. >*/
	image = TRUE_;
/*<       ELSE IF(SIDE(2:2).EQ.'G' .OR. SIDE(2:2).EQ.'g') THEN >*/
    } else if (*(unsigned char *)&side[1] == 'G' || *(unsigned char *)&side[1]
	     == 'g') {
/*<          IMAGE = .FALSE. >*/
	image = FALSE_;
/*<       ELSE >*/
    } else {
/*<          CALL GRWARN('Invalid "SIDE" argument in PGWEDG.') >*/
	grwarn_("Invalid \"SIDE\" argument in PGWEDG.", (ftnlen)34);
/*<       END IF >*/
    }

/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Store the current world and viewport coords and the character height. */

/*<       CALL PGQWIN(WXA, WXB, WYA, WYB) >*/
    pgqwin_(&wxa, &wxb, &wya, &wyb);
/*<       CALL PGQVP(0, XA, XB, YA, YB) >*/
    pgqvp_(&c__0, &xa, &xb, &ya, &yb);
/*<       CALL PGQCH(OLDCH) >*/
    pgqch_(&oldch);

/* Determine the unit character height in NDC coords. */

/*<       CALL PGSCH(1.0) >*/
    pgsch_(&c_b18);
/*<       CALL PGQCS(0, XCH, YCH) >*/
    pgqcs_(&c__0, &xch, &ych);
/*<       IF(HORIZ) THEN >*/
    if (horiz) {
/*<         NDCSIZ = YCH >*/
	ndcsiz = ych;
/*<       ELSE >*/
    } else {
/*<         NDCSIZ = XCH >*/
	ndcsiz = xch;
/*<       END IF >*/
    }

/* Convert 'WIDTH' and 'DISP' into viewport units. */

/*<       VWIDTH = WIDTH * NDCSIZ * OLDCH >*/
    vwidth = *width * ndcsiz * oldch;
/*<       VDISP  = DISP * NDCSIZ * OLDCH >*/
    vdisp = *disp * ndcsiz * oldch;

/* Determine the number of character heights required under the wedge. */

/*<       LABWID = TXTSEP >*/
    labwid = (float)2.2;
/*<       IF(LABEL.NE.' ') LABWID = LABWID + 1.0 >*/
    if (s_cmp(label, " ", label_len, (ftnlen)1) != 0) {
	labwid += (float)1.;
    }

/* Determine and set the character height required to fit the wedge */
/* anotation text within the area allowed for it. */

/*<       NEWCH = TXTFRC*VWIDTH / (LABWID*NDCSIZ) >*/
    newch = vwidth * (float).6 / (labwid * ndcsiz);
/*<       CALL PGSCH(NEWCH) >*/
    pgsch_(&newch);

/* Determine the width of the wedge part of the plot minus the anotation. */
/* (NDC units). */

/*<       WEDWID = VWIDTH * (1.0-TXTFRC) >*/
    wedwid = vwidth * (float).40000000000000002;

/* Use these to determine viewport coordinates for the wedge + annotation. */

/*<       VXA = XA >*/
    vxa = xa;
/*<       VXB = XB >*/
    vxb = xb;
/*<       VYA = YA >*/
    vya = ya;
/*<       VYB = YB >*/
    vyb = yb;
/*<       IF(NSIDE.EQ.BOT) THEN >*/
    if (nside == 1) {
/*<         VYB = YA - VDISP >*/
	vyb = ya - vdisp;
/*<         VYA = VYB - WEDWID >*/
	vya = vyb - wedwid;
/*<       ELSE IF(NSIDE.EQ.TOP) THEN >*/
    } else if (nside == 2) {
/*<         VYA = YB + VDISP >*/
	vya = yb + vdisp;
/*<         VYB = VYA + WEDWID >*/
	vyb = vya + wedwid;
/*<       ELSE IF(NSIDE.EQ.LFT) THEN >*/
    } else if (nside == 3) {
/*<         VXB = XA - VDISP >*/
	vxb = xa - vdisp;
/*<         VXA = VXB - WEDWID >*/
	vxa = vxb - wedwid;
/*<       ELSE IF(NSIDE.EQ.RGT) THEN >*/
    } else if (nside == 4) {
/*<         VXA = XB + VDISP >*/
	vxa = xb + vdisp;
/*<         VXB = VXA + WEDWID >*/
	vxb = vxa + wedwid;
/*<       END IF >*/
    }

/* Set the viewport for the wedge. */

/*<       CALL PGSVP(VXA, VXB, VYA, VYB) >*/
    pgsvp_(&vxa, &vxb, &vya, &vyb);

/* Swap FG/BG if necessary to get axis direction right. */

/*<       FG1 = MAX(FG,BG) >*/
    fg1 = dmax(*fg,*bg);
/*<       BG1 = MIN(FG,BG) >*/
    bg1 = dmin(*fg,*bg);

/* Create a dummy wedge array to be plotted. */

/*<       WDGINC = (FG1-BG1)/(WDGPIX-1) >*/
    wdginc = (fg1 - bg1) / 99;
/*<       DO 1 I=1,WDGPIX >*/
    for (i__ = 1; i__ <= 100; ++i__) {
/*<         WDGARR(I) = BG1 + (I-1) * WDGINC >*/
	wdgarr[i__ - 1] = bg1 + (i__ - 1) * wdginc;
/*<  1    CONTINUE >*/
/* L1: */
    }

/* Draw the wedge then change the world coordinates for labelling. */

/*<       IF (HORIZ) THEN >*/
    if (horiz) {
/*<         CALL PGSWIN(1.0, REAL(WDGPIX), 0.9, 1.1) >*/
	pgswin_(&c_b18, &c_b25, &c_b23, &c_b24);
/*<         IF (IMAGE) THEN >*/
	if (image) {
/*<            CALL PGIMAG(WDGARR, WDGPIX,1, 1,WDGPIX, 1,1, FG,BG, TR) >*/
	    pgimag_(wdgarr, &c__100, &c__1, &c__1, &c__100, &c__1, &c__1, fg, 
		    bg, tr);
/*<         ELSE >*/
	} else {
/*<            CALL PGGRAY(WDGARR, WDGPIX,1, 1,WDGPIX, 1,1, FG,BG, TR) >*/
	    pggray_(wdgarr, &c__100, &c__1, &c__1, &c__100, &c__1, &c__1, fg, 
		    bg, tr);
/*<         END IF >*/
	}
/*<         CALL PGSWIN(BG1,FG1,0.0,1.0) >*/
	pgswin_(&bg1, &fg1, &c_b38, &c_b18);
/*<       ELSE >*/
    } else {
/*<         CALL PGSWIN(0.9, 1.1, 1.0, REAL(WDGPIX)) >*/
	pgswin_(&c_b23, &c_b24, &c_b18, &c_b25);
/*<         IF (IMAGE) THEN >*/
	if (image) {
/*<            CALL PGIMAG(WDGARR, 1,WDGPIX, 1,1, 1,WDGPIX, FG,BG, TR) >*/
	    pgimag_(wdgarr, &c__1, &c__100, &c__1, &c__1, &c__1, &c__100, fg, 
		    bg, tr);
/*<         ELSE >*/
	} else {
/*<            CALL PGGRAY(WDGARR, 1,WDGPIX, 1,1, 1,WDGPIX, FG,BG, TR) >*/
	    pggray_(wdgarr, &c__1, &c__100, &c__1, &c__1, &c__1, &c__100, fg, 
		    bg, tr);
/*<         END IF >*/
	}
/*<         CALL PGSWIN(0.0, 1.0, BG1, FG1) >*/
	pgswin_(&c_b38, &c_b18, &bg1, &fg1);
/*<       ENDIF >*/
    }

/* Draw a labelled frame around the wedge. */

/*<       IF(NSIDE.EQ.BOT) THEN >*/
    if (nside == 1) {
/*<         CALL PGBOX('BCNST',0.0,0,'BC',0.0,0) >*/
	pgbox_("BCNST", &c_b38, &c__0, "BC", &c_b38, &c__0, (ftnlen)5, (
		ftnlen)2);
/*<       ELSE IF(NSIDE.EQ.TOP) THEN >*/
    } else if (nside == 2) {
/*<         CALL PGBOX('BCMST',0.0,0,'BC',0.0,0) >*/
	pgbox_("BCMST", &c_b38, &c__0, "BC", &c_b38, &c__0, (ftnlen)5, (
		ftnlen)2);
/*<       ELSE IF(NSIDE.EQ.LFT) THEN >*/
    } else if (nside == 3) {
/*<         CALL PGBOX('BC',0.0,0,'BCNST',0.0,0) >*/
	pgbox_("BC", &c_b38, &c__0, "BCNST", &c_b38, &c__0, (ftnlen)2, (
		ftnlen)5);
/*<       ELSE IF(NSIDE.EQ.RGT) THEN >*/
    } else if (nside == 4) {
/*<         CALL PGBOX('BC',0.0,0,'BCMST',0.0,0) >*/
	pgbox_("BC", &c_b38, &c__0, "BCMST", &c_b38, &c__0, (ftnlen)2, (
		ftnlen)5);
/*<       ENDIF >*/
    }

/* Write the units label. */

/*<       IF(LABEL.NE.' ') THEN >*/
    if (s_cmp(label, " ", label_len, (ftnlen)1) != 0) {
/*<         CALL PGMTXT(SIDE,TXTSEP,1.0,1.0,LABEL) >*/
	pgmtxt_(side, &c_b83, &c_b18, &c_b18, label, side_len, label_len);
/*<       END IF >*/
    }

/* Reset the original viewport and world coordinates. */

/*<       CALL PGSVP(XA,XB,YA,YB) >*/
    pgsvp_(&xa, &xb, &ya, &yb);
/*<       CALL PGSWIN(WXA,WXB,WYA,WYB) >*/
    pgswin_(&wxa, &wxb, &wya, &wyb);
/*<       CALL PGSCH(OLDCH) >*/
    pgsch_(&oldch);
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgwedg_ */

