/* /work2/ssa/pgplot/drivers/ttdriv.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;
static integer c__1 = 1;
static integer c__5 = 5;
static integer c__3 = 3;
static integer c__4 = 4;
static integer c__6 = 6;
static integer c__9 = 9;
static integer c__7 = 7;
static integer c__8 = 8;
static integer c__11 = 11;
static integer c__10 = 10;

/* *TTDRIV -- PGPLOT Tektronix terminal drivers */
/* + */
/*<       SUBROUTINE TTDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE) >*/
/* Subroutine */ int ttdriv_(ifunc, rbuf, nbuf, chr, lchr, mode, chr_len)
integer *ifunc;
real *rbuf;
integer *nbuf;
char *chr;
integer *lchr, *mode;
ftnlen chr_len;
{
    /* Initialized data */

    static char device[48*10+1] = "TEK4010 (Tektronix 4010 terminal)        \
       GF    (GraphOn Tek terminal emulator)           RETRO (Retrographics \
VT640 Tek emulator)        GTERM (Color gterm terminal emulator)           X\
TERM (XTERM Tek terminal emulator)             ZSTEM (ZSTEM Tek terminal emu\
lator)             V603  (Visual 603 terminal)                     KRM3  (Ke\
rmit 3 IBM-PC terminal emulator)       TK4100 (Tektronix 4100 terminals)    \
           VMAC  (VersaTerm-PRO for Mac, Tek 4105)         ";
    static integer state = 0;
    static integer xsize[10] = { 1023,1023,1023,1023,1023,1023,1023,1023,1023,
	    1023 };
    static integer ysize[10] = { 779,779,779,779,779,779,779,779,779,779 };
    static integer maxci[10] = { 1,1,1,15,1,7,1,14,15,15 };
    static real xresln[10] = { (float)130.,(float)128.,(float)128.,(float)
	    130.,(float)128.,(float)130.,(float)115.,(float)110.,(float)100.,(
	    float)128. };
    static real yresln[10] = { (float)130.,(float)130.,(float)130.,(float)
	    130.,(float)130.,(float)130.,(float)115.,(float)110.,(float)100.,(
	    float)128. };
    static integer i4014[10] = { 0,0,0,0,1,1,0,0,1,1 };
    static integer irgb[48]	/* was [3][16] */ = { 0,0,0,255,255,255,255,0,
	    0,0,255,0,0,0,255,0,255,255,255,0,255,255,255,0,255,128,0,128,255,
	    0,0,255,128,0,128,255,128,0,255,255,0,128,85,85,85,170,170,170 };
    static integer tkrgb[48]	/* was [3][16] */ = { 0,0,0,100,100,100,100,0,
	    0,0,100,0,0,0,100,0,100,100,100,0,100,100,100,0,100,50,0,50,100,0,
	    0,100,50,0,50,100,50,0,100,100,0,50,33,33,33,67,67,67 };

    /* System generated locals */
    address a__1[2], a__2[11];
    integer i__1[2], i__2, i__3, i__4, i__5, i__6[11];
    real r__1, r__2, r__3;
    icilist ici__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer i_len();
    /* Subroutine */ int s_cat();
    integer i_nint(), s_wsfi(), do_fio(), e_wsfi();

    /* Local variables */
    static integer ladd;
    static char cbuf[500];
    static integer ibuf[4], lbuf;
    static char cscr[4*4], ctmp[32];
    static integer ltmp, itot;
    static char text[80];
    static integer i__, j, ichan, npage, lasti, inten, lastj;
    extern /* Subroutine */ int grtt01_(), grtt02_(), grtt03_(), grtt04_(), 
	    grtt05_(), grtt06_();
    static integer i0, j0, i1, j1;
    static logical append, sefcol;
    extern /* Subroutine */ int grcter_(), grwarn_();
    extern integer groter_();
    extern /* Subroutine */ int grtrml_(), grxhls_(), grwter_();
    static integer ich, ici;
    static real lig;
    static integer ier;
    static real hue, sat;
    static char cadd[32];

/*<       INTEGER IFUNC, NBUF, LCHR, MODE >*/
/*<       REAL    RBUF(*) >*/
/*<       CHARACTER*(*) CHR >*/

/* PGPLOT driver for Tektronix terminals and emulators. */

/* 1993 Jan 18 - T. J. Pearson. */
/* 1993 Jun 24 - L. Staveley-Smith, minor alteration of */
/*               flush-buffer for better /tek */
/*               compatibility. Also added MODE 7 for */
/*               Visual 603's and MODE 8 for IBM-PCs */
/*               running as remote terminals using */
/*               Kermit version 3 (for DOS). */
/* 1994 Dec 19 - TJP: better XTERM support. */
/* 1994 Dec 29 - TJP: and Tek4100 support (MODE 9). */
/* 1996 Apr 18 - TJP: prevent concurrent access. */
/* 1998 Mar 09 - M. Zolliker: new MODE 10 for VersaTerm-PRO for Macintosh */

/* Supported device: */
/* 1. Tektronix 4006/4010 storage-tube terminal; can be used with */
/*   emulators, but the options below take advantage of features not */
/*   present in the basic Tektronix terminal. */
/* 2. GraphOn Corporation 200-series terminals. These emulate a */
/*   Tektronix-4010 with enhancements (selective erase, rectangle fill, */
/*   switch between Tek and VT100 modes). */
/* 3. Digital Engineering, Inc., Retrographics modified VT100 */
/*   terminal (VT640). */
/* 4. IRAF GTERM Tektronix terminal emulator, with color extensions. */
/* 5. Xterm window on an X-window server. Emulates a Tektronix-4014, */
/*   with extensions (switch between Tek and VT100 windows). */
/* 6. ZSTEM 240 and ZSTEM 4014 terminal emulators for the IBM PC and */
/*   clones. ZSTEM supports Tektronix 4014 emulation and the 4105 color */
/*   escape sequences. ZSTEM can be obtained from: KEA Systems Ltd., */
/*   2150 West Broadway, Suite 412, Vancouver, British Columbia, Canada, */
/*   V6K 4L9. */
/* 7.Visual-603 and 630 terminals. These are VT100/220 compatible */
/*   terminals with Tektronix 4010/4014 emulation (Visual Technology */
/*   Incorporated, 1703 Middlesex Street, Lowell, Mass 01851). The */
/*   Visual 630 has the capability of displaying dual text and graphics. */
/*   This feature is not used in this driver. Graphics mode is entered */
/*   automatically when the graph is drawn but only exited when PGPAGE */
/*   or PGEND is called. Therefore, for multiple plots interspersed */
/*   with text I/O, use PGPAGE at the end of each plot. This will prompt */
/*   for a carriage return before switching. If this is not done, */
/*   intervening text will appear on the graphics screen. Graphics mode */
/*   can be entered and exited from the setup menu, or by SHIFT-PF1. */
/*   Graphics extensions include rectangle fill, selective erase and */
/*   switch between Tek and VT100 modes. */
/* 8.IBM PC's and compatibles running MS-Kermit 3 as a terminal emulator. */
/*   The video board is assumed to have sufficient memory to retain the */
/*   graphics image in memory when switched to text. This will be true */
/*   for VGA and EGA, but some early PCs might not be able to do this. */
/*   If Kermit is using full VGA resolution (ie SET TERMINAL GRAPHICS */
/*   VGA), there is not usually enough memory to store the full 480 */
/*   vertical lines, so the bottom few lines may disappear. Tektronix */
/*   enhancements include selective erase, colours, rectangle fill, and */
/*   switching between text and graphics mode. The cursor may be */
/*   operated with the mouse. Tested with Kermit version 3.1. */
/* 9.Tektronix 4100 series color terminals (and emulators) */
/* 10.Versaterm-PRO for Macintosh (Tek 4105 emulation). */

/* Device type codes: */
/* 1.  /TEK4010 Tektronix-4010 terminal */
/* 2.  /GF      GraphOn terminal */
/* 3.  /RETRO   Retrographics VT640 terminal */
/* 4.  /GTERM   GTERM terminal emulator */
/* 5.  /XTERM   XTERM terminal emulator */
/* 6.  /ZSTEM   ZSTEM terminal emulator */
/* 7.  /V603    Visual V603 terminal */
/* 8.  /KRM3    Kermit 3 on IBM-PC */
/* 9.  /TK4100  Tektronix 4100 series terminals */
/* 10. /VMAC    VersaTerm-PRO for Macintosh */

/* Default device name: the logged-in terminal */
/*   /dev/tty (UNIX) */
/*   TT: (VMS) */

/* Default view surface dimensions: */
/*   Depends on monitor; nominally 8in (horizontal) by 6in (vertical). */

/* Resolution: */
/*   A standard Tektronix terminal displays a screen of 1024 pixels */
/*   (horizontal) by 780 pixels (vertical), with a nominal resolution */
/*   of 130 pixels per inch. The actual resolution may be less. */

/* Color capability: */
/*   /TEK4010, /XTERM: none; only color index 1 is available; selective */
/*       erase is not possible. Requests to draw in color index 0 are */
/*       ignored. */
/*   /GF, /RETRO, /V603: color indices 0 (erase, black) and 1 (bright: */
/*       usually white, green or amber) are supported. It is not */
/*       possible to change color representation. */
/*   /GTERM:  color indices 0 to 15 are available and default to the */
/*       standard PGPLOT colors. The color representation can be changed. */
/*   /ZSTEM: color indices 0 to 7 are available and default to the */
/*       indicated in the ZSTEM setup menu (which default to the standard */
/*       PGPLOT colors).  The color representation cannot be changed. */
/*   /KRM3: color indices 0 to 7 are the standard PGPLOT colors. Indices */
/*       8 to 14 are also available, but are BRIGHT versions of 1 to 7, */
/*       and thus non-standard. Color representation can't be changed. */
/*   /TK4100: color indices 0-15. */
/*   /VMAC: color indices 0 to 15 are available and default to the */
/*       standard PGPLOT colors. The color representation can be changed. */
/*       Caution: this does not work reliably, owing to bugs (?) in */
/*       Versaterm. */

/* Input capability: */
/*   Depending on the emulation, the graphics cursor may be a pointer, */
/*   a small cross, or a crosshair across the entire screen. The user */
/*   positions the cursor using thumbwheels, mouse, trackball, or the */
/*   arrow keys on the keyboard. The user indicates that the cursor has */
/*   been positioned by typing any printable ASCII character on the */
/*   keyboard. Most control characters (eg, ^C) are intercepted by the */
/*   operating system and cannot be used. */

/* File format: */
/*   Binary byte stream. Under Unix, the output may be directed to */
/*   a file; under VMS, this is not possible: the output device must */
/*   be a terminal. */

/* Obtaining hardcopy: */

/* Environment variables: */
/*   None. */
/* -- */
/* Implementation Notes: */

/* Standard Tektronix codes: */
/*   graph mode: [GS]=char(29) */
/*   alpha mode: [US]=char(31) */
/* The emulators provide various extensions to basic Tektronix */
/* operation, using the following codes: */
/*    [SOH]=char(1),  [STX]=char(2),  [ETX]=char(3), */
/*    [DLE]=char(16), [CAN]=char(24), [ESC]=char(27) */

/* Enter Tektronix mode (from VT100 mode): */
/*   graphon: automatic on receipt of [GS] */
/*   gterm:   [GS] */
/*   tek:     not available */
/*   retro:   automatic on receipt of [GS] */
/*   xterm:   [ESC][?38h */
/*   zstem:   [ESC][?38h */
/*   v603:    [GS] */
/*   krm3:    [ESC][?38h */
/* Return to VT100 mode (from Tektronix mode): */
/*   graphon: [CAN] */
/*   gterm:   [CAN] */
/*   tek:     not available */
/*   xterm:   [ESC][ETX] */
/*   zstem:   [CAN] */
/*   v603:    [CAN][ESC][?38l */
/*   krm3:    [ESC][?38l */
/* Rectangle fill: */
/*   graphon: draw the diagonal in special rectangle mode, */
/*     entered with [ESC][STX], exit with [ESC][ETX] */
/*   v603: bottom corner and rectangle width */
/*   krm3: bottom corner and rectangle width */
/*   vmac: use panel boundary commands [ESC]LP and [ESC]LE */
/* Color index zero (erase): */
/*   graphon select erase:        [ESC][DLE] */
/*   graphon unselect erase:      [ESC][SOH] */
/*   retro,v603 select erase:     [ESC]/1d */
/*   retro,v603 unselect erase:   [ESC]/0d */
/*   krm3, select erase:          [ESC][0;30m */
/*   krm3, unselect erase:        [ESC][0;37m */
/* ----------------------------------------------------------------------- */
/*<       INTEGER NDEVS >*/
/*<       PARAMETER (NDEVS=10) >*/
/*<       INTEGER CAN, ESC, GS, US >*/
/*<       PARAMETER (CAN=24, ESC=27, GS=29, US=31) >*/

/*<       CHARACTER*48 DEVICE(NDEVS) >*/
/*<       SAVE         DEVICE >*/
/*<       CHARACTER*80 TEXT >*/
/*<       CHARACTER*32 CTMP, CADD, CSCR(4)*4 >*/
/*<       CHARACTER*500 CBUF >*/
/*<       SAVE          CBUF >*/
/*<       INTEGER I, J, INTEN, I0, J0, I1, J1, LADD, LTMP, ICH, IER >*/
/*<       INTEGER XSIZE(NDEVS), YSIZE(NDEVS), MAXCI(NDEVS), I4014(NDEVS) >*/
/*<       SAVE    XSIZE,        YSIZE,        MAXCI,        I4014 >*/
/*<       INTEGER ICHAN, LASTI, LASTJ, NPAGE, ICI, LBUF, STATE >*/
/*<       SAVE    ICHAN, LASTI, LASTJ, NPAGE, ICI, LBUF, STATE >*/
/*<       INTEGER GROTER >*/
/*<       INTEGER IBUF(4), ITOT >*/
/*<       LOGICAL APPEND >*/
/*<       SAVE    APPEND >*/
/*<       REAL    XRESLN(NDEVS), YRESLN(NDEVS) >*/
/*<       SAVE    XRESLN,        YRESLN >*/
/*<       REAL    HUE,SAT,LIG >*/
/*<       LOGICAL SEFCOL >*/
/*<       SAVE    SEFCOL >*/

/*<       INTEGER IRGB(3,0:15), TKRGB(3,0:15) >*/

/*<       DATA DEVICE(1) /'TEK4010 (Tektronix 4010 terminal)'/ >*/
    /* Parameter adjustments */
    --rbuf;

    /* Function Body */
/*<       DATA DEVICE(2) /'GF    (GraphOn Tek terminal emulator)'/ >*/
/*<       DATA DEVICE(3) /'RETRO (Retrographics VT640 Tek emulator)'/ >*/
/*<       DATA DEVICE(4) /'GTERM (Color gterm terminal emulator)'/ >*/
/*<       DATA DEVICE(5) /'XTERM (XTERM Tek terminal emulator)'/ >*/
/*<       DATA DEVICE(6) /'ZSTEM (ZSTEM Tek terminal emulator)'/ >*/
/*<       DATA DEVICE(7) /'V603  (Visual 603 terminal)'/ >*/
/*<       DATA DEVICE(8) /'KRM3  (Kermit 3 IBM-PC terminal emulator)'/ >*/
/*<       DATA DEVICE(9) /'TK4100 (Tektronix 4100 terminals)'/ >*/
/*<       DATA DEVICE(10) /'VMAC  (VersaTerm-PRO for Mac, Tek 4105)'/ >*/
/*                 TEK  GF   RET  GTER XTER ZSTE V603 KRM3 TK41 VMAC */
/*<       DATA XSIZE /1023,1023,1023,1023,1023,1023,1023,1023,1023,1023/ >*/
/*<       DATA YSIZE / 779, 779, 779, 779, 779, 779, 779, 779, 779, 779/ >*/
/*<       DATA MAXCI /   1,   1,   1,  15,   1,   7,   1,  14,  15,  15/ >*/
/*<       DATA XRESLN/130.,128.,128.,130.,128.,130.,115.,110.,100.,128./ >*/
/*<       DATA YRESLN/130.,130.,130.,130.,130.,130.,115.,110.,100.,128./ >*/
/*<       DATA I4014/    0,   0,   0,   0,   1,   1,   0,   0,   1,   1/ >*/
/*<    >*/
/*<    >*/
/*<       DATA STATE/0/ >*/
/* ----------------------------------------------------------------------- */

/*<       IF (MODE.LT.1 .OR. MODE.GT.NDEVS) CALL GRWARN('Error in GRTT00') >*/
    if (*mode < 1 || *mode > 10) {
	grwarn_("Error in GRTT00", (ftnlen)15);
    }
/*<    >*/
    switch ((int)*ifunc) {
	case 1:  goto L10;
	case 2:  goto L20;
	case 3:  goto L30;
	case 4:  goto L40;
	case 5:  goto L50;
	case 6:  goto L60;
	case 7:  goto L70;
	case 8:  goto L80;
	case 9:  goto L90;
	case 10:  goto L100;
	case 11:  goto L110;
	case 12:  goto L120;
	case 13:  goto L130;
	case 14:  goto L140;
	case 15:  goto L150;
	case 16:  goto L160;
	case 17:  goto L170;
	case 18:  goto L180;
	case 19:  goto L900;
	case 20:  goto L900;
	case 21:  goto L210;
	case 22:  goto L900;
	case 23:  goto L900;
	case 24:  goto L240;
    }
/*     -- Ignore unimplemented function */
/*<   900 RETURN >*/
L900:
    return 0;

/* --- IFUNC = 1, Return device name.------------------------------------- */

/*<    10 CONTINUE >*/
L10:
/*<       CHR  = DEVICE(MODE) >*/
    s_copy(chr, device + (*mode - 1) * 48, chr_len, (ftnlen)48);
/*<       LCHR = LEN(DEVICE(MODE)) >*/
    *lchr = i_len(device + (*mode - 1) * 48, (ftnlen)48);
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 2, Return physical min and max for plot device, and range */
/*               of color indices.--------------------------------------- */

/*<    20 CONTINUE >*/
L20:
/*<       RBUF(1) = 0 >*/
    rbuf[1] = (float)0.;
/*<       RBUF(2) = XSIZE(MODE) >*/
    rbuf[2] = (real) xsize[*mode - 1];
/*<       RBUF(3) = 0 >*/
    rbuf[3] = (float)0.;
/*<       RBUF(4) = YSIZE(MODE) >*/
    rbuf[4] = (real) ysize[*mode - 1];
/*<       RBUF(5) = 0 >*/
    rbuf[5] = (float)0.;
/*<       RBUF(6) = MAXCI(MODE) >*/
    rbuf[6] = (real) maxci[*mode - 1];
/*<       NBUF = 6 >*/
    *nbuf = 6;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 3, Return device resolution. ------------------------------ */

/*<    30 CONTINUE >*/
L30:
/*<       RBUF(1) = XRESLN(MODE) >*/
    rbuf[1] = xresln[*mode - 1];
/*<       RBUF(2) = YRESLN(MODE) >*/
    rbuf[2] = yresln[*mode - 1];
/*<       RBUF(3) = 1 >*/
    rbuf[3] = (float)1.;
/*<       NBUF = 3 >*/
    *nbuf = 3;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 4, Return misc device info. ------------------------------- */
/*    (This device is Interactive, Cursor, No dashed lines, No areafill, */
/*    No thick lines, No markers; some varieties have rectangle fill) */

/*<    40 CONTINUE >*/
L40:
/*<       CHR = 'ICNNNNNNNN' >*/
    s_copy(chr, "ICNNNNNNNN", chr_len, (ftnlen)10);
/*<       IF (MODE.EQ.2 .OR. MODE.EQ.7 .OR. MODE.EQ.8) CHR(6:6) = 'R' >*/
    if (*mode == 2 || *mode == 7 || *mode == 8) {
	*(unsigned char *)&chr[5] = 'R';
    }
/*<       IF (MODE.EQ.10) THEN >*/
    if (*mode == 10) {
/*       -- VMAC: rect. fill and wait before closing graph window */
/*<         CHR(6:6) = 'R' >*/
	*(unsigned char *)&chr[5] = 'R';
/*<         CHR(8:8) = 'V' >*/
	*(unsigned char *)&chr[7] = 'V';
/*<       ENDIF >*/
    }
/*<       LCHR = 10 >*/
    *lchr = 10;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 5, Return default file name. ------------------------------ */

/*<    50 CONTINUE >*/
L50:
/*<       CALL GRTRML(CHR,LCHR) >*/
    grtrml_(chr, lchr, chr_len);
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 6, Return default physical size of plot. ------------------ */

/*<    60 CONTINUE >*/
L60:
/*<       RBUF(1) = 0 >*/
    rbuf[1] = (float)0.;
/*<       RBUF(2) = XSIZE(MODE) >*/
    rbuf[2] = (real) xsize[*mode - 1];
/*<       RBUF(3) = 0 >*/
    rbuf[3] = (float)0.;
/*<       RBUF(4) = YSIZE(MODE) >*/
    rbuf[4] = (real) ysize[*mode - 1];
/*<       NBUF = 4 >*/
    *nbuf = 4;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 7, Return misc defaults. ---------------------------------- */

/*<    70 CONTINUE >*/
L70:
/*<       RBUF(1) = 2.0 >*/
    rbuf[1] = (float)2.;
/*<       NBUF = 1 >*/
    *nbuf = 1;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 8, Select plot. ------------------------------------------- */

/*<    80 CONTINUE >*/
L80:
/*     -- do nothing */
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 9, Open workstation. -------------------------------------- */

/*<    90 CONTINUE >*/
L90:
/*     -- check for concurrent access */
/*<       IF (STATE.EQ.1) THEN >*/
    if (state == 1) {
/*<          CALL GRWARN('a PGPLOT Tektronix device is already open') >*/
	grwarn_("a PGPLOT Tektronix device is already open", (ftnlen)41);
/*<          RBUF(1) = 0 >*/
	rbuf[1] = (float)0.;
/*<          RBUF(2) = 0 >*/
	rbuf[2] = (float)0.;
/*<          RETURN >*/
	return 0;
/*<       END IF >*/
    }
/*<       APPEND = RBUF(3) .NE. 0.0 >*/
    append = rbuf[3] != (float)0.;
/*<       RBUF(1) = 0.0 >*/
    rbuf[1] = (float)0.;
/*<       NBUF = 2 >*/
    *nbuf = 2;
/*<       ICHAN = GROTER(CHR, LCHR) >*/
    ichan = groter_(chr, lchr, chr_len);
/*<       IF (ICHAN .LT. 0) THEN >*/
    if (ichan < 0) {
/*<    >*/
/* Writing concatenation */
	i__1[0] = 40, a__1[0] = "Cannot open output device for plot type ";
	i__1[1] = 48, a__1[1] = device + (*mode - 1) * 48;
	s_cat(text, a__1, i__1, &c__2, (ftnlen)80);
/*<           CALL GRWARN(TEXT) >*/
	grwarn_(text, (ftnlen)80);
/*<           RBUF(2) = 0.0 >*/
	rbuf[2] = (float)0.;
/*<           RETURN >*/
	return 0;
/*<       ELSE >*/
    } else {
/*<           STATE = 1 >*/
	state = 1;
/*<           RBUF(2) = 1.0 >*/
	rbuf[2] = (float)1.;
/*<       END IF >*/
    }
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       LASTJ = -1 >*/
    lastj = -1;
/*<       ICI = 1 >*/
    ici = 1;
/*<       NPAGE = 0 >*/
    npage = 0;
/*<       LBUF = 0 >*/
    lbuf = 0;
/*<       IF (.NOT.APPEND) THEN >*/
    if (! append) {
/*<          IF ( MODE.EQ.4 ) THEN >*/
	if (*mode == 4) {
/*           -- load gterm default color table. */
/*<             DO 91 I=0,15 >*/
	    for (i__ = 0; i__ <= 15; ++i__) {
/*<                CTMP(1:6) = CHAR(GS)//CHAR(ESC)//'TG14' >*/
		s_copy(ctmp, "\035\033TG14", (ftnlen)6, (ftnlen)6);
/*<                LTMP = 6 >*/
		ltmp = 6;
/*<                CALL GRTT05(I,         CADD, LADD) >*/
		grtt05_(&i__, cadd, &ladd, (ftnlen)32);
/*<                CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
		i__2 = ltmp;
		s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<                LTMP = LTMP + LADD >*/
		ltmp += ladd;
/*              -- red */
/*<                CALL GRTT05(IRGB(1,I), CADD, LADD) >*/
		grtt05_(&irgb[i__ * 3], cadd, &ladd, (ftnlen)32);
/*<                CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
		i__2 = ltmp;
		s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<                LTMP = LTMP + LADD >*/
		ltmp += ladd;
/*              -- green */
/*<                CALL GRTT05(IRGB(2,I), CADD, LADD) >*/
		grtt05_(&irgb[i__ * 3 + 1], cadd, &ladd, (ftnlen)32);
/*<                CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
		i__2 = ltmp;
		s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<                LTMP = LTMP + LADD >*/
		ltmp += ladd;
/*              -- blue */
/*<                CALL GRTT05(IRGB(3,I), CADD, LADD) >*/
		grtt05_(&irgb[i__ * 3 + 2], cadd, &ladd, (ftnlen)32);
/*<                CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
		i__2 = ltmp;
		s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<                LTMP = LTMP + LADD >*/
		ltmp += ladd;
/*<                CTMP(LTMP+1:LTMP+1) = CHAR(US) >*/
		i__2 = ltmp;
		s_copy(ctmp + i__2, "\037", ltmp + 1 - i__2, (ftnlen)1);
/*<                LTMP = LTMP + 1 >*/
		++ltmp;
/*<                CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
		grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (
			ftnlen)500);
/*<  91         CONTINUE >*/
/* L91: */
	    }
/*<             CALL GRTT02(ICHAN, MODE, CHAR(CAN), 1, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, "\030", &c__1, cbuf, &lbuf, (ftnlen)1, (
		    ftnlen)500);
/*<          ELSE IF (MODE.EQ.10) THEN >*/
	} else if (*mode == 10) {
/*           -- VMAC: put into Tek 4105 mode */
/*<             CTMP(1:5)=CHAR(ESC)//'%!1'//CHAR(GS) >*/
	    s_copy(ctmp, "\033%!1\035", (ftnlen)5, (ftnlen)5);
/*<             CALL GRTT02(ICHAN, MODE, CTMP, 5, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &c__5, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<             SEFCOL = .TRUE. >*/
	    sefcol = TRUE_;
/*           -- set default color representation */
/*<             DO 92,I=0,15 >*/
	    for (i__ = 0; i__ <= 15; ++i__) {
/*<    >*/
		r__1 = irgb[i__ * 3] / (float)255.;
		r__2 = irgb[i__ * 3 + 1] / (float)255.;
		r__3 = irgb[i__ * 3 + 2] / (float)255.;
		grxhls_(&r__1, &r__2, &r__3, &hue, &lig, &sat);
/*<    >*/
		i__2 = i_nint(&hue);
		r__1 = lig * 100;
		i__3 = i_nint(&r__1);
		r__2 = sat * 100;
		i__4 = i_nint(&r__2);
		grtt06_(&i__, &i__2, &i__3, &i__4, ctmp, &ltmp, (ftnlen)32);
/*<               CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
		grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (
			ftnlen)500);
/*< 92          CONTINUE >*/
/* L92: */
	    }
/*<          END IF >*/
	}
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=10, Close workstation. -------------------------------------- */

/*<   100 CONTINUE >*/
L100:
/*<       IF ( MODE.EQ.6 ) THEN >*/
    if (*mode == 6) {
/*         -- For zstem switch back to alpha mode at the last possible */
/*            moment. */
/*<           LTMP = 1 >*/
	ltmp = 1;
/*<           CALL GRWTER(ICHAN, CHAR(CAN), LTMP) >*/
	grwter_(&ichan, "\030", &ltmp, (ftnlen)1);
/*<       ELSE IF ( MODE.EQ.7 ) THEN >*/
    } else if (*mode == 7) {
/*         -- For v603 switch back to alpha mode at the last possible */
/*            moment. */
/*<    >*/
	s_copy(ctmp, "\030\033[?38l", (ftnlen)7, (ftnlen)7);
/*<           LTMP=7 >*/
	ltmp = 7;
/*<           CALL GRWTER(ICHAN, CTMP, LTMP) >*/
	grwter_(&ichan, ctmp, &ltmp, (ftnlen)32);
/*<       ELSE IF (MODE.EQ.10) THEN >*/
    } else if (*mode == 10) {
/*         -- VMAC: put into VT100 Mode without window resize */
/*<           CTMP(1:5)=CHAR(GS)//CHAR(ESC)//'%!7' >*/
	s_copy(ctmp, "\035\033%!7", (ftnlen)5, (ftnlen)5);
/*<           LTMP=5 >*/
	ltmp = 5;
/*<           CALL GRWTER(ICHAN, CTMP, LTMP) >*/
	grwter_(&ichan, ctmp, &ltmp, (ftnlen)32);
/*<       END IF >*/
    }
/*<       CALL GRCTER(ICHAN) >*/
    grcter_(&ichan);
/*<       STATE = 0 >*/
    state = 0;
/*<       RETURN >*/
    return 0;

/* --- IFUNC=11, Begin picture. ------------------------------------------ */

/*<   110 CONTINUE >*/
L110:
/*<       NPAGE = NPAGE+1 >*/
    ++npage;
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       IF (.NOT.APPEND) THEN >*/
    if (! append) {
/*<          IF (MODE.EQ.5 .OR. MODE.EQ.6 .OR. MODE. EQ.8) THEN >*/
	if (*mode == 5 || *mode == 6 || *mode == 8) {
/*           -- xterm, zstem, krm3: select Tek mode, erase screen */
/*<             CTMP(1:1) = CHAR(ESC) >*/
	    *(unsigned char *)ctmp = '\33';
/*<             CTMP(2:2) = CHAR(12) >*/
	    *(unsigned char *)&ctmp[1] = '\f';
/*<             CALL GRTT02(ICHAN, MODE, CTMP, 2, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &c__2, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<          ELSE IF (MODE.EQ.7) THEN >*/
	} else if (*mode == 7) {
/*           -- V603: select Tek mode */
/*<             CTMP(1:1) = CHAR(GS) >*/
	    *(unsigned char *)ctmp = '\35';
/*<             CTMP(2:2) = CHAR(ESC) >*/
	    *(unsigned char *)&ctmp[1] = '\33';
/*<             CTMP(3:3) = CHAR(12) >*/
	    *(unsigned char *)&ctmp[2] = '\f';
/*<             CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &c__3, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<          ELSE >*/
	} else {
/*           -- erase graphics screen */
/*<             CTMP(1:1) = CHAR(GS) >*/
	    *(unsigned char *)ctmp = '\35';
/*<             CTMP(2:2) = CHAR(ESC) >*/
	    *(unsigned char *)&ctmp[1] = '\33';
/*<             CTMP(3:3) = CHAR(12) >*/
	    *(unsigned char *)&ctmp[2] = '\f';
/*<             CTMP(4:4) = CHAR(CAN) >*/
	    *(unsigned char *)&ctmp[3] = '\30';
/*<             CALL GRTT02(ICHAN, MODE, CTMP, 4, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &c__4, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<          END IF >*/
	}
/*<       ELSE IF (MODE.EQ.8) THEN >*/
    } else if (*mode == 8) {
/*        -- krm3: enter graph mode without deleting screen */
/*<          CTMP(1:1) = CHAR(ESC) >*/
	*(unsigned char *)ctmp = '\33';
/*<          CTMP(2:2) = CHAR(91) >*/
	*(unsigned char *)&ctmp[1] = '[';
/*<          CTMP(3:3) = CHAR(63) >*/
	*(unsigned char *)&ctmp[2] = '?';
/*<          CTMP(4:4) = CHAR(51) >*/
	*(unsigned char *)&ctmp[3] = '3';
/*<          CTMP(5:5) = CHAR(56) >*/
	*(unsigned char *)&ctmp[4] = '8';
/*<          CTMP(6:6) = CHAR(104) >*/
	*(unsigned char *)&ctmp[5] = 'h';
/*<          CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__6, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       ELSE IF (MODE.EQ.9) THEN >*/
    } else if (*mode == 9) {
/*        -- TK4100: put device in graphics mode, erase screen */
/*<          CTMP(1:1) = CHAR(ESC) >*/
	*(unsigned char *)ctmp = '\33';
/*<          CTMP(2:4) = '%!0' >*/
	s_copy(ctmp + 1, "%!0", (ftnlen)3, (ftnlen)3);
/*<          CTMP(5:5) = CHAR(ESC) >*/
	*(unsigned char *)&ctmp[4] = '\33';
/*<          CTMP(6:6) = CHAR(12) >*/
	*(unsigned char *)&ctmp[5] = '\f';
/*<          CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__6, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<          CTMP(1:1) = CHAR(ESC) >*/
	*(unsigned char *)ctmp = '\33';
/*<          CTMP(2:6) = 'RU1;4' >*/
	s_copy(ctmp + 1, "RU1;4", (ftnlen)5, (ftnlen)5);
/*<          CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__6, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*        -- set default color representation */
/*<          DO 111 I=0,15 >*/
	for (i__ = 0; i__ <= 15; ++i__) {
/*<             CTMP(1:5) = CHAR(ESC)//'TG14' >*/
	    s_copy(ctmp, "\033TG14", (ftnlen)5, (ftnlen)5);
/*<             LTMP = 5 >*/
	    ltmp = 5;
/*<             CALL GRTT05(I,         CADD, LADD) >*/
	    grtt05_(&i__, cadd, &ladd, (ftnlen)32);
/*<             CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	    i__2 = ltmp;
	    s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<             LTMP = LTMP + LADD >*/
	    ltmp += ladd;
/*           -- red */
/*<             CALL GRTT05(TKRGB(1,I), CADD, LADD) >*/
	    grtt05_(&tkrgb[i__ * 3], cadd, &ladd, (ftnlen)32);
/*<             CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	    i__2 = ltmp;
	    s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<             LTMP = LTMP + LADD >*/
	    ltmp += ladd;
/*           -- green */
/*<             CALL GRTT05(TKRGB(2,I), CADD, LADD) >*/
	    grtt05_(&tkrgb[i__ * 3 + 1], cadd, &ladd, (ftnlen)32);
/*<             CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	    i__2 = ltmp;
	    s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<             LTMP = LTMP + LADD >*/
	    ltmp += ladd;
/*           -- blue */
/*<             CALL GRTT05(TKRGB(3,I), CADD, LADD) >*/
	    grtt05_(&tkrgb[i__ * 3 + 2], cadd, &ladd, (ftnlen)32);
/*<             CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	    i__2 = ltmp;
	    s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<             LTMP = LTMP + LADD >*/
	    ltmp += ladd;
/*<             CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<  111     CONTINUE >*/
/* L111: */
	}
/*         -- set color index 1 */
/*<          CTMP(1:1) = CHAR(ESC) >*/
	*(unsigned char *)ctmp = '\33';
/*<          CTMP(2:4) = 'ML1' >*/
	s_copy(ctmp + 1, "ML1", (ftnlen)3, (ftnlen)3);
/*<          CALL GRTT02(ICHAN, MODE, CTMP, 4, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__4, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=12, Draw line. ---------------------------------------------- */
/*     (omitted for color 0 on devices without selective erase) */

/*<   120 CONTINUE >*/
L120:
/*<       IF (ICI.EQ.0 .AND. (MODE.EQ.1 .OR. MODE.EQ.5)) RETURN >*/
    if (ici == 0 && (*mode == 1 || *mode == 5)) {
	return 0;
    }
/*<       IF ( I4014(MODE).EQ.0 ) THEN >*/
    if (i4014[*mode - 1] == 0) {
/*<          I0 = NINT(RBUF(1)) >*/
	i0 = i_nint(&rbuf[1]);
/*<          J0 = NINT(RBUF(2)) >*/
	j0 = i_nint(&rbuf[2]);
/*<          I1 = NINT(RBUF(3)) >*/
	i1 = i_nint(&rbuf[3]);
/*<          J1 = NINT(RBUF(4)) >*/
	j1 = i_nint(&rbuf[4]);
/*<       ELSE >*/
    } else {
/*<          I0 = NINT(4.*RBUF(1)) >*/
	r__1 = rbuf[1] * (float)4.;
	i0 = i_nint(&r__1);
/*<          J0 = NINT(4.*RBUF(2)) >*/
	r__1 = rbuf[2] * (float)4.;
	j0 = i_nint(&r__1);
/*<          I1 = NINT(4.*RBUF(3)) >*/
	r__1 = rbuf[3] * (float)4.;
	i1 = i_nint(&r__1);
/*<          J1 = NINT(4.*RBUF(4)) >*/
	r__1 = rbuf[4] * (float)4.;
	j1 = i_nint(&r__1);
/*<       END IF >*/
    }
/*<    >*/
    grtt01_(&ichan, mode, &i4014[*mode - 1], &lasti, &lastj, &i0, &j0, &i1, &
	    j1, cbuf, &lbuf, (ftnlen)500);
/*<       RETURN >*/
    return 0;

/* --- IFUNC=13, Draw dot. ----------------------------------------------- */
/*     (omitted for color 0 on devices without selective erase) */

/*<   130 CONTINUE >*/
L130:
/*<       IF (ICI.EQ.0 .AND. (MODE.EQ.1 .OR. MODE.EQ.5)) RETURN >*/
    if (ici == 0 && (*mode == 1 || *mode == 5)) {
	return 0;
    }
/*<       IF ( I4014(MODE).EQ.0 ) THEN >*/
    if (i4014[*mode - 1] == 0) {
/*<          I0 = NINT(RBUF(1)) >*/
	i0 = i_nint(&rbuf[1]);
/*<          J0 = NINT(RBUF(2)) >*/
	j0 = i_nint(&rbuf[2]);
/*<       ELSE >*/
    } else {
/*<          I0 = NINT(4.*RBUF(1)) >*/
	r__1 = rbuf[1] * (float)4.;
	i0 = i_nint(&r__1);
/*<          J0 = NINT(4.*RBUF(2)) >*/
	r__1 = rbuf[2] * (float)4.;
	j0 = i_nint(&r__1);
/*<       END IF >*/
    }
/*<    >*/
    grtt01_(&ichan, mode, &i4014[*mode - 1], &lasti, &lastj, &i0, &j0, &i0, &
	    j0, cbuf, &lbuf, (ftnlen)500);
/*<       RETURN >*/
    return 0;

/* --- IFUNC=14, End picture. -------------------------------------------- */

/*<   140 CONTINUE >*/
L140:
/*<       IF (MODE.EQ.7) THEN >*/
    if (*mode == 7) {
/*        -- V603: enter alphanumerics and unset graphics */
/*<    >*/
	s_copy(ctmp, "\030\033[?38l", (ftnlen)7, (ftnlen)7);
/*<          LTMP=7 >*/
	ltmp = 7;
/*<          CALL GRWTER(ICHAN, CTMP, LTMP) >*/
	grwter_(&ichan, ctmp, &ltmp, (ftnlen)32);
/*<       ELSE IF (MODE.EQ.8) THEN >*/
    } else if (*mode == 8) {
/*         -- krm3: enter alphanumerics and unset graphics */
/*<    >*/
	s_copy(ctmp, "\033[?38l", (ftnlen)6, (ftnlen)6);
/*<          LTMP=6 >*/
	ltmp = 6;
/*<          CALL GRWTER(ICHAN, CTMP, LTMP) >*/
	grwter_(&ichan, ctmp, &ltmp, (ftnlen)32);
/*<       ELSE IF (MODE.EQ.9 .OR. MODE.EQ.10) THEN >*/
    } else if (*mode == 9 || *mode == 10) {
/*        -- TK4100, VMAC: return to text mode */
/*<          CTMP(1:1) = CHAR(ESC) >*/
	*(unsigned char *)ctmp = '\33';
/*<          CTMP(2:4) = '%!1' >*/
	s_copy(ctmp + 1, "%!1", (ftnlen)3, (ftnlen)3);
/*<          LTMP=4 >*/
	ltmp = 4;
/*<          CALL GRWTER(ICHAN, CTMP, LTMP) >*/
	grwter_(&ichan, ctmp, &ltmp, (ftnlen)32);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=15, Select color index. ------------------------------------- */

/*<   150 CONTINUE >*/
L150:
/*<       ICI = RBUF(1) >*/
    ici = rbuf[1];
/*<       IF (ICI.LT.0 .OR. ICI.GT.MAXCI(MODE)) THEN >*/
    if (ici < 0 || ici > maxci[*mode - 1]) {
/*<           ICI = 1 >*/
	ici = 1;
/*<           RBUF(1) = ICI >*/
	rbuf[1] = (real) ici;
/*<       END IF >*/
    }
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       IF (MODE.EQ.2) THEN >*/
    if (*mode == 2) {
/*         -- GraphOn */
/*<           CTMP(1:1) = CHAR(GS) >*/
	*(unsigned char *)ctmp = '\35';
/*<           CTMP(2:2) = CHAR(ESC) >*/
	*(unsigned char *)&ctmp[1] = '\33';
/*<           CTMP(3:3) = CHAR(1) >*/
	*(unsigned char *)&ctmp[2] = '\1';
/*<           IF (ICI.EQ.0) CTMP(3:3) = CHAR(16) >*/
	if (ici == 0) {
	    *(unsigned char *)&ctmp[2] = '\20';
	}
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__3, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       ELSE IF (MODE.EQ.3 .OR. MODE.EQ.7) THEN >*/
    } else if (*mode == 3 || *mode == 7) {
/*         -- Retrographics, V603 */
/*<           CTMP(1:1) = CHAR(GS) >*/
	*(unsigned char *)ctmp = '\35';
/*<           CTMP(2:2) = CHAR(ESC) >*/
	*(unsigned char *)&ctmp[1] = '\33';
/*<           CTMP(3:3) = CHAR(47) >*/
	*(unsigned char *)&ctmp[2] = '/';
/*<           CTMP(4:4) = CHAR(49-ICI) >*/
	*(unsigned char *)&ctmp[3] = (char) (49 - ici);
/*<           CTMP(5:5) = CHAR(100) >*/
	*(unsigned char *)&ctmp[4] = 'd';
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 5, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__5, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       ELSE IF ( MODE.EQ.4 .OR. MODE.EQ.6 .OR. MODE.EQ.10) THEN >*/
    } else if (*mode == 4 || *mode == 6 || *mode == 10) {
/*         -- gterm and zstem, VMAC */
/*<           CTMP(1:4) = CHAR(GS)//CHAR(ESC)//'ML' >*/
	s_copy(ctmp, "\035\033ML", (ftnlen)4, (ftnlen)4);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 4, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__4, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<           CALL GRTT05(ICI, CTMP, LTMP) >*/
	grtt05_(&ici, ctmp, &ltmp, (ftnlen)32);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<           SEFCOL=.TRUE. >*/
	sefcol = TRUE_;
/*<       ELSE IF (MODE.EQ.9) THEN >*/
    } else if (*mode == 9) {
/*         -- TK4100 */
/*<           CTMP(1:3) = CHAR(ESC)//'ML' >*/
	s_copy(ctmp, "\033ML", (ftnlen)3, (ftnlen)3);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__3, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<           CALL GRTT05(ICI, CTMP, LTMP) >*/
	grtt05_(&ici, ctmp, &ltmp, (ftnlen)32);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       ELSE IF( MODE.EQ.8) THEN >*/
    } else if (*mode == 8) {
/*         -- krm3: all attributes off */
/*<           CTMP(1:1) = CHAR(27) >*/
	*(unsigned char *)ctmp = '\33';
/*<           CTMP(2:2) = CHAR(91) >*/
	*(unsigned char *)&ctmp[1] = '[';
/*<           CTMP(3:3) = CHAR(48) >*/
	*(unsigned char *)&ctmp[2] = '0';
/*<           CTMP(4:4) = CHAR(59) >*/
	*(unsigned char *)&ctmp[3] = ';';

/*  Load color definitions (8-14 are bold versions of 1-7, so are not the */
/*  standard PGPLOT ones) */

/*<           IF ( ICI.EQ.0 ) I=0 >*/
	if (ici == 0) {
	    i__ = 0;
	}
/*<           IF ( ICI.EQ.1 .OR. ICI.EQ.8)  I=7 >*/
	if (ici == 1 || ici == 8) {
	    i__ = 7;
	}
/*<           IF ( ICI.EQ.2 .OR. ICI.EQ.9)  I=1 >*/
	if (ici == 2 || ici == 9) {
	    i__ = 1;
	}
/*<           IF ( ICI.EQ.3 .OR. ICI.EQ.10) I=2 >*/
	if (ici == 3 || ici == 10) {
	    i__ = 2;
	}
/*<           IF ( ICI.EQ.4 .OR. ICI.EQ.11) I=4 >*/
	if (ici == 4 || ici == 11) {
	    i__ = 4;
	}
/*<           IF ( ICI.EQ.5 .OR. ICI.EQ.12) I=6 >*/
	if (ici == 5 || ici == 12) {
	    i__ = 6;
	}
/*<           IF ( ICI.EQ.6 .OR. ICI.EQ.13) I=5 >*/
	if (ici == 6 || ici == 13) {
	    i__ = 5;
	}
/*<           IF ( ICI.EQ.7 .OR. ICI.EQ.14) I=3 >*/
	if (ici == 7 || ici == 14) {
	    i__ = 3;
	}
/*<           CTMP(5:5) = CHAR(51) >*/
	*(unsigned char *)&ctmp[4] = '3';
/*<           CTMP(6:6) = CHAR(48+I) >*/
	*(unsigned char *)&ctmp[5] = (char) (i__ + 48);
/*<           IF (ICI.GT.7) THEN >*/
	if (ici > 7) {
/*<               CTMP(7:7) = CHAR(59) >*/
	    *(unsigned char *)&ctmp[6] = ';';
/*<               CTMP(8:8) = CHAR(49) >*/
	    *(unsigned char *)&ctmp[7] = '1';
/*<               CTMP(9:9) = CHAR(109) >*/
	    *(unsigned char *)&ctmp[8] = 'm';
/*<               CALL GRTT02(ICHAN, MODE, CTMP, 9, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &c__9, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<           ELSE >*/
	} else {
/*<               CTMP(7:7) = CHAR(109) >*/
	    *(unsigned char *)&ctmp[6] = 'm';
/*<               CALL GRTT02(ICHAN, MODE, CTMP, 7, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &c__7, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<           END IF >*/
	}
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=16, Flush buffer. ------------------------------------------- */

/*<   160 CONTINUE >*/
L160:
/*<       IF (MODE.EQ.1 .OR. MODE.GT.5) THEN >*/
    if (*mode == 1 || *mode > 5) {
/*         -- tek4010, zstem, v603, krm3, or tk4100 */
/*<    >*/
	s_copy(ctmp, "\0357\177 @\037", (ftnlen)6, (ftnlen)6);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__6, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       ELSE IF (MODE.EQ.5) THEN >*/
    } else if (*mode == 5) {
/*         -- xterm */
/*<           CTMP(1:3) = CHAR(US)//CHAR(ESC)//CHAR(3) >*/
	s_copy(ctmp, "\037\033\003", (ftnlen)3, (ftnlen)3);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__3, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       ELSE >*/
    } else {
/*<    >*/
	s_copy(ctmp, "\0357\177 @\003\030\037", (ftnlen)8, (ftnlen)8);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 8, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__8, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       END IF >*/
    }
/*<       CALL GRWTER(ICHAN, CBUF, LBUF) >*/
    grwter_(&ichan, cbuf, &lbuf, (ftnlen)500);
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       RETURN >*/
    return 0;

/* --- IFUNC=17, Read cursor. -------------------------------------------- */

/*<   170 CONTINUE >*/
L170:
/*     -- flush buffer */
/*<       CALL GRWTER(ICHAN, CBUF, LBUF) >*/
    grwter_(&ichan, cbuf, &lbuf, (ftnlen)500);
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       IF ( MODE.EQ.5 .OR. MODE.EQ.6 ) THEN >*/
    if (*mode == 5 || *mode == 6) {
/*         -- xterm and zstem make sure terminal is in Tektronix mode. */
/*<           LTMP = 6 >*/
	ltmp = 6;
/*<           CALL GRWTER(ICHAN, CHAR(ESC)//'[?38h', LTMP) >*/
	grwter_(&ichan, "\033[?38h", &ltmp, (ftnlen)6);
/*<       END IF >*/
    }
/*     -- initial cursor position */
/*<       I0 = NINT(RBUF(1)) >*/
    i0 = i_nint(&rbuf[1]);
/*<       J0 = NINT(RBUF(2)) >*/
    j0 = i_nint(&rbuf[2]);
/*     -- read cursor */
/*<       CALL GRTT03(ICHAN, I0, J0, ICH, IER) >*/
    grtt03_(&ichan, &i0, &j0, &ich, &ier);
/*     -- on XTERM, map mouse button clicks onto A, D, X. */
/*<       IF (MODE.EQ.5) THEN >*/
    if (*mode == 5) {
/*<          IF (ICH.EQ.236) THEN >*/
	if (ich == 236) {
/*<             ICH = ICHAR('a') >*/
	    ich = 'a';
/*<          ELSE IF (ICH.EQ.237) THEN >*/
	} else if (ich == 237) {
/*<             ICH = ICHAR('d') >*/
	    ich = 'd';
/*<          ELSE IF (ICH.EQ.242) THEN >*/
	} else if (ich == 242) {
/*<             ICH = ICHAR('x') >*/
	    ich = 'x';
/*<          ELSE IF (ICH.EQ.204) THEN >*/
	} else if (ich == 204) {
/*<             ICH = ICHAR('A') >*/
	    ich = 'A';
/*<          ELSE IF (ICH.EQ.205) THEN >*/
	} else if (ich == 205) {
/*<             ICH = ICHAR('D') >*/
	    ich = 'D';
/*<          ELSE IF (ICH.EQ.210) THEN >*/
	} else if (ich == 210) {
/*<             ICH = ICHAR('X') >*/
	    ich = 'X';
/*<          END IF >*/
	}
/*<       END IF >*/
    }
/*     -- return result */
/*<       IF (IER.EQ.0) THEN >*/
    if (ier == 0) {
/*<           RBUF(1) = I0 >*/
	rbuf[1] = (real) i0;
/*<           RBUF(2) = J0 >*/
	rbuf[2] = (real) j0;
/*<           CHR(1:1) = CHAR(ICH) >*/
	*(unsigned char *)chr = (char) ich;
/*<       ELSE >*/
    } else {
/*<           CHR(1:1) = CHAR(0) >*/
	*(unsigned char *)chr = '\0';
/*<       END IF >*/
    }
/*<       NBUF = 2 >*/
    *nbuf = 2;
/*<       LCHR = 1 >*/
    *lchr = 1;
/*<       RETURN >*/
    return 0;

/* --- IFUNC=18, Erase alpha screen. ------------------------------------- */

/*<   180 CONTINUE >*/
L180:
/*<       IF (MODE.EQ.2 .OR. MODE.EQ.3) THEN >*/
    if (*mode == 2 || *mode == 3) {
/*         -- GraphOn, Retrographics: return to VT100 mode and */
/*            issue VT100 erase-screen command */
/*<    >*/
	s_copy(ctmp, "\0357\177 @\003\030\037", (ftnlen)8, (ftnlen)8);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 8, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__8, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<           CTMP(1:7) = CHAR(ESC)//'[2J'//CHAR(ESC)//'[H' >*/
	s_copy(ctmp, "\033[2J\033[H", (ftnlen)7, (ftnlen)7);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 7, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__7, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<           LASTI = -1 >*/
	lasti = -1;
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=21, Set color representation. ------------------------------- */

/*<   210 CONTINUE >*/
L210:
/*<       IF (MODE.EQ.4) THEN >*/
    if (*mode == 4) {
/*        -- gterm */
/*<          I = RBUF(1) >*/
	i__ = rbuf[1];
/*<          CTMP(1:6) = CHAR(GS)//CHAR(ESC)//'TG14' >*/
	s_copy(ctmp, "\035\033TG14", (ftnlen)6, (ftnlen)6);
/*<          LTMP = 6 >*/
	ltmp = 6;
/*<          CALL GRTT05(I,     CADD, LADD) >*/
	grtt05_(&i__, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;
/*        -- red */
/*<          INTEN = RBUF(2)*255.0 >*/
	inten = rbuf[2] * (float)255.;
/*<          CALL GRTT05(INTEN, CADD, LADD) >*/
	grtt05_(&inten, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;
/*        -- green */
/*<          INTEN = RBUF(3)*255.0 >*/
	inten = rbuf[3] * (float)255.;
/*<          CALL GRTT05(INTEN, CADD, LADD) >*/
	grtt05_(&inten, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;
/*        -- blue */
/*<          INTEN = RBUF(4)*255.0 >*/
	inten = rbuf[4] * (float)255.;
/*<          CALL GRTT05(INTEN, CADD, LADD) >*/
	grtt05_(&inten, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;

/*<          CTMP(LTMP+1:LTMP+2) = CHAR(US)//CHAR(CAN) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, "\037\030", ltmp + 2 - i__2, (ftnlen)2);
/*<          LTMP = LTMP + 2 >*/
	ltmp += 2;
/*<          CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<          CALL GRWTER(ICHAN, CBUF, LBUF) >*/
	grwter_(&ichan, cbuf, &lbuf, (ftnlen)500);
/*<          LASTI = -1 >*/
	lasti = -1;
/*<       ELSE IF (MODE.EQ.9) THEN >*/
    } else if (*mode == 9) {
/*        -- TK4100 */
/*<          I = RBUF(1) >*/
	i__ = rbuf[1];
/*<          CTMP(1:5) = CHAR(ESC)//'TG14' >*/
	s_copy(ctmp, "\033TG14", (ftnlen)5, (ftnlen)5);
/*<          LTMP = 5 >*/
	ltmp = 5;
/*<          CALL GRTT05(I,     CADD, LADD) >*/
	grtt05_(&i__, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;
/*        -- red */
/*<          INTEN = RBUF(2)*100.0 >*/
	inten = rbuf[2] * (float)100.;
/*<          CALL GRTT05(INTEN, CADD, LADD) >*/
	grtt05_(&inten, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;
/*        -- green */
/*<          INTEN = RBUF(3)*100.0 >*/
	inten = rbuf[3] * (float)100.;
/*<          CALL GRTT05(INTEN, CADD, LADD) >*/
	grtt05_(&inten, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;
/*        -- blue */
/*<          INTEN = RBUF(4)*100.0 >*/
	inten = rbuf[4] * (float)100.;
/*<          CALL GRTT05(INTEN, CADD, LADD) >*/
	grtt05_(&inten, cadd, &ladd, (ftnlen)32);
/*<          CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD) >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, cadd, ltmp + ladd - i__2, ladd);
/*<          LTMP = LTMP + LADD >*/
	ltmp += ladd;
/*<          CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<          CALL GRWTER(ICHAN, CBUF, LBUF) >*/
	grwter_(&ichan, cbuf, &lbuf, (ftnlen)500);
/*<          LASTI = -1 >*/
	lasti = -1;
/*<       ELSE IF (MODE.EQ.10) THEN >*/
    } else if (*mode == 10) {
/*        -- VersaTerm */
/*<          CTMP(1:1)=CHAR(GS) >*/
	*(unsigned char *)ctmp = '\35';
/*<          CALL GRTT02(ICHAN, MODE, CTMP, 1, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__1, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<          CALL GRXHLS(RBUF(2), RBUF(3), RBUF(4), HUE, LIG, SAT) >*/
	grxhls_(&rbuf[2], &rbuf[3], &rbuf[4], &hue, &lig, &sat);
/*<    >*/
	i__2 = i_nint(&rbuf[1]);
	i__3 = i_nint(&hue);
	r__1 = lig * 100;
	i__4 = i_nint(&r__1);
	r__2 = sat * 100;
	i__5 = i_nint(&r__2);
	grtt06_(&i__2, &i__3, &i__4, &i__5, ctmp, &ltmp, (ftnlen)32);
/*<          CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<          CALL GRWTER(ICHAN, CBUF, LBUF) >*/
	grwter_(&ichan, cbuf, &lbuf, (ftnlen)500);
/*<          LASTI = -1 >*/
	lasti = -1;
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=24, Rectangle fill. ----------------------------------------- */

/*<   240 CONTINUE >*/
L240:
/*<       IF ( I4014(MODE).EQ.0 ) THEN >*/
    if (i4014[*mode - 1] == 0) {
/*<          I0 = NINT(RBUF(1)) >*/
	i0 = i_nint(&rbuf[1]);
/*<          J0 = NINT(RBUF(2)) >*/
	j0 = i_nint(&rbuf[2]);
/*<          I1 = NINT(RBUF(3)) >*/
	i1 = i_nint(&rbuf[3]);
/*<          J1 = NINT(RBUF(4)) >*/
	j1 = i_nint(&rbuf[4]);
/*<       ELSE >*/
    } else {
/*<          I0 = NINT(4.*RBUF(1)) >*/
	r__1 = rbuf[1] * (float)4.;
	i0 = i_nint(&r__1);
/*<          J0 = NINT(4.*RBUF(2)) >*/
	r__1 = rbuf[2] * (float)4.;
	j0 = i_nint(&r__1);
/*<          I1 = NINT(4.*RBUF(3)) >*/
	r__1 = rbuf[3] * (float)4.;
	i1 = i_nint(&r__1);
/*<          J1 = NINT(4.*RBUF(4)) >*/
	r__1 = rbuf[4] * (float)4.;
	j1 = i_nint(&r__1);
/*<       END IF >*/
    }
/*<       IF (MODE.EQ.2) THEN >*/
    if (*mode == 2) {
/*         -- GraphOn */
/*         -- enter rectangle mode */
/*<    >*/
	grtt02_(&ichan, mode, "\035\033\002", &c__3, cbuf, &lbuf, (ftnlen)3, (
		ftnlen)500);
/*         -- draw rectangle */
/*<    >*/
	grtt01_(&ichan, mode, &i4014[*mode - 1], &lasti, &lastj, &i0, &j0, &
		i1, &j1, cbuf, &lbuf, (ftnlen)500);
/*         -- exit rectangle mode */
/*<           CALL GRTT02(ICHAN, MODE, CHAR(ESC)//CHAR(3), 2, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, "\033\003", &c__2, cbuf, &lbuf, (ftnlen)2, (
		ftnlen)500);
/*<       ELSE IF (MODE.EQ.7 .OR. MODE.EQ.8) THEN >*/
    } else if (*mode == 7 || *mode == 8) {
/*         -- v603, krm3: needs bottom left corner and rectangle */
/*            dimensions */
/*<           IBUF(1)=I0+1 >*/
	ibuf[0] = i0 + 1;
/*<           IBUF(2)=J0+1 >*/
	ibuf[1] = j0 + 1;
/*<           IBUF(3)=I1+1 >*/
	ibuf[2] = i1 + 1;
/*<           IBUF(4)=J1+1 >*/
	ibuf[3] = j1 + 1;
/*<           DO 241 I=1,4 >*/
	for (i__ = 1; i__ <= 4; ++i__) {
/*<              IF (IBUF(I) .LT. 1)    IBUF(I)=1 >*/
	    if (ibuf[i__ - 1] < 1) {
		ibuf[i__ - 1] = 1;
	    }
/*<              IF (IBUF(I) .GT. 1056) IBUF(I)=1056 >*/
	    if (ibuf[i__ - 1] > 1056) {
		ibuf[i__ - 1] = 1056;
	    }
/*<   241     CONTINUE >*/
/* L241: */
	}
/*<           IBUF(3)=IBUF(3)-IBUF(1) >*/
	ibuf[2] -= ibuf[0];
/*<           IBUF(4)=IBUF(4)-IBUF(2) >*/
	ibuf[3] -= ibuf[1];
/*<           ITOT=0 >*/
	itot = 0;
/*<           DO 244 I=1,4 >*/
	for (i__ = 1; i__ <= 4; ++i__) {
/*<              WRITE (CSCR(I)(1:4), '(I4)') IBUF(I) >*/
	    ici__1.icierr = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = 4;
	    ici__1.iciunit = cscr + (i__ - 1 << 2);
	    ici__1.icifmt = "(I4)";
	    s_wsfi(&ici__1);
	    do_fio(&c__1, (char *)&ibuf[i__ - 1], (ftnlen)sizeof(integer));
	    e_wsfi();
/*<              IBUF(I)=1 >*/
	    ibuf[i__ - 1] = 1;
/*<              DO 242 J=1,4 >*/
	    for (j = 1; j <= 4; ++j) {
/*<                 IF (CSCR(I)(J:J) .NE. ' ') THEN >*/
		if (*(unsigned char *)&cscr[(i__ - 1 << 2) + (j - 1)] != ' ') 
			{
/*<                    GOTO 243 >*/
		    goto L243;
/*<                 END IF >*/
		}
/*<                 IBUF(I)=IBUF(I)+1 >*/
		++ibuf[i__ - 1];
/*<   242        CONTINUE >*/
/* L242: */
	    }
/*<   243        CONTINUE >*/
L243:
/*<              ITOT=ITOT+5-IBUF(I) >*/
	    itot = itot + 5 - ibuf[i__ - 1];
/*<   244     CONTINUE >*/
/* L244: */
	}
/*<    >*/
	i__2 = ibuf[0] - 1;
	i__3 = ibuf[1] - 1;
	i__4 = ibuf[2] - 1;
	i__5 = ibuf[3] - 1;
/* Writing concatenation */
	i__6[0] = 2, a__2[0] = "\033/";
	i__6[1] = 4 - i__2, a__2[1] = cscr + i__2;
	i__6[2] = 1, a__2[2] = ";";
	i__6[3] = 4 - i__3, a__2[3] = cscr + (i__3 + 4);
	i__6[4] = 1, a__2[4] = ";";
	i__6[5] = 4 - i__4, a__2[5] = cscr + (i__4 + 8);
	i__6[6] = 1, a__2[6] = ";";
	i__6[7] = 4 - i__5, a__2[7] = cscr + (i__5 + 12);
	i__6[8] = 1, a__2[8] = ";";
	i__6[9] = 1, a__2[9] = "1";
	i__6[10] = 1, a__2[10] = "y";
	s_cat(ctmp, a__2, i__6, &c__11, itot + 8);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 8+ITOT, CBUF, LBUF) >*/
	i__2 = itot + 8;
	grtt02_(&ichan, mode, ctmp, &i__2, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       ELSE IF (MODE.EQ.10) THEN >*/
    } else if (*mode == 10) {
/*         -- VMAC: use polygon fill commands */
/*<           IF (SEFCOL) THEN >*/
	if (sefcol) {
/* set fill color */
/*<             SEFCOL=.FALSE. >*/
	    sefcol = FALSE_;
/*<             CTMP(1:3) = CHAR(ESC)//'MP' >*/
	    s_copy(ctmp, "\033MP", (ftnlen)3, (ftnlen)3);
/*<             CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &c__3, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<             CALL GRTT05(-ICI, CTMP, LTMP) >*/
	    i__2 = -ici;
	    grtt05_(&i__2, ctmp, &ltmp, (ftnlen)32);
/*<             CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	    grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (
		    ftnlen)500);
/*<           ENDIF >*/
	}
/* send "start polygon fill" */
/*<           CTMP(1:3) = CHAR(ESC)//'LP' >*/
	s_copy(ctmp, "\033LP", (ftnlen)3, (ftnlen)3);
/*<           LTMP=3 >*/
	ltmp = 3;
/* make lasti,lastj different from i0,j0 in each bit */
/*<           LASTI=4095-I0 >*/
	lasti = 4095 - i0;
/*<           LASTJ=4095-J0 >*/
	lastj = 4095 - j0;
/* send first coordinate */
/*<           CALL GRTT04(I4014(MODE), LASTI, LASTJ, I0, J0, CTMP, LTMP) >*/
	grtt04_(&i4014[*mode - 1], &lasti, &lastj, &i0, &j0, ctmp, &ltmp, (
		ftnlen)32);
/*<           LASTI=I0 >*/
	lasti = i0;
/*<           LASTJ=J0 >*/
	lastj = j0;
/* '0' means: boundary has the same the color as fill area */
/*<           CTMP(LTMP+1:LTMP+1)='0' >*/
	i__2 = ltmp;
	s_copy(ctmp + i__2, "0", ltmp + 1 - i__2, (ftnlen)1);
/*<           LTMP=LTMP+1 >*/
	++ltmp;
/*<           CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &ltmp, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/* further edges: */
/*<    >*/
	grtt01_(&ichan, mode, &i4014[*mode - 1], &lasti, &lastj, &i0, &j1, &
		i1, &j1, cbuf, &lbuf, (ftnlen)500);
/*<    >*/
	grtt01_(&ichan, mode, &i4014[*mode - 1], &lasti, &lastj, &i1, &j1, &
		i1, &j0, cbuf, &lbuf, (ftnlen)500);
/* send "end polygon fill" */
/*<           CTMP(1:3)=CHAR(ESC)//'LE' >*/
	s_copy(ctmp, "\033LE", (ftnlen)3, (ftnlen)3);
/*<           CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF) >*/
	grtt02_(&ichan, mode, ctmp, &c__3, cbuf, &lbuf, (ftnlen)32, (ftnlen)
		500);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* ttdriv_ */

/* *GRTT01 -- PGPLOT Tektronix driver, draw line segment */
/* + */
/*<    >*/
/* Subroutine */ int grtt01_(ichan, mode, i4014, lasti, lastj, i0, j0, i1, j1,
	 cbuf, lbuf, cbuf_len)
integer *ichan, *mode, *i4014, *lasti, *lastj, *i0, *j0, *i1, *j1;
char *cbuf;
integer *lbuf;
ftnlen cbuf_len;
{
    /* System generated locals */
    address a__1[4], a__2[5], a__3[2];
    integer i__1, i__2[4], i__3[5], i__4, i__5[2];
    char ch__1[1], ch__2[1], ch__3[1], ch__4[1], ch__5[1];

    /* Builtin functions */
    integer i_len();
    /* Subroutine */ int s_cat();

    /* Local variables */
    static integer ihix, ihiy;
    static char ctmp[12];
    static integer itmp, ilox, iloy, ltmp;
    extern /* Subroutine */ int grtt02_(), grtt04_();
    static integer iflush, id0, id1;
    extern /* Subroutine */ int grwter_();
    static integer iex;

/*<       INTEGER   ICHAN, MODE, I4014, LASTI, LASTJ, I0, J0, I1, J1, LBUF >*/
/*<       CHARACTER CBUF*(*) >*/

/* This routine draws a line from (I0, J0) to (I1, J1).  If LASTI>=0 */
/* assume that the cursor is at the position is at (LASTI, LASTJ). */
/* For this case, a minimum length move is done from (LASTI, LASTJ) to */
/* the nearer point.  Of course, if (LASTI, LASTJ) and the nearer point */
/* are the same, then no bytes of positioning data are generated and */
/* sent to the terminal.  If LASTI<0 then a move is done with the */
/* coordinate fully specified.  In both cases the line end point */
/* is specified using the fewest number of bytes allowed by the protocol. */
/* Upon return, LASTI,LASTJ will contain the current cursor position. */
/* If I4014=0 then 10 bit (4010) coordinates are generated, for I4014=1, */
/* full 12 bit Tektronix (4014 and higher) coordinates are generated. */
/* Note:  The 'delete' character (127) can occur in LOY or EXTRA byte; */
/* it can be replaced by escape-? if desired. */

/* Arguments: */
/*   ICHAN       (in)     : passed to GRTT02 if called. */
/*   MODE        (in)     : passed to GRTT02 if called. */
/*   I4014       (in)     : =0 generate 4010 coords, =1 generate 4014. */
/*   LASTI,LASTJ (in/out) : current position */
/*   I0, J0      (in/out) : device coordinates of the starting point. */
/*   I1, J1      (in/out) : device coordinates of the end point. */
/*   CBUF        (in/out) : buffer for instruction. */
/*   LBUF        (in/out) : Number of valid characters in CBUF. */

/* 1993-Feb-02 - Created from GRZS01 - [AFT] */
/* ----------------------------------------------------------------------- */
/*<       INTEGER    GS >*/
/*<       PARAMETER (GS = 29) >*/
/*<       INTEGER    MASKLX, MASKHX >*/
/*<       PARAMETER (MASKLX = 64, MASKHX = 32) >*/
/*<       INTEGER   MASKLY, MASKHY >*/
/*<       PARAMETER (MASKLY = 96, MASKHY = 32) >*/
/*<       INTEGER   MASKEX >*/
/*<       PARAMETER (MASKEX = 96) >*/

/*<       CHARACTER CTMP*12 >*/
/*<       INTEGER ID0, ID1, IFLUSH, ITMP >*/
/*<       INTEGER IEX, ILOX, IHIX, ILOY, IHIY, LTMP >*/

/* If it is possible for this routine to generate enough data to fill */
/* the buffer, and thus cause it to be flushed to the terminal, then we */
/* force the write to take place now.  This will ensure that terminal */
/* is in the correct state for the following commands. */
/*<       IF ( LBUF+11.GE.LEN(CBUF) ) THEN >*/
    if (*lbuf + 11 >= i_len(cbuf, cbuf_len)) {
/*<           CALL GRWTER(ICHAN, CBUF, LBUF) >*/
	grwter_(ichan, cbuf, lbuf, cbuf_len);
/*<           IFLUSH = 1 >*/
	iflush = 1;
/*<       ELSE >*/
    } else {
/*<           IFLUSH = 0 >*/
	iflush = 0;
/*<       END IF >*/
    }

/*<       LTMP = 0 >*/
    ltmp = 0;
/*<       IF(LASTI.LT.0) THEN >*/
    if (*lasti < 0) {
/* Last position is invalid, therefore do a dark vector move with all */
/* coordinates specified. */
/*<           LTMP=LTMP+1 >*/
	++ltmp;
/*<           CTMP(LTMP:LTMP)=CHAR(GS) >*/
	*(unsigned char *)&ctmp[ltmp - 1] = '\35';
/*<           IF ( I4014.EQ.0 ) THEN >*/
	if (*i4014 == 0) {
/*<               IHIY = J0/32 >*/
	    ihiy = *j0 / 32;
/*<               ILOY = MOD(J0, 32) >*/
	    iloy = *j0 % 32;
/*<               IHIX = I0/32 >*/
	    ihix = *i0 / 32;
/*<               ILOX = MOD(I0, 32) >*/
	    ilox = *i0 % 32;
/*<    >*/
	    i__1 = ltmp;
/* Writing concatenation */
	    *(unsigned char *)&ch__1[0] = ihiy + 32;
	    i__2[0] = 1, a__1[0] = ch__1;
	    *(unsigned char *)&ch__2[0] = iloy + 96;
	    i__2[1] = 1, a__1[1] = ch__2;
	    *(unsigned char *)&ch__3[0] = ihix + 32;
	    i__2[2] = 1, a__1[2] = ch__3;
	    *(unsigned char *)&ch__4[0] = ilox + 64;
	    i__2[3] = 1, a__1[3] = ch__4;
	    s_cat(ctmp + i__1, a__1, i__2, &c__4, ltmp + 4 - i__1);
/*<               LTMP = LTMP + 4 >*/
	    ltmp += 4;
/*<           ELSE >*/
	} else {
/*<               IHIY = J0/128 >*/
	    ihiy = *j0 / 128;
/*<               ILOY = MOD(J0/4, 32) >*/
	    iloy = *j0 / 4 % 32;
/*<               IHIX = I0/128 >*/
	    ihix = *i0 / 128;
/*<               ILOX = MOD(I0/4, 32) >*/
	    ilox = *i0 / 4 % 32;
/*<               IEX  = 4*MOD(J0, 4) + MOD(I0, 4) >*/
	    iex = (*j0 % 4 << 2) + *i0 % 4;
/*<    >*/
	    i__1 = ltmp;
/* Writing concatenation */
	    *(unsigned char *)&ch__1[0] = ihiy + 32;
	    i__3[0] = 1, a__2[0] = ch__1;
	    *(unsigned char *)&ch__2[0] = iex + 96;
	    i__3[1] = 1, a__2[1] = ch__2;
	    *(unsigned char *)&ch__3[0] = iloy + 96;
	    i__3[2] = 1, a__2[2] = ch__3;
	    *(unsigned char *)&ch__4[0] = ihix + 32;
	    i__3[3] = 1, a__2[3] = ch__4;
	    *(unsigned char *)&ch__5[0] = ilox + 64;
	    i__3[4] = 1, a__2[4] = ch__5;
	    s_cat(ctmp + i__1, a__2, i__3, &c__5, ltmp + 5 - i__1);
/*<               LTMP = LTMP + 5 >*/
	    ltmp += 5;
/*<           END IF >*/
	}
/*<       ELSE >*/
    } else {
/* Last position is valid, move pen to nearest end point of line. */
/*<           ID0=ABS(LASTI-I0)+ABS(LASTJ-J0) >*/
	id0 = (i__1 = *lasti - *i0, abs(i__1)) + (i__4 = *lastj - *j0, abs(
		i__4));
/*<           ID1=ABS(LASTI-I1)+ABS(LASTJ-J1) >*/
	id1 = (i__1 = *lasti - *i1, abs(i__1)) + (i__4 = *lastj - *j1, abs(
		i__4));
/*<           IF(ID1.LT.ID0) THEN >*/
	if (id1 < id0) {
/* Swap coordinates to minimize 'pen motion'.  For optimized coordinates */
/* this can reduce the amount of I/O to the the terminal. */
/*<               ITMP=I0 >*/
	    itmp = *i0;
/*<               I0=I1 >*/
	    *i0 = *i1;
/*<               I1=ITMP >*/
	    *i1 = itmp;
/*<               ITMP=J0 >*/
	    itmp = *j0;
/*<               J0=J1 >*/
	    *j0 = *j1;
/*<               J1=ITMP >*/
	    *j1 = itmp;
/*<               ITMP=ID0 >*/
	    itmp = id0;
/*<               ID0=ID1 >*/
	    id0 = id1;
/*<               ID1=ITMP >*/
	    id1 = itmp;
/*<           END IF >*/
	}
/*<           IF(ID0.NE.0 .OR. ID1.NE.0) THEN >*/
	if (id0 != 0 || id1 != 0) {
/* Position has changed, so do a move operation. */
/*<               LTMP=LTMP+1 >*/
	    ++ltmp;
/*<               CTMP(LTMP:LTMP)=CHAR(GS) >*/
	    *(unsigned char *)&ctmp[ltmp - 1] = '\35';
/*<               CALL GRTT04(I4014,LASTI,LASTJ,I0,J0,CTMP,LTMP) >*/
	    grtt04_(i4014, lasti, lastj, i0, j0, ctmp, &ltmp, (ftnlen)12);
/*<           ELSE >*/
	} else {
/*<               IF(IFLUSH.NE.0) THEN >*/
	    if (iflush != 0) {
/* The position is valid, but the buffer was flushed, so terminal may */
/* no longer be in graph mode.  Therefore, send GS and followed by a */
/* zero length dark move (i.e., just resend LOX coordinate). */
/*<                   IF ( I4014.EQ.0 ) THEN >*/
		if (*i4014 == 0) {
/*<                       ILOX = MOD(I0, 32) >*/
		    ilox = *i0 % 32;
/*<                   ELSE >*/
		} else {
/*<                       ILOX = MOD(I0/4, 32) >*/
		    ilox = *i0 / 4 % 32;
/*<                   END IF >*/
		}
/*<                   CTMP(LTMP+1:LTMP+2)=CHAR(GS)//CHAR(MASKLX+ILOX) >*/
		i__1 = ltmp;
/* Writing concatenation */
		i__5[0] = 1, a__3[0] = "\035";
		*(unsigned char *)&ch__1[0] = ilox + 64;
		i__5[1] = 1, a__3[1] = ch__1;
		s_cat(ctmp + i__1, a__3, i__5, &c__2, ltmp + 2 - i__1);
/*<                   LTMP=LTMP+2 >*/
		ltmp += 2;
/*<               END IF >*/
	    }
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/* Terminal is now in graph mode, and the `pen' has been positioned. */
/* Do an optimized draw. */
/*<       CALL GRTT04(I4014,I0,J0,I1,J1,CTMP,LTMP) >*/
    grtt04_(i4014, i0, j0, i1, j1, ctmp, &ltmp, (ftnlen)12);
/*<       CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF) >*/
    grtt02_(ichan, mode, ctmp, &ltmp, cbuf, lbuf, (ftnlen)12, cbuf_len);

/* Remember current position. */
/*<       LASTI=I1 >*/
    *lasti = *i1;
/*<       LASTJ=J1 >*/
    *lastj = *j1;
/*<       RETURN >*/
    return 0;

/*<       END >*/
} /* grtt01_ */

/* *GRTT02 -- PGPLOT Tektronix driver, transfer data to buffer */
/* + */
/*<       SUBROUTINE GRTT02 (ICHAN, MODE, CADD, LADD, CBUF, LBUF) >*/
/* Subroutine */ int grtt02_(ichan, mode, cadd, ladd, cbuf, lbuf, cadd_len, 
	cbuf_len)
integer *ichan, *mode;
char *cadd;
integer *ladd;
char *cbuf;
integer *lbuf;
ftnlen cadd_len;
ftnlen cbuf_len;
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    integer i_len();
    /* Subroutine */ int s_copy();

    /* Local variables */
    extern /* Subroutine */ int grwter_();

/*<       INTEGER   ICHAN, MODE, LADD, LBUF >*/
/*<       CHARACTER CADD*(*), CBUF*(*) >*/

/* Arguments: */
/*   ICHAN  (input)  : channel number for output (when buffer is full). */
/*   MODE   (input)  : emulation type. */
/*   CADD   (input)  : text to add to buffer. */
/*   LADD   (input)  : number of characters to transfer. */
/*   CBUF   (input)  : output buffer. */
/*   LBUF   (in/out) : number of valid characters in CBUF. */

/* Subroutines called: */
/*   GRWTER */
/* ----------------------------------------------------------------------- */
/*<       IF (LBUF+LADD.GE.LEN(CBUF) ) THEN >*/
    if (*lbuf + *ladd >= i_len(cbuf, cbuf_len)) {
/*<           CALL GRWTER(ICHAN, CBUF, LBUF) >*/
	grwter_(ichan, cbuf, lbuf, cbuf_len);
/*<       END IF >*/
    }

/*<       IF ( LADD.GT.0 ) THEN >*/
    if (*ladd > 0) {
/*<           IF ( LBUF.EQ.0 ) THEN >*/
	if (*lbuf == 0) {
/*<               IF ( MODE.EQ.5 .OR. MODE.EQ.6 ) THEN >*/
	    if (*mode == 5 || *mode == 6) {
/*<                   CBUF(1:6) = CHAR(27)//'[?38h' >*/
		s_copy(cbuf, "\033[?38h", (ftnlen)6, (ftnlen)6);
/*<                   LBUF = 6 >*/
		*lbuf = 6;
/*<               END IF >*/
	    }
/*<           END IF >*/
	}
/*<           CBUF(LBUF+1:LBUF+LADD) = CADD(1:LADD) >*/
	i__1 = *lbuf;
	s_copy(cbuf + i__1, cadd, *lbuf + *ladd - i__1, (*ladd));
/*<           LBUF = LBUF + LADD >*/
	*lbuf += *ladd;
/*<       END IF >*/
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grtt02_ */

/* *GRTT03 -- PGPLOT Tektronix driver, cursor routine */
/* + */
/*<       SUBROUTINE GRTT03 (ICHAN, IX, IY, IC, IER) >*/
/* Subroutine */ int grtt03_(ichan, ix, iy, ic, ier)
integer *ichan, *ix, *iy, *ic, *ier;
{
    static char cbuf[8];
    static integer lbuf;
    static char cprom[10];
    static integer i1, i2;
    extern /* Subroutine */ int grpter_();

/*<       INTEGER   ICHAN, IX, IY, IC, IER >*/

/* Arguments: */
/*   ICHAN  (input)  : channel for output to device. */
/*   IX, IY (in/out) : initial/final coordinates of cursor (device */
/*                     coordinates). */
/*   IC     (output) : character code. */
/*   IER    (output) : error status (0 is OK). */

/* ----------------------------------------------------------------------- */
/*<       CHARACTER CBUF*8, CPROM*10 >*/
/*<       INTEGER   I1, I2, LBUF >*/

/* Position cursor (by drawing a dark vector). */

/*<       CPROM(1:1) = CHAR(29) >*/
    *(unsigned char *)cprom = '\35';
/*<       CPROM(2:2) = CHAR(32+(IY/32)) >*/
    *(unsigned char *)&cprom[1] = (char) (*iy / 32 + 32);
/*<       CPROM(3:3) = CHAR(96+MOD(IY,32)) >*/
    *(unsigned char *)&cprom[2] = (char) (*iy % 32 + 96);
/*<       CPROM(4:4) = CHAR(32+(IX/32)) >*/
    *(unsigned char *)&cprom[3] = (char) (*ix / 32 + 32);
/*<       CPROM(5:5) = CHAR(64+MOD(IX,32)) >*/
    *(unsigned char *)&cprom[4] = (char) (*ix % 32 + 64);
/*<       CPROM(6:6) = CHAR(27) >*/
    *(unsigned char *)&cprom[5] = '\33';
/*<       CPROM(7:7) = CHAR(47) >*/
    *(unsigned char *)&cprom[6] = '/';
/*<       CPROM(8:8) = CHAR(102) >*/
    *(unsigned char *)&cprom[7] = 'f';
/*<       CPROM(9:9) = CHAR(27) >*/
    *(unsigned char *)&cprom[8] = '\33';
/*<       CPROM(10:10) = CHAR(26) >*/
    *(unsigned char *)&cprom[9] = '\32';

/* Do a read with prompt. */

/*<       LBUF = 5 >*/
    lbuf = 5;
/*<       CALL GRPTER(ICHAN, CPROM, 10, CBUF, LBUF) >*/
    grpter_(ichan, cprom, &c__10, cbuf, &lbuf, (ftnlen)10, (ftnlen)8);

/* Must read at least 5 characters. */

/*<       IF( LBUF.LT.5) THEN >*/
    if (lbuf < 5) {
/*<          IER = 1 >*/
	*ier = 1;
/*<       ELSE >*/
    } else {

/* Decode coordinates. */

/*<          IC = ICHAR( CBUF(1:1) ) >*/
	*ic = *(unsigned char *)cbuf;
/*<          I1 = MOD( ICHAR(CBUF(2:2)), 32 ) >*/
	i1 = *(unsigned char *)&cbuf[1] % 32;
/*<          I2 = MOD( ICHAR(CBUF(3:3)), 32 ) >*/
	i2 = *(unsigned char *)&cbuf[2] % 32;
/*<          IX = I1*32 + I2 >*/
	*ix = (i1 << 5) + i2;
/*<          I1 = MOD( ICHAR(CBUF(4:4)), 32 ) >*/
	i1 = *(unsigned char *)&cbuf[3] % 32;
/*<          I2 = MOD( ICHAR(CBUF(5:5)), 32 ) >*/
	i2 = *(unsigned char *)&cbuf[4] % 32;
/*<          IY = I1*32 + I2 >*/
	*iy = (i1 << 5) + i2;
/*<          IER = 0 >*/
	*ier = 0;
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grtt03_ */

/* *GRTT04 -- PGPLOT Tektronix driver, encode coordinate pair, optimize */
/* + */
/*<       SUBROUTINE GRTT04(I4014, LASTI, LASTJ, I0, J0, CTMP, LTMP) >*/
/* Subroutine */ int grtt04_(i4014, lasti, lastj, i0, j0, ctmp, ltmp, 
	ctmp_len)
integer *i4014, *lasti, *lastj, *i0, *j0;
char *ctmp;
integer *ltmp;
ftnlen ctmp_len;
{
    static integer ihix, ihiy, lhix, lhiy, ilox, iloy, llox, lloy, iex, lex;

/*<       INTEGER   I4014, LASTI, LASTJ, I0, J0, LTMP >*/
/*<       CHARACTER CTMP*(*) >*/

/* Assume cursor is at position LASTI, LASTJ and that the light or */
/* dark vector condition has been correctly set.  Add up to 5 characters */
/* to CTMP to draw a vector to I0, J0.  The minimum number of characters */
/* are encoded to obtain the motion. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER    MASKLX, MASKHX >*/
/*<       PARAMETER (MASKLX = 64, MASKHX = 32) >*/
/*<       INTEGER   MASKLY, MASKHY >*/
/*<       PARAMETER (MASKLY = 96, MASKHY = 32) >*/
/*<       INTEGER   MASKEX >*/
/*<       PARAMETER (MASKEX=96) >*/

/*<       INTEGER IEX, ILOX, IHIX, ILOY, IHIY >*/
/*<       INTEGER LEX, LLOX, LHIX, LLOY, LHIY >*/

/*<       IF ( I4014.EQ.0 ) THEN >*/
    if (*i4014 == 0) {
/*<           LHIY = LASTJ/32 >*/
	lhiy = *lastj / 32;
/*<           LLOY = MOD(LASTJ, 32) >*/
	lloy = *lastj % 32;
/*<           LHIX = LASTI/32 >*/
	lhix = *lasti / 32;
/*<           LLOX = MOD(LASTI, 32) >*/
	llox = *lasti % 32;
/*<           LEX = 0 >*/
	lex = 0;
/*<           IHIY = J0/32 >*/
	ihiy = *j0 / 32;
/*<           ILOY = MOD(J0, 32) >*/
	iloy = *j0 % 32;
/*<           IHIX = I0/32 >*/
	ihix = *i0 / 32;
/*<           ILOX = MOD(I0, 32) >*/
	ilox = *i0 % 32;
/*<           IEX = 0 >*/
	iex = 0;
/*<       ELSE >*/
    } else {
/*<           LHIY = LASTJ/128 >*/
	lhiy = *lastj / 128;
/*<           LLOY = MOD(LASTJ/4, 32) >*/
	lloy = *lastj / 4 % 32;
/*<           LHIX = LASTI/128 >*/
	lhix = *lasti / 128;
/*<           LLOX = MOD(LASTI/4, 32) >*/
	llox = *lasti / 4 % 32;
/*<           LEX = 4*MOD(LASTJ, 4) + MOD(LASTI, 4) >*/
	lex = (*lastj % 4 << 2) + *lasti % 4;
/*<           IHIY = J0/128 >*/
	ihiy = *j0 / 128;
/*<           ILOY = MOD(J0/4, 32) >*/
	iloy = *j0 / 4 % 32;
/*<           IHIX = I0/128 >*/
	ihix = *i0 / 128;
/*<           ILOX = MOD(I0/4, 32) >*/
	ilox = *i0 / 4 % 32;
/*<           IEX = 4*MOD(J0, 4) + MOD(I0, 4) >*/
	iex = (*j0 % 4 << 2) + *i0 % 4;
/*<       END IF >*/
    }

/*<       IF(IHIY.NE.LHIY) THEN >*/
    if (ihiy != lhiy) {
/*<           LTMP=LTMP+1 >*/
	++(*ltmp);
/*<           CTMP(LTMP:LTMP) = CHAR(32+IHIY) >*/
	*(unsigned char *)&ctmp[*ltmp - 1] = (char) (ihiy + 32);
/*<       END IF >*/
    }
/* Note, for 4010 mode, IEX=LEX (by definition) */
/*<       IF(IEX.NE.LEX) THEN >*/
    if (iex != lex) {
/*<           LTMP=LTMP+1 >*/
	++(*ltmp);
/*<           CTMP(LTMP:LTMP) = CHAR(96+IEX) >*/
	*(unsigned char *)&ctmp[*ltmp - 1] = (char) (iex + 96);
/*<       END IF >*/
    }
/*<       IF(IEX.NE.LEX .OR. ILOY.NE.LLOY .OR. IHIX.NE.LHIX) THEN >*/
    if (iex != lex || iloy != lloy || ihix != lhix) {
/*<           LTMP=LTMP+1 >*/
	++(*ltmp);
/*<           CTMP(LTMP:LTMP) = CHAR(96+ILOY) >*/
	*(unsigned char *)&ctmp[*ltmp - 1] = (char) (iloy + 96);
/*<       END IF >*/
    }
/*<       IF(IHIX.NE.LHIX) THEN >*/
    if (ihix != lhix) {
/*<           LTMP=LTMP+1 >*/
	++(*ltmp);
/*<           CTMP(LTMP:LTMP) = CHAR(32+IHIX) >*/
	*(unsigned char *)&ctmp[*ltmp - 1] = (char) (ihix + 32);
/*<       END IF >*/
    }
/*<       LTMP=LTMP+1 >*/
    ++(*ltmp);
/*<       CTMP(LTMP:LTMP) = CHAR(64+ILOX) >*/
    *(unsigned char *)&ctmp[*ltmp - 1] = (char) (ilox + 64);
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* grtt04_ */

/* *GRTT05 -- PGPLOT Tektronix 4100 driver, encode integer */
/* + */
/*<       SUBROUTINE GRTT05(I, C, NC) >*/
/* Subroutine */ int grtt05_(i__, c__, nc, c_len)
integer *i__;
char *c__;
integer *nc;
ftnlen c_len;
{
    static integer j;

/*<       INTEGER I >*/
/*<       CHARACTER*(*) C >*/
/*<       INTEGER NC >*/

/* Encode integer in host syntax. Input integer I; output encoded string */
/* C, containing NC characters (1, 2, or 3).  This version encodes */
/* integers up to 1023, which fit in two characters. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER J >*/

/*<       J = IABS(I) >*/
    j = abs(*i__);
/*<       IF (J.LT.16) THEN >*/
    if (j < 16) {
/*<           IF (I.LT.0) THEN >*/
	if (*i__ < 0) {
/*<               C(1:1) = CHAR(J+32) >*/
	    *(unsigned char *)c__ = (char) (j + 32);
/*<           ELSE >*/
	} else {
/*<               C(1:1) = CHAR(J+48) >*/
	    *(unsigned char *)c__ = (char) (j + 48);
/*<           END IF >*/
	}
/*<           NC = 1 >*/
	*nc = 1;
/*<       ELSE >*/
    } else {
/*<           C(1:1) = CHAR(J/16+64) >*/
	*(unsigned char *)c__ = (char) (j / 16 + 64);
/*<           IF (I.LT.0) THEN >*/
	if (*i__ < 0) {
/*<               C(2:2) = CHAR(MOD(J,16)+32) >*/
	    *(unsigned char *)&c__[1] = (char) (j % 16 + 32);
/*<           ELSE >*/
	} else {
/*<               C(2:2) = CHAR(MOD(J,16)+48) >*/
	    *(unsigned char *)&c__[1] = (char) (j % 16 + 48);
/*<           END IF >*/
	}
/*<           NC = 2 >*/
	*nc = 2;
/*<       END IF >*/
    }

/*<       END >*/
} /* grtt05_ */

/* *GRTT06 -- PGPLOT Tektronix 4100 driver, encode color definition */
/* + */
/*<       SUBROUTINE GRTT06(IDX, I1, I2, I3, C, NC) >*/
/* Subroutine */ int grtt06_(idx, i1, i2, i3, c__, nc, c_len)
integer *idx, *i1, *i2, *i3;
char *c__;
integer *nc;
ftnlen c_len;
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy();

    /* Local variables */
    static integer l;
    extern /* Subroutine */ int grtt05_();

/*<       INTEGER ESC, GS, US >*/
/*<       PARAMETER (ESC=27, GS=29, US=31) >*/
/*<       INTEGER IDX, I1, I2, I3 >*/
/*<       CHARACTER*(*) C >*/
/*<       INTEGER NC >*/

/* Encode color definition, Color index IDX, I1,I2,I3 are the 3 integer */
/* color components (definiton is device-dependent). */
/* output encoded string containing NC characters (max 20). */
/* ----------------------------------------------------------------------- */
/*<       INTEGER L >*/

/*<       C(1:5) = CHAR(ESC)//'TG14' >*/
    s_copy(c__, "\033TG14", (ftnlen)5, (ftnlen)5);
/*<       NC=5 >*/
    *nc = 5;
/*<       CALL GRTT05(IDX, C(NC+1:NC+3), L) >*/
    i__1 = *nc;
    grtt05_(idx, c__ + i__1, &l, *nc + 3 - i__1);
/*<       NC=NC+L >*/
    *nc += l;
/*<       CALL GRTT05(I1, C(NC+1:NC+3), L) >*/
    i__1 = *nc;
    grtt05_(i1, c__ + i__1, &l, *nc + 3 - i__1);
/*<       NC=NC+L >*/
    *nc += l;
/*<       CALL GRTT05(I2, C(NC+1:NC+3), L) >*/
    i__1 = *nc;
    grtt05_(i2, c__ + i__1, &l, *nc + 3 - i__1);
/*<       NC=NC+L >*/
    *nc += l;
/*<       CALL GRTT05(I3, C(NC+1:NC+3), L) >*/
    i__1 = *nc;
    grtt05_(i3, c__ + i__1, &l, *nc + 3 - i__1);
/*<       NC=NC+L >*/
    *nc += l;
/*<       END >*/
} /* grtt06_ */

