/* /work2/ssa/pgplot/src/grclip.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRCLIP -- clip a point against clipping rectangle */
/* + */
/*<       SUBROUTINE GRCLIP (X,Y,XMIN,XMAX,YMIN,YMAX,C) >*/
/* Subroutine */ int grclip_(x, y, xmin, xmax, ymin, ymax, c__)
real *x, *y, *xmin, *xmax, *ymin, *ymax;
integer *c__;
{
/*<       REAL X,Y >*/
/*<       REAL XMIN,XMAX,YMIN,YMAX >*/
/*<       INTEGER C >*/

/* GRPCKG (internal routine): support routine for the clipping algorithm; */
/* called from GRLIN0 only. C is a 4 bit code indicating the relationship */
/* between point (X,Y) and the window boundaries; 0 implies the point is */
/* within the window. */

/* Arguments: */
/* -- */
/* (11-Feb-1983) */
/* Revised 20-Jun-1985 (TJP); use floating arithmetic */
/* Revised 12-Jun-1992 (TJP); clip exactly on the boundary */
/* ----------------------------------------------------------------------- */

/*<       C = 0 >*/
    *c__ = 0;
/*<       IF (X.LT.XMIN) THEN >*/
    if (*x < *xmin) {
/*<           C = 1 >*/
	*c__ = 1;
/*<       ELSE IF (X.GT.XMAX) THEN >*/
    } else if (*x > *xmax) {
/*<           C = 2 >*/
	*c__ = 2;
/*<       END IF >*/
    }
/*<       IF (Y.LT.YMIN) THEN >*/
    if (*y < *ymin) {
/*<           C = C+4 >*/
	*c__ += 4;
/*<       ELSE IF (Y.GT.YMAX) THEN >*/
    } else if (*y > *ymax) {
/*<           C = C+8 >*/
	*c__ += 8;
/*<       END IF >*/
    }
/*<       END >*/
} /* grclip_ */

