/* grexec.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__2 = 2;
static integer c__3 = 3;
static integer c__4 = 4;
static integer c__5 = 5;

/* *GREXEC -- PGPLOT device handler dispatch routine */
/* + */
/*<       SUBROUTINE GREXEC(IDEV,IFUNC,RBUF,NBUF,CHR,LCHR) >*/
/* Subroutine */ int grexec_(idev, ifunc, rbuf, nbuf, chr, lchr, chr_len)
integer *idev, *ifunc;
real *rbuf;
integer *nbuf;
char *chr;
integer *lchr;
ftnlen chr_len;
{
    /* System generated locals */
    address a__1[2];
    integer i__1[2];
    char ch__1[41];

    /* Builtin functions */
    integer s_wsfi(), do_fio(), e_wsfi();
    /* Subroutine */ int s_cat();

    /* Local variables */
    extern /* Subroutine */ int xadriv_(), grwarn_(), tkdriv_(), nudriv_(), 
	    psdriv_(), ttdriv_(), xwdriv_();
    static char msg[10];

    /* Fortran I/O blocks */
    static icilist io___2 = { 0, msg, 0, "(I10)", 10, 1 };


/*<       INTEGER IDEV, IFUNC, NBUF, LCHR >*/
/*<       REAL    RBUF(*) >*/
/*<       CHARACTER*(*) CHR >*/
/* --- */
/*<       INTEGER NDEV >*/
/*<       PARAMETER (NDEV=10) >*/
/*<       CHARACTER*10 MSG >*/
/* --- */
/*<       GOTO(1,2,3,4,5,6,7,8,9,10) IDEV >*/
    /* Parameter adjustments */
    --rbuf;

    /* Function Body */
    switch ((int)*idev) {
	case 1:  goto L1;
	case 2:  goto L2;
	case 3:  goto L3;
	case 4:  goto L4;
	case 5:  goto L5;
	case 6:  goto L6;
	case 7:  goto L7;
	case 8:  goto L8;
	case 9:  goto L9;
	case 10:  goto L10;
    }
/*<       IF (IDEV.EQ.0) THEN >*/
    if (*idev == 0) {
/*<           RBUF(1) = NDEV >*/
	rbuf[1] = (float)10.;
/*<           NBUF = 1 >*/
	*nbuf = 1;
/*<       ELSE >*/
    } else {
/*<           WRITE (MSG,'(I10)') IDEV >*/
	s_wsfi(&io___2);
	do_fio(&c__1, (char *)&(*idev), (ftnlen)sizeof(integer));
	e_wsfi();
/*<           CALL GRWARN('Unknown device code in GREXEC: '//MSG) >*/
/* Writing concatenation */
	i__1[0] = 31, a__1[0] = "Unknown device code in GREXEC: ";
	i__1[1] = 10, a__1[1] = msg;
	s_cat(ch__1, a__1, i__1, &c__2, (ftnlen)41);
	grwarn_(ch__1, (ftnlen)41);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;
/* --- */
/*< 1     CALL NUDRIV(IFUNC,RBUF,NBUF,CHR,LCHR) >*/
L1:
    nudriv_(ifunc, &rbuf[1], nbuf, chr, lchr, chr_len);
/*<       RETURN >*/
    return 0;
/*< 2     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1) >*/
L2:
    psdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, &c__1, chr_len);
/*<       RETURN >*/
    return 0;
/*< 3     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2) >*/
L3:
    psdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, &c__2, chr_len);
/*<       RETURN >*/
    return 0;
/*< 4     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,3) >*/
L4:
    psdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, &c__3, chr_len);
/*<       RETURN >*/
    return 0;
/*< 5     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,4) >*/
L5:
    psdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, &c__4, chr_len);
/*<       RETURN >*/
    return 0;
/*< 6     CALL TTDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,5) >*/
L6:
    ttdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, &c__5, chr_len);
/*<       RETURN >*/
    return 0;
/*< 7     CALL XWDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1) >*/
L7:
    xwdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, &c__1, chr_len);
/*<       RETURN >*/
    return 0;
/*< 8     CALL XWDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2) >*/
L8:
    xwdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, &c__2, chr_len);
/*<       RETURN >*/
    return 0;
/*< 9     CALL XADRIV(IFUNC,RBUF,NBUF,CHR,LCHR) >*/
L9:
    xadriv_(ifunc, &rbuf[1], nbuf, chr, lchr, chr_len);
/*<       RETURN >*/
    return 0;
/*< 10    CALL TKDRIV(IFUNC,RBUF,NBUF,CHR,LCHR) >*/
L10:
    tkdriv_(ifunc, &rbuf[1], nbuf, chr, lchr, chr_len);
/*<       RETURN >*/
    return 0;

/*<       END >*/
} /* grexec_ */

