/* /work2/ssa/pgplot/src/grfa.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__20 = 20;
static integer c__1 = 1;
static integer c__3 = 3;

/* *GRFA -- fill area (polygon) */
/* + */
/*<       SUBROUTINE GRFA (N,PX,PY) >*/
/* Subroutine */ int grfa_(n, px, py)
integer *n;
real *px, *py;
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2;

    /* Builtin functions */
    integer i_nint();

    /* Local variables */
    static integer line, lchr, nbuf;
    static real rbuf[6], temp, ymin, ymax;
    static integer i__, j;
    static real x[32], y;
    static integer nsect;
    static logical forwd;
    extern /* Subroutine */ int grqls_(), grsls_(), grqlw_(), grslw_();
    static real s1, s2, t1, t2;
    extern /* Subroutine */ int grlin0_();
    static real dy;
    static integer ls;
    static real yd;
    static integer lw;
    extern /* Subroutine */ int grbpic_(), grexec_(), grwarn_();
    static char chr[32];

/*<       INTEGER N >*/
/*<       REAL PX(*), PY(*) >*/

/* GRPCKG: FILL AREA: fill a polygon with solid color.  The polygon */
/* is defined by the (x,y) world coordinates of its N vertices.  If */
/* this is not a function supported by the device, shading is */
/* accomplished by drawing horizontal lines spaced by 1 pixel.  By */
/* selecting color index 0, the interior of the polygon can be erased */
/* on devices which permit it.  The polygon need not be convex, but if */
/* it is re-entrant (i.e., edges intersect other than at the vertices), */
/* it may not be obvious which regions are "inside" the polygon.  The */
/* following rule is applied: for a given point, create a straight line */
/* starting at the point and going to infinity. If the number of */
/* intersections between the straight line and the polygon is odd, the */
/* point is within the polygon; otherwise it is outside. If the */
/* straight line passes a polygon vertex tangentially, the */
/* intersection  count is not affected. The only attribute which applies */
/* to FILL AREA is color index: line-width and line-style are ignored. */
/* There is a limitation on the complexity of the polygon: GFA will */
/* fail if any horizontal line intersects more than 32 edges of the */
/* polygon. */

/* Arguments: */

/* N (input, integer): the number of vertices of the polygon (at least */
/*       3). */
/* PX, PY (input, real arrays, dimension at least N): world coordinates */
/*       of the N vertices of the polygon. */
/* -- */
/* 16-Jul-1984 - [TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 21-Feb-1987 - If needed, calls begin picture [AFT]. */
/*  7-Sep-1994 - avoid driver call for capabilities [TJP]. */
/*  1-May-1995 - fixed bug for re-entrant polygons, and optimized code */
/*               [A.F.Carman]. */
/* 18-Oct-1995 - fixed bug: emulated fill failed for reversed y-axis */
/*               [S.C.Allendorf/TJP]. */
/*  4-Dec-1995 - remove use of real variable as do-loop variable [TJP]. */
/* 20-Mar-1996 - use another do loop 40 to avoid gaps between adjacent */
/*               polygons [RS] */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER MAXSEC >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (MAXSEC=32) >*/
/*<       INTEGER I, J, NSECT, LW, LS, NBUF, LCHR, LINE >*/
/*<       REAL    RBUF(6) >*/
/*<       CHARACTER*32 CHR >*/
/*<       REAL    X(MAXSEC), Y, YMIN, YMAX, DY, YD, TEMP, S1, S2, T1, T2 >*/
/*<       LOGICAL FORWD >*/

/*<       IF (GRCIDE.LT.1) RETURN >*/
    /* Parameter adjustments */
    --py;
    --px;

    /* Function Body */
    if (grcm00_1.grcide < 1) {
	return 0;
    }
/*<       IF (N.LT.3) THEN >*/
    if (*n < 3) {
/*<           CALL GRWARN('GRFA - polygon has < 3 vertices.') >*/
	grwarn_("GRFA - polygon has < 3 vertices.", (ftnlen)32);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Devices with polygon fill capability. */

/*<       IF(GRGCAP(GRCIDE)(4:4).EQ.'A') THEN >*/
    if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 3] == 
	    'A') {
/*<          IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
	if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	    grbpic_();
	}
/*<          RBUF(1) = N >*/
	rbuf[0] = (real) (*n);
/*<          CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<          DO 10 I=1,N >*/
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<             RBUF(1) = PX(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE) >*/
	    rbuf[0] = px[i__] * grcm00_1.grxscl[grcm00_1.grcide - 1] + 
		    grcm00_1.grxorg[grcm00_1.grcide - 1];
/*<             RBUF(2) = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE) >*/
	    rbuf[1] = py[i__] * grcm00_1.gryscl[grcm00_1.grcide - 1] + 
		    grcm00_1.gryorg[grcm00_1.grcide - 1];
/*<             CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR) >*/
	    grexec_(&grcm00_1.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (
		    ftnlen)32);
/*<  10      CONTINUE >*/
/* L10: */
	}
/*<          RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* For other devices fill area is simulated. */

/* Save attributes. */

/*<       CALL GRQLS(LS) >*/
    grqls_(&ls);
/*<       CALL GRQLW(LW) >*/
    grqlw_(&lw);
/*<       CALL GRSLS(1) >*/
    grsls_(&c__1);
/*<       CALL GRSLW(1) >*/
    grslw_(&c__1);

/* Find range of raster-lines to be shaded. */

/*<       YMIN = PY(1)*GRYSCL(GRCIDE) + GRYORG(GRCIDE) >*/
    ymin = py[1] * grcm00_1.gryscl[grcm00_1.grcide - 1] + grcm00_1.gryorg[
	    grcm00_1.grcide - 1];
/*<       YMAX = YMIN >*/
    ymax = ymin;
/*<       DO 20 I=2,N >*/
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
/*<          YD = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE) >*/
	yd = py[i__] * grcm00_1.gryscl[grcm00_1.grcide - 1] + grcm00_1.gryorg[
		grcm00_1.grcide - 1];
/*<          YMIN = MIN(YMIN,YD) >*/
	ymin = dmin(ymin,yd);
/*<          YMAX = MAX(YMAX,YD) >*/
	ymax = dmax(ymax,yd);
/*<  20   CONTINUE >*/
/* L20: */
    }
/*<       CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__3, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
/*<       DY = ABS(RBUF(3)) >*/
    dy = dabs(rbuf[2]);

/* Find intersections of edges with current raster line. */

/*<       FORWD = .TRUE. >*/
    forwd = TRUE_;
/*<       S1 = PX(N)*GRXSCL(GRCIDE) + GRXORG(GRCIDE) >*/
    s1 = px[*n] * grcm00_1.grxscl[grcm00_1.grcide - 1] + grcm00_1.grxorg[
	    grcm00_1.grcide - 1];
/*<       T1 = PY(N)*GRYSCL(GRCIDE) + GRYORG(GRCIDE) >*/
    t1 = py[*n] * grcm00_1.gryscl[grcm00_1.grcide - 1] + grcm00_1.gryorg[
	    grcm00_1.grcide - 1];

/*<       DO 40 LINE = NINT(YMIN/DY),NINT(YMAX/DY) >*/
    r__1 = ymin / dy;
    r__2 = ymax / dy;
    i__1 = i_nint(&r__2);
    for (line = i_nint(&r__1); line <= i__1; ++line) {
/*<          Y = LINE * DY >*/
	y = line * dy;
/*<          NSECT = 0 >*/
	nsect = 0;
/*<          DO 30 I=1,N >*/
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
/*<             S2 = PX(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE) >*/
	    s2 = px[i__] * grcm00_1.grxscl[grcm00_1.grcide - 1] + 
		    grcm00_1.grxorg[grcm00_1.grcide - 1];
/*<             T2 = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE) >*/
	    t2 = py[i__] * grcm00_1.gryscl[grcm00_1.grcide - 1] + 
		    grcm00_1.gryorg[grcm00_1.grcide - 1];
/*<    >*/
	    if (t1 < y && y <= t2 || t1 >= y && y > t2) {
/*<                NSECT = NSECT+1 >*/
		++nsect;
/*<                IF (NSECT.GT.MAXSEC) THEN >*/
		if (nsect > 32) {
/*<                   CALL GRWARN('GRFA - polygon is too complex.') >*/
		    grwarn_("GRFA - polygon is too complex.", (ftnlen)30);
/*<                   RETURN >*/
		    return 0;
/*<                END IF >*/
		}
/*<                X(NSECT)=(S1+(S2-S1)*((Y-T1)/(T2-T1))) >*/
		x[nsect - 1] = s1 + (s2 - s1) * ((y - t1) / (t2 - t1));
/*<             END IF >*/
	    }
/*<             S1 = S2 >*/
	    s1 = s2;
/*<             T1 = T2 >*/
	    t1 = t2;
/*<  30      CONTINUE >*/
/* L30: */
	}

/* Sort the intersections into increasing x order. */

/*<          DO 34 I=2,NSECT >*/
	i__2 = nsect;
	for (i__ = 2; i__ <= i__2; ++i__) {
/*<             DO 32 J=1,I >*/
	    i__3 = i__;
	    for (j = 1; j <= i__3; ++j) {
/*<                IF (X(J).GT.X(I)) THEN >*/
		if (x[j - 1] > x[i__ - 1]) {
/*<                   TEMP = X(J) >*/
		    temp = x[j - 1];
/*<                   X(J) = X(I) >*/
		    x[j - 1] = x[i__ - 1];
/*<                   X(I) = TEMP >*/
		    x[i__ - 1] = temp;
/*<                END IF >*/
		}
/*<  32         CONTINUE >*/
/* L32: */
	    }
/*<  34      CONTINUE >*/
/* L34: */
	}

/* Draw the horizontal line-segments. */

/*<          GRYPRE(GRCIDE) = Y >*/
	grcm00_1.grypre[grcm00_1.grcide - 1] = y;
/*<          IF (FORWD) THEN >*/
	if (forwd) {
/*<             DO 36 I=1,NSECT-1,2 >*/
	    i__2 = nsect - 1;
	    for (i__ = 1; i__ <= i__2; i__ += 2) {
/*<                GRXPRE(GRCIDE) = X(I) >*/
		grcm00_1.grxpre[grcm00_1.grcide - 1] = x[i__ - 1];
/*<                CALL GRLIN0(X(I+1),Y) >*/
		grlin0_(&x[i__], &y);
/*<  36         CONTINUE >*/
/* L36: */
	    }
/*<             FORWD = .FALSE. >*/
	    forwd = FALSE_;
/*<          ELSE >*/
	} else {
/*<             DO 38 I=NSECT,2,-2 >*/
	    for (i__ = nsect; i__ >= 2; i__ += -2) {
/*<                GRXPRE(GRCIDE) = X(I) >*/
		grcm00_1.grxpre[grcm00_1.grcide - 1] = x[i__ - 1];
/*<                CALL GRLIN0(X(I-1),Y) >*/
		grlin0_(&x[i__ - 2], &y);
/*<  38         CONTINUE >*/
/* L38: */
	    }
/*<             FORWD = .TRUE. >*/
	    forwd = TRUE_;
/*<          END IF >*/
	}
/*<  40   CONTINUE >*/
/* L40: */
    }

/* Restore attributes. */

/*<       CALL GRSLS(LS) >*/
    grsls_(&ls);
/*<       CALL GRSLW(LW) >*/
    grslw_(&lw);
/*<       END >*/
} /* grfa_ */

