/* /work2/ssa/pgplot/sys/grgcom.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* *GRGCOM -- read with prompt from user's terminal (Sun/Convex-UNIX) */
/* + */
/*<       INTEGER FUNCTION GRGCOM(STRING, PROMPT, L) >*/
integer grgcom_(string, prompt, l, string_len, prompt_len)
char *string, *prompt;
integer *l;
ftnlen string_len;
ftnlen prompt_len;
{
    /* System generated locals */
    integer ret_val;

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe(), s_rsfe(), e_rsfe(), i_len();

    /* Local variables */
    static integer ier;

    /* Fortran I/O blocks */
    static cilist io___2 = { 1, 6, 0, "(1X,A,$)", 0 };
    static cilist io___3 = { 1, 5, 1, "(A)", 0 };


/*<       CHARACTER*(*) STRING, PROMPT >*/
/*<       INTEGER L >*/

/* Issue prompt and read a line from the user's terminal; in VMS, */
/* this is equivalent to LIB$GET_COMMAND. */

/* Arguments: */
/*  STRING : (output) receives the string read from the terminal. */
/*  PROMPT : (input) prompt string. */
/*  L      : (output) length of STRING. */

/* Returns: */
/*  GRGCOM : 1 if successful, 0 if an error occurs (e.g., end of file). */
/* -- */
/* 9-Feb-1988 */
/* 10-Feb-1990 revised to always read from stdin (unit 5), but issue a */
/*             prompt only when device is a terminal. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER IER >*/

/*<       GRGCOM = 0 >*/
    ret_val = 0;
/*<       L = 0 >*/
    *l = 0;
/*<       IER = 0 >*/
    ier = 0;
/*<       WRITE (*, '(1X,A,$)', IOSTAT=IER) PROMPT >*/
    ier = s_wsfe(&io___2);
    if (ier != 0) {
	goto L100001;
    }
    ier = do_fio(&c__1, prompt, prompt_len);
    if (ier != 0) {
	goto L100001;
    }
    ier = e_wsfe();
L100001:
/*<       IF (IER.EQ.0) READ (*, '(A)', IOSTAT=IER) STRING >*/
    if (ier == 0) {
	ier = s_rsfe(&io___3);
	if (ier != 0) {
	    goto L100002;
	}
	ier = do_fio(&c__1, string, string_len);
	if (ier != 0) {
	    goto L100002;
	}
	ier = e_rsfe();
L100002:
	;
    }
/*<       IF (IER.EQ.0) GRGCOM = 1 >*/
    if (ier == 0) {
	ret_val = 1;
    }
/*<       L = LEN(STRING) >*/
    *l = i_len(string, string_len);
/*<    10 IF (STRING(L:L).NE.' ') GOTO 20 >*/
L10:
    if (*(unsigned char *)&string[*l - 1] != ' ') {
	goto L20;
    }
/*<           L = L-1 >*/
    --(*l);
/*<           GOTO 10 >*/
    goto L10;
/*<    20 CONTINUE >*/
L20:
/*<       END >*/
    return ret_val;
} /* grgcom_ */

