/* /work2/ssa/pgplot/src/grgfil.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;

/* *GRGFIL -- find data file */
/* + */
/*<       SUBROUTINE GRGFIL(TYPE, NAME) >*/
/* Subroutine */ int grgfil_(type__, name__, type_len, name_len)
char *type__, *name__;
ftnlen type_len;
ftnlen name_len;
{
    /* System generated locals */
    address a__1[2];
    integer i__1, i__2[2];
    char ch__1[267];
    inlist ioin__1;

    /* Builtin functions */
    integer s_cmp();
    /* Subroutine */ int s_copy();
    integer i_len();
    /* Subroutine */ int s_cat();
    integer f_inqu();

    /* Local variables */
    static logical test;
    static integer i__, l;
    static logical debug;
    static char deflt[16], ff[255];
    static integer ld;
    extern /* Subroutine */ int grgenv_(), grwarn_();

/*<       CHARACTER*(*) TYPE, NAME >*/

/* This routine encsapsulates the algorithm for finding the PGPLOT */
/* run-time data files. */

/* 1. The binary font file: try the following in order: */
/*     file specified by PGPLOT_FONT */
/*     file "grfont.dat" in directory specified by PGPLOT_DIR */
/*                       (with or without '/' appended) */
/*     file "grfont.dat" in directory /usr/local/pgplot/ */

/* 2. The color-name database: try the following in order: */
/*     file specified by PGPLOT_RGB */
/*     file "rgb.txt" in directory specified by PGPLOT_DIR */
/*                       (with or without '/' appended) */
/*     file "rgb.txt" in directory /usr/local/pgplot/ */

/* Arguments: */
/*  TYPE (input)  : either 'FONT' or 'RGB' to request the corresponding */
/*                  file. */
/*  NAME (output) : receives the file name. */
/* -- */
/*  2-Dec-1994 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*(*) DEFDIR, DEFFNT, DEFRGB >*/
/*<       PARAMETER  (DEFDIR='/usr/local/pgplot/') >*/
/*<       PARAMETER  (DEFFNT='grfont.dat') >*/
/*<       PARAMETER  (DEFRGB='rgb.txt') >*/
/*<       CHARACTER*255 FF >*/
/*<       CHARACTER*16 DEFLT >*/
/*<       INTEGER I, L, LD >*/
/*<       LOGICAL TEST, DEBUG >*/

/* Is debug output requested? */

/*<       CALL GRGENV('DEBUG', FF, L) >*/
    grgenv_("DEBUG", ff, &l, (ftnlen)5, (ftnlen)255);
/*<       DEBUG = L.GT.0 >*/
    debug = l > 0;

/* Which file? */

/*<       IF (TYPE.EQ.'FONT') THEN >*/
    if (s_cmp(type__, "FONT", type_len, (ftnlen)4) == 0) {
/*<          DEFLT = DEFFNT >*/
	s_copy(deflt, "grfont.dat", (ftnlen)16, (ftnlen)10);
/*<          LD = LEN(DEFFNT) >*/
	ld = i_len("grfont.dat", (ftnlen)10);
/*<       ELSE IF (TYPE.EQ.'RGB') THEN >*/
    } else if (s_cmp(type__, "RGB", type_len, (ftnlen)3) == 0) {
/*<          DEFLT = DEFRGB >*/
	s_copy(deflt, "rgb.txt", (ftnlen)16, (ftnlen)7);
/*<          LD = LEN(DEFRGB) >*/
	ld = i_len("rgb.txt", (ftnlen)7);
/*<       ELSE >*/
    } else {
/*<          CALL GRWARN('Internal error in routine GRGFIL') >*/
	grwarn_("Internal error in routine GRGFIL", (ftnlen)32);
/*<       END IF >*/
    }

/* Try each possibility in turn. */

/*<       DO 10 I=1,4 >*/
    for (i__ = 1; i__ <= 4; ++i__) {
/*<          IF (I.EQ.1) THEN >*/
	if (i__ == 1) {
/*<             CALL GRGENV(TYPE, FF, L) >*/
	    grgenv_(type__, ff, &l, type_len, (ftnlen)255);
/*<          ELSE IF (I.EQ.2) THEN >*/
	} else if (i__ == 2) {
/*<             CALL GRGENV('DIR', FF, L) >*/
	    grgenv_("DIR", ff, &l, (ftnlen)3, (ftnlen)255);
/*<             IF (L.GT.0) THEN >*/
	    if (l > 0) {
/*<                FF(L+1:) = DEFLT >*/
		i__1 = l;
		s_copy(ff + i__1, deflt, 255 - i__1, (ftnlen)16);
/*<                L = L+LD >*/
		l += ld;
/*<             END IF >*/
	    }
/*<          ELSE IF (I.EQ.3) THEN >*/
	} else if (i__ == 3) {
/*<             CALL GRGENV('DIR', FF, L) >*/
	    grgenv_("DIR", ff, &l, (ftnlen)3, (ftnlen)255);
/*<             IF (L.GT.0) THEN >*/
	    if (l > 0) {
/*<                FF(L+1:L+1) = '/' >*/
		i__1 = l;
		s_copy(ff + i__1, "/", l + 1 - i__1, (ftnlen)1);
/*<                FF(L+2:) = DEFLT >*/
		i__1 = l + 1;
		s_copy(ff + i__1, deflt, 255 - i__1, (ftnlen)16);
/*<                L = L+1+LD >*/
		l = l + 1 + ld;
/*<             END IF >*/
	    }
/*<          ELSE IF (I.EQ.4) THEN >*/
	} else if (i__ == 4) {
/*<             FF = DEFDIR//DEFLT >*/
/* Writing concatenation */
	    i__2[0] = 18, a__1[0] = "/usr/local/pgplot/";
	    i__2[1] = 16, a__1[1] = deflt;
	    s_cat(ff, a__1, i__2, &c__2, (ftnlen)255);
/*<             L = LEN(DEFDIR)+LD >*/
	    l = i_len("/usr/local/pgplot/", (ftnlen)18) + ld;
/*<          END IF >*/
	}
/*<          IF (L.GT.0) THEN >*/
	if (l > 0) {
/*<             IF (DEBUG) THEN >*/
	    if (debug) {
/*<                CALL GRWARN('Looking for '//FF(:L)) >*/
/* Writing concatenation */
		i__2[0] = 12, a__1[0] = "Looking for ";
		i__2[1] = l, a__1[1] = ff;
		s_cat(ch__1, a__1, i__2, &c__2, (ftnlen)267);
		grwarn_(ch__1, l + 12);
/*<             END IF >*/
	    }
/*<             INQUIRE (FILE=FF(:L), EXIST=TEST) >*/
	    ioin__1.inerr = 0;
	    ioin__1.infilen = l;
	    ioin__1.infile = ff;
	    ioin__1.inex = &test;
	    ioin__1.inopen = 0;
	    ioin__1.innum = 0;
	    ioin__1.innamed = 0;
	    ioin__1.inname = 0;
	    ioin__1.inacc = 0;
	    ioin__1.inseq = 0;
	    ioin__1.indir = 0;
	    ioin__1.infmt = 0;
	    ioin__1.inform = 0;
	    ioin__1.inunf = 0;
	    ioin__1.inrecl = 0;
	    ioin__1.innrec = 0;
	    ioin__1.inblank = 0;
	    f_inqu(&ioin__1);
/*<             IF (TEST) THEN >*/
	    if (test) {
/*<                NAME = FF(:L) >*/
		s_copy(name__, ff, name_len, l);
/*<                RETURN >*/
		return 0;
/*<             ELSE IF (DEBUG) THEN >*/
	    } else if (debug) {
/*<                CALL GRWARN('WARNING: file not found') >*/
		grwarn_("WARNING: file not found", (ftnlen)23);
/*<             END IF >*/
	    }
/*<          END IF >*/
	}
/*<  10   CONTINUE >*/
/* L10: */
    }

/* Failed to find the file. */

/*<       NAME = DEFLT >*/
    s_copy(name__, deflt, name_len, (ftnlen)16);
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grgfil_ */

