/* /work2/ssa/pgplot/src/grimg0.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* *GRIMG0 -- color image of a 2D data array */
/* + */
/*<    >*/
/* Subroutine */ int grimg0_(a, idim, jdim, i1, i2, j1, j2, a1, a2, pa, 
	minind, maxind, mode)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *a1, *a2, *pa;
integer *minind, *maxind, *mode;
{
    /* System generated locals */
    integer a_dim1, a_offset;

    /* Local variables */
    static char c__[1];
    extern /* Subroutine */ int grimg1_(), grimg2_(), grwarn_();

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE >*/
/*<       REAL    A(IDIM,JDIM), A1, A2, PA(6) >*/

/* This is a support routine for PGIMAG. */

/* Arguments: */
/*  A      (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  A1     (input)  : the array value which is to appear in color */
/*                    index MININD. */
/*  A2     (input)  : the array value which is to appear in color */
/*                    index MAXIND. */
/*  PA     (input)  : transformation matrix between array grid and */
/*                    device coordinates. */
/*  MININD (input)  : minimum color index to use. */
/*  MAXIND (input)  : maximum color index to use. */
/*  MODE   (input)  : =0 for linear, =1 for logarithmic, =2 for */
/*                    square-root mapping of array values to color */
/*                    indices. */
/* -- */
/*  7-Sep-1994 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       CHARACTER C >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

/* Switch on type of device support. */

/*<       C = GRGCAP(GRCIDE)(7:7) >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --pa;

    /* Function Body */
    *(unsigned char *)c__ = *(unsigned char *)&grcm01_1.grgcap[(
	    grcm00_1.grcide - 1) * 11 + 6];
/*<       IF (C.EQ.'Q') THEN >*/
    if (*(unsigned char *)c__ == 'Q') {
/*         -- Image-primitive devices */
/*<    >*/
	grimg1_(&a[a_offset], idim, jdim, i1, i2, j1, j2, a1, a2, &pa[1], 
		minind, maxind, mode);
/*<       ELSE IF (C.EQ.'P') THEN >*/
    } else if (*(unsigned char *)c__ == 'P') {
/*         -- Pixel-primitive devices */
/*<    >*/
	grimg2_(&a[a_offset], idim, jdim, i1, i2, j1, j2, a1, a2, &pa[1], 
		minind, maxind, mode);
/*<       ELSE IF (C.EQ.'N') THEN >*/
    } else if (*(unsigned char *)c__ == 'N') {
/*         -- Other devices */
/*<    >*/
	grwarn_("images cannot be displayed on the selected device", (ftnlen)
		49);
/*<       ELSE >*/
    } else {
/*         -- Unknown device code */
/*<           CALL GRWARN('unexpected error in routine GRIMG0') >*/
	grwarn_("unexpected error in routine GRIMG0", (ftnlen)34);
/*<       END IF >*/
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grimg0_ */

