/* /work2/ssa/pgplot/src/gritoc.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRITOC - convert integer to character string */
/* + */
/*<       INTEGER FUNCTION GRITOC(INT, STR) >*/
integer gritoc_(int__, str, str_len)
integer *int__;
char *str;
ftnlen str_len;
{
    /* Initialized data */

    static char digits[10+1] = "0123456789";

    /* System generated locals */
    integer ret_val, i__1;

    /* Builtin functions */
    integer i_len();

    /* Local variables */
    static integer d__, i__, j;
    static char k[1];
    static integer l, intval;

/*<       INTEGER INT >*/
/*<       CHARACTER*(*) STR >*/

/* Convert integer INT into (decimal) character string in STR. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*10 DIGITS >*/
/*<       INTEGER D, I, INTVAL, J, L >*/
/*<       CHARACTER K >*/
/*<       DATA DIGITS /'0123456789'/ >*/

/*<       INTVAL = ABS(INT) >*/
    intval = abs(*int__);
/*<       I = 0 >*/
    i__ = 0;

/* Generate digits in reverse order. */

/*<   10  CONTINUE >*/
L10:
/*<           I = I+1 >*/
    ++i__;
/*<           D = 1 + MOD(INTVAL, 10) >*/
    d__ = intval % 10 + 1;
/*<           STR(I:I) = DIGITS(D:D) >*/
    *(unsigned char *)&str[i__ - 1] = *(unsigned char *)&digits[d__ - 1];
/*<           INTVAL = INTVAL/10 >*/
    intval /= 10;
/*<           IF (I.LT.LEN(STR) .AND. INTVAL.NE.0) GOTO 10 >*/
    if (i__ < i_len(str, str_len) && intval != 0) {
	goto L10;
    }

/* Add minus sign if necessary. */

/*<       IF (INT.LT.0 .AND. I.LT.LEN(STR)) THEN >*/
    if (*int__ < 0 && i__ < i_len(str, str_len)) {
/*<           I = I+1 >*/
	++i__;
/*<           STR(I:I) = '-' >*/
	*(unsigned char *)&str[i__ - 1] = '-';
/*<       END IF >*/
    }
/*<       GRITOC = I >*/
    ret_val = i__;

/* Reverse string in place. */

/*<       L = I/2 >*/
    l = i__ / 2;
/*<       DO 20 J=1,L >*/
    i__1 = l;
    for (j = 1; j <= i__1; ++j) {
/*<           K = STR(I:I) >*/
	*(unsigned char *)k = *(unsigned char *)&str[i__ - 1];
/*<           STR(I:I) = STR(J:J) >*/
	*(unsigned char *)&str[i__ - 1] = *(unsigned char *)&str[j - 1];
/*<           STR(J:J) = K >*/
	*(unsigned char *)&str[j - 1] = *(unsigned char *)k;
/*<           I = I-1 >*/
	--i__;
/*<    20 CONTINUE >*/
/* L20: */
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
    return ret_val;
} /* gritoc_ */

