/* /work2/ssa/pgplot/src/grlin1.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* *GRLIN1 -- draw a dashed line */
/* + */
/*<       SUBROUTINE GRLIN1 (X0,Y0,X1,Y1,RESET) >*/
/* Subroutine */ int grlin1_(x0, y0, x1, y1, reset)
real *x0, *y0, *x1, *y1;
logical *reset;
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static real scale;
    static integer thick;
    static real dsold, alpha1, alpha2;
    extern /* Subroutine */ int grlin2_(), grlin3_();
    static real ds, xp, seglen, yp, xq, yq;


/* GRPCKG : dashed line. Generate a visible dashed line between points */
/* (X0,Y0) and (X1,Y1) according to the dash pattern stored in common. */
/* If RESET = .TRUE., the pattern will start from the beginning. */
/* Otherwise, it will continue from its last position. */
/*     DASHED LINE PATTERN ARRAY CONTAINING LENGTHS OF */
/*          MARKS AND SPACES IN UNIT CUBE: GRPATN(*) */
/*     OFFSET IN CURRENT PATTERN SEGMENT: GRPOFF */
/*     CURRENT PATTERN SEGMENT NUMBER: GRIPAT */
/*     NUMBER OF PATTERN SEGMENTS: 8 */
/* -- */
/* (1-Feb-1983) */
/*  6-Sep-1989 - Changes for standard Fortran-77 [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       REAL ADJUST, ARG1, ARG2, ALFARG >*/

/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL SCALE, SEGLEN, X1, X0, Y1, Y0, DS, DSOLD >*/
/*<       REAL ALPHA1, ALPHA2, XP, YP, XQ, YQ >*/
/*<       LOGICAL RESET >*/
/*<       INTEGER THICK >*/
/*<       INTRINSIC ABS, MIN, MOD, REAL, SQRT >*/

/*<       ADJUST(ARG1,ARG2,ALFARG) = ALFARG*(ARG2 - ARG1) + ARG1 >*/

/*<       THICK = GRWIDT(GRCIDE) >*/
    thick = grcm00_1.grwidt[grcm00_1.grcide - 1];
/*<       SCALE = SQRT(REAL(ABS(THICK))) >*/
    scale = sqrt((real) abs(thick));
/*<       IF (RESET) THEN >*/
    if (*reset) {
/*<           GRPOFF(GRCIDE) = 0.0 >*/
	grcm00_1.grpoff[grcm00_1.grcide - 1] = (float)0.;
/*<           GRIPAT(GRCIDE) = 1 >*/
	grcm00_1.gripat[grcm00_1.grcide - 1] = 1;
/*<       END IF >*/
    }
/*<       SEGLEN = SQRT((X1-X0)**2 + (Y1-Y0)**2) >*/
/* Computing 2nd power */
    r__1 = *x1 - *x0;
/* Computing 2nd power */
    r__2 = *y1 - *y0;
    seglen = sqrt(r__1 * r__1 + r__2 * r__2);
/*<       IF (SEGLEN .EQ. 0.0) RETURN >*/
    if (seglen == (float)0.) {
	return 0;
    }
/*<       DS = 0.0 >*/
    ds = (float)0.;

/*       Repeat until (ALPHA2 .GE. 1.0) */

/*       Line segments matching the pattern segments are determined */
/*       by finding values (ALPHA1,ALPHA2) defining the start and end */
/*       of the segment in the parametric equation (1-ALPHA)*P1 + ALPHA*P2 */
/*       defining the line.  DS measures the progress along the line */
/*       segment and defines the starting ALPHA1.  The ending ALPHA2 */
/*       is computed from the end of the current pattern mark or space */
/*       or the segment end, whichever comes first. */

/*<    10 DSOLD = DS >*/
L10:
    dsold = ds;
/*<       ALPHA1 = DS/SEGLEN >*/
    alpha1 = ds / seglen;
/*<    >*/
/* Computing MIN */
    r__1 = (float)1., r__2 = (ds + scale * grcm00_1.grpatn[grcm00_1.grcide + (
	    grcm00_1.gripat[grcm00_1.grcide - 1] << 3) - 9] - grcm00_1.grpoff[
	    grcm00_1.grcide - 1]) / seglen;
    alpha2 = dmin(r__1,r__2);
/*<       IF (MOD(GRIPAT(GRCIDE),2) .NE. 0) THEN >*/
    if (grcm00_1.gripat[grcm00_1.grcide - 1] % 2 != 0) {
/*<           XP = ADJUST(X0,X1,ALPHA1) >*/
	xp = alpha1 * (*x1 - *x0) + *x0;
/*<           YP = ADJUST(Y0,Y1,ALPHA1) >*/
	yp = alpha1 * (*y1 - *y0) + *y0;
/*<           XQ = ADJUST(X0,X1,ALPHA2) >*/
	xq = alpha2 * (*x1 - *x0) + *x0;
/*<           YQ = ADJUST(Y0,Y1,ALPHA2) >*/
	yq = alpha2 * (*y1 - *y0) + *y0;
/*<           IF (THICK.GT.1) THEN >*/
	if (thick > 1) {
/*<               CALL GRLIN3(XP,YP,XQ,YQ) >*/
	    grlin3_(&xp, &yp, &xq, &yq);
/*<           ELSE >*/
	} else {
/*<               CALL GRLIN2(XP,YP,XQ,YQ) >*/
	    grlin2_(&xp, &yp, &xq, &yq);
/*<           END IF >*/
	}
/*<       END IF >*/
    }
/*<       DS = ALPHA2*SEGLEN >*/
    ds = alpha2 * seglen;
/*<       IF (ALPHA2 .GE. 1.0) THEN >*/
    if (alpha2 >= (float)1.) {
/*<           GRPOFF(GRCIDE) = GRPOFF(GRCIDE) + DS - DSOLD >*/
	grcm00_1.grpoff[grcm00_1.grcide - 1] = grcm00_1.grpoff[
		grcm00_1.grcide - 1] + ds - dsold;
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }
/*<       GRIPAT(GRCIDE) = MOD(GRIPAT(GRCIDE),8) + 1 >*/
    grcm00_1.gripat[grcm00_1.grcide - 1] = grcm00_1.gripat[grcm00_1.grcide - 
	    1] % 8 + 1;
/*<       GRPOFF(GRCIDE) = 0.0 >*/
    grcm00_1.grpoff[grcm00_1.grcide - 1] = (float)0.;
/*<       GO TO 10 >*/
    goto L10;
/*<       END >*/
} /* grlin1_ */

