/* /work2/ssa/pgplot/sys/groptx.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GROPTX -- open input/output text file [Unix] */
/* + */
/*<       INTEGER FUNCTION GROPTX (UNIT, NAME, DEFNAM, MODE) >*/
integer groptx_(unit, name__, defnam, mode, name_len, defnam_len)
integer *unit;
char *name__, *defnam;
integer *mode;
ftnlen name_len;
ftnlen defnam_len;
{
    /* System generated locals */
    integer ret_val;
    olist o__1;

    /* Builtin functions */
    integer f_open();

    /* Local variables */
    static integer ier;

/*<       INTEGER UNIT, MODE >*/
/*<       CHARACTER*(*) NAME, DEFNAM >*/

/* Input: */
/*  UNIT : Fortran unit number to use */
/*  NAME : name of file to create */
/*  DEFNAM : default file name (used to fill in missing fields for VMS) */
/*  MODE : 0 to open for reading, 1 to open for writing. */

/* Returns: */
/*  0 => success; any other value => error. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER IER >*/
/*<       IF (MODE.EQ.1) THEN >*/
    if (*mode == 1) {
/*<           OPEN (UNIT=UNIT, FILE=NAME, STATUS='UNKNOWN', IOSTAT=IER) >*/
	o__1.oerr = 1;
	o__1.ounit = *unit;
	o__1.ofnmlen = name_len;
	o__1.ofnm = name__;
	o__1.orl = 0;
	o__1.osta = "UNKNOWN";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	ier = f_open(&o__1);
/*<       ELSE >*/
    } else {
/*<           OPEN (UNIT=UNIT, FILE=NAME, STATUS='OLD', IOSTAT=IER) >*/
	o__1.oerr = 1;
	o__1.ounit = *unit;
	o__1.ofnmlen = name_len;
	o__1.ofnm = name__;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	ier = f_open(&o__1);
/*<       END IF >*/
    }
/*<       GROPTX = IER >*/
    ret_val = ier;
/* ----------------------------------------------------------------------- */
/*<       END >*/
    return ret_val;
} /* groptx_ */

