/* /work2/ssa/pgplot/src/grpixl.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static logical c_false = FALSE_;
static integer c__3 = 3;

/* *GRPIXL -- solid-fill multiple rectangular areas */
/* + */
/*<    >*/
/* Subroutine */ int grpixl_(ia, idim, jdim, i1, i2, j1, j2, x1, x2, y1, y2)
integer *ia, *idim, *jdim, *i1, *i2, *j1, *j2;
real *x1, *x2, *y1, *y2;
{
    /* System generated locals */
    integer ia_dim1, ia_offset;

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[3], xmin, ymin, xmax, ymax, xpix, ypix, width, xsize, 
	    ysize;
    static integer jb, il, ir, jt;
    extern /* Subroutine */ int grtxy0_(), grexec_(), grpxps_(), grpxre_(), 
	    grpxpx_(), grpxpo_();
    static char chr[32];
    static real xll, yll, xur, yur;

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2 >*/
/*<       INTEGER IA(IDIM,JDIM) >*/
/*<       REAL    X1, X2, Y1, Y2 >*/

/* Determine the size of each rectangular element. If it is equal */
/* to the device pen width and the device supports pixel primitives, */
/* use pixel primitives. Otherwise, if the size is smaller than the */
/* device pen width emulate pixel output by plotting points. If the */
/* size is larger than the device pen width, emulate by outputting */
/* solid-filled rectangles. */

/* Arguments: */
/*  IA     (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  X1, Y1 (input)  : world coordinates of one corner of the output */
/*                    region */
/*  X2, Y2 (input)  : world coordinates of the opposite corner of the */
/*                    output region */
/* -- */
/* 18-Jan-1991 - [Ge van Geldorp] */
/* 31-Mar-1993 - Include color PostScript GRPXPS [Remko Scharroo] */
/*  4-Apr-1993 - New version of GRPXPS incorporated */
/*  4-Aug-1993 - Debugging */
/*  7-Sep-1994 - Revised for v5.0 [TJP]. */
/* 24-Jan-1996 - GRXMIN etc changed to REAL as required in grpckg1.inc [RS] */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       REAL    RBUF(3) >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER NBUF, LCHR >*/
/*<       CHARACTER*32 CHR >*/
/*<       REAL    XLL, YLL, XUR, YUR >*/
/*<       REAL    XMIN, YMIN, XMAX, YMAX, XPIX, YPIX >*/
/*<       REAL    WIDTH, XSIZE, YSIZE >*/
/*<       INTEGER IL, IR, JB, JT >*/

/*<       IF (GRCIDE.LT.1) RETURN >*/
    /* Parameter adjustments */
    ia_dim1 = *idim;
    ia_offset = 1 + ia_dim1 * 1;
    ia -= ia_offset;

    /* Function Body */
    if (grcm00_1.grcide < 1) {
	return 0;
    }

/* Convert to device coordinates */

/*<       CALL GRTXY0(.FALSE., X1, Y1, XLL, YLL) >*/
    grtxy0_(&c_false, x1, y1, &xll, &yll);
/*<       CALL GRTXY0(.FALSE., X2, Y2, XUR, YUR) >*/
    grtxy0_(&c_false, x2, y2, &xur, &yur);
/*<       XMIN = MIN(XLL,XUR) >*/
    xmin = dmin(xll,xur);
/*<       XMAX = MAX(XLL,XUR) >*/
    xmax = dmax(xll,xur);
/*<       YMIN = MIN(YLL,YUR) >*/
    ymin = dmin(yll,yur);
/*<       YMAX = MAX(YLL,YUR) >*/
    ymax = dmax(yll,yur);

/* Check if completely outside clipping region */

/*<    >*/
    if (xmax < grcm00_1.grxmin[grcm00_1.grcide - 1] || grcm00_1.grxmax[
	    grcm00_1.grcide - 1] < xmin || ymax < grcm00_1.grymin[
	    grcm00_1.grcide - 1] || grcm00_1.grymax[grcm00_1.grcide - 1] < 
	    ymin) {
	return 0;
    }

/* Don't paint "pixels" completely before left clipping boundary */

/*<       XPIX = XMAX - XMIN >*/
    xpix = xmax - xmin;
/*<       YPIX = YMAX - YMIN >*/
    ypix = ymax - ymin;
/*<       IF (XMIN .LT. GRXMIN(GRCIDE)) THEN >*/
    if (xmin < grcm00_1.grxmin[grcm00_1.grcide - 1]) {
/*<          IL = I1 + (GRXMIN(GRCIDE) - XMIN) * (I2 - I1 + 1) / XPIX >*/
	il = *i1 + (grcm00_1.grxmin[grcm00_1.grcide - 1] - xmin) * (*i2 - *i1 
		+ 1) / xpix;
/*<          XMIN = XMIN + (XPIX * (IL - I1)) / (I2 - I1 + 1) >*/
	xmin += xpix * (il - *i1) / (*i2 - *i1 + 1);
/*<       ELSE >*/
    } else {
/*<          IL = I1 >*/
	il = *i1;
/*<       ENDIF >*/
    }

/* Don't paint "pixels" completely after right clipping boundary */

/*<       IF (GRXMAX(GRCIDE) .LT. XMAX) THEN >*/
    if (grcm00_1.grxmax[grcm00_1.grcide - 1] < xmax) {
/*<          IR = I2 - (XMAX - GRXMAX(GRCIDE)) * (I2 - I1 + 1) / XPIX + 1 >*/
	ir = *i2 - (xmax - grcm00_1.grxmax[grcm00_1.grcide - 1]) * (*i2 - *i1 
		+ 1) / xpix + 1;
/*<    >*/
	xmax = xmin + xpix * (ir - *i1 + 1) / (*i2 - *i1 + 1);
/*<       ELSE >*/
    } else {
/*<          IR = I2 >*/
	ir = *i2;
/*<       ENDIF >*/
    }

/* Don't paint "pixels" completely under bottom clipping boundary */

/*<       IF (YMIN .LT. GRYMIN(GRCIDE)) THEN >*/
    if (ymin < grcm00_1.grymin[grcm00_1.grcide - 1]) {
/*<          JB = J1 + (GRYMIN(GRCIDE) - YMIN) * (J2 - J1 + 1) / YPIX >*/
	jb = *j1 + (grcm00_1.grymin[grcm00_1.grcide - 1] - ymin) * (*j2 - *j1 
		+ 1) / ypix;
/*<          YMIN = YMIN + (YPIX * (JB - J1)) / (J2 - J1 + 1) >*/
	ymin += ypix * (jb - *j1) / (*j2 - *j1 + 1);
/*<       ELSE >*/
    } else {
/*<          JB = J1 >*/
	jb = *j1;
/*<       ENDIF >*/
    }

/* Don't paint "pixels" completely above top clipping boundary */

/*<       IF (GRYMAX(GRCIDE) .LT. YMAX) THEN >*/
    if (grcm00_1.grymax[grcm00_1.grcide - 1] < ymax) {
/*<          JT = J2 - (YMAX - GRYMAX(GRCIDE)) * (J2 - J1 + 1) / YPIX + 1 >*/
	jt = *j2 - (ymax - grcm00_1.grymax[grcm00_1.grcide - 1]) * (*j2 - *j1 
		+ 1) / ypix + 1;
/*<    >*/
	ymax = ymin + ypix * (jt - *j1 + 1) / (*j2 - *j1 + 1);
/*<       ELSE >*/
    } else {
/*<          JT = J2 >*/
	jt = *j2;
/*<       ENDIF >*/
    }

/* If device accepts image primitives, use GRPXPS */

/*<       IF (GRGCAP(GRCIDE)(7:7).EQ.'Q') THEN >*/
    if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 6] == 
	    'Q') {
/*<    >*/
	grpxps_(&ia[ia_offset], idim, jdim, &il, &ir, &jb, &jt, &xmin, &xmax, 
		&ymin, &ymax);
/*<          RETURN >*/
	return 0;
/*<       ENDIF >*/
    }

/* Check against pen width */

/*<       CALL GREXEC(GRGTYP, 3, RBUF, NBUF, CHR, LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__3, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
/*<       WIDTH = RBUF(3) >*/
    width = rbuf[2];
/*<       XSIZE = (I2 - I1 + 1) * WIDTH >*/
    xsize = (*i2 - *i1 + 1) * width;
/*<       YSIZE = (J2 - J1 + 1) * WIDTH >*/
    ysize = (*j2 - *j1 + 1) * width;
/*<       XPIX = XMAX - XMIN + 1 >*/
    xpix = xmax - xmin + 1;
/*<       YPIX = YMAX - YMIN + 1 >*/
    ypix = ymax - ymin + 1;

/* Use rectangles if "pixel" is too large */

/*<    >*/
    if (xpix > xsize + width * (float).5 || ypix > ysize + width * (float).5) 
	    {
/*     write (6,*) 'GRPXRE' */
/*<    >*/
	grpxre_(&ia[ia_offset], idim, jdim, &il, &ir, &jb, &jt, &xmin, &xmax, 
		&ymin, &ymax);

/* Use either pixel primitives or points */

/*<       ELSE >*/
    } else {

/* Clip pixels lying more than 50% outside clipping boundaries */

/*<          IF (XMIN .LT. GRXMIN(GRCIDE) - 0.5 * WIDTH) THEN >*/
	if (xmin < grcm00_1.grxmin[grcm00_1.grcide - 1] - width * (float).5) {
/*<             XMIN = XMIN + XPIX / (IR - IL + 1) >*/
	    xmin += xpix / (ir - il + 1);
/*<             IL = IL + 1 >*/
	    ++il;
/*<          ENDIF >*/
	}
/*<          IF (GRXMAX(GRCIDE) + 0.5 * WIDTH .LT. XMAX) THEN >*/
	if (grcm00_1.grxmax[grcm00_1.grcide - 1] + width * (float).5 < xmax) {
/*<             XMAX = XMAX - XPIX / (IR - IL + 1) >*/
	    xmax -= xpix / (ir - il + 1);
/*<             IR = IR - 1 >*/
	    --ir;
/*<          ENDIF >*/
	}
/*<          IF (YMIN .LT. GRYMIN(GRCIDE) - 0.5 * WIDTH) THEN >*/
	if (ymin < grcm00_1.grymin[grcm00_1.grcide - 1] - width * (float).5) {
/*<             YMIN = YMIN + YPIX / (JT - JB + 1) >*/
	    ymin += ypix / (jt - jb + 1);
/*<             JB = JB + 1 >*/
	    ++jb;
/*<          ENDIF >*/
	}
/*<          IF (GRYMAX(GRCIDE) + 0.5 * WIDTH .LT. YMAX) THEN >*/
	if (grcm00_1.grymax[grcm00_1.grcide - 1] + width * (float).5 < ymax) {
/*<             YMAX = YMAX - YPIX / (JT - JB + 1) >*/
	    ymax -= ypix / (jt - jb + 1);
/*<             JT = JT - 1 >*/
	    --jt;
/*<          ENDIF >*/
	}

/* Recalculate size */

/*<          XSIZE = (IR - IL + 1) * WIDTH >*/
	xsize = (ir - il + 1) * width;
/*<          YSIZE = (JT - JB + 1) * WIDTH >*/
	ysize = (jt - jb + 1) * width;
/*<          XPIX = XMAX - XMIN + 1 >*/
	xpix = xmax - xmin + 1;
/*<          YPIX = YMAX - YMIN + 1 >*/
	ypix = ymax - ymin + 1;

/* Use pixel primitives if available and possible */

/*<    >*/
	if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 6]
		 == 'P' && xsize - width * (float).5 <= xpix && ysize - width 
		* (float).5 <= ypix) {
/*     write (6,*) 'GRPXPX' */
/*<             CALL GRPXPX(IA, IDIM, JDIM, IL, IR, JB, JT, XMIN, YMIN) >*/
	    grpxpx_(&ia[ia_offset], idim, jdim, &il, &ir, &jb, &jt, &xmin, &
		    ymin);

/* Otherwise, use points */

/*<          ELSE >*/
	} else {
/*     write (6,*) 'GRPXPO' */
/*<    >*/
	    grpxpo_(&ia[ia_offset], idim, jdim, &il, &ir, &jb, &jt, &xmin, &
		    xmax, &ymin, &ymax);
/*<          ENDIF >*/
	}
/*<       ENDIF >*/
    }
/*<       END >*/
} /* grpixl_ */

