/* /work2/ssa/pgplot/src/grpxre.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRPXRE -- Emulate pixel operations using rectangles */
/* + */
/*<    >*/
/* Subroutine */ int grpxre_(ia, idim, jdim, i1, i2, j1, j2, x1, x2, y1, y2)
integer *ia, *idim, *jdim, *i1, *i2, *j1, *j2;
real *x1, *x2, *y1, *y2;
{
    /* System generated locals */
    integer ia_dim1, ia_offset, i__1, i__2;
    real r__1, r__2;

    /* Local variables */
    static integer icol, i__, j;
    extern /* Subroutine */ int grqci_(), grsci_(), grrec0_();
    static real yb, yt;
    static integer lstcol;

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2 >*/
/*<       INTEGER IA(IDIM,JDIM) >*/
/*<       REAL    X1, X2, Y1, Y2 >*/

/* Arguments: */
/*  IA     (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  X1, X2 (input)  : the horizontal range of the output region */
/*  Y1, Y2 (input)  : the vertical range of the output region */
/* -- */
/* 18-Jan-1991 - [GvG] */
/* ----------------------------------------------------------------------- */
/*<       REAL YB, YT >*/
/*<       INTEGER I, J, ICOL, LSTCOL >*/

/* Save color attribute */

/*<       CALL GRQCI(ICOL) >*/
    /* Parameter adjustments */
    ia_dim1 = *idim;
    ia_offset = 1 + ia_dim1 * 1;
    ia -= ia_offset;

    /* Function Body */
    grqci_(&icol);
/*<       LSTCOL = ICOL >*/
    lstcol = icol;
/*<       DO 20 J = J1, J2 >*/
    i__1 = *j2;
    for (j = *j1; j <= i__1; ++j) {

/* Compute Y range for this index */

/*<          YB = Y1 + ((Y2 - Y1) * (J - J1)) / (J2 - J1 + 1) >*/
	yb = *y1 + (*y2 - *y1) * (j - *j1) / (*j2 - *j1 + 1);
/*<          YT = Y1 + ((Y2 - Y1) * (J - J1 + 1)) / (J2 - J1 + 1) >*/
	yt = *y1 + (*y2 - *y1) * (j - *j1 + 1) / (*j2 - *j1 + 1);
/*<          DO 10 I = I1, I2 >*/
	i__2 = *i2;
	for (i__ = *i1; i__ <= i__2; ++i__) {

/* Need to change color? */

/*<             IF (IA(I, J) .NE. LSTCOL) THEN >*/
	    if (ia[i__ + j * ia_dim1] != lstcol) {
/*<                CALL GRSCI(IA(I, J)) >*/
		grsci_(&ia[i__ + j * ia_dim1]);
/*<                LSTCOL = IA(I, J) >*/
		lstcol = ia[i__ + j * ia_dim1];
/*<             ENDIF >*/
	    }

/* Output rectangle */

/*<    >*/
	    r__1 = *x1 + (*x2 - *x1) * (i__ - *i1) / (*i2 - *i1 + 1);
	    r__2 = *x1 + (*x2 - *x1) * (i__ - *i1 + 1) / (*i2 - *i1 + 1);
	    grrec0_(&r__1, &yb, &r__2, &yt);
/*<   10     CONTINUE >*/
/* L10: */
	}
/*<   20  CONTINUE >*/
/* L20: */
    }

/* Restore color attribute */

/*<       CALL GRSCI(ICOL) >*/
    grsci_(&icol);
/*<       END >*/
} /* grpxre_ */

