/* /work2/ssa/pgplot/src/grrec0.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__24 = 24;
static integer c__20 = 20;
static integer c__1 = 1;
static integer c__3 = 3;

/* *GRREC0 -- fill a rectangle (device coordinates) */
/* + */
/*<       SUBROUTINE GRREC0 (X0,Y0,X1,Y1) >*/
/* Subroutine */ int grrec0_(x0, y0, x1, y1)
real *x0, *y0, *x1, *y1;
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[6], xmin, ymin, xmax, ymax;
    static integer i__;
    static real y;
    extern /* Subroutine */ int grqls_(), grsls_(), grqlw_(), grslw_(), 
	    grlin0_();
    static real dy;
    static integer ls, lw;
    extern /* Subroutine */ int grbpic_(), grexec_();
    static integer nlines;
    static char chr[32];

/*<       REAL X0, Y0, X1, Y1 >*/

/* GRPCKG: Fill a rectangle with solid color.  The rectangle */
/* is defined by the (x,y) device coordinates of its lower left and */
/* upper right corners; the edges are parallel to the coordinate axes. */
/* X0 is guaranteed to be <= X1 and Y0 <= Y1. The rectangle possible */
/* extends beyond the clipping boundaries */

/* Arguments: */

/* X0, Y0 (input, real): device coordinates of one corner of the */
/*       rectangle. */
/* X1, Y1 (input, real): device coordinates of the opposite corner of */
/*       the rectangle. */
/* -- */
/* 23-Mar-1988 - [TJP]. */
/* 18-Jan-1991 - Code moved from GRRECT to GRREC0 so that it can also be */
/*               used by GRPXRE. */
/*  1-Sep-1994 - suppress driver call [TJP]. */
/*  4-Dec-1995 - avoid use of real variable as do-loop index [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       REAL    RBUF(6) >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER NBUF,LCHR >*/
/*<       CHARACTER*32 CHR >*/
/*<       REAL    XMIN, YMIN, XMAX, YMAX, Y, DY >*/
/*<       INTEGER LS, LW, I, NLINES >*/

/* Clip */

/*<       XMIN = X0 >*/
    xmin = *x0;
/*<       XMAX = X1 >*/
    xmax = *x1;
/*<       YMIN = Y0 >*/
    ymin = *y0;
/*<       YMAX = Y1 >*/
    ymax = *y1;
/*<       IF (XMIN .LT. GRXMIN(GRCIDE)) XMIN = GRXMIN(GRCIDE) >*/
    if (xmin < grcm00_1.grxmin[grcm00_1.grcide - 1]) {
	xmin = grcm00_1.grxmin[grcm00_1.grcide - 1];
    }
/*<       IF (XMAX .GT. GRXMAX(GRCIDE)) XMAX = GRXMAX(GRCIDE) >*/
    if (xmax > grcm00_1.grxmax[grcm00_1.grcide - 1]) {
	xmax = grcm00_1.grxmax[grcm00_1.grcide - 1];
    }
/*<       IF (YMIN .LT. GRYMIN(GRCIDE)) YMIN = GRYMIN(GRCIDE) >*/
    if (ymin < grcm00_1.grymin[grcm00_1.grcide - 1]) {
	ymin = grcm00_1.grymin[grcm00_1.grcide - 1];
    }
/*<       IF (YMAX .GT. GRYMAX(GRCIDE)) YMAX = GRYMAX(GRCIDE) >*/
    if (ymax > grcm00_1.grymax[grcm00_1.grcide - 1]) {
	ymax = grcm00_1.grymax[grcm00_1.grcide - 1];
    }
/*<       IF (XMIN .GT. XMAX) RETURN >*/
    if (xmin > xmax) {
	return 0;
    }
/*<       IF (YMIN .GT. YMAX) RETURN >*/
    if (ymin > ymax) {
	return 0;
    }

/* Use hardware rectangle fill if available. */

/*<       IF (GRGCAP(GRCIDE)(6:6).EQ.'R') THEN >*/
    if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 5] == 
	    'R') {
/*<           IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
	if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	    grbpic_();
	}
/*<           RBUF(1) = XMIN >*/
	rbuf[0] = xmin;
/*<           RBUF(2) = YMIN >*/
	rbuf[1] = ymin;
/*<           RBUF(3) = XMAX >*/
	rbuf[2] = xmax;
/*<           RBUF(4) = YMAX >*/
	rbuf[3] = ymax;
/*<           CALL GREXEC(GRGTYP,24,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__24, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<           RETURN >*/
	return 0;

/* Else use hardware polygon fill if available. */

/*<       ELSE IF (GRGCAP(GRCIDE)(4:4).EQ.'A') THEN >*/
    } else if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 
	    + 3] == 'A') {
/*<           IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
	if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	    grbpic_();
	}
/*<           RBUF(1) = 4 >*/
	rbuf[0] = (float)4.;
/*<           CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<           RBUF(1) = XMIN >*/
	rbuf[0] = xmin;
/*<           RBUF(2) = YMIN >*/
	rbuf[1] = ymin;
/*<           CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<           RBUF(1) = XMAX >*/
	rbuf[0] = xmax;
/*<           RBUF(2) = YMIN >*/
	rbuf[1] = ymin;
/*<           CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<           RBUF(1) = XMAX >*/
	rbuf[0] = xmax;
/*<           RBUF(2) = YMAX >*/
	rbuf[1] = ymax;
/*<           CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<           RBUF(1) = XMIN >*/
	rbuf[0] = xmin;
/*<           RBUF(2) = YMAX >*/
	rbuf[1] = ymax;
/*<           CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* For other devices fill area is simulated. */

/* Save attributes. */

/*<       CALL GRQLS(LS) >*/
    grqls_(&ls);
/*<       CALL GRQLW(LW) >*/
    grqlw_(&lw);
/*<       CALL GRSLS(1) >*/
    grsls_(&c__1);
/*<       CALL GRSLW(1) >*/
    grslw_(&c__1);
/*<       CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__3, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
/*<       DY = RBUF(3) >*/
    dy = rbuf[2];

/* Draw horizontal raster lines. */

/*<       NLINES = ABS((YMAX-YMIN)/DY) >*/
    nlines = (r__1 = (ymax - ymin) / dy, dabs(r__1));
/*<       Y = YMIN - DY/2.0 >*/
    y = ymin - dy / (float)2.;
/*<       DO 40 I=1,NLINES >*/
    i__1 = nlines;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<          Y = Y + DY >*/
	y += dy;
/*<          GRXPRE(GRCIDE) = XMIN >*/
	grcm00_1.grxpre[grcm00_1.grcide - 1] = xmin;
/*<          GRYPRE(GRCIDE) = Y >*/
	grcm00_1.grypre[grcm00_1.grcide - 1] = y;
/*<          CALL GRLIN0(XMAX,Y) >*/
	grlin0_(&xmax, &y);
/*<    40 CONTINUE >*/
/* L40: */
    }

/* Restore attributes. */

/*<       CALL GRSLS(LS) >*/
    grsls_(&ls);
/*<       CALL GRSLW(LW) >*/
    grslw_(&lw);
/*<       END >*/
} /* grrec0_ */

