/* /work2/ssa/pgplot/src/grscr.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__21 = 21;
static integer c__15 = 15;

/* *GRSCR -- set color representation */
/* + */
/*<       SUBROUTINE GRSCR (CI, CR, CG, CB) >*/
/* Subroutine */ int grscr_(ci, cr, cg, cb)
integer *ci;
real *cr, *cg, *cb;
{
    static integer lchr, nbuf;
    static real rbuf[6];
    extern /* Subroutine */ int grexec_(), grwarn_();
    static char chr[1];

/*<       INTEGER  CI >*/
/*<       REAL     CR, CG, CB >*/

/* GRPCKG: SET COLOUR REPRESENTATION -- define the colour to be */
/* associated with a colour index.  Ignored for devices which do not */
/* support variable colour or intensity.  On monochrome output */
/* devices (e.g. VT125 terminals with monochrome monitors), the */
/* monochrome intensity is computed from the specified Red, Green, Blue */
/* intensities as 0.30*R + 0.59*G + 0.11*B, as in US color television */
/* systems, NTSC encoding.  Note that most devices do not have an */
/* infinite range of colours or monochrome intensities available; */
/* the nearest available colour is used. */

/* Arguments: */

/* CI (integer, input): colour index. If the colour index is outside the */
/*       range available on the device, the call is ignored. Colour */
/*       index 0 applies to the background colour. */
/* CR, CG, CB (real, input): red, green, and blue intensities, */
/*       in range 0.0 to 1.0. */
/* -- */
/* 20-Feb-1984 - [TJP]. */
/*  5-Jun-1984 - add GMFILE device [TJP]. */
/*  2-Jul-1984 - add REGIS device [TJP]. */
/*  2-Oct-1984 - change use of map tables in Regis [TJP]. */
/* 11-Nov-1984 - add code for /TK [TJP]. */
/*  1-Sep-1986 - add GREXEC support [AFT]. */
/* 21-Feb-1987 - If needed, calls begin picture [AFT]. */
/* 31-Aug-1994 - suppress call of begin picture [TJP]. */
/*  1-Sep-1994 - use common data [TJP]. */
/* 26-Jul-1995 - fix bug: some drivers would ignore a change to the */
/*               current color [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER   NBUF, LCHR >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL      RBUF(6) >*/
/*<       CHARACTER CHR >*/

/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*<           CALL GRWARN('GRSCR - Specified workstation is not open.') >*/
	grwarn_("GRSCR - Specified workstation is not open.", (ftnlen)42);
/*<    >*/
    } else if (*cr < (float)0. || *cg < (float)0. || *cb < (float)0. || *cr > 
	    (float)1. || *cg > (float)1. || *cb > (float)1.) {
/*<           CALL GRWARN('GRSCR - Colour is outside range [0,1].') >*/
	grwarn_("GRSCR - Colour is outside range [0,1].", (ftnlen)38);
/*<       ELSE IF (CI.GE.GRMNCI(GRCIDE) .AND. CI.LE.GRMXCI(GRCIDE)) THEN >*/
    } else if (*ci >= grcm00_1.grmnci[grcm00_1.grcide - 1] && *ci <= 
	    grcm00_1.grmxci[grcm00_1.grcide - 1]) {
/*         IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC */
/*<           RBUF(1)=CI >*/
	rbuf[0] = (real) (*ci);
/*<           RBUF(2)=CR >*/
	rbuf[1] = *cr;
/*<           RBUF(3)=CG >*/
	rbuf[2] = *cg;
/*<           RBUF(4)=CB >*/
	rbuf[3] = *cb;
/*<           NBUF=4 >*/
	nbuf = 4;
/*<           CALL GREXEC(GRGTYP,21,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__21, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*         -- If this is the current color, reselect it in the driver. */
/*<           IF (CI.EQ.GRCCOL(GRCIDE)) THEN >*/
	if (*ci == grcm00_1.grccol[grcm00_1.grcide - 1]) {
/*<              RBUF(1) = CI >*/
	    rbuf[0] = (real) (*ci);
/*<              CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR) >*/
	    grexec_(&grcm00_1.grgtyp, &c__15, rbuf, &nbuf, chr, &lchr, (
		    ftnlen)1);
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/*<       END >*/
} /* grscr_ */

