/* /work2/ssa/pgplot/src/grsls.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__19 = 19;

/* *GRSLS -- set line style */
/* + */
/*<       SUBROUTINE GRSLS (IS) >*/
/* Subroutine */ int grsls_(is)
integer *is;
{
    /* Initialized data */

    static real patern[40]	/* was [8][5] */ = { (float)10.,(float)10.,(
	    float)10.,(float)10.,(float)10.,(float)10.,(float)10.,(float)10.,(
	    float)10.,(float)10.,(float)10.,(float)10.,(float)10.,(float)10.,(
	    float)10.,(float)10.,(float)8.,(float)6.,(float)1.,(float)6.,(
	    float)8.,(float)6.,(float)1.,(float)6.,(float)1.,(float)6.,(float)
	    1.,(float)6.,(float)1.,(float)6.,(float)1.,(float)6.,(float)8.,(
	    float)6.,(float)1.,(float)6.,(float)1.,(float)6.,(float)1.,(float)
	    6. };

    static integer lchr, nbuf;
    static real rbuf[6];
    static integer i__, l, idash;
    extern /* Subroutine */ int grexec_(), grwarn_();
    static char chr[10];
    static real tmp;

/*<       INTEGER IS >*/

/* GRPCKG: Set the line style for subsequent plotting on the current */
/* device. The different line styles are generated in hardware on */
/* some devices and by GRPCKG software for the other devices. Five */
/* different line styles are available, with the following codes: */
/* 1 (full line), 2 (dashed), 3 (dot-dash-dot-dash), 4 (dotted), */
/* 5 (dash-dot-dot-dot). The default is 1 (normal full line). Line */
/* style is ignored when drawing characters, which are always drawn with */
/* a full line. */

/* Argument: */

/* IS (input, integer): the line-style code for subsequent plotting on */
/*       the current device (in range 1-5). */
/* -- */
/*  9-Feb-1983 - [TJP]. */
/*  3-Jun-1984 - add GMFILE device [TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 21-Feb-1987 - If needed, calls begin picture [AFT]. */
/* 19-Jan-1987 - fix bug in GREXEC call [TJP]. */
/* 16-May-1989 - fix bug for hardware line dash [TJP]. */
/*  1-Sep-1994 - do not call driver to get size and capabilities [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER I, L, IDASH, NBUF,LCHR >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL    RBUF(6),TMP >*/
/*<       CHARACTER*10 CHR >*/
/*<       REAL PATERN(8,5) >*/

/*<    >*/

/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*<           CALL GRWARN('GRSLS - no graphics device is active.') >*/
	grwarn_("GRSLS - no graphics device is active.", (ftnlen)37);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/*<       I = IS >*/
    i__ = *is;
/*<       IF (I.LT.1 .OR. I.GT.5) THEN >*/
    if (i__ < 1 || i__ > 5) {
/*<           CALL GRWARN('GRSLS - invalid line-style requested.') >*/
	grwarn_("GRSLS - invalid line-style requested.", (ftnlen)37);
/*<           I = 1 >*/
	i__ = 1;
/*<       END IF >*/
    }

/* Inquire if hardware dash is available. */

/*<       IDASH=0 >*/
    idash = 0;
/*<       IF(GRGCAP(GRCIDE)(3:3).EQ.'D') IDASH=1 >*/
    if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 2] == 
	    'D') {
	idash = 1;
    }

/* Set up for hardware dash. */

/*<       IF(IDASH.NE.0) THEN >*/
    if (idash != 0) {
/*<           GRDASH(GRCIDE) = .FALSE. >*/
	grcm00_1.grdash[grcm00_1.grcide - 1] = FALSE_;
/*<           IF (GRPLTD(GRCIDE)) THEN >*/
	if (grcm00_1.grpltd[grcm00_1.grcide - 1]) {
/*<               RBUF(1)=I >*/
	    rbuf[0] = (real) i__;
/*<               NBUF=1 >*/
	    nbuf = 1;
/*<               CALL GREXEC(GRGTYP,19,RBUF,NBUF,CHR,LCHR) >*/
	    grexec_(&grcm00_1.grgtyp, &c__19, rbuf, &nbuf, chr, &lchr, (
		    ftnlen)10);
/*<           END IF >*/
	}

/* Set up for software dash. */

/*<       ELSE >*/
    } else {
/*<           IF (I.EQ.1) THEN >*/
	if (i__ == 1) {
/*<               GRDASH(GRCIDE) = .FALSE. >*/
	    grcm00_1.grdash[grcm00_1.grcide - 1] = FALSE_;
/*<           ELSE >*/
	} else {
/*<               GRDASH(GRCIDE) = .TRUE. >*/
	    grcm00_1.grdash[grcm00_1.grcide - 1] = TRUE_;
/*<               GRIPAT(GRCIDE) = 1 >*/
	    grcm00_1.gripat[grcm00_1.grcide - 1] = 1;
/*<               GRPOFF(GRCIDE) = 0.0 >*/
	    grcm00_1.grpoff[grcm00_1.grcide - 1] = (float)0.;
/*<               TMP = GRYMXA(GRCIDE)/1000. >*/
	    tmp = grcm00_1.grymxa[grcm00_1.grcide - 1] / (float)1e3;
/*<               DO 10 L=1,8 >*/
	    for (l = 1; l <= 8; ++l) {
/*<                   GRPATN(GRCIDE,L) = PATERN(L,I)*TMP >*/
		grcm00_1.grpatn[grcm00_1.grcide + (l << 3) - 9] = patern[l + (
			i__ << 3) - 9] * tmp;
/*<    10         CONTINUE >*/
/* L10: */
	    }
/*<           END IF >*/
	}
/*<       END IF >*/
    }
/*<       GRSTYL(GRCIDE) = I >*/
    grcm00_1.grstyl[grcm00_1.grcide - 1] = i__;
/*<       END >*/
} /* grsls_ */

