/* /work2/ssa/pgplot/src/grtext.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__1 = 1;
static integer c__3 = 3;
static integer c__23 = 23;
static integer c__0 = 0;
static real c_b14 = (float)0.;
static real c_b19 = (float).75;

/* *GRTEXT -- draw text */
/* + */
/*<       SUBROUTINE GRTEXT (CENTER,ORIENT,ABSXY,X0,Y0,STRING) >*/
/* Subroutine */ int grtext_(center, orient, absxy, x0, y0, string, 
	string_len)
logical *center;
real *orient;
logical *absxy;
real *x0, *y0;
char *string;
ftnlen string_len;
{
    /* System generated locals */
    address a__1[3];
    integer i__1[3], i__2, i__3;

    /* Builtin functions */
    integer i_len(), s_cmp();
    /* Subroutine */ int s_cat();
    double cos(), sin(), pow_ri();

    /* Local variables */
    static real cosa, sina, rbuf[6];
    static integer slen, list[256];
    static real xmin, xmax, ymin, xorg, yorg, xcur, ycur, ymax;
    static integer i__, k;
    static real angle, ratio;
    static char stemp[258];
    static integer nlist;
    extern /* Subroutine */ int grqls_(), grsls_();
    static logical vtext;
    extern /* Subroutine */ int grlin0_();
    static real dx, dy;
    extern /* Subroutine */ int grtxy0_();
    static real fntfac;
    extern /* Subroutine */ int grarea_();
    static integer lx, ly;
    static real factor, fntbas;
    extern /* Subroutine */ int grexec_();
    static logical visble, devint;
    extern /* Subroutine */ int grgenv_();
    static logical unused;
    static integer xygrid[300], ifntlv, lxlast, lylast, lstyle;
    extern integer grtrim_();
    static char devtyp[14];
    extern /* Subroutine */ int grwarn_(), grqtyp_(), grsyds_(), grsyxd_();
    static real rlx, rly;


/* GRPCKG: Write a text string using the high-quality character set. */
/* The text is NOT windowed in the current viewport, but may extend over */
/* the whole view surface.  Line attributes (color, intensity thickness) */
/* apply to text, but line-style is ignored.  The current pen position */
/* after a call to GRTEXT is undefined. */

/* Arguments: */

/* STRING (input, character): the character string to be plotted. This */
/*       may include standard escape-sequences to represent non-ASCII */
/*       characters and special commands. The number of characters in */
/*       STRING (i.e., LEN(STRING)) should not exceed 256. */
/* -- */
/* (3-May-1983) */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/*  6-Sep-1989 - standardize [TJP]. */
/* 20-Apr-1995 - Verbose PS file support.  If PGPLOT_PS_VERBOSE_TEXT is */
/*               defined, text strings in PS files are preceded by a */
/*               comment with the text of the string plotted as vectors */
/*               [TJP after D.S.Briggs]. */
/*  4-Feb-1997 - grexec requires an RBUF array, not a scalar [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       LOGICAL ABSXY,UNUSED,VISBLE,CENTER >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER XYGRID(300) >*/
/*<       INTEGER LIST(256) >*/
/*<       CHARACTER*(*) STRING >*/
/*<       REAL ANGLE, FACTOR, FNTBAS, FNTFAC, COSA, SINA, DX, DY, XORG, YORG >*/
/*<       REAL XCUR, YCUR, ORIENT, RATIO, X0, Y0, RLX, RLY >*/
/*<       REAL XMIN, XMAX, YMIN, YMAX >*/
/*<       REAL RBUF(6) >*/
/*<       INTEGER I, IFNTLV,NLIST,LX,LY, K, LXLAST,LYLAST, LSTYLE >*/
/*<       INTEGER SLEN, GRTRIM >*/
/*<       INTRINSIC ABS, COS, LEN, MIN, SIN >*/
/*<       CHARACTER DEVTYP*14, STEMP*258 >*/
/*<       LOGICAL DEVINT, VTEXT >*/

/* Check that there is something to be plotted. */

/*<       IF (LEN(STRING).LE.0) RETURN >*/
    if (i_len(string, string_len) <= 0) {
	return 0;
    }

/* Check that a device is selected. */

/*<       IF (GRCIDE.LT.1) THEN >*/
    if (grcm00_1.grcide < 1) {
/*<           CALL GRWARN('GRTEXT - no graphics device is active.') >*/
	grwarn_("GRTEXT - no graphics device is active.", (ftnlen)38);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Save current line-style, and set style "normal". */

/*<       CALL GRQLS(LSTYLE) >*/
    grqls_(&lstyle);
/*<       CALL GRSLS(1) >*/
    grsls_(&c__1);

/* Put device dependent code here or at end */

/*<       VTEXT = .FALSE. >*/
    vtext = FALSE_;
/*<       CALL GRQTYP (DEVTYP, DEVINT) >*/
    grqtyp_(devtyp, &devint, (ftnlen)14);
/*<    >*/
    if (s_cmp(devtyp, "PS", (ftnlen)14, (ftnlen)2) == 0 || s_cmp(devtyp, 
	    "VPS", (ftnlen)14, (ftnlen)3) == 0 || s_cmp(devtyp, "CPS", (
	    ftnlen)14, (ftnlen)3) == 0 || s_cmp(devtyp, "VCPS", (ftnlen)14, (
	    ftnlen)4) == 0) {
/*<          CALL GRGENV ('PS_VERBOSE_TEXT', STEMP, I) >*/
	grgenv_("PS_VERBOSE_TEXT", stemp, &i__, (ftnlen)15, (ftnlen)258);
/*<          VTEXT = (I.GT.0) >*/
	vtext = i__ > 0;
/*<          IF (VTEXT) THEN >*/
	if (vtext) {
/*<             SLEN = GRTRIM(STRING) >*/
	    slen = grtrim_(string, string_len);
/*<             STEMP = '% Start "' // STRING(1:SLEN) // '"' >*/
/* Writing concatenation */
	    i__1[0] = 9, a__1[0] = "% Start \"";
	    i__1[1] = slen, a__1[1] = string;
	    i__1[2] = 1, a__1[2] = "\"";
	    s_cat(stemp, a__1, i__1, &c__3, (ftnlen)258);
/*<             CALL GREXEC (GRGTYP, 23, RBUF, 0, STEMP, SLEN+10) >*/
	    i__2 = slen + 10;
	    grexec_(&grcm00_1.grgtyp, &c__23, rbuf, &c__0, stemp, &i__2, (
		    ftnlen)258);
/*<          END IF >*/
	}
/*<       END IF >*/
    }

/* Save current viewport, and open the viewport to include the full */
/* view surface. */

/*<       XORG = GRXPRE(GRCIDE) >*/
    xorg = grcm00_1.grxpre[grcm00_1.grcide - 1];
/*<       YORG = GRYPRE(GRCIDE) >*/
    yorg = grcm00_1.grypre[grcm00_1.grcide - 1];
/*<       XMIN = GRXMIN(GRCIDE) >*/
    xmin = grcm00_1.grxmin[grcm00_1.grcide - 1];
/*<       XMAX = GRXMAX(GRCIDE) >*/
    xmax = grcm00_1.grxmax[grcm00_1.grcide - 1];
/*<       YMIN = GRYMIN(GRCIDE) >*/
    ymin = grcm00_1.grymin[grcm00_1.grcide - 1];
/*<       YMAX = GRYMAX(GRCIDE) >*/
    ymax = grcm00_1.grymax[grcm00_1.grcide - 1];
/*<       CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0) >*/
    grarea_(&grcm00_1.grcide, &c_b14, &c_b14, &c_b14, &c_b14);

/* Compute scaling and orientation. */

/*<       ANGLE = ORIENT*(3.14159265359/180.) >*/
    angle = *orient * (float).017453292519944444;
/*<       FACTOR = GRCFAC(GRCIDE)/2.5 >*/
    factor = grcm00_1.grcfac[grcm00_1.grcide - 1] / (float)2.5;
/*<       RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE) >*/
    ratio = grcm00_1.grpxpi[grcm00_1.grcide - 1] / grcm00_1.grpypi[
	    grcm00_1.grcide - 1];
/*<       COSA = FACTOR * COS(ANGLE) >*/
    cosa = factor * cos(angle);
/*<       SINA = FACTOR * SIN(ANGLE) >*/
    sina = factor * sin(angle);
/*<       CALL GRTXY0(ABSXY, X0, Y0, XORG, YORG) >*/
    grtxy0_(absxy, x0, y0, &xorg, &yorg);
/*<       FNTBAS = 0.0 >*/
    fntbas = (float)0.;
/*<       FNTFAC = 1.0 >*/
    fntfac = (float)1.;
/*<       IFNTLV = 0 >*/
    ifntlv = 0;
/*<       DX = 0.0 >*/
    dx = (float)0.;
/*<       DY = 0.0 >*/
    dy = (float)0.;

/* Convert the string to a list of symbol numbers; to prevent overflow */
/* of array LIST, the length of STRING is limited to 256 characters. */

/*<    >*/
/* Computing MIN */
    i__2 = 256, i__3 = i_len(string, string_len);
    grsyds_(list, &nlist, string, &grcm00_1.grcfnt[grcm00_1.grcide - 1], (min(
	    i__2,i__3)));

/* Plot the string of characters */

/*<       DO 380 I = 1,NLIST >*/
    i__2 = nlist;
    for (i__ = 1; i__ <= i__2; ++i__) {
/*<           IF (LIST(I).LT.0) THEN >*/
	if (list[i__ - 1] < 0) {
/*<               IF (LIST(I).EQ.-1) THEN >*/
	    if (list[i__ - 1] == -1) {
/*                 ! up */
/*<                   IFNTLV = IFNTLV+1 >*/
		++ifntlv;
/*<                   FNTBAS = FNTBAS + 16.0*FNTFAC >*/
		fntbas += fntfac * (float)16.;
/*<                   FNTFAC = 0.75**ABS(IFNTLV) >*/
		i__3 = abs(ifntlv);
		fntfac = pow_ri(&c_b19, &i__3);
/*<               ELSE IF (LIST(I).EQ.-2) THEN >*/
	    } else if (list[i__ - 1] == -2) {
/*                 ! down */
/*<                   IFNTLV = IFNTLV-1 >*/
		--ifntlv;
/*<                   FNTFAC = 0.75**ABS(IFNTLV) >*/
		i__3 = abs(ifntlv);
		fntfac = pow_ri(&c_b19, &i__3);
/*<                   FNTBAS = FNTBAS - 16.0*FNTFAC >*/
		fntbas -= fntfac * (float)16.;
/*<               ELSE IF (LIST(I).EQ.-3) THEN >*/
	    } else if (list[i__ - 1] == -3) {
/*                 ! backspace */
/*<                   XORG = XORG - DX*FNTFAC >*/
		xorg -= dx * fntfac;
/*<                   YORG = YORG - DY*FNTFAC >*/
		yorg -= dy * fntfac;
/*<               END IF >*/
	    }
/*<               GOTO 380 >*/
	    goto L380;
/*<           END IF >*/
	}
/*<           CALL GRSYXD(LIST(I),XYGRID,UNUSED) >*/
	grsyxd_(&list[i__ - 1], xygrid, &unused);
/*<           VISBLE = .FALSE. >*/
	visble = FALSE_;
/*<           LX = XYGRID(5)-XYGRID(4) >*/
	lx = xygrid[4] - xygrid[3];
/*<           DX = COSA*LX*RATIO >*/
	dx = cosa * lx * ratio;
/*<           DY = SINA*LX >*/
	dy = sina * lx;
/*<           K = 4 >*/
	k = 4;
/*<           LXLAST = -64 >*/
	lxlast = -64;
/*<           LYLAST = -64 >*/
	lylast = -64;
/*<   320     K = K+2 >*/
L320:
	k += 2;
/*<           LX = XYGRID(K) >*/
	lx = xygrid[k - 1];
/*<           LY = XYGRID(K+1) >*/
	ly = xygrid[k];
/*<           IF (LY.EQ.-64) GOTO 330 >*/
	if (ly == -64) {
	    goto L330;
	}
/*<           IF (LX.EQ.-64) THEN >*/
	if (lx == -64) {
/*<               VISBLE = .FALSE. >*/
	    visble = FALSE_;
/*<           ELSE >*/
	} else {
/*<               RLX = (LX - XYGRID(4))*FNTFAC >*/
	    rlx = (lx - xygrid[3]) * fntfac;
/*<               RLY = (LY - XYGRID(2))*FNTFAC + FNTBAS >*/
	    rly = (ly - xygrid[1]) * fntfac + fntbas;
/*<               IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN >*/
	    if (lx != lxlast || ly != lylast) {
/*<                   XCUR = XORG + (COSA*RLX - SINA*RLY)*RATIO >*/
		xcur = xorg + (cosa * rlx - sina * rly) * ratio;
/*<                   YCUR = YORG + (SINA*RLX + COSA*RLY) >*/
		ycur = yorg + (sina * rlx + cosa * rly);
/*<                   IF (VISBLE) THEN >*/
		if (visble) {
/*<                       CALL GRLIN0(XCUR,YCUR) >*/
		    grlin0_(&xcur, &ycur);
/*<                   ELSE >*/
		} else {
/*<                       GRXPRE(GRCIDE) = XCUR >*/
		    grcm00_1.grxpre[grcm00_1.grcide - 1] = xcur;
/*<                       GRYPRE(GRCIDE) = YCUR >*/
		    grcm00_1.grypre[grcm00_1.grcide - 1] = ycur;
/*<                   END IF >*/
		}
/*<               END IF >*/
	    }
/*<               VISBLE = .TRUE. >*/
	    visble = TRUE_;
/*<               LXLAST = LX >*/
	    lxlast = lx;
/*<               LYLAST = LY >*/
	    lylast = ly;
/*<           END IF >*/
	}
/*<           GOTO 320 >*/
	goto L320;
/*<   330     XORG = XORG + DX*FNTFAC >*/
L330:
	xorg += dx * fntfac;
/*<           YORG = YORG + DY*FNTFAC >*/
	yorg += dy * fntfac;
/*<   380 CONTINUE >*/
L380:
	;
    }

/* Set pen position ready for next character. */

/*<       GRXPRE(GRCIDE) = XORG >*/
    grcm00_1.grxpre[grcm00_1.grcide - 1] = xorg;
/*<       GRYPRE(GRCIDE) = YORG >*/
    grcm00_1.grypre[grcm00_1.grcide - 1] = yorg;

/* Another possible device dependent section */

/*<       IF (VTEXT) THEN >*/
    if (vtext) {
/*<          STEMP = '% End "' // STRING(1:SLEN) // '"' >*/
/* Writing concatenation */
	i__1[0] = 7, a__1[0] = "% End \"";
	i__1[1] = slen, a__1[1] = string;
	i__1[2] = 1, a__1[2] = "\"";
	s_cat(stemp, a__1, i__1, &c__3, (ftnlen)258);
/*<          CALL GREXEC(GRGTYP, 23, RBUF, 0, STEMP, SLEN+8) >*/
	i__2 = slen + 8;
	grexec_(&grcm00_1.grgtyp, &c__23, rbuf, &c__0, stemp, &i__2, (ftnlen)
		258);
/*<       END IF >*/
    }

/* Restore the viewport and line-style, and return. */

/*<       GRXMIN(GRCIDE) = XMIN >*/
    grcm00_1.grxmin[grcm00_1.grcide - 1] = xmin;
/*<       GRXMAX(GRCIDE) = XMAX >*/
    grcm00_1.grxmax[grcm00_1.grcide - 1] = xmax;
/*<       GRYMIN(GRCIDE) = YMIN >*/
    grcm00_1.grymin[grcm00_1.grcide - 1] = ymin;
/*<       GRYMAX(GRCIDE) = YMAX >*/
    grcm00_1.grymax[grcm00_1.grcide - 1] = ymax;
/*<       CALL GRSLS(LSTYLE) >*/
    grsls_(&lstyle);

/*<       END >*/
} /* grtext_ */

