/* /work2/ssa/pgplot/src/grtrim.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRTRIM -- length of string excluding trailing blanks */
/* + */
/*<       INTEGER FUNCTION GRTRIM(S) >*/
integer grtrim_(s, s_len)
char *s;
ftnlen s_len;
{
    /* System generated locals */
    integer ret_val;

    /* Builtin functions */
    integer s_cmp(), i_len();

    /* Local variables */
    static integer i__;

/*<       CHARACTER*(*) S >*/

/* Find the length of a character string excluding trailing blanks. */
/* A blank string returns a value of 0. */

/* Argument: */
/*  S      (input)  : character string. */

/* Returns: */
/*  GRTRIM          : number of characters in S, excluding trailing */
/*                    blanks, in range 0...LEN(S). A blank string */
/*                    returns a value of 0. */

/* Subroutines required: */
/*  None */

/* Fortran 77 extensions: */
/*  None */

/* History: */
/*  1987 Nov 12 - TJP. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I >*/

/*<       IF (S.EQ.' ') THEN >*/
    if (s_cmp(s, " ", s_len, (ftnlen)1) == 0) {
/*<           GRTRIM = 0 >*/
	ret_val = 0;
/*<       ELSE >*/
    } else {
/*<           DO 10 I=LEN(S),1,-1 >*/
	for (i__ = i_len(s, s_len); i__ >= 1; --i__) {
/*<               GRTRIM = I >*/
	    ret_val = i__;
/*<               IF (S(I:I).NE.' ') GOTO 20 >*/
	    if (*(unsigned char *)&s[i__ - 1] != ' ') {
		goto L20;
	    }
/*<    10     CONTINUE >*/
/* L10: */
	}
/*<           GRTRIM = 0 >*/
	ret_val = 0;
/*<    20     CONTINUE >*/
L20:
/*<       END IF >*/
	;
    }
/*<       END >*/
    return ret_val;
} /* grtrim_ */

