/* /work2/ssa/pgplot/src/pgcl.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__1 = 1;
static integer c__0 = 0;
static real c_b4 = (float).5;


/*<       SUBROUTINE PGCL (K, X, Y, Z) >*/
/* Subroutine */ int pgcl_(k, x, y, z__)
integer *k;
real *x, *y, *z__;
{
    /* Initialized data */

    static integer i__ = 0;

    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    double atan2();

    /* Local variables */
    static real xbox[4], ybox[4], angle, dindx, dindy;
    extern /* Subroutine */ int pgqvp_();
    static integer tb;
    static real xc, yc, yb, xl, xn, yn, xo, xr, yo, xp, xx, yy, yt, yp;
    extern /* Subroutine */ int pgqtbg_(), pgstbg_(), pgqpos_(), pgqwin_(), 
	    pgmove_(), pgptxt_(), pgqtxt_();
    static real xv1, xv2, yv1, yv2;

/*<       INTEGER K >*/
/*<       REAL X, Y, Z >*/

/* PGPLOT (internal routine): Label one contour segment (for use by */
/* PGCONX). */

/* Arguments: */

/* K (input, integer): if K=0, move the pen to (X,Y); if K=1, draw */
/*       a line from the current position to (X,Y); otherwise */
/*       do nothing. */
/* X (input, real): X world-coordinate of end point. */
/* Y (input, real): Y world-coordinate of end point. */
/* Z (input, real): the value of the contour level, not used by PGCL. */
/* -- */
/*  5-May-1994 - new routine [TJP] */
/*  7-Mar-1995 - correct error in angle; do not draw labels outside */
/*               window [TJP]. */
/* 28-Aug-1995 - check arguments of atan2 [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       REAL     XX, YY, XC, YC, XV1, XV2, YV1, YV2, XL, XR, YB, YT >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     XN, YN >*/
/*<       REAL     ANGLE, XO, YO, XP, YP, DINDX, DINDY, XBOX(4), YBOX(4) >*/
/*<       INTEGER  I, TB >*/
/*<       SAVE     I >*/
/*<       DATA     I /0/ >*/

/*     -- transform to world coordinates */
/*<       XX = TRANS(1) + TRANS(2)*X + TRANS(3)*Y >*/
    xx = pgplt1_1.trans[0] + pgplt1_1.trans[1] * *x + pgplt1_1.trans[2] * *y;
/*<       YY = TRANS(4) + TRANS(5)*X + TRANS(6)*Y >*/
    yy = pgplt1_1.trans[3] + pgplt1_1.trans[4] * *x + pgplt1_1.trans[5] * *y;

/*<       IF (K.EQ.0) THEN >*/
    if (*k == 0) {
/*        -- start of contour: reset segment counter */
/*<          I = 0 >*/
	i__ = 0;
/*<       ELSE >*/
    } else {
/*        -- increment segment counter and check whether this */
/*           segment should be labelled */
/*<          I = MOD(I+1,PGCINT) >*/
	i__ = (i__ + 1) % pgplt1_1.pgcint;
/*<          IF (I.EQ.PGCMIN) THEN >*/
	if (i__ == pgplt1_1.pgcmin) {
/*           -- find center of this segment (XC, YC) */
/*<             CALL PGQPOS(XP, YP) >*/
	    pgqpos_(&xp, &yp);
/*<             XC = (XX+XP)*0.5 >*/
	    xc = (xx + xp) * (float).5;
/*<             YC = (YY+YP)*0.5 >*/
	    yc = (yy + yp) * (float).5;
/*            -- find slope of this segment (ANGLE) */
/*<             CALL PGQVP(1, XV1, XV2, YV1, YV2) >*/
	    pgqvp_(&c__1, &xv1, &xv2, &yv1, &yv2);
/*<             CALL PGQWIN(XL, XR, YB, YT) >*/
	    pgqwin_(&xl, &xr, &yb, &yt);
/*<             ANGLE = 0.0 >*/
	    angle = (float)0.;
/*<             IF (XR.NE.XL .AND. YT.NE.YB) THEN >*/
	    if (xr != xl && yt != yb) {
/*<                DINDX = (XV2 - XV1) / (XR - XL) >*/
		dindx = (xv2 - xv1) / (xr - xl);
/*<                DINDY = (YV2 - YV1) / (YT - YB) >*/
		dindy = (yv2 - yv1) / (yt - yb);
/*<    >*/
		if (yy - yp != (float)0. || xx - xp != (float)0.) {
		    angle = atan2((yy - yp) * dindy, (xx - xp) * dindx) * (
			    float)57.3;
		}
/*<             END IF >*/
	    }
/*           -- check whether point is in window */
/*<             XN = (XC-XL)/(XR-XL) >*/
	    xn = (xc - xl) / (xr - xl);
/*<             YN = (YC-YB)/(YT-YB) >*/
	    yn = (yc - yb) / (yt - yb);
/*<    >*/
	    if (xn >= (float)0. && xn <= (float)1. && yn >= (float)0. && yn <=
		     (float)1.) {
/*              -- save current text background and set to erase */
/*<                CALL PGQTBG(TB) >*/
		pgqtbg_(&tb);
/*<                CALL PGSTBG(0) >*/
		pgstbg_(&c__0);
/*              -- find bounding box of label */
/*<                CALL PGQTXT(XC, YC, ANGLE, 0.5, PGCLAB, XBOX, YBOX) >*/
		pgqtxt_(&xc, &yc, &angle, &c_b4, pgplt2_1.pgclab, xbox, ybox, 
			(ftnlen)32);
/*<                XO = 0.5*(XBOX(1)+XBOX(3)) >*/
		xo = (xbox[0] + xbox[2]) * (float).5;
/*<                YO = 0.5*(YBOX(1)+YBOX(3)) >*/
		yo = (ybox[0] + ybox[2]) * (float).5;
/*              -- plot label with bounding box centered at (XC, YC) */
/*<                CALL PGPTXT(2.0*XC-XO, 2.0*YC-YO, ANGLE, 0.5, PGCLAB) >*/
		r__1 = xc * (float)2. - xo;
		r__2 = yc * (float)2. - yo;
		pgptxt_(&r__1, &r__2, &angle, &c_b4, pgplt2_1.pgclab, (ftnlen)
			32);
/*              -- restore text background */
/*<                CALL PGSTBG(TB) >*/
		pgstbg_(&tb);
/*<             END IF >*/
	    }
/*<          END IF >*/
	}
/*<       END IF >*/
    }
/*<       CALL PGMOVE(XX,YY) >*/
    pgmove_(&xx, &yy);
/*<       END >*/
} /* pgcl_ */

