/* /work2/ssa/pgplot/src/pgcn01.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;

/*<    >*/
/* Subroutine */ int pgcn01_(z__, mx, my, ia, ib, ja, jb, z0, plot, flags, is,
	 js, sdir)
real *z__;
integer *mx, *my, *ia, *ib, *ja, *jb;
real *z0;
/* Subroutine */ int (*plot) ();
logical *flags;
integer *is, *js, *sdir;
{
    /* System generated locals */
    integer z_dim1, z_offset;

    /* Local variables */
    static integer i__, j;
    static real x, y;
    static integer ii, jj;
    static real startx, starty;
    static integer dir;


/* Support routine for PGCNSC. This routine draws a continuous contour, */
/* starting at the specified point, until it either crosses the edge of */
/* the array or closes on itself. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER UP, DOWN, LEFT, RIGHT >*/
/*<       PARAMETER (UP=1, DOWN=2, LEFT=3, RIGHT=4) >*/
/*<       INTEGER  MAXEMX, MAXEMY >*/
/*<       PARAMETER (MAXEMX=100, MAXEMY=100) >*/
/*<       LOGICAL FLAGS(MAXEMX,MAXEMY,2) >*/
/*<       INTEGER MX, MY, IA, IB, JA, JB, IS, JS, I, J, II, JJ, DIR, SDIR >*/
/*<       REAL Z(MX,*) >*/
/*<       REAL Z0, X, Y, STARTX, STARTY >*/
/*<       EXTERNAL PLOT >*/

/*<       I = IS >*/
    /* Parameter adjustments */
    z_dim1 = *mx;
    z_offset = 1 + z_dim1 * 1;
    z__ -= z_offset;
    flags -= 10101;

    /* Function Body */
    i__ = *is;
/*<       J = JS >*/
    j = *js;
/*<       DIR = SDIR >*/
    dir = *sdir;
/*<       II = 1+I-IA >*/
    ii = i__ + 1 - *ia;
/*<       JJ = 1+J-JA >*/
    jj = j + 1 - *ja;
/*<       IF (DIR.EQ.UP .OR. DIR.EQ.DOWN) THEN >*/
    if (dir == 1 || dir == 2) {
/*<           X = REAL(I) + (Z0-Z(I,J))/(Z(I+1,J)-Z(I,J)) >*/
	x = (real) i__ + (*z0 - z__[i__ + j * z_dim1]) / (z__[i__ + 1 + j * 
		z_dim1] - z__[i__ + j * z_dim1]);
/*<           Y = REAL(J) >*/
	y = (real) j;
/*<       ELSE >*/
    } else {
/*<           X = REAL(I) >*/
	x = (real) i__;
/*<           Y = REAL(J) + (Z0-Z(I,J))/(Z(I,J+1)-Z(I,J)) >*/
	y = (real) j + (*z0 - z__[i__ + j * z_dim1]) / (z__[i__ + (j + 1) * 
		z_dim1] - z__[i__ + j * z_dim1]);
/*<       END IF >*/
    }
/* D    WRITE (*,*) 'SEGMENT' */

/* Move to start of contour and record starting point. */

/*<       CALL PLOT(0, X, Y, Z0) >*/
    (*plot)(&c__0, &x, &y, z0);
/*<       STARTX = X >*/
    startx = x;
/*<       STARTY = Y >*/
    starty = y;

/* We have reached grid-point (I,J) going in direction DIR (UP, DOWN, */
/* LEFT, or RIGHT). Look at the other three sides of the cell we are */
/* entering to decide where to go next. It is important to look to the */
/* two sides before looking straight ahead, in order to avoid self- */
/* intersecting contours. If all 3 sides have unused crossing-points, */
/* the cell is "degenerate" and we have to decide which of two possible */
/* pairs of contour segments to draw; at present we make an arbitrary */
/* choice. If we have reached the edge of the array, we have */
/* finished drawing an unclosed contour. If none of the other three */
/* sides of the cell have an unused crossing-point, we must have */
/* completed a closed contour, which requires a final segment back to */
/* the starting point. */

/*<   100 CONTINUE >*/
L100:
/* D    WRITE (*,*) I,J,DIR */
/*<       II = 1 + I - IA >*/
    ii = i__ + 1 - *ia;
/*<       JJ = 1 + J - JA >*/
    jj = j + 1 - *ja;
/*<       GOTO (110, 120, 130, 140), DIR >*/
    switch ((int)dir) {
	case 1:  goto L110;
	case 2:  goto L120;
	case 3:  goto L130;
	case 4:  goto L140;
    }

/* DIR = UP */

/*<   110 CONTINUE >*/
L110:
/*<       FLAGS(II,JJ,1) = .FALSE. >*/
    flags[ii + (jj + 100) * 100] = FALSE_;
/*<       IF (J.EQ.JB) THEN >*/
    if (j == *jb) {
/*<           RETURN >*/
	return 0;
/*<       ELSE IF (FLAGS(II,JJ,2)) THEN >*/
    } else if (flags[ii + (jj + 200) * 100]) {
/*<           DIR = LEFT >*/
	dir = 3;
/*<           GOTO 200 >*/
	goto L200;
/*<       ELSE IF (FLAGS(II+1,JJ,2)) THEN >*/
    } else if (flags[ii + 1 + (jj + 200) * 100]) {
/*<           DIR = RIGHT >*/
	dir = 4;
/*<           I = I+1 >*/
	++i__;
/*<           GOTO 200 >*/
	goto L200;
/*<       ELSE IF (FLAGS(II,JJ+1,1)) THEN >*/
    } else if (flags[ii + (jj + 101) * 100]) {
/* !        DIR = UP */
/*<           J = J+1 >*/
	++j;
/*<           GOTO 250 >*/
	goto L250;
/*<       ELSE >*/
    } else {
/*<           GOTO 300 >*/
	goto L300;
/*<       END IF >*/
    }

/* DIR = DOWN */

/*<   120 CONTINUE >*/
L120:
/*<       FLAGS(II,JJ,1) = .FALSE. >*/
    flags[ii + (jj + 100) * 100] = FALSE_;
/*<       IF (J.EQ.JA) THEN >*/
    if (j == *ja) {
/*<           RETURN >*/
	return 0;
/*<       ELSE IF (FLAGS(II+1,JJ-1,2)) THEN >*/
    } else if (flags[ii + 1 + (jj + 199) * 100]) {
/*<           DIR = RIGHT >*/
	dir = 4;
/*<           I = I+1 >*/
	++i__;
/*<           J = J-1 >*/
	--j;
/*<           GOTO 200 >*/
	goto L200;
/*<       ELSE IF (FLAGS(II,JJ-1,2)) THEN >*/
    } else if (flags[ii + (jj + 199) * 100]) {
/*<           DIR = LEFT >*/
	dir = 3;
/*<           J = J-1 >*/
	--j;
/*<           GOTO 200 >*/
	goto L200;
/*<       ELSE IF (FLAGS(II,JJ-1,1)) THEN >*/
    } else if (flags[ii + (jj + 99) * 100]) {
/* !        DIR = DOWN */
/*<           J = J-1 >*/
	--j;
/*<           GOTO 250 >*/
	goto L250;
/*<       ELSE >*/
    } else {
/*<           GOTO 300 >*/
	goto L300;
/*<       END IF >*/
    }

/* DIR = LEFT */

/*<   130 CONTINUE >*/
L130:
/*<       FLAGS(II,JJ,2) = .FALSE. >*/
    flags[ii + (jj + 200) * 100] = FALSE_;
/*<       IF (I.EQ.IA) THEN >*/
    if (i__ == *ia) {
/*<           RETURN >*/
	return 0;
/*<       ELSE IF (FLAGS(II-1,JJ,1)) THEN >*/
    } else if (flags[ii - 1 + (jj + 100) * 100]) {
/*<           DIR = DOWN >*/
	dir = 2;
/*<           I = I-1 >*/
	--i__;
/*<           GOTO 250 >*/
	goto L250;
/*<       ELSE IF (FLAGS(II-1,JJ+1,1)) THEN >*/
    } else if (flags[ii - 1 + (jj + 101) * 100]) {
/*<           DIR = UP >*/
	dir = 1;
/*<           I = I-1 >*/
	--i__;
/*<           J = J+1 >*/
	++j;
/*<           GOTO 250 >*/
	goto L250;
/*<       ELSE IF (FLAGS(II-1,JJ,2)) THEN >*/
    } else if (flags[ii - 1 + (jj + 200) * 100]) {
/* !        DIR = LEFT */
/*<           I = I-1 >*/
	--i__;
/*<           GOTO 200 >*/
	goto L200;
/*<       ELSE >*/
    } else {
/*<           GOTO 300 >*/
	goto L300;
/*<       END IF >*/
    }

/* DIR = RIGHT */

/*<   140 CONTINUE >*/
L140:
/*<       FLAGS(II,JJ,2) = .FALSE. >*/
    flags[ii + (jj + 200) * 100] = FALSE_;
/*<       IF (I.EQ.IB) THEN >*/
    if (i__ == *ib) {
/*<           RETURN >*/
	return 0;
/*<       ELSE IF (FLAGS(II,JJ+1,1)) THEN >*/
    } else if (flags[ii + (jj + 101) * 100]) {
/*<           DIR = UP >*/
	dir = 1;
/*<           J = J+1 >*/
	++j;
/*<           GOTO 250 >*/
	goto L250;
/*<       ELSE IF (FLAGS(II,JJ,1)) THEN >*/
    } else if (flags[ii + (jj + 100) * 100]) {
/*<           DIR = DOWN >*/
	dir = 2;
/*<           GOTO 250 >*/
	goto L250;
/*<       ELSE IF (FLAGS(II+1,JJ,2)) THEN >*/
    } else if (flags[ii + 1 + (jj + 200) * 100]) {
/* !        DIR = RIGHT */
/*<           I = I+1 >*/
	++i__;
/*<           GOTO 200 >*/
	goto L200;
/*<       ELSE >*/
    } else {
/*<           GOTO 300 >*/
	goto L300;
/*<       END IF >*/
    }

/* Draw a segment of the contour. */

/*<   200 X = REAL(I) >*/
L200:
    x = (real) i__;
/*<       Y = REAL(J) + (Z0-Z(I,J))/(Z(I,J+1)-Z(I,J)) >*/
    y = (real) j + (*z0 - z__[i__ + j * z_dim1]) / (z__[i__ + (j + 1) * 
	    z_dim1] - z__[i__ + j * z_dim1]);
/*<       CALL PLOT(1,X,Y,Z0) >*/
    (*plot)(&c__1, &x, &y, z0);
/*<       GOTO 100 >*/
    goto L100;
/*<   250 X = REAL(I) + (Z0-Z(I,J))/(Z(I+1,J)-Z(I,J)) >*/
L250:
    x = (real) i__ + (*z0 - z__[i__ + j * z_dim1]) / (z__[i__ + 1 + j * 
	    z_dim1] - z__[i__ + j * z_dim1]);
/*<       Y = REAL(J) >*/
    y = (real) j;
/*<       CALL PLOT(1,X,Y,Z0) >*/
    (*plot)(&c__1, &x, &y, z0);
/*<       GOTO 100 >*/
    goto L100;

/* Close the contour and go look for another one. */

/*<   300 CALL PLOT(1,STARTX,STARTY,Z0) >*/
L300:
    (*plot)(&c__1, &startx, &starty, z0);
/*<       RETURN >*/
    return 0;

/*<       END >*/
} /* pgcn01_ */

