/* /work2/ssa/pgplot/src/pgcurs.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;
static real c_b6 = (float)0.;

/* *PGCURS -- read cursor position */
/* %int cpgcurs(float *x, float *y, char *ch_scalar); */
/* + */
/*<       INTEGER FUNCTION PGCURS (X, Y, CH) >*/
integer pgcurs_(x, y, ch, ch_len)
real *x, *y;
char *ch;
ftnlen ch_len;
{
    /* System generated locals */
    integer ret_val;

    /* Builtin functions */
    /* Subroutine */ int s_copy();

    /* Local variables */
    extern integer pgband_();
    extern logical pgnoto_();

/*<       REAL X, Y >*/
/*<       CHARACTER*(*) CH >*/

/* Read the cursor position and a character typed by the user. */
/* The position is returned in world coordinates.  PGCURS positions */
/* the cursor at the position specified, allows the user to move the */
/* cursor using the joystick or arrow keys or whatever is available on */
/* the device. When he has positioned the cursor, the user types a */
/* single character on the keyboard; PGCURS then returns this */
/* character and the new cursor position (in world coordinates). */

/* Returns: */
/*  PGCURS         : 1 if the call was successful; 0 if the device */
/*                    has no cursor or some other error occurs. */
/* Arguments: */
/*  X      (in/out) : the world x-coordinate of the cursor. */
/*  Y      (in/out) : the world y-coordinate of the cursor. */
/*  CH     (output) : the character typed by the user; if the device has */
/*                    no cursor or if some other error occurs, the value */
/*                    CHAR(0) [ASCII NUL character] is returned. */

/* Note: The cursor coordinates (X,Y) may be changed by PGCURS even if */
/* the device has no cursor or if the user does not move the cursor. */
/* Under these circumstances, the position returned in (X,Y) is that of */
/* the pixel nearest to the requested position. */
/* -- */
/*  7-Sep-1994 - changed to use PGBAND [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGBAND >*/
/*<       LOGICAL PGNOTO >*/

/*<       IF (PGNOTO('PGCURS')) THEN >*/
    if (pgnoto_("PGCURS", (ftnlen)6)) {
/*<          CH = CHAR(0) >*/
	s_copy(ch, "\000", ch_len, (ftnlen)1);
/*<          PGCURS = 0 >*/
	ret_val = 0;
/*<       ELSE >*/
    } else {
/*<          PGCURS = PGBAND(0, 1, 0.0, 0.0, X, Y, CH) >*/
	ret_val = pgband_(&c__0, &c__1, &c_b6, &c_b6, x, y, ch, ch_len);
/*<       END IF >*/
    }
/*<       END >*/
    return ret_val;
} /* pgcurs_ */

