/* /work2/ssa/pgplot/src/pgenv.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;
static real c_b23 = (float)0.;
static integer c__0 = 0;

/* *PGENV -- set window and viewport and draw labeled frame */
/* %void cpgenv(float xmin, float xmax, float ymin, float ymax, \ */
/* % int just, int axis); */
/* + */
/*<       SUBROUTINE PGENV (XMIN, XMAX, YMIN, YMAX, JUST, AXIS) >*/
/* Subroutine */ int pgenv_(xmin, xmax, ymin, ymax, just, axis)
real *xmin, *xmax, *ymin, *ymax;
integer *just, *axis;
{
    /* System generated locals */
    address a__1[2];
    integer i__1[2];

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer s_cmp();
    /* Subroutine */ int s_cat();

    /* Local variables */
    static char temp[10];
    static integer l;
    extern /* Subroutine */ int pgbox_();
    static char xopts[10], yopts[10];
    extern /* Subroutine */ int pgpage_(), pgwnad_(), grgenv_(), grwarn_();
    extern logical pgnoto_();
    extern /* Subroutine */ int pgvstd_(), pgswin_();
    static char envopt[10];

/*<       REAL XMIN, XMAX, YMIN, YMAX >*/
/*<       INTEGER JUST, AXIS >*/

/* Set PGPLOT "Plotter Environment".  PGENV establishes the scaling */
/* for subsequent calls to PGPT, PGLINE, etc.  The plotter is */
/* advanced to a new page or panel, clearing the screen if necessary. */
/* If the "prompt state" is ON (see PGASK), confirmation */
/* is requested from the user before clearing the screen. */
/* If requested, a box, axes, labels, etc. are drawn according to */
/* the setting of argument AXIS. */

/* Arguments: */
/*  XMIN   (input)  : the world x-coordinate at the bottom left corner */
/*                    of the viewport. */
/*  XMAX   (input)  : the world x-coordinate at the top right corner */
/*                    of the viewport (note XMAX may be less than XMIN). */
/*  YMIN   (input)  : the world y-coordinate at the bottom left corner */
/*                    of the viewport. */
/*  YMAX   (input)  : the world y-coordinate at the top right corner */
/*                    of the viewport (note YMAX may be less than YMIN). */
/*  JUST   (input)  : if JUST=1, the scales of the x and y axes (in */
/*                    world coordinates per inch) will be equal, */
/*                    otherwise they will be scaled independently. */
/*  AXIS   (input)  : controls the plotting of axes, tick marks, etc: */
/*      AXIS = -2 : draw no box, axes or labels; */
/*      AXIS = -1 : draw box only; */
/*      AXIS =  0 : draw box and label it with coordinates; */
/*      AXIS =  1 : same as AXIS=0, but also draw the */
/*                  coordinate axes (X=0, Y=0); */
/*      AXIS =  2 : same as AXIS=1, but also draw grid lines */
/*                  at major increments of the coordinates; */
/*      AXIS = 10 : draw box and label X-axis logarithmically; */
/*      AXIS = 20 : draw box and label Y-axis logarithmically; */
/*      AXIS = 30 : draw box and label both axes logarithmically. */

/* For other axis options, use routine PGBOX. PGENV can be persuaded to */
/* call PGBOX with additional axis options by defining an environment */
/* parameter PGPLOT_ENVOPT containing the required option codes. */
/* Examples: */
/*   PGPLOT_ENVOPT=P      ! draw Projecting tick marks */
/*   PGPLOT_ENVOPT=I      ! Invert the tick marks */
/*   PGPLOT_ENVOPT=IV     ! Invert tick marks and label y Vertically */
/* -- */
/*  1-May-1983 */
/* 25-Sep-1985 [TJP] - change to use PGWNAD. */
/* 23-Nov-1985 [TJP] - add PGPLOT_ENVOPT option. */
/* 31-Dec-1985 [TJP] - remove automatic PGBEG call. */
/* 29-Aug-1989 [TJP] - remove common block; no longer needed. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER      L >*/
/*<       LOGICAL      PGNOTO >*/
/*<       CHARACTER*10 XOPTS, YOPTS, ENVOPT, TEMP >*/

/*<       IF (PGNOTO('PGENV')) RETURN >*/
    if (pgnoto_("PGENV", (ftnlen)5)) {
	return 0;
    }

/* Start a new picture: move to a new panel or page as necessary. */

/*<       CALL PGPAGE >*/
    pgpage_();

/* Redefine the standard viewport. */

/*<       CALL PGVSTD >*/
    pgvstd_();

/* If invalid arguments are specified, issue warning and leave window */
/* unchanged. */

/*<       IF (XMIN.EQ.XMAX) THEN >*/
    if (*xmin == *xmax) {
/*<           CALL GRWARN('invalid x limits in PGENV: XMIN = XMAX.') >*/
	grwarn_("invalid x limits in PGENV: XMIN = XMAX.", (ftnlen)39);
/*<           RETURN >*/
	return 0;
/*<       ELSE IF (YMIN.EQ.YMAX) THEN >*/
    } else if (*ymin == *ymax) {
/*<           CALL GRWARN('invalid y limits in PGENV: YMIN = YMAX.') >*/
	grwarn_("invalid y limits in PGENV: YMIN = YMAX.", (ftnlen)39);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Call PGSWIN to define the window. */
/* If equal-scales requested, adjust viewport. */

/*<       IF (JUST.EQ.1) THEN >*/
    if (*just == 1) {
/*<           CALL PGWNAD(XMIN,XMAX,YMIN,YMAX) >*/
	pgwnad_(xmin, xmax, ymin, ymax);
/*<       ELSE >*/
    } else {
/*<           CALL PGSWIN(XMIN,XMAX,YMIN,YMAX) >*/
	pgswin_(xmin, xmax, ymin, ymax);
/*<       END IF >*/
    }

/* Call PGBOX to draw and label frame around viewport. */

/*<       YOPTS = '*' >*/
    s_copy(yopts, "*", (ftnlen)10, (ftnlen)1);
/*<       IF (AXIS.EQ.-2) THEN >*/

//    printf("axis=%d\n",*axis);
    if (*axis == -2) {
/*<           XOPTS = ' ' >*/
	s_copy(xopts, " ", (ftnlen)10, (ftnlen)1);
/*<       ELSE IF (AXIS.EQ.-1) THEN >*/
    } else if (*axis == -1) {
/*<           XOPTS = 'BC' >*/
	s_copy(xopts, "BC", (ftnlen)10, (ftnlen)2);
/*<       ELSE IF (AXIS.EQ.0) THEN >*/
    } else if (*axis == 0) {
/*<           XOPTS = 'BCNST' >*/
	s_copy(xopts, "BCNST", (ftnlen)10, (ftnlen)5);
/*<       ELSE IF (AXIS.EQ.1) THEN >*/
    } else if (*axis == 1) {
/*<           XOPTS = 'ABCNST' >*/
	s_copy(xopts, "ABCNST", (ftnlen)10, (ftnlen)6);
/*<       ELSE IF (AXIS.EQ.2) THEN >*/
    } else if (*axis == 2) {
/*<           XOPTS = 'ABCGNST' >*/
	s_copy(xopts, "ABCGNST", (ftnlen)10, (ftnlen)7);
/*<       ELSE IF (AXIS.EQ.10) THEN >*/
    } else if (*axis == 10) {
/*<           XOPTS = 'BCNSTL' >*/
	s_copy(xopts, "BCNSTL", (ftnlen)10, (ftnlen)6);
/*<           YOPTS = 'BCNST' >*/
	s_copy(yopts, "BCNST", (ftnlen)10, (ftnlen)5);
/*<       ELSE IF (AXIS.EQ.20) THEN >*/
    } else if (*axis == 20) {
/*<           XOPTS = 'BCNST' >*/
	s_copy(xopts, "BCNST", (ftnlen)10, (ftnlen)5);
/*<           YOPTS = 'BCNSTL' >*/
	s_copy(yopts, "BCNSTL", (ftnlen)10, (ftnlen)6);
/*<       ELSE IF (AXIS.EQ.30) THEN >*/
    } else if (*axis == 30) {
/*<           XOPTS = 'BCNSTL' >*/
	s_copy(xopts, "BCNSTL", (ftnlen)10, (ftnlen)6);
/*<           YOPTS = 'BCNSTL' >*/
	s_copy(yopts, "BCNSTL", (ftnlen)10, (ftnlen)6);
/*<       ELSE >*/
    } else {
/*<           CALL GRWARN('PGENV: illegal AXIS argument.') >*/
	grwarn_("PGENV: illegal AXIS argument.", (ftnlen)29);
/*<           XOPTS = 'BCNST' >*/
	s_copy(xopts, "BCNST", (ftnlen)10, (ftnlen)5);
/*<       END IF >*/
    }
/*<       IF (YOPTS.EQ.'*') YOPTS = XOPTS >*/
    if (s_cmp(yopts, "*", (ftnlen)10, (ftnlen)1) == 0) {
	s_copy(yopts, xopts, (ftnlen)10, (ftnlen)10);
    }

/* Additional PGBOX options from PGPLOT_ENVOPT. */

/*<       CALL GRGENV('ENVOPT', ENVOPT, L) >*/
    grgenv_("ENVOPT", envopt, &l, (ftnlen)6, (ftnlen)10);
/*<       IF (L.GT.0 .AND. AXIS.GE.0) THEN >*/
    if (l > 0 && *axis >= 0) {
/*<           TEMP = XOPTS >*/
	s_copy(temp, xopts, (ftnlen)10, (ftnlen)10);
/*<           XOPTS = ENVOPT(1:L)//TEMP >*/
/* Writing concatenation */
	i__1[0] = l, a__1[0] = envopt;
	i__1[1] = 10, a__1[1] = temp;
	s_cat(xopts, a__1, i__1, &c__2, (ftnlen)10);
/*<           TEMP = YOPTS >*/
	s_copy(temp, yopts, (ftnlen)10, (ftnlen)10);
/*<           YOPTS = ENVOPT(1:L)//TEMP >*/
/* Writing concatenation */
	i__1[0] = l, a__1[0] = envopt;
	i__1[1] = 10, a__1[1] = temp;
	s_cat(yopts, a__1, i__1, &c__2, (ftnlen)10);
/*<       END IF >*/
    }
/*<       CALL PGBOX(XOPTS, 0.0, 0, YOPTS, 0.0, 0) >*/
    pgbox_(xopts, &c_b23, &c__0, yopts, &c_b23, &c__0, (ftnlen)10, (ftnlen)10)
	    ;

/*<       END >*/
} /* pgenv_ */

