/* /work2/ssa/pgplot/src/pgerry.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGERRY -- vertical error bar */
/* %void cpgerry(int n, const float *x, const float *y1, \ */
/* % const float *y2, float t); */
/* + */
/*<       SUBROUTINE PGERRY (N, X, Y1, Y2, T) >*/
/* Subroutine */ int pgerry_(n, x, y1, y2, t)
integer *n;
real *x, *y1, *y2, *t;
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    static real xtik, ytik;
    static integer i__;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grlina_(), pgtikl_(), 
	    grmova_();
    extern logical pgnoto_();

/*<       INTEGER N >*/
/*<       REAL X(*), Y1(*), Y2(*) >*/
/*<       REAL T >*/

/* Plot vertical error bars. */
/* This routine draws an error bar only; to mark the data point in */
/* the middle of the error bar, an additional call to PGPT or */
/* PGERRX is required. */

/* Arguments: */
/*  N      (input)  : number of error bars to plot. */
/*  X      (input)  : world x-coordinates of the data. */
/*  Y1     (input)  : world y-coordinates of top end of the */
/*                    error bars. */
/*  Y2     (input)  : world y-coordinates of bottom end of the */
/*                    error bars. */
/*  T      (input)  : length of terminals to be drawn at the ends */
/*                    of the error bar, as a multiple of the default */
/*                    length; if T = 0.0, no terminals will be drawn. */

/* Note: the dimension of arrays X, Y1, and Y2 must be greater */
/* than or equal to N. If N is 1, X, Y1, and Y2 may be scalar */
/* variables or expressions, eg: */
/*       CALL PGERRY(1,X,Y+SIGMA,Y-SIGMA) */
/* -- */
/* (6-Oct-1983) */
/* 31-Mar-1997 - use pgtikl [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I >*/
/*<       LOGICAL  PGNOTO >*/
/*<       REAL     XTIK, YTIK >*/

/*<       IF (PGNOTO('PGERRY')) RETURN >*/
    /* Parameter adjustments */
    --y2;
    --y1;
    --x;

    /* Function Body */
    if (pgnoto_("PGERRY", (ftnlen)6)) {
	return 0;
    }
/*<       IF (N.LT.1) RETURN >*/
    if (*n < 1) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/*<       CALL PGTIKL(T, XTIK, YTIK) >*/
    pgtikl_(t, &xtik, &ytik);
/*<       DO 10 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           IF (T.NE.0.0) THEN >*/
	if (*t != (float)0.) {
/*<               CALL GRMOVA(X(I)-XTIK,Y1(I)) >*/
	    r__1 = x[i__] - xtik;
	    grmova_(&r__1, &y1[i__]);
/*<               CALL GRLINA(X(I)+XTIK,Y1(I)) >*/
	    r__1 = x[i__] + xtik;
	    grlina_(&r__1, &y1[i__]);
/*<           END IF >*/
	}
/*<           CALL GRMOVA(X(I),Y1(I)) >*/
	grmova_(&x[i__], &y1[i__]);
/*<           CALL GRLINA(X(I),Y2(I)) >*/
	grlina_(&x[i__], &y2[i__]);
/*<           IF (T.NE.0.0) THEN >*/
	if (*t != (float)0.) {
/*<               CALL GRMOVA(X(I)-XTIK,Y2(I)) >*/
	    r__1 = x[i__] - xtik;
	    grmova_(&r__1, &y2[i__]);
/*<               CALL GRLINA(X(I)+XTIK,Y2(I)) >*/
	    r__1 = x[i__] + xtik;
	    grlina_(&r__1, &y2[i__]);
/*<           END IF >*/
	}
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgerry_ */

