/* /work2/ssa/pgplot/src/pgimag.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGIMAG -- color image from a 2D data array */
/* %void cpgimag(const float *a, int idim, int jdim, int i1, int i2, \ */
/* % int j1, int j2, float a1, float a2, const float *tr); */
/* + */
/*<    >*/
/* Subroutine */ int pgimag_(a, idim, jdim, i1, i2, j1, j2, a1, a2, tr)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *a1, *a2, *tr;
{
    /* System generated locals */
    integer a_dim1, a_offset;

    /* Local variables */
    extern /* Subroutine */ int grimg0_();
    static real pa[6];
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grwarn_();
    extern logical pgnoto_();

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2 >*/
/*<       REAL    A(IDIM,JDIM), A1, A2, TR(6) >*/

/* Draw a color image of an array in current window. The subsection */
/* of the array A defined by indices (I1:I2, J1:J2) is mapped onto */
/* the view surface world-coordinate system by the transformation */
/* matrix TR. The resulting quadrilateral region is clipped at the edge */
/* of the window. Each element of the array is represented in the image */
/* by a small quadrilateral, which is filled with a color specified by */
/* the corresponding array value. */

/* The subroutine uses color indices in the range C1 to C2, which can */
/* be specified by calling PGSCIR before PGIMAG. The default values */
/* for C1 and C2 are device-dependent; these values can be determined by */
/* calling PGQCIR. Note that color representations should be assigned to */
/* color indices C1 to C2 by calling PGSCR before calling PGIMAG. On some */
/* devices (but not all), the color representation can be changed after */
/* the call to PGIMAG by calling PGSCR again. */

/* Array values in the range A1 to A2 are mapped on to the range of */
/* color indices C1 to C2, with array values <= A1 being given color */
/* index C1 and values >= A2 being given color index C2. The mapping */
/* function for intermediate array values can be specified by */
/* calling routine PGSITF before PGIMAG; the default is linear. */

/* On devices which have no available color indices (C1 > C2), */
/* PGIMAG will return without doing anything. On devices with only */
/* one color index (C1=C2), all array values map to the same color */
/* which is rather uninteresting. An image is always "opaque", */
/* i.e., it obscures all graphical elements previously drawn in */
/* the region. */

/* The transformation matrix TR is used to calculate the world */
/* coordinates of the center of the "cell" that represents each */
/* array element. The world coordinates of the center of the cell */
/* corresponding to array element A(I,J) are given by: */

/*          X = TR(1) + TR(2)*I + TR(3)*J */
/*          Y = TR(4) + TR(5)*I + TR(6)*J */

/* Usually TR(3) and TR(5) are zero -- unless the coordinate */
/* transformation involves a rotation or shear.  The corners of the */
/* quadrilateral region that is shaded by PGIMAG are given by */
/* applying this transformation to (I1-0.5,J1-0.5), (I2+0.5, J2+0.5). */

/* Arguments: */
/*  A      (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  A1     (input)  : the array value which is to appear with shade C1. */
/*  A2     (input)  : the array value which is to appear with shade C2. */
/*  TR     (input)  : transformation matrix between array grid and */
/*                    world coordinates. */
/* -- */
/* 15-Sep-1994: new routine [TJP]. */
/* 21-Jun-1995: minor change to header comments [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       REAL PA(6) >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL PGNOTO >*/

/* Check inputs. */

/*<       IF (PGNOTO('PGIMAG')) RETURN >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --tr;

    /* Function Body */
    if (pgnoto_("PGIMAG", (ftnlen)6)) {
	return 0;
    }
/*<    >*/
    if (*i1 < 1 || *i2 > *idim || *i1 > *i2 || *j1 < 1 || *j2 > *jdim || *j1 
	    > *j2) {
/*<           CALL GRWARN('PGIMAG: invalid range I1:I2, J1:J2') >*/
	grwarn_("PGIMAG: invalid range I1:I2, J1:J2", (ftnlen)34);
/*<       ELSE IF (A1.EQ.A2) THEN >*/
    } else if (*a1 == *a2) {
/*<           CALL GRWARN('PGIMAG: foreground level = background level') >*/
	grwarn_("PGIMAG: foreground level = background level", (ftnlen)43);
/*<       ELSE IF (PGMNCI(PGID).GT.PGMXCI(PGID)) THEN >*/
    } else if (pgplt1_1.pgmnci[pgplt1_1.pgid - 1] > pgplt1_1.pgmxci[
	    pgplt1_1.pgid - 1]) {
/*<           CALL GRWARN('PGIMAG: not enough colors available') >*/
	grwarn_("PGIMAG: not enough colors available", (ftnlen)35);
/*<       ELSE >*/
    } else {

/* Call lower-level routine to do the work. */

/*<           CALL PGBBUF >*/
	pgbbuf_();
/*<           PA(1) = TR(1)*PGXSCL(PGID) + PGXORG(PGID) >*/
	pa[0] = tr[1] * pgplt1_1.pgxscl[pgplt1_1.pgid - 1] + pgplt1_1.pgxorg[
		pgplt1_1.pgid - 1];
/*<           PA(2) = TR(2)*PGXSCL(PGID) >*/
	pa[1] = tr[2] * pgplt1_1.pgxscl[pgplt1_1.pgid - 1];
/*<           PA(3) = TR(3)*PGXSCL(PGID) >*/
	pa[2] = tr[3] * pgplt1_1.pgxscl[pgplt1_1.pgid - 1];
/*<           PA(4) = TR(4)*PGYSCL(PGID) + PGYORG(PGID) >*/
	pa[3] = tr[4] * pgplt1_1.pgyscl[pgplt1_1.pgid - 1] + pgplt1_1.pgyorg[
		pgplt1_1.pgid - 1];
/*<           PA(5) = TR(5)*PGYSCL(PGID) >*/
	pa[4] = tr[5] * pgplt1_1.pgyscl[pgplt1_1.pgid - 1];
/*<           PA(6) = TR(6)*PGYSCL(PGID) >*/
	pa[5] = tr[6] * pgplt1_1.pgyscl[pgplt1_1.pgid - 1];
/*<    >*/
	grimg0_(&a[a_offset], idim, jdim, i1, i2, j1, j2, a1, a2, pa, &
		pgplt1_1.pgmnci[pgplt1_1.pgid - 1], &pgplt1_1.pgmxci[
		pgplt1_1.pgid - 1], &pgplt1_1.pgitf[pgplt1_1.pgid - 1]);
/*<           CALL PGEBUF >*/
	pgebuf_();
/*<       END IF >*/
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* pgimag_ */

