/* /work2/ssa/pgplot/src/pgldev.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__3 = 3;
static integer c__4 = 4;

/* *PGLDEV -- list available device types on standard output */
/* %void cpgldev(void); */
/* + */
/*<       SUBROUTINE PGLDEV >*/
/* Subroutine */ int pgldev_()
{
    /* System generated locals */
    address a__1[3], a__2[4];
    integer i__1[3], i__2, i__3[4];
    char ch__1[73], ch__2[78];

    /* Builtin functions */
    /* Subroutine */ int s_cat();

    /* Local variables */
    static integer dlen, tlen;
    static char gver[16], d__[64];
    static integer i__, l, n;
    static char t[10];
    extern /* Subroutine */ int grmsg_(), pgqdt_();
    static integer inter;
    extern /* Subroutine */ int pgqinf_(), pginit_(), pgqndt_();


/* Writes (to standard output) a list of all device types available in */
/* the current PGPLOT installation. */

/* Arguments: none. */
/* -- */
/* 5-Aug-1986 - [AFT]. */
/* 1-Aug-1988 - add version number [TJP]. */
/* 24-Apr-1989 - add copyright notice [TJP]. */
/* 13-Dec-1990 - changed warnings to messages [TJP]. */
/* 26-Feb-1997 - revised description [TJP]. */
/* 18-Mar-1997 - revised [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*16 GVER >*/
/*<       INTEGER L >*/
/*<       CHARACTER*10 T >*/
/*<       CHARACTER*64 D >*/
/*<       INTEGER I, N, TLEN, DLEN, INTER >*/

/* Initialize PGPLOT if necessary. */

/*<       CALL PGINIT >*/
    pginit_();

/* Report version and copyright. */

/*<       CALL PGQINF('VERSION', GVER, L) >*/
    pgqinf_("VERSION", gver, &l, (ftnlen)7, (ftnlen)16);
/*<    >*/
/* Writing concatenation */
    i__1[0] = 7, a__1[0] = "PGPLOT ";
    i__1[1] = l, a__1[1] = gver;
    i__1[2] = 50, a__1[2] = " Copyright 1997 California Institute of Technol\
ogy";
    s_cat(ch__1, a__1, i__1, &c__3, (ftnlen)73);
    grmsg_(ch__1, l + 57);

/* Find number of device types. */

/*<       CALL PGQNDT(N) >*/
    pgqndt_(&n);

/* Loop through device-type list (twice). */
/*<       CALL GRMSG('Interactive devices:') >*/
    grmsg_("Interactive devices:", (ftnlen)20);
/*<       DO 10 I=1,N >*/
    i__2 = n;
    for (i__ = 1; i__ <= i__2; ++i__) {
/*<          CALL PGQDT(I, T, TLEN, D, DLEN, INTER) >*/
	pgqdt_(&i__, t, &tlen, d__, &dlen, &inter, (ftnlen)10, (ftnlen)64);
/*<    >*/
	if (tlen > 0 && inter == 1) {
/* Writing concatenation */
	    i__3[0] = 3, a__2[0] = "   ";
	    i__3[1] = 10, a__2[1] = t;
	    i__3[2] = 1, a__2[2] = " ";
	    i__3[3] = dlen, a__2[3] = d__;
	    s_cat(ch__2, a__2, i__3, &c__4, (ftnlen)78);
	    grmsg_(ch__2, dlen + 14);
	}
/*<  10   CONTINUE >*/
/* L10: */
    }
/*<       CALL GRMSG('Non-interactive file formats:') >*/
    grmsg_("Non-interactive file formats:", (ftnlen)29);
/*<       DO 20 I=1,N >*/
    i__2 = n;
    for (i__ = 1; i__ <= i__2; ++i__) {
/*<          CALL PGQDT(I, T, TLEN, D, DLEN, INTER) >*/
	pgqdt_(&i__, t, &tlen, d__, &dlen, &inter, (ftnlen)10, (ftnlen)64);
/*<    >*/
	if (tlen > 0 && inter == 0) {
/* Writing concatenation */
	    i__3[0] = 3, a__2[0] = "   ";
	    i__3[1] = 10, a__2[1] = t;
	    i__3[2] = 1, a__2[2] = " ";
	    i__3[3] = dlen, a__2[3] = d__;
	    s_cat(ch__2, a__2, i__3, &c__4, (ftnlen)78);
	    grmsg_(ch__2, dlen + 14);
	}
/*<  20   CONTINUE >*/
/* L20: */
    }

/*<       END >*/
} /* pgldev_ */

