/* /work2/ssa/pgplot/src/pgline.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGLINE -- draw a polyline (curve defined by line-segments) */
/* %void cpgline(int n, const float *xpts, const float *ypts); */
/* + */
/*<       SUBROUTINE PGLINE (N, XPTS, YPTS) >*/
/* Subroutine */ int pgline_(n, xpts, ypts)
integer *n;
real *xpts, *ypts;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grlina_(), grmova_();
    extern logical pgnoto_();

/*<       INTEGER  N >*/
/*<       REAL     XPTS(*), YPTS(*) >*/

/* Primitive routine to draw a Polyline. A polyline is one or more */
/* connected straight-line segments.  The polyline is drawn using */
/* the current setting of attributes color-index, line-style, and */
/* line-width. The polyline is clipped at the edge of the window. */

/* Arguments: */
/*  N      (input)  : number of points defining the line; the line */
/*                    consists of (N-1) straight-line segments. */
/*                    N should be greater than 1 (if it is 1 or less, */
/*                    nothing will be drawn). */
/*  XPTS   (input)  : world x-coordinates of the points. */
/*  YPTS   (input)  : world y-coordinates of the points. */

/* The dimension of arrays X and Y must be greater than or equal to N. */
/* The "pen position" is changed to (X(N),Y(N)) in world coordinates */
/* (if N > 1). */
/* -- */
/* 27-Nov-1986 */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I >*/
/*<       LOGICAL PGNOTO >*/

/*<       IF (PGNOTO('PGLINE')) RETURN >*/
    /* Parameter adjustments */
    --ypts;
    --xpts;

    /* Function Body */
    if (pgnoto_("PGLINE", (ftnlen)6)) {
	return 0;
    }
/*<       IF (N.LT.2) RETURN >*/
    if (*n < 2) {
	return 0;
    }

/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       CALL GRMOVA(XPTS(1),YPTS(1)) >*/
    grmova_(&xpts[1], &ypts[1]);
/*<       DO 10 I=2,N >*/
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
/*<          CALL GRLINA(XPTS(I),YPTS(I)) >*/
	grlina_(&xpts[i__], &ypts[i__]);
/*<  10   CONTINUE >*/
/* L10: */
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgline_ */

