/* /work2/ssa/pgplot/src/pgmtxt.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__4 = 4;
static logical c_false = FALSE_;
static logical c_true = TRUE_;

/* *PGMTXT -- write text at position relative to viewport */
/* %void cpgmtxt(const char *side, float disp, float coord, \ */
/* % float fjust, const char *text); */
/* + */
/*<       SUBROUTINE PGMTXT (SIDE, DISP, COORD, FJUST, TEXT) >*/
/* Subroutine */ int pgmtxt_(side, disp, coord, fjust, text, side_len, 
	text_len)
char *side;
real *disp, *coord, *fjust;
char *text;
ftnlen side_len;
ftnlen text_len;
{
    /* Builtin functions */
    integer i_indx();

    /* Local variables */
    extern /* Subroutine */ int grfa_();
    static char test[20];
    static real xbox[4], ybox[4], d__;
    static integer i__, l;
    static real angle, x, y;
    extern /* Subroutine */ int pgqci_(), grlen_(), pgsci_();
    static real ratio;
    static integer ci;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grwarn_();
    extern integer grtrim_();
    extern logical pgnoto_();
    extern /* Subroutine */ int grtext_(), grtoup_(), grqtxt_();

/*<       CHARACTER*(*) SIDE, TEXT >*/
/*<       REAL DISP, COORD, FJUST >*/

/* Write text at a position specified relative to the viewport (outside */
/* or inside).  This routine is useful for annotating graphs. It is used */
/* by routine PGLAB.  The text is written using the current values of */
/* attributes color-index, line-width, character-height, and */
/* character-font. */

/* Arguments: */
/*  SIDE   (input)  : must include one of the characters 'B', 'L', 'T', */
/*                    or 'R' signifying the Bottom, Left, Top, or Right */
/*                    margin of the viewport. If it includes 'LV' or */
/*                    'RV', the string is written perpendicular to the */
/*                    frame rather than parallel to it. */
/*  DISP   (input)  : the displacement of the character string from the */
/*                    specified edge of the viewport, measured outwards */
/*                    from the viewport in units of the character */
/*                    height. Use a negative value to write inside the */
/*                    viewport, a positive value to write outside. */
/*  COORD  (input)  : the location of the character string along the */
/*                    specified edge of the viewport, as a fraction of */
/*                    the length of the edge. */
/*  FJUST  (input)  : controls justification of the string parallel to */
/*                    the specified edge of the viewport. If */
/*                    FJUST = 0.0, the left-hand end of the string will */
/*                    be placed at COORD; if JUST = 0.5, the center of */
/*                    the string will be placed at COORD; if JUST = 1.0, */
/*                    the right-hand end of the string will be placed at */
/*                    at COORD. Other values between 0 and 1 give inter- */
/*                    mediate placing, but they are not very useful. */
/*  TEXT   (input) :  the text string to be plotted. Trailing spaces are */
/*                    ignored when justifying the string, but leading */
/*                    spaces are significant. */

/* -- */
/* 18-Apr-1983 */
/* 15-Aug-1987 - fix BBUF/EBUF error. */
/* 27-Aug-1987 - fix justification error if XPERIN.ne.YPERIN. */
/* 05-Sep-1989 - change so that DISP has some effect for 'RV' and */
/*               'LV' options [nebk] */
/* 16-Oct-1993 - erase background of opaque text. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       LOGICAL PGNOTO >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL ANGLE, D, X, Y, RATIO, XBOX(4), YBOX(4) >*/
/*<       INTEGER CI, I, L, GRTRIM >*/
/*<       CHARACTER*20 TEST >*/

/*<       IF (PGNOTO('PGMTXT')) RETURN >*/
    if (pgnoto_("PGMTXT", (ftnlen)6)) {
	return 0;
    }

/*<       L = GRTRIM(TEXT) >*/
    l = grtrim_(text, text_len);
/*<       IF (L.LT.1) RETURN >*/
    if (l < 1) {
	return 0;
    }
/*<       D = 0.0 >*/
    d__ = (float)0.;
/*<       IF (FJUST.NE.0.0) CALL GRLEN(TEXT(1:L),D) >*/
    if (*fjust != (float)0.) {
	grlen_(text, &d__, l);
    }
/*<       D = D*FJUST >*/
    d__ *= *fjust;
/*<       RATIO = PGYPIN(PGID)/PGXPIN(PGID) >*/
    ratio = pgplt1_1.pgypin[pgplt1_1.pgid - 1] / pgplt1_1.pgxpin[
	    pgplt1_1.pgid - 1];
/*<       CALL GRTOUP(TEST,SIDE) >*/
    grtoup_(test, side, (ftnlen)20, side_len);
/*<       IF (INDEX(TEST,'B').NE.0) THEN >*/
    if (i_indx(test, "B", (ftnlen)20, (ftnlen)1) != 0) {
/*<           ANGLE = 0.0 >*/
	angle = (float)0.;
/*<           X = PGXOFF(PGID) + COORD*PGXLEN(PGID) - D >*/
	x = pgplt1_1.pgxoff[pgplt1_1.pgid - 1] + *coord * pgplt1_1.pgxlen[
		pgplt1_1.pgid - 1] - d__;
/*<           Y = PGYOFF(PGID) - PGYSP(PGID)*DISP >*/
	y = pgplt1_1.pgyoff[pgplt1_1.pgid - 1] - pgplt1_1.pgysp[pgplt1_1.pgid 
		- 1] * *disp;
/*<       ELSE IF (INDEX(TEST,'LV').NE.0) THEN >*/
    } else if (i_indx(test, "LV", (ftnlen)20, (ftnlen)2) != 0) {
/*<           ANGLE = 0.0 >*/
	angle = (float)0.;
/*<           X = PGXOFF(PGID) - PGYSP(PGID)*DISP - D >*/
	x = pgplt1_1.pgxoff[pgplt1_1.pgid - 1] - pgplt1_1.pgysp[pgplt1_1.pgid 
		- 1] * *disp - d__;
/*<           Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - 0.3*PGYSP(PGID) >*/
	y = pgplt1_1.pgyoff[pgplt1_1.pgid - 1] + *coord * pgplt1_1.pgylen[
		pgplt1_1.pgid - 1] - pgplt1_1.pgysp[pgplt1_1.pgid - 1] * (
		float).3;
/*<       ELSE IF (INDEX(TEST,'L').NE.0) THEN >*/
    } else if (i_indx(test, "L", (ftnlen)20, (ftnlen)1) != 0) {
/*<           ANGLE = 90.0 >*/
	angle = (float)90.;
/*<           X = PGXOFF(PGID) - PGYSP(PGID)*DISP >*/
	x = pgplt1_1.pgxoff[pgplt1_1.pgid - 1] - pgplt1_1.pgysp[pgplt1_1.pgid 
		- 1] * *disp;
/*<           Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - D*RATIO >*/
	y = pgplt1_1.pgyoff[pgplt1_1.pgid - 1] + *coord * pgplt1_1.pgylen[
		pgplt1_1.pgid - 1] - d__ * ratio;
/*<       ELSE IF (INDEX(TEST,'T').NE.0) THEN >*/
    } else if (i_indx(test, "T", (ftnlen)20, (ftnlen)1) != 0) {
/*<           ANGLE = 0.0 >*/
	angle = (float)0.;
/*<           X = PGXOFF(PGID) + COORD*PGXLEN(PGID) - D >*/
	x = pgplt1_1.pgxoff[pgplt1_1.pgid - 1] + *coord * pgplt1_1.pgxlen[
		pgplt1_1.pgid - 1] - d__;
/*<           Y = PGYOFF(PGID) + PGYLEN(PGID) + PGYSP(PGID)*DISP >*/
	y = pgplt1_1.pgyoff[pgplt1_1.pgid - 1] + pgplt1_1.pgylen[
		pgplt1_1.pgid - 1] + pgplt1_1.pgysp[pgplt1_1.pgid - 1] * *
		disp;
/*<       ELSE IF (INDEX(TEST,'RV').NE.0) THEN >*/
    } else if (i_indx(test, "RV", (ftnlen)20, (ftnlen)2) != 0) {
/*<           ANGLE = 0.0 >*/
	angle = (float)0.;
/*<           X = PGXOFF(PGID) + PGXLEN(PGID) + PGYSP(PGID)*DISP - D >*/
	x = pgplt1_1.pgxoff[pgplt1_1.pgid - 1] + pgplt1_1.pgxlen[
		pgplt1_1.pgid - 1] + pgplt1_1.pgysp[pgplt1_1.pgid - 1] * *
		disp - d__;
/*<           Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - 0.3*PGYSP(PGID) >*/
	y = pgplt1_1.pgyoff[pgplt1_1.pgid - 1] + *coord * pgplt1_1.pgylen[
		pgplt1_1.pgid - 1] - pgplt1_1.pgysp[pgplt1_1.pgid - 1] * (
		float).3;
/*<       ELSE IF (INDEX(TEST,'R').NE.0) THEN >*/
    } else if (i_indx(test, "R", (ftnlen)20, (ftnlen)1) != 0) {
/*<           ANGLE = 90.0 >*/
	angle = (float)90.;
/*<           X = PGXOFF(PGID) + PGXLEN(PGID) + PGYSP(PGID)*DISP >*/
	x = pgplt1_1.pgxoff[pgplt1_1.pgid - 1] + pgplt1_1.pgxlen[
		pgplt1_1.pgid - 1] + pgplt1_1.pgysp[pgplt1_1.pgid - 1] * *
		disp;
/*<           Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - D*RATIO >*/
	y = pgplt1_1.pgyoff[pgplt1_1.pgid - 1] + *coord * pgplt1_1.pgylen[
		pgplt1_1.pgid - 1] - d__ * ratio;
/*<       ELSE >*/
    } else {
/*<           CALL GRWARN('Invalid "SIDE" argument in PGMTXT.') >*/
	grwarn_("Invalid \"SIDE\" argument in PGMTXT.", (ftnlen)34);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       IF (PGTBCI(PGID).GE.0) THEN >*/
    if (pgplt1_1.pgtbci[pgplt1_1.pgid - 1] >= 0) {
/*<           CALL GRQTXT (ANGLE, X, Y, TEXT(1:L), XBOX, YBOX) >*/
	grqtxt_(&angle, &x, &y, text, xbox, ybox, l);
/*<           DO 25 I=1,4 >*/
	for (i__ = 1; i__ <= 4; ++i__) {
/*<               XBOX(I) = (XBOX(I)-PGXORG(PGID))/PGXSCL(PGID) >*/
	    xbox[i__ - 1] = (xbox[i__ - 1] - pgplt1_1.pgxorg[pgplt1_1.pgid - 
		    1]) / pgplt1_1.pgxscl[pgplt1_1.pgid - 1];
/*<               YBOX(I) = (YBOX(I)-PGYORG(PGID))/PGYSCL(PGID) >*/
	    ybox[i__ - 1] = (ybox[i__ - 1] - pgplt1_1.pgyorg[pgplt1_1.pgid - 
		    1]) / pgplt1_1.pgyscl[pgplt1_1.pgid - 1];
/*<    25     CONTINUE >*/
/* L25: */
	}
/*<           CALL PGQCI(CI) >*/
	pgqci_(&ci);
/*<           CALL PGSCI(PGTBCI(PGID)) >*/
	pgsci_(&pgplt1_1.pgtbci[pgplt1_1.pgid - 1]);
/*<           CALL GRFA(4, XBOX, YBOX) >*/
	grfa_(&c__4, xbox, ybox);
/*<           CALL PGSCI(CI) >*/
	pgsci_(&ci);
/*<       END IF >*/
    }
/*<       CALL GRTEXT(.FALSE.,ANGLE,.TRUE., X, Y, TEXT(1:L)) >*/
    grtext_(&c_false, &angle, &c_true, &x, &y, text, l);
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgmtxt_ */

