/* /work2/ssa/pgplot/src/pgpap.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static real c_b4 = (float)1.;

/* *PGPAP -- change the size of the view surface */
/* %void cpgpap(float width, float aspect); */
/* + */
/*<       SUBROUTINE PGPAP (WIDTH, ASPECT) >*/
/* Subroutine */ int pgpap_(width, aspect)
real *width, *aspect;
{
    static real hdef, wdef, hmax, hreq, wmax, wreq;
    extern /* Subroutine */ int pgsch_();
    static real xsmax, ysmax;
    extern /* Subroutine */ int grwarn_(), grsize_();
    extern logical pgnoto_();
    extern /* Subroutine */ int grsets_(), pgvstd_();
    static real xsz, ysz;

/*<       REAL WIDTH, ASPECT >*/

/* This routine changes the size of the view surface ("paper size") to a */
/* specified width and aspect ratio (height/width), in so far as this is */
/* possible on the specific device. It is always possible to obtain a */
/* view surface smaller than the default size; on some devices (e.g., */
/* printers that print on roll or fan-feed paper) it is possible to */
/* obtain a view surface larger than the default. */

/* This routine should be called either immediately after PGBEG or */
/* immediately before PGPAGE. The new size applies to all subsequent */
/* images until the next call to PGPAP. */

/* Arguments: */
/*  WIDTH  (input)  : the requested width of the view surface in inches; */
/*                    if WIDTH=0.0, PGPAP will obtain the largest view */
/*                    surface available consistent with argument ASPECT. */
/*                    (1 inch = 25.4 mm.) */
/*  ASPECT (input)  : the aspect ratio (height/width) of the view */
/*                    surface; e.g., ASPECT=1.0 gives a square view */
/*                    surface, ASPECT=0.618 gives a horizontal */
/*                    rectangle, ASPECT=1.618 gives a vertical rectangle. */
/* -- */
/* (22-Apr-1983; bug fixed 7-Jun-1988) */
/*  6-Oct-1990 Modified to work correctly on interactive devices. */
/* 13-Dec-1990 Make errors non-fatal [TJP]. */
/* 14-Sep-1994 Fix bug to do with drivers changing view surface size. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       LOGICAL  PGNOTO >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL     HDEF, HMAX, HREQ, WDEF, WMAX, WREQ >*/
/*<       REAL     XSMAX, YSMAX, XSZ, YSZ >*/

/*<       IF (PGNOTO('PGPAP'))  RETURN >*/
    if (pgnoto_("PGPAP", (ftnlen)5)) {
	return 0;
    }
/*<       IF (WIDTH.LT.0.0 .OR. ASPECT.LE.0.0) THEN >*/
    if (*width < (float)0. || *aspect <= (float)0.) {
/*<           CALL GRWARN('PGPAP ignored: invalid arguments') >*/
	grwarn_("PGPAP ignored: invalid arguments", (ftnlen)32);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/*<       PGPFIX(PGID) = .TRUE. >*/
    pgplt1_1.pgpfix[pgplt1_1.pgid - 1] = TRUE_;
/*     -- Find default size WDEF, HDEF and maximum size WMAX, HMAX */
/*        of view surface (inches) */
/*<    >*/
    grsize_(&pgplt1_1.pgid, &xsz, &ysz, &xsmax, &ysmax, &pgplt1_1.pgxpin[
	    pgplt1_1.pgid - 1], &pgplt1_1.pgypin[pgplt1_1.pgid - 1]);
/*<       WDEF = XSZ/PGXPIN(PGID) >*/
    wdef = xsz / pgplt1_1.pgxpin[pgplt1_1.pgid - 1];
/*<       HDEF = YSZ/PGYPIN(PGID) >*/
    hdef = ysz / pgplt1_1.pgypin[pgplt1_1.pgid - 1];
/*<       WMAX = XSMAX/PGXPIN(PGID) >*/
    wmax = xsmax / pgplt1_1.pgxpin[pgplt1_1.pgid - 1];
/*<       HMAX = YSMAX/PGYPIN(PGID) >*/
    hmax = ysmax / pgplt1_1.pgypin[pgplt1_1.pgid - 1];
/*     -- Find desired size WREQ, HREQ of view surface (inches) */
/*<       IF (WIDTH.NE.0.0) THEN >*/
    if (*width != (float)0.) {
/*<           WREQ = WIDTH >*/
	wreq = *width;
/*<           HREQ = WIDTH*ASPECT >*/
	hreq = *width * *aspect;
/*<       ELSE >*/
    } else {
/*<           WREQ = WDEF >*/
	wreq = wdef;
/*<           HREQ = WDEF*ASPECT >*/
	hreq = wdef * *aspect;
/*<           IF (HREQ.GT.HDEF) THEN >*/
	if (hreq > hdef) {
/*<               WREQ = HDEF/ASPECT >*/
	    wreq = hdef / *aspect;
/*<               HREQ = HDEF >*/
	    hreq = hdef;
/*<           END IF >*/
	}
/*<       END IF >*/
    }
/*     -- Scale the requested view surface to fit the maximum */
/*        dimensions */
/*<       IF (WMAX.GT.0.0 .AND. WREQ.GT.WMAX) THEN >*/
    if (wmax > (float)0. && wreq > wmax) {
/*<           WREQ = WMAX >*/
	wreq = wmax;
/*<           HREQ = WMAX*ASPECT >*/
	hreq = wmax * *aspect;
/*<       END IF >*/
    }
/*<       IF (HMAX.GT.0.0 .AND. HREQ.GT.HMAX) THEN >*/
    if (hmax > (float)0. && hreq > hmax) {
/*<           WREQ = HMAX/ASPECT >*/
	wreq = hmax / *aspect;
/*<           HREQ = HMAX >*/
	hreq = hmax;
/*<       END IF >*/
    }
/*     -- Establish the new view surface dimensions */
/*<       XSZ = WREQ*PGXPIN(PGID) >*/
    xsz = wreq * pgplt1_1.pgxpin[pgplt1_1.pgid - 1];
/*<       YSZ = HREQ*PGYPIN(PGID) >*/
    ysz = hreq * pgplt1_1.pgypin[pgplt1_1.pgid - 1];
/*<       CALL GRSETS(PGID,XSZ,YSZ) >*/
    grsets_(&pgplt1_1.pgid, &xsz, &ysz);
/*<       PGXSZ(PGID) = XSZ/PGNX(PGID) >*/
    pgplt1_1.pgxsz[pgplt1_1.pgid - 1] = xsz / pgplt1_1.pgnx[pgplt1_1.pgid - 1]
	    ;
/*<       PGYSZ(PGID) = YSZ/PGNY(PGID) >*/
    pgplt1_1.pgysz[pgplt1_1.pgid - 1] = ysz / pgplt1_1.pgny[pgplt1_1.pgid - 1]
	    ;
/*<       PGNXC(PGID) = PGNX(PGID) >*/
    pgplt1_1.pgnxc[pgplt1_1.pgid - 1] = pgplt1_1.pgnx[pgplt1_1.pgid - 1];
/*<       PGNYC(PGID) = PGNY(PGID) >*/
    pgplt1_1.pgnyc[pgplt1_1.pgid - 1] = pgplt1_1.pgny[pgplt1_1.pgid - 1];
/*<       CALL PGSCH(1.0) >*/
    pgsch_(&c_b4);
/*<       CALL PGVSTD >*/
    pgvstd_();
/*<       END >*/
} /* pgpap_ */

