/* /work2/ssa/pgplot/src/pgpnts.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGPNTS -- draw several graph markers, not all the same */
/* %void cpgpnts(int n, const float *x, const float *y, \ */
/* % const int *symbol, int ns); */
/* + */
/*<       SUBROUTINE PGPNTS (N, X, Y, SYMBOL, NS) >*/
/* Subroutine */ int pgpnts_(n, x, y, symbol, ns)
integer *n;
real *x, *y;
integer *symbol, *ns;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer symb;
    extern /* Subroutine */ int pgpt1_();
    static integer i__;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_();

/*<       INTEGER N, NS >*/
/*<       REAL X(*), Y(*) >*/
/*<       INTEGER SYMBOL(*) >*/

/* Draw Graph Markers. Unlike PGPT, this routine can draw a different */
/* symbol at each point. The markers are drawn using the current values */
/* of attributes color-index, line-width, and character-height */
/* (character-font applies if the symbol number is >31).  If the point */
/* to be marked lies outside the window, no marker is drawn.  The "pen */
/* position" is changed to (XPTS(N),YPTS(N)) in world coordinates */
/* (if N > 0). */

/* Arguments: */
/*  N      (input)  : number of points to mark. */
/*  X      (input)  : world x-coordinate of the points. */
/*  Y      (input)  : world y-coordinate of the points. */
/*  SYMBOL (input)  : code number of the symbol to be plotted at each */
/*                    point (see PGPT). */
/*  NS     (input)  : number of values in the SYMBOL array.  If NS <= N, */
/*                    then the first NS points are drawn using the value */
/*                    of SYMBOL(I) at (X(I), Y(I)) and SYMBOL(1) for all */
/*                    the values of (X(I), Y(I)) where I > NS. */

/* Note: the dimension of arrays X and Y must be greater than or equal */
/* to N and the dimension of the array SYMBOL must be greater than or */
/* equal to NS.  If N is 1, X and Y may be scalars (constants or */
/* variables).  If NS is 1, then SYMBOL may be a scalar.  If N is */
/* less than 1, nothing is drawn. */
/* -- */
/* 11-Mar-1991 - new routine [JM]. */
/* 26-Feb-1997 - revised to use PGPT1 [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER I, SYMB >*/

/*<       IF (N.LT.1) RETURN >*/
    /* Parameter adjustments */
    --symbol;
    --y;
    --x;

    /* Function Body */
    if (*n < 1) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       DO 10 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           IF (I .LE. NS) THEN >*/
	if (i__ <= *ns) {
/*<               SYMB = SYMBOL(I) >*/
	    symb = symbol[i__];
/*<           ELSE >*/
	} else {
/*<               SYMB = SYMBOL(1) >*/
	    symb = symbol[1];
/*<           END IF >*/
	}
/*<           CALL PGPT1(X(I), Y(I), SYMB) >*/
	pgpt1_(&x[i__], &y[i__], &symb);
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgpnts_ */

