/* /work2/ssa/pgplot/src/pgpoly.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static real c_b4 = (float)0.;
static real c_b6 = (float)90.;
static integer c__1 = 1;
static integer c__1000 = 1000;
static integer c__2 = 2;
static integer c__3 = 3;
static integer c__4 = 4;

/* *PGPOLY -- draw a polygon, using fill-area attributes */
/* %void cpgpoly(int n, const float *xpts, const float *ypts); */
/* + */
/*<       SUBROUTINE PGPOLY (N, XPTS, YPTS) >*/
/* Subroutine */ int pgpoly_(n, xpts, ypts)
integer *n;
real *xpts, *ypts;
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Local variables */
    extern /* Subroutine */ int grfa_();
    static logical clip;
    static integer i__, n1, n2, n3, n4;
    static real xh, yh, xl, yl;
    extern /* Subroutine */ int pgbbuf_();
    static real qx[1000], qy[1000], rx[1000], ry[1000];
    extern /* Subroutine */ int grlina_(), pghtch_(), grmova_(), grpocl_(), 
	    grwarn_(), pgebuf_();
    extern logical pgnoto_();

/*<       INTEGER N >*/
/*<       REAL XPTS(*), YPTS(*) >*/

/* Fill-area primitive routine: shade the interior of a closed */
/* polygon in the current window.  The action of this routine depends */
/* on the setting of the Fill-Area Style attribute (see PGSFS). */
/* The polygon is clipped at the edge of the */
/* window. The pen position is changed to (XPTS(1),YPTS(1)) in world */
/* coordinates (if N > 1).  If the polygon is not convex, a point is */
/* assumed to lie inside the polygon if a straight line drawn to */
/* infinity intersects and odd number of the polygon's edges. */

/* Arguments: */
/*  N      (input)  : number of points defining the polygon; the */
/*                    line consists of N straight-line segments, */
/*                    joining points 1 to 2, 2 to 3,... N-1 to N, N to 1. */
/*                    N should be greater than 2 (if it is 2 or less, */
/*                    nothing will be drawn). */
/*  XPTS   (input)  : world x-coordinates of the vertices. */
/*  YPTS   (input)  : world y-coordinates of the vertices. */
/*                    Note: the dimension of arrays XPTS and YPTS must be */
/*                    greater than or equal to N. */
/* -- */
/* 21-Nov-1983 - [TJP]. */
/* 16-Jul-1984 - revised to shade polygon with GRFA [TJP]. */
/* 21-Oct-1985 - test PGFAS [TJP]. */
/* 25-Nov-1994 - implement clipping [TJP]. */
/* 13-Jan-1994 - fix bug in clipping [TJP]. */
/*  6-Mar-1995 - add support for fill styles 3 and 4 [TJP]. */
/* 12-Sep-1995 - fix another bug in clipping [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MAXOUT >*/
/*<       PARAMETER (MAXOUT=1000) >*/
/*<       LOGICAL CLIP >*/
/*<       INTEGER I, N1, N2, N3, N4 >*/
/*<       REAL    QX(MAXOUT), QY(MAXOUT), RX(MAXOUT), RY(MAXOUT) >*/
/*<       REAL    XL, XH, YL, YH >*/
/*<       LOGICAL PGNOTO >*/
/*<       INCLUDE 'pgplot.inc' >*/
/*<       IF (PGNOTO('PGPOLY')) RETURN >*/

/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
    /* Parameter adjustments */
    --ypts;
    --xpts;

    /* Function Body */
    if (pgnoto_("PGPOLY", (ftnlen)6)) {
	return 0;
    }
/*<       IF (N.LT.1) RETURN >*/
    if (*n < 1) {
	return 0;
    }

/* Outline style, or polygon of less than 3 vertices. */

/*<       IF (PGFAS(PGID).EQ.2 .OR. N.LT.3) THEN >*/
    if (pgplt1_1.pgfas[pgplt1_1.pgid - 1] == 2 || *n < 3) {
/*<          CALL PGBBUF >*/
	pgbbuf_();
/*<          CALL GRMOVA(XPTS(N),YPTS(N)) >*/
	grmova_(&xpts[*n], &ypts[*n]);
/*<          DO 10 I=1,N >*/
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<             CALL GRLINA(XPTS(I),YPTS(I)) >*/
	    grlina_(&xpts[i__], &ypts[i__]);
/*<  10      CONTINUE >*/
/* L10: */
	}

/* Hatched style. */

/*<       ELSE IF (PGFAS(PGID).EQ.3) THEN >*/
    } else if (pgplt1_1.pgfas[pgplt1_1.pgid - 1] == 3) {
/*<          CALL PGBBUF >*/
	pgbbuf_();
/*<          CALL PGHTCH(N, XPTS, YPTS, 0.0) >*/
	pghtch_(n, &xpts[1], &ypts[1], &c_b4);
/*<       ELSE IF (PGFAS(PGID).EQ.4) THEN >*/
    } else if (pgplt1_1.pgfas[pgplt1_1.pgid - 1] == 4) {
/*<          CALL PGBBUF >*/
	pgbbuf_();
/*<          CALL PGHTCH(N, XPTS, YPTS, 0.0) >*/
	pghtch_(n, &xpts[1], &ypts[1], &c_b4);
/*<          CALL PGHTCH(N, XPTS, YPTS, 90.0) >*/
	pghtch_(n, &xpts[1], &ypts[1], &c_b6);
/*<       ELSE >*/
    } else {

/* Test whether polygon lies completely in the window. */

/*<          CLIP = .FALSE. >*/
	clip = FALSE_;
/*<          XL = MIN(PGXBLC(PGID),PGXTRC(PGID)) >*/
/* Computing MIN */
	r__1 = pgplt1_1.pgxblc[pgplt1_1.pgid - 1], r__2 = pgplt1_1.pgxtrc[
		pgplt1_1.pgid - 1];
	xl = dmin(r__1,r__2);
/*<          XH = MAX(PGXBLC(PGID),PGXTRC(PGID)) >*/
/* Computing MAX */
	r__1 = pgplt1_1.pgxblc[pgplt1_1.pgid - 1], r__2 = pgplt1_1.pgxtrc[
		pgplt1_1.pgid - 1];
	xh = dmax(r__1,r__2);
/*<          YL = MIN(PGYBLC(PGID),PGYTRC(PGID)) >*/
/* Computing MIN */
	r__1 = pgplt1_1.pgyblc[pgplt1_1.pgid - 1], r__2 = pgplt1_1.pgytrc[
		pgplt1_1.pgid - 1];
	yl = dmin(r__1,r__2);
/*<          YH = MAX(PGYBLC(PGID),PGYTRC(PGID)) >*/
/* Computing MAX */
	r__1 = pgplt1_1.pgyblc[pgplt1_1.pgid - 1], r__2 = pgplt1_1.pgytrc[
		pgplt1_1.pgid - 1];
	yh = dmax(r__1,r__2);
/*<          DO 20 I=1,N >*/
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<    >*/
	    if (xpts[i__] < xl || xpts[i__] > xh || ypts[i__] < yl || ypts[
		    i__] > yh) {
/*<                CLIP = .TRUE. >*/
		clip = TRUE_;
/*<                GOTO 30 >*/
		goto L30;
/*<             END IF >*/
	    }
/*<  20      CONTINUE >*/
/* L20: */
	}
/*<  30      CONTINUE >*/
L30:

/* Filled style, no clipping required. */

/*<          CALL PGBBUF >*/
	pgbbuf_();
/*<          IF (.NOT.CLIP) THEN >*/
	if (! clip) {
/*<             CALL GRFA(N,XPTS,YPTS) >*/
	    grfa_(n, &xpts[1], &ypts[1]);

/* Filled style, clipping required: the vertices of the clipped */
/* polygon are put in temporary arrays QX,QY, RX, RY. */

/*<          ELSE >*/
	} else {
/*<             CALL GRPOCL(N,  XPTS, YPTS, 1, XL, MAXOUT, N1, QX, QY) >*/
	    grpocl_(n, &xpts[1], &ypts[1], &c__1, &xl, &c__1000, &n1, qx, qy);
/*<             IF (N1.GT.MAXOUT) GOTO 40 >*/
	    if (n1 > 1000) {
		goto L40;
	    }
/*<             IF (N1.LT.3) GOTO 50 >*/
	    if (n1 < 3) {
		goto L50;
	    }
/*<             CALL GRPOCL(N1, QX,   QY,   2, XH, MAXOUT, N2, RX, RY) >*/
	    grpocl_(&n1, qx, qy, &c__2, &xh, &c__1000, &n2, rx, ry);
/*<             IF (N2.GT.MAXOUT) GOTO 40 >*/
	    if (n2 > 1000) {
		goto L40;
	    }
/*<             IF (N2.LT.3) GOTO 50 >*/
	    if (n2 < 3) {
		goto L50;
	    }
/*<             CALL GRPOCL(N2, RX,   RY,   3, YL, MAXOUT, N3, QX, QY) >*/
	    grpocl_(&n2, rx, ry, &c__3, &yl, &c__1000, &n3, qx, qy);
/*<             IF (N3.GT.MAXOUT) GOTO 40 >*/
	    if (n3 > 1000) {
		goto L40;
	    }
/*<             IF (N3.LT.3) GOTO 50 >*/
	    if (n3 < 3) {
		goto L50;
	    }
/*<             CALL GRPOCL(N3, QX,   QY,   4, YH, MAXOUT, N4, RX, RY) >*/
	    grpocl_(&n3, qx, qy, &c__4, &yh, &c__1000, &n4, rx, ry);
/*<             IF (N4.GT.MAXOUT) GOTO 40 >*/
	    if (n4 > 1000) {
		goto L40;
	    }
/*<             IF (N4.GT.0) CALL GRFA(N4,RX,RY) >*/
	    if (n4 > 0) {
		grfa_(&n4, rx, ry);
	    }
/*<             GOTO 50 >*/
	    goto L50;
/*<  40         CALL GRWARN('PGPOLY: polygon is too complex') >*/
L40:
	    grwarn_("PGPOLY: polygon is too complex", (ftnlen)30);
/*<  50         CONTINUE >*/
L50:
/*<          END IF >*/
	    ;
	}
/*<       END IF >*/
    }

/* Set the current pen position. */

/*<       CALL GRMOVA(XPTS(1),YPTS(1)) >*/
    grmova_(&xpts[1], &ypts[1]);
/*<       CALL PGEBUF >*/
    pgebuf_();

/*<       END >*/
} /* pgpoly_ */

