/* /work2/ssa/pgplot/src/pgpt1.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* *PGPT1 -- draw one graph marker */
/* %void cpgpt1(float xpt, float ypt, int symbol); */
/* + */
/*<       SUBROUTINE PGPT1 (XPT, YPT, SYMBOL) >*/
/* Subroutine */ int pgpt1_(xpt, ypt, symbol)
real *xpt, *ypt;
integer *symbol;
{
    extern /* Subroutine */ int pgpt_();
    static real xpts[1], ypts[1];
    extern logical pgnoto_();

/*<       REAL XPT, YPT >*/
/*<       INTEGER SYMBOL >*/

/* Primitive routine to draw a single Graph Marker at a specified point. */
/* The marker is drawn using the current values of attributes */
/* color-index, line-width, and character-height (character-font applies */
/* if the symbol number is >31).  If the point to be marked lies outside */
/* the window, no marker is drawn.  The "pen position" is changed to */
/* (XPT,YPT) in world coordinates. */

/* To draw several markers with coordinates specified by X and Y */
/* arrays, use routine PGPT. */

/* Arguments: */
/*  XPT    (input)  : world x-coordinate of the point. */
/*  YPT    (input)  : world y-coordinate of the point. */
/*  SYMBOL (input)  : code number of the symbol to be drawn: */
/*                    -1, -2  : a single dot (diameter = current */
/*                              line width). */
/*                    -3..-31 : a regular polygon with ABS(SYMBOL) */
/*                              edges (style set by current fill style). */
/*                    0..31   : standard marker symbols. */
/*                    32..127 : ASCII characters (in current font). */
/*                              e.g. to use letter F as a marker, let */
/*                              SYMBOL = ICHAR('F'). */
/*                    > 127  :  a Hershey symbol number. */
/* -- */
/*  4-Feb-1997 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL PGNOTO >*/
/*<       REAL XPTS(1), YPTS(1) >*/

/*<       IF (PGNOTO('PGPT1')) RETURN >*/
    if (pgnoto_("PGPT1", (ftnlen)5)) {
	return 0;
    }
/*<       XPTS(1) = XPT >*/
    xpts[0] = *xpt;
/*<       YPTS(1) = YPT >*/
    ypts[0] = *ypt;
/*<       CALL PGPT(1, XPTS, YPTS, SYMBOL) >*/
    pgpt_(&c__1, xpts, ypts, symbol);
/*<       END >*/
} /* pgpt1_ */

