/* /work2/ssa/pgplot/src/pgqdt.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__4 = 4;

/* *PGQDT -- inquire name of nth available device type */
/* %void cpgqdt(int n, char *type, int *type_length, char *descr, \ */
/* % int *descr_length, int *inter); */
/* + */
/*<       SUBROUTINE PGQDT(N, TYPE, TLEN, DESCR, DLEN, INTER) >*/
/* Subroutine */ int pgqdt_(n, type__, tlen, descr, dlen, inter, type_len, 
	descr_len)
integer *n;
char *type__;
integer *tlen;
char *descr;
integer *dlen, *inter;
ftnlen type_len;
ftnlen descr_len;
{
    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer i_indx(), i_len();

    /* Local variables */
    static integer lchr, nbuf, ndev;
    static real rbuf;
    static integer l1, l2;
    extern /* Subroutine */ int grexec_(), pginit_(), pgqndt_();
    static char chr[80];

/*<       INTEGER N >*/
/*<       CHARACTER*(*) TYPE, DESCR >*/
/*<       INTEGER TLEN, DLEN, INTER >*/

/* Return the name of the Nth available device type as a character */
/* string. The number of available types can be determined by calling */
/* PGQNDT. If the value of N supplied is outside the range from 1 to */
/* the number of available types, the routine returns DLEN=TLEN=0. */

/* Arguments: */
/*  N      (input)  : the number of the device type (1..maximum). */
/*  TYPE   (output) : receives the character device-type code of the */
/*                    Nth device type. The argument supplied should be */
/*                    large enough for at least 8 characters. The first */
/*                    character in the string is a '/' character. */
/*  TLEN   (output) : receives the number of characters in TYPE, */
/*                    excluding trailing blanks. */
/*  DESCR  (output) : receives a description of the device type. The */
/*                    argument supplied should be large enough for at */
/*                    least 64 characters. */
/*  DLEN   (output) : receives the number of characters in DESCR, */
/*                    excluding trailing blanks. */
/*  INTER  (output) : receives 1 if the device type is an interactive */
/*                    one, 0 otherwise. */
/* -- */
/* 17-Mar-1997 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER NDEV, NBUF, LCHR, L1, L2 >*/
/*<       REAL RBUF >*/
/*<       CHARACTER*80 CHR >*/

/* Initialize PGPLOT if necessary. */

/*<       CALL PGINIT >*/
    pginit_();

/*<       TYPE = 'error' >*/
    s_copy(type__, "error", type_len, (ftnlen)5);
/*<       TLEN = 0 >*/
    *tlen = 0;
/*<       DESCR = ' ' >*/
    s_copy(descr, " ", descr_len, (ftnlen)1);
/*<       DLEN = 0 >*/
    *dlen = 0;
/*<       INTER = 1 >*/
    *inter = 1;
/*<       CALL PGQNDT(NDEV) >*/
    pgqndt_(&ndev);
/*<       IF (N.GE.1 .AND. N.LE.NDEV) THEN >*/
    if (*n >= 1 && *n <= ndev) {
/*<          NBUF = 0 >*/
	nbuf = 0;
/*<          CALL GREXEC(N, 1, RBUF, NBUF, CHR, LCHR) >*/
	grexec_(n, &c__1, &rbuf, &nbuf, chr, &lchr, (ftnlen)80);
/*<          IF (LCHR.GT.0) THEN >*/
	if (lchr > 0) {
/*<             L1 = INDEX(CHR(1:LCHR), ' ') >*/
	    l1 = i_indx(chr, " ", lchr, (ftnlen)1);
/*<             IF (L1.GT.1) THEN >*/
	    if (l1 > 1) {
/*<                TYPE(1:1) = '/' >*/
		*(unsigned char *)type__ = '/';
/*<                IF (LEN(TYPE).GT.1) TYPE(2:) = CHR(1:L1-1) >*/
		if (i_len(type__, type_len) > 1) {
		    s_copy(type__ + 1, chr, type_len - 1, l1 - 1);
		}
/*<                TLEN = MIN(L1,LEN(TYPE)) >*/
/* Computing MIN */
		i__1 = l1, i__2 = i_len(type__, type_len);
		*tlen = min(i__1,i__2);
/*<             END IF >*/
	    }
/*<             L2 = INDEX(CHR(1:LCHR), '(') >*/
	    l2 = i_indx(chr, "(", lchr, (ftnlen)1);
/*<             IF (L2.GT.0) DESCR = CHR(L2:LCHR) >*/
	    if (l2 > 0) {
		s_copy(descr, chr + (l2 - 1), descr_len, lchr - (l2 - 1));
	    }
/*<             DLEN = MIN(LCHR-L2+1,LEN(DESCR)) >*/
/* Computing MIN */
	    i__1 = lchr - l2 + 1, i__2 = i_len(descr, descr_len);
	    *dlen = min(i__1,i__2);
/*<             CALL GREXEC(N, 4, RBUF, NBUF, CHR, LCHR) >*/
	    grexec_(n, &c__4, &rbuf, &nbuf, chr, &lchr, (ftnlen)80);
/*<             IF (CHR(1:1).EQ.'H') INTER = 0 >*/
	    if (*(unsigned char *)chr == 'H') {
		*inter = 0;
	    }
/*<          END IF >*/
	}
/*<       END IF >*/
    }

/*<       END >*/
} /* pgqdt_ */

