/* /work2/ssa/pgplot/src/pgqinf.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGQINF -- inquire PGPLOT general information */
/* %void cpgqinf(const char *item, char *value, int *value_length); */
/* + */
/*<       SUBROUTINE PGQINF (ITEM, VALUE, LENGTH) >*/
/* Subroutine */ int pgqinf_(item, value, length, item_len, value_len)
char *item, *value;
integer *length;
ftnlen item_len;
ftnlen value_len;
{
    /* Builtin functions */
    integer s_cmp();
    /* Subroutine */ int s_copy();

    /* Local variables */
    static logical same;
    static char test[8];
    static logical inter;
    extern /* Subroutine */ int grqdt_();
    static integer l1;
    extern /* Subroutine */ int grdate_(), pginit_(), grqdev_(), grqcap_();
    extern integer grtrim_();
    extern /* Subroutine */ int gruser_(), grtter_(), grtoup_(), grqtyp_();
    static integer ier;
    static char dev1[64];

/*<       CHARACTER*(*) ITEM, VALUE >*/
/*<       INTEGER LENGTH >*/

/* This routine can be used to obtain miscellaneous information about */
/* the PGPLOT environment. Input is a character string defining the */
/* information required, and output is a character string containing the */
/* requested information. */

/* The following item codes are accepted (note that the strings must */
/* match exactly, except for case, but only the first 8 characters are */
/* significant). For items marked *, PGPLOT must be in the OPEN state */
/* for the inquiry to succeed. If the inquiry is unsuccessful, either */
/* because the item code is not recognized or because the information */
/* is not available, a question mark ('?') is returned. */

/*   'VERSION'     - version of PGPLOT software in use. */
/*   'STATE'       - status of PGPLOT ('OPEN' if a graphics device */
/*                   is open for output, 'CLOSED' otherwise). */
/*   'USER'        - the username associated with the calling program. */
/*   'NOW'         - current date and time (e.g., '17-FEB-1986 10:04'). */
/*   'DEVICE'    * - current PGPLOT device or file. */
/*   'FILE'      * - current PGPLOT device or file. */
/*   'TYPE'      * - device-type of the current PGPLOT device. */
/*   'DEV/TYPE'  * - current PGPLOT device and type, in a form which */
/*                   is acceptable as an argument for PGBEG. */
/*   'HARDCOPY'  * - is the current device a hardcopy device? ('YES' or */
/*                   'NO'). */
/*   'TERMINAL'  * - is the current device the user's interactive */
/*                   terminal? ('YES' or 'NO'). */
/*   'CURSOR'    * - does the current device have a graphics cursor? */
/*                   ('YES' or 'NO'). */
/*   'SCROLL'    * - does current device have rectangle-scroll */
/*                   capability ('YES' or 'NO'); see PGSCRL. */

/* Arguments: */
/*  ITEM  (input)  : character string defining the information to */
/*                   be returned; see above for a list of possible */
/*                   values. */
/*  VALUE (output) : returns a character-string containing the */
/*                   requested information, truncated to the length */
/*                   of the supplied string or padded on the right with */
/*                   spaces if necessary. */
/*  LENGTH (output): the number of characters returned in VALUE */
/*                   (excluding trailing blanks). */
/* -- */
/* 18-Feb-1988 - [TJP]. */
/* 30-Aug-1988 - remove pseudo logical use of IER. */
/* 12-Mar-1992 - change comments for clarity. */
/* 17-Apr-1995 - clean up some zero-length string problems [TJP]. */
/*  7-Jul-1995 - get cursor information directly from driver [TJP]. */
/* 24-Feb-1997 - add SCROLL request. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       INTEGER IER, L1, GRTRIM >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL INTER, SAME >*/
/*<       CHARACTER*8 TEST >*/
/*<       CHARACTER*64 DEV1 >*/

/* Initialize PGPLOT if necessary. */

/*<       CALL PGINIT >*/
    pginit_();

/*<       CALL GRTOUP(TEST,ITEM) >*/
    grtoup_(test, item, (ftnlen)8, item_len);
/*<       IF (TEST.EQ.'USER') THEN >*/
    if (s_cmp(test, "USER", (ftnlen)8, (ftnlen)4) == 0) {
/*<           CALL GRUSER(VALUE, LENGTH) >*/
	gruser_(value, length, value_len);
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (TEST.EQ.'NOW') THEN >*/
    } else if (s_cmp(test, "NOW", (ftnlen)8, (ftnlen)3) == 0) {
/*<           CALL GRDATE(VALUE, LENGTH) >*/
	grdate_(value, length, value_len);
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (TEST.EQ.'VERSION') THEN >*/
    } else if (s_cmp(test, "VERSION", (ftnlen)8, (ftnlen)7) == 0) {
/*<           VALUE = 'v5.2.2' >*/
	s_copy(value, "v5.2.2", value_len, (ftnlen)6);
/*<           LENGTH = 6 >*/
	*length = 6;
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (TEST.EQ.'STATE') THEN >*/
    } else if (s_cmp(test, "STATE", (ftnlen)8, (ftnlen)5) == 0) {
/*<           IF (PGID.LT.1 .OR. PGID.GT.PGMAXD) THEN >*/
	if (pgplt1_1.pgid < 1 || pgplt1_1.pgid > 8) {
/*<              VALUE = 'CLOSED' >*/
	    s_copy(value, "CLOSED", value_len, (ftnlen)6);
/*<              LENGTH = 6 >*/
	    *length = 6;
/*<           ELSE IF (PGDEVS(PGID).EQ.0) THEN >*/
	} else if (pgplt1_1.pgdevs[pgplt1_1.pgid - 1] == 0) {
/*<              VALUE = 'CLOSED' >*/
	    s_copy(value, "CLOSED", value_len, (ftnlen)6);
/*<              LENGTH = 6 >*/
	    *length = 6;
/*<           ELSE >*/
	} else {
/*<              VALUE = 'OPEN' >*/
	    s_copy(value, "OPEN", value_len, (ftnlen)4);
/*<              LENGTH = 4 >*/
	    *length = 4;
/*<           END IF >*/
	}
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (PGID.LT.1 .OR. PGID.GT.PGMAXD) THEN >*/
    } else if (pgplt1_1.pgid < 1 || pgplt1_1.pgid > 8) {
/*<           IER = 0 >*/
	ier = 0;
/*<       ELSE IF (PGDEVS(PGID).EQ.0) THEN >*/
    } else if (pgplt1_1.pgdevs[pgplt1_1.pgid - 1] == 0) {
/*<           IER = 0 >*/
	ier = 0;
/*<       ELSE IF (TEST.EQ.'DEV/TYPE') THEN >*/
    } else if (s_cmp(test, "DEV/TYPE", (ftnlen)8, (ftnlen)8) == 0) {
/*<           CALL GRQDT(VALUE) >*/
	grqdt_(value, value_len);
/*<           LENGTH = GRTRIM(VALUE) >*/
	*length = grtrim_(value, value_len);
/*<           IER = 0 >*/
	ier = 0;
/*<           IF (LENGTH.GT.0) IER = 1 >*/
	if (*length > 0) {
	    ier = 1;
	}
/*<       ELSE IF (TEST.EQ.'DEVICE' .OR. TEST.EQ.'FILE') THEN >*/
    } else if (s_cmp(test, "DEVICE", (ftnlen)8, (ftnlen)6) == 0 || s_cmp(test,
	     "FILE", (ftnlen)8, (ftnlen)4) == 0) {
/*<           CALL GRQDEV(VALUE, LENGTH) >*/
	grqdev_(value, length, value_len);
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (TEST.EQ.'TERMINAL') THEN >*/
    } else if (s_cmp(test, "TERMINAL", (ftnlen)8, (ftnlen)8) == 0) {
/*<           CALL GRQDEV(DEV1, L1) >*/
	grqdev_(dev1, &l1, (ftnlen)64);
/*<           IF (L1.GE.1) THEN >*/
	if (l1 >= 1) {
/*<              CALL GRTTER(DEV1(1:L1), SAME) >*/
	    grtter_(dev1, &same, l1);
/*<           ELSE >*/
	} else {
/*<              SAME = .FALSE. >*/
	    same = FALSE_;
/*<           END IF >*/
	}
/*<           IF (SAME) THEN >*/
	if (same) {
/*<               VALUE = 'YES' >*/
	    s_copy(value, "YES", value_len, (ftnlen)3);
/*<               LENGTH = 3 >*/
	    *length = 3;
/*<           ELSE >*/
	} else {
/*<               VALUE = 'NO' >*/
	    s_copy(value, "NO", value_len, (ftnlen)2);
/*<               LENGTH = 2 >*/
	    *length = 2;
/*<           END IF >*/
	}
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (TEST.EQ.'TYPE') THEN >*/
    } else if (s_cmp(test, "TYPE", (ftnlen)8, (ftnlen)4) == 0) {
/*<           CALL GRQTYP(VALUE,INTER) >*/
	grqtyp_(value, &inter, value_len);
/*<           LENGTH = GRTRIM(VALUE) >*/
	*length = grtrim_(value, value_len);
/*<           IER = 0 >*/
	ier = 0;
/*<           IF (LENGTH.GT.0) IER = 1 >*/
	if (*length > 0) {
	    ier = 1;
	}
/*<       ELSE IF (TEST.EQ.'HARDCOPY') THEN >*/
    } else if (s_cmp(test, "HARDCOPY", (ftnlen)8, (ftnlen)8) == 0) {
/*<           CALL GRQTYP(VALUE,INTER) >*/
	grqtyp_(value, &inter, value_len);
/*<           IF (INTER) THEN >*/
	if (inter) {
/*<               VALUE = 'NO' >*/
	    s_copy(value, "NO", value_len, (ftnlen)2);
/*<               LENGTH = 2 >*/
	    *length = 2;
/*<           ELSE >*/
	} else {
/*<               VALUE = 'YES' >*/
	    s_copy(value, "YES", value_len, (ftnlen)3);
/*<               LENGTH = 3 >*/
	    *length = 3;
/*<           END IF >*/
	}
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (TEST.EQ.'CURSOR') THEN >*/
    } else if (s_cmp(test, "CURSOR", (ftnlen)8, (ftnlen)6) == 0) {
/*<           CALL GRQCAP(DEV1) >*/
	grqcap_(dev1, (ftnlen)64);
/*<           IF (DEV1(2:2).EQ.'N') THEN >*/
	if (*(unsigned char *)&dev1[1] == 'N') {
/*<               VALUE = 'NO' >*/
	    s_copy(value, "NO", value_len, (ftnlen)2);
/*<               LENGTH = 2 >*/
	    *length = 2;
/*<           ELSE >*/
	} else {
/*<               VALUE = 'YES' >*/
	    s_copy(value, "YES", value_len, (ftnlen)3);
/*<               LENGTH = 3 >*/
	    *length = 3;
/*<           END IF >*/
	}
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE IF (TEST.EQ.'SCROLL') THEN >*/
    } else if (s_cmp(test, "SCROLL", (ftnlen)8, (ftnlen)6) == 0) {
/*<           CALL GRQCAP(DEV1) >*/
	grqcap_(dev1, (ftnlen)64);
/*<           IF (DEV1(11:11).NE.'S') THEN >*/
	if (*(unsigned char *)&dev1[10] != 'S') {
/*<               VALUE = 'NO' >*/
	    s_copy(value, "NO", value_len, (ftnlen)2);
/*<               LENGTH = 2 >*/
	    *length = 2;
/*<           ELSE >*/
	} else {
/*<               VALUE = 'YES' >*/
	    s_copy(value, "YES", value_len, (ftnlen)3);
/*<               LENGTH = 3 >*/
	    *length = 3;
/*<           END IF >*/
	}
/*<           IER = 1 >*/
	ier = 1;
/*<       ELSE >*/
    } else {
/*<           IER = 0 >*/
	ier = 0;
/*<       END IF >*/
    }
/*<       IF (IER.NE.1) THEN >*/
    if (ier != 1) {
/*<          VALUE = '?' >*/
	s_copy(value, "?", value_len, (ftnlen)1);
/*<          LENGTH = 1 >*/
	*length = 1;
/*<       ELSE IF (LENGTH.LT.1) THEN >*/
    } else if (*length < 1) {
/*<          LENGTH = 1 >*/
	*length = 1;
/*<          VALUE = ' ' >*/
	s_copy(value, " ", value_len, (ftnlen)1);
/*<       END IF >*/
    }
/*<       END >*/
} /* pgqinf_ */

