/* /work2/ssa/pgplot/src/pgqtxt.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGQTXT -- find bounding box of text string */
/* %void cpgqtxt(float x, float y, float angle, float fjust, \ */
/* % const char *text, float *xbox, float *ybox); */
/* + */
/*<       SUBROUTINE PGQTXT (X, Y, ANGLE, FJUST, TEXT, XBOX, YBOX) >*/
/* Subroutine */ int pgqtxt_(x, y, angle, fjust, text, xbox, ybox, text_len)
real *x, *y, *angle, *fjust;
char *text;
real *xbox, *ybox;
ftnlen text_len;
{
    /* Builtin functions */
    double cos(), sin();

    /* Local variables */
    static real d__;
    static integer i__, l;
    extern /* Subroutine */ int grlen_();
    static real xoffs, yoffs, xpbox[4], ypbox[4], xp, yp;
    extern integer grtrim_();
    extern logical pgnoto_();
    extern /* Subroutine */ int grqtxt_();

/*<       REAL X, Y, ANGLE, FJUST >*/
/*<       CHARACTER*(*) TEXT >*/
/*<       REAL XBOX(4), YBOX(4) >*/

/* This routine returns a bounding box for a text string. Instead */
/* of drawing the string as routine PGPTXT does, it returns in XBOX */
/* and YBOX the coordinates of the corners of a rectangle parallel */
/* to the string baseline that just encloses the string. The four */
/* corners are in the order: lower left, upper left, upper right, */
/* lower right (where left and right refer to the first and last */
/* characters in the string). */

/* If the string is blank or contains no drawable characters, all */
/* four elements of XBOX and YBOX are assigned the starting point */
/* of the string, (X,Y). */

/* Arguments: */
/*  X, Y, ANGLE, FJUST, TEXT (input) : these arguments are the same as */
/*                    the corrresponding arguments in PGPTXT. */
/*  XBOX, YBOX (output) : arrays of dimension 4; on output, they */
/*                    contain the world coordinates of the bounding */
/*                    box in (XBOX(1), YBOX(1)), ..., (XBOX(4), YBOX(4)). */
/* -- */
/* 12-Sep-1993 - new routine [TJP]. */
/*  8-Nov-1994 - return something for blank string [TJP]. */
/* 14-Jan-1997 - additional explanation [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       LOGICAL PGNOTO >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER I, L, GRTRIM >*/
/*<       REAL D, XP, YP, XPBOX(4), YPBOX(4), XOFFS, YOFFS >*/

/*<       IF (PGNOTO('PGQTXT')) RETURN >*/
    /* Parameter adjustments */
    --ybox;
    --xbox;

    /* Function Body */
    if (pgnoto_("PGQTXT", (ftnlen)6)) {
	return 0;
    }

/*<       L = GRTRIM(TEXT) >*/
    l = grtrim_(text, text_len);
/*<       IF (L.LE.0) THEN >*/
    if (l <= 0) {
/*<          DO 15 I=1,4 >*/
	for (i__ = 1; i__ <= 4; ++i__) {
/*<             XBOX(I) = X >*/
	    xbox[i__] = *x;
/*<             YBOX(I) = Y >*/
	    ybox[i__] = *y;
/*<  15      CONTINUE >*/
/* L15: */
	}
/*<       ELSE >*/
    } else {
/*<          D = 0.0 >*/
	d__ = (float)0.;
/*<          IF (FJUST.NE.0.0) CALL GRLEN(TEXT(1:L),D) >*/
	if (*fjust != (float)0.) {
	    grlen_(text, &d__, l);
	}
/*<          XOFFS = PGXORG(PGID) - D*FJUST*COS(ANGLE/57.29578) >*/
	xoffs = pgplt1_1.pgxorg[pgplt1_1.pgid - 1] - d__ * *fjust * cos(*
		angle / (float)57.29578);
/*<          YOFFS = PGYORG(PGID) - D*FJUST*SIN(ANGLE/57.29578) >*/
	yoffs = pgplt1_1.pgyorg[pgplt1_1.pgid - 1] - d__ * *fjust * sin(*
		angle / (float)57.29578);
/*<          XP = X*PGXSCL(PGID) + XOFFS >*/
	xp = *x * pgplt1_1.pgxscl[pgplt1_1.pgid - 1] + xoffs;
/*<          YP = Y*PGYSCL(PGID) + YOFFS >*/
	yp = *y * pgplt1_1.pgyscl[pgplt1_1.pgid - 1] + yoffs;
/*<          CALL GRQTXT(ANGLE, XP, YP, TEXT(1:L), XPBOX, YPBOX) >*/
	grqtxt_(angle, &xp, &yp, text, xpbox, ypbox, l);
/*<          DO 25 I=1,4 >*/
	for (i__ = 1; i__ <= 4; ++i__) {
/*<             XBOX(I) = (XPBOX(I) - PGXORG(PGID))/PGXSCL(PGID) >*/
	    xbox[i__] = (xpbox[i__ - 1] - pgplt1_1.pgxorg[pgplt1_1.pgid - 1]) 
		    / pgplt1_1.pgxscl[pgplt1_1.pgid - 1];
/*<             YBOX(I) = (YPBOX(I) - PGYORG(PGID))/PGYSCL(PGID) >*/
	    ybox[i__] = (ypbox[i__ - 1] - pgplt1_1.pgyorg[pgplt1_1.pgid - 1]) 
		    / pgplt1_1.pgyscl[pgplt1_1.pgid - 1];
/*<  25      CONTINUE >*/
/* L25: */
	}
/*<       END IF >*/
    }
/*<       END >*/
} /* pgqtxt_ */

