/* /work2/ssa/pgplot/src/pgqvp.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGQVP -- inquire viewport size and position */
/* %void cpgqvp(int units, float *x1, float *x2, float *y1, float *y2); */
/* + */
/*<       SUBROUTINE PGQVP (UNITS, X1, X2, Y1, Y2) >*/
/* Subroutine */ int pgqvp_(units, x1, x2, y1, y2)
integer *units;
real *x1, *x2, *y1, *y2;
{
    static real sx, sy;
    extern /* Subroutine */ int grwarn_();

/*<       INTEGER UNITS >*/
/*<       REAL    X1, X2, Y1, Y2 >*/

/* Inquiry routine to determine the current viewport setting. */
/* The values returned may be normalized device coordinates, inches, mm, */
/* or pixels, depending on the value of the input parameter CFLAG. */

/* Arguments: */
/*  UNITS  (input)  : used to specify the units of the output parameters: */
/*                    UNITS = 0 : normalized device coordinates */
/*                    UNITS = 1 : inches */
/*                    UNITS = 2 : millimeters */
/*                    UNITS = 3 : pixels */
/*                    Other values give an error message, and are */
/*                    treated as 0. */
/*  X1     (output) : the x-coordinate of the bottom left corner of the */
/*                    viewport. */
/*  X2     (output) : the x-coordinate of the top right corner of the */
/*                    viewport. */
/*  Y1     (output) : the y-coordinate of the bottom left corner of the */
/*                    viewport. */
/*  Y2     (output) : the y-coordinate of the top right corner of the */
/*                    viewport. */
/* -- */
/* 26-Sep-1985 - new routine (TJP). */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       REAL SX, SY >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */

/*<       IF (UNITS.EQ.0) THEN >*/
    if (*units == 0) {
/*<           SX = PGXSZ(PGID) >*/
	sx = pgplt1_1.pgxsz[pgplt1_1.pgid - 1];
/*<           SY = PGYSZ(PGID) >*/
	sy = pgplt1_1.pgysz[pgplt1_1.pgid - 1];
/*<       ELSE IF (UNITS.EQ.1) THEN >*/
    } else if (*units == 1) {
/*<           SX = PGXPIN(PGID) >*/
	sx = pgplt1_1.pgxpin[pgplt1_1.pgid - 1];
/*<           SY = PGYPIN(PGID) >*/
	sy = pgplt1_1.pgypin[pgplt1_1.pgid - 1];
/*<       ELSE IF (UNITS.EQ.2) THEN >*/
    } else if (*units == 2) {
/*<           SX = (PGXPIN(PGID)/25.4) >*/
	sx = pgplt1_1.pgxpin[pgplt1_1.pgid - 1] / (float)25.4;
/*<           SY = (PGYPIN(PGID)/25.4) >*/
	sy = pgplt1_1.pgypin[pgplt1_1.pgid - 1] / (float)25.4;
/*<       ELSE IF (UNITS.EQ.3) THEN >*/
    } else if (*units == 3) {
/*<           SX = 1.0 >*/
	sx = (float)1.;
/*<           SY = 1.0 >*/
	sy = (float)1.;
/*<       ELSE >*/
    } else {
/*<    >*/
	grwarn_("Illegal value for parameter UNITS in routine PGQVP", (ftnlen)
		50);
/*<           SX = PGXSZ(PGID) >*/
	sx = pgplt1_1.pgxsz[pgplt1_1.pgid - 1];
/*<           SY = PGYSZ(PGID) >*/
	sy = pgplt1_1.pgysz[pgplt1_1.pgid - 1];
/*<       END IF >*/
    }
/*<       X1 = PGXVP(PGID)/SX >*/
    *x1 = pgplt1_1.pgxvp[pgplt1_1.pgid - 1] / sx;
/*<       X2 = (PGXVP(PGID)+PGXLEN(PGID))/SX >*/
    *x2 = (pgplt1_1.pgxvp[pgplt1_1.pgid - 1] + pgplt1_1.pgxlen[pgplt1_1.pgid 
	    - 1]) / sx;
/*<       Y1 = PGYVP(PGID)/SY >*/
    *y1 = pgplt1_1.pgyvp[pgplt1_1.pgid - 1] / sy;
/*<       Y2 = (PGYVP(PGID)+PGYLEN(PGID))/SY >*/
    *y2 = (pgplt1_1.pgyvp[pgplt1_1.pgid - 1] + pgplt1_1.pgylen[pgplt1_1.pgid 
	    - 1]) / sy;
/*<       END >*/
} /* pgqvp_ */

