/* /work2/ssa/pgplot/src/pgrect.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__4 = 4;
static real c_b3 = (float)0.;
static real c_b5 = (float)90.;

/* *PGRECT -- draw a rectangle, using fill-area attributes */
/* %void cpgrect(float x1, float x2, float y1, float y2); */
/* + */
/*<       SUBROUTINE PGRECT (X1, X2, Y1, Y2) >*/
/* Subroutine */ int pgrect_(x1, x2, y1, y2)
real *x1, *x2, *y1, *y2;
{
    extern /* Subroutine */ int pgbbuf_();
    static real xp[4], yp[4];
    extern /* Subroutine */ int pgebuf_(), grlina_(), pghtch_(), grmova_(), 
	    grrect_();

/*<       REAL X1, X2, Y1, Y2 >*/

/* This routine can be used instead of PGPOLY for the special case of */
/* drawing a rectangle aligned with the coordinate axes; only two */
/* vertices need be specified instead of four.  On most devices, it is */
/* faster to use PGRECT than PGPOLY for drawing rectangles.  The */
/* rectangle has vertices at (X1,Y1), (X1,Y2), (X2,Y2), and (X2,Y1). */

/* Arguments: */
/*  X1, X2 (input) : the horizontal range of the rectangle. */
/*  Y1, Y2 (input) : the vertical range of the rectangle. */
/* -- */
/* 21-Nov-1986 - [TJP]. */
/* 22-Mar-1988 - use GRRECT for fill [TJP]. */
/*  6-Mar-1995 - add hatching (by calling PGHTCH) [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       REAL XP(4), YP(4) >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */

/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Outline only. */

/*<       IF (PGFAS(PGID).EQ.2) THEN >*/
    if (pgplt1_1.pgfas[pgplt1_1.pgid - 1] == 2) {
/*<          CALL GRMOVA(X1,Y1) >*/
	grmova_(x1, y1);
/*<          CALL GRLINA(X1,Y2) >*/
	grlina_(x1, y2);
/*<          CALL GRLINA(X2,Y2) >*/
	grlina_(x2, y2);
/*<          CALL GRLINA(X2,Y1) >*/
	grlina_(x2, y1);
/*<          CALL GRLINA(X1,Y1) >*/
	grlina_(x1, y1);

/* Hatching. */

/*<       ELSE IF (PGFAS(PGID).EQ.3 .OR. PGFAS(PGID).EQ.4) THEN >*/
    } else if (pgplt1_1.pgfas[pgplt1_1.pgid - 1] == 3 || pgplt1_1.pgfas[
	    pgplt1_1.pgid - 1] == 4) {
/*<          XP(1) = X1 >*/
	xp[0] = *x1;
/*<          XP(2) = X1 >*/
	xp[1] = *x1;
/*<          XP(3) = X2 >*/
	xp[2] = *x2;
/*<          XP(4) = X2 >*/
	xp[3] = *x2;
/*<          YP(1) = Y1 >*/
	yp[0] = *y1;
/*<          YP(2) = Y2 >*/
	yp[1] = *y2;
/*<          YP(3) = Y2 >*/
	yp[2] = *y2;
/*<          YP(4) = Y1 >*/
	yp[3] = *y1;
/*<          CALL PGHTCH(4, XP, YP, 0.0) >*/
	pghtch_(&c__4, xp, yp, &c_b3);
/*<          IF (PGFAS(PGID).EQ.4) CALL PGHTCH(4, XP, YP, 90.0) >*/
	if (pgplt1_1.pgfas[pgplt1_1.pgid - 1] == 4) {
	    pghtch_(&c__4, xp, yp, &c_b5);
	}

/* Solid fill. */

/*<       ELSE >*/
    } else {
/*<           CALL GRRECT(X1,Y1,X2,Y2) >*/
	grrect_(x1, y1, x2, y2);
/*<           CALL GRMOVA(X1,Y1) >*/
	grmova_(x1, y1);
/*<       END IF >*/
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgrect_ */

