/* /work2/ssa/pgplot/src/pgrnge.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGRNGE -- choose axis limits */
/* %void cpgrnge(float x1, float x2, float *xlo, float *xhi); */
/* + */
/*<       SUBROUTINE PGRNGE (X1, X2, XLO, XHI) >*/
/* Subroutine */ int pgrnge_(x1, x2, xlo, xhi)
real *x1, *x2, *xlo, *xhi;
{
/*<       REAL X1, X2, XLO, XHI >*/

/* Choose plotting limits XLO and XHI which encompass the data */
/* range X1 to X2. */

/* Arguments: */
/*  X1, X2 (input)  : the data range (X1<X2), ie, the min and max values */
/*                    to be plotted. */
/*  XLO, XHI (output) : suitable values to use as the extremes of a graph */
/*                    axis (XLO <= X1, XHI >= X2). */
/* -- */
/* 10-Nov-1985 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       XLO = X1 - 0.1*(X2-X1) >*/
    *xlo = *x1 - (*x2 - *x1) * (float).1;
/*<       XHI = X2 + 0.1*(X2-X1) >*/
    *xhi = *x2 + (*x2 - *x1) * (float).1;
/*<       IF (XLO.LT.0.0 .AND. X1.GE.0.0) XLO = 0.0 >*/
    if (*xlo < (float)0. && *x1 >= (float)0.) {
	*xlo = (float)0.;
    }
/*<       IF (XHI.GT.0.0 .AND. X2.LE.0.0) XHI = 0.0 >*/
    if (*xhi > (float)0. && *x2 <= (float)0.) {
	*xhi = (float)0.;
    }
/*<       END >*/
} /* pgrnge_ */

