/* /work2/ssa/pgplot/src/pgsave.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGSAVE -- save PGPLOT attributes */
/* %void cpgsave(void); */
/* + */
/*<       SUBROUTINE PGSAVE >*/
/* Subroutine */ int pgsave_0_(n__)
int n__;
{
    /* Initialized data */

    static integer lev = 0;

    static integer ahfs[20];
    static real ahang[20];
    extern /* Subroutine */ int pgqcf_(), pgqah_(), pgqch_(), pgqci_(), 
	    pgscf_(), pgsch_(), pgsci_(), pgsah_(), pgqfs_(), pgqhs_(), 
	    pgsfs_(), pgshs_(), pgqls_(), pgsls_(), pgqlw_(), pgslw_();
    static integer cf[20];
    static real ch[20];
    static integer ci[20];
    static real ahbarb[20];
    static integer fs[20], ls[20], lw[20];
    extern /* Subroutine */ int pgqtbg_(), pgqclp_(), pgstbg_(), pgsclp_(), 
	    pgmove_(), grwarn_(), pgqpos_();
    static real hsa[20];
    static integer tbg[20], clp[20];
    static real hsp[20], hss[20], pos[40]	/* was [2][20] */;


/* This routine saves the current PGPLOT attributes in a private storage */
/* area. They can be restored by calling PGUNSA (unsave). Attributes */
/* saved are: character font, character height, color index, fill-area */
/* style, line style, line width, pen position, arrow-head style, */
/* hatching style, and clipping state. Color representation is not saved. */

/* Calls to PGSAVE and PGUNSA should always be paired. Up to 20 copies */
/* of the attributes may be saved. PGUNSA always retrieves the last-saved */
/* values (last-in first-out stack). */

/* Note that when multiple devices are in use, PGUNSA retrieves the */
/* values saved by the last PGSAVE call, even if they were for a */
/* different device. */

/* Arguments: none */
/* -- */
/* 20-Apr-1992 - new routine [TJP]. */
/* 27-Nov-1992 - add arrowhead style [TJP]. */
/*  6-Oct-1993 - add text opacity [TJP]. */
/* 28-Feb-1994 - correct bug (variable not saved) [TJP]. */
/* 26-Feb-1995 - add hatching attributes. */
/* 19-Jun-1996 - correction in header comments [TJP]. */
/* 26-Feb-1997 - add clipping state [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MAXS >*/
/*<       PARAMETER (MAXS=20) >*/

/*<       INTEGER LEV >*/
/*<       INTEGER CF(MAXS), CI(MAXS), FS(MAXS), LS(MAXS), LW(MAXS) >*/
/*<       INTEGER AHFS(MAXS), TBG(MAXS), CLP(MAXS) >*/
/*<       REAL    CH(MAXS), POS(2,MAXS) >*/
/*<       REAL    AHANG(MAXS), AHBARB(MAXS), HSA(MAXS), HSS(MAXS), HSP(MAXS) >*/
/*<       SAVE    LEV, CF, CI, FS, LS, LW, AHFS, TBG, CH, POS >*/
/*<       SAVE    AHANG, AHBARB, HSA, HSS, HSP, CLP >*/
/*<       DATA    LEV /0/ >*/
    switch(n__) {
	case 1: goto L_pgunsa;
	}


/*<       IF (LEV.GE.MAXS) THEN >*/
    if (lev >= 20) {
/*<           CALL GRWARN('Too many unmatched calls to PGSAVE') >*/
	grwarn_("Too many unmatched calls to PGSAVE", (ftnlen)34);
/*<       ELSE >*/
    } else {
/*<           LEV = LEV+1 >*/
	++lev;
/*<           CALL PGQCF(CF(LEV)) >*/
	pgqcf_(&cf[lev - 1]);
/*<           CALL PGQCH(CH(LEV)) >*/
	pgqch_(&ch[lev - 1]);
/*<           CALL PGQCI(CI(LEV)) >*/
	pgqci_(&ci[lev - 1]);
/*<           CALL PGQFS(FS(LEV)) >*/
	pgqfs_(&fs[lev - 1]);
/*<           CALL PGQLS(LS(LEV)) >*/
	pgqls_(&ls[lev - 1]);
/*<           CALL PGQLW(LW(LEV)) >*/
	pgqlw_(&lw[lev - 1]);
/*          CALL PGQVP(0, VP(1,LEV), VP(2,LEV), VP(3,LEV), VP(4,LEV)) */
/*          CALL PGQWIN(WIN(1,LEV), WIN(2,LEV), WIN(3,LEV), WIN(4,LEV)) */
/*<           CALL PGQPOS(POS(1,LEV), POS(2,LEV)) >*/
	pgqpos_(&pos[(lev << 1) - 2], &pos[(lev << 1) - 1]);
/*<           CALL PGQAH(AHFS(LEV), AHANG(LEV), AHBARB(LEV)) >*/
	pgqah_(&ahfs[lev - 1], &ahang[lev - 1], &ahbarb[lev - 1]);
/*<           CALL PGQTBG(TBG(LEV)) >*/
	pgqtbg_(&tbg[lev - 1]);
/*<           CALL PGQHS(HSA(LEV), HSS(LEV), HSP(LEV)) >*/
	pgqhs_(&hsa[lev - 1], &hss[lev - 1], &hsp[lev - 1]);
/*<           CALL PGQCLP(CLP(LEV)) >*/
	pgqclp_(&clp[lev - 1]);
/*<       END IF >*/
    }
/*<       RETURN      >*/
    return 0;

/* *PGUNSA -- restore PGPLOT attributes */
/* %void cpgunsa(void); */
/* + */
/*<       ENTRY PGUNSA >*/

L_pgunsa:

/* This routine restores the PGPLOT attributes saved in the last call to */
/* PGSAVE. Usage: CALL PGUNSA (no arguments). See PGSAVE. */

/* Arguments: none */
/* ----------------------------------------------------------------------- */
/*<       IF (LEV.LE.0) THEN >*/
    if (lev <= 0) {
/*<           CALL GRWARN('PGUNSA: nothing has been saved') >*/
	grwarn_("PGUNSA: nothing has been saved", (ftnlen)30);
/*<       ELSE >*/
    } else {
/*<           CALL PGSCF(CF(LEV)) >*/
	pgscf_(&cf[lev - 1]);
/*<           CALL PGSCH(CH(LEV)) >*/
	pgsch_(&ch[lev - 1]);
/*<           CALL PGSCI(CI(LEV)) >*/
	pgsci_(&ci[lev - 1]);
/*<           CALL PGSFS(FS(LEV)) >*/
	pgsfs_(&fs[lev - 1]);
/*<           CALL PGSLS(LS(LEV)) >*/
	pgsls_(&ls[lev - 1]);
/*<           CALL PGSLW(LW(LEV)) >*/
	pgslw_(&lw[lev - 1]);
/*          CALL PGSVP(VP(1,LEV), VP(2,LEV), VP(3,LEV), VP(4,LEV)) */
/*          CALL PGSWIN(WIN(1,LEV), WIN(2,LEV), WIN(3,LEV), WIN(4,LEV)) */
/*<           CALL PGMOVE(POS(1,LEV), POS(2,LEV)) >*/
	pgmove_(&pos[(lev << 1) - 2], &pos[(lev << 1) - 1]);
/*<           CALL PGSAH(AHFS(LEV), AHANG(LEV), AHBARB(LEV)) >*/
	pgsah_(&ahfs[lev - 1], &ahang[lev - 1], &ahbarb[lev - 1]);
/*<           CALL PGSTBG(TBG(LEV)) >*/
	pgstbg_(&tbg[lev - 1]);
/*<           CALL PGSHS(HSA(LEV), HSS(LEV), HSP(LEV)) >*/
	pgshs_(&hsa[lev - 1], &hss[lev - 1], &hsp[lev - 1]);
/*<           CALL PGSCLP(CLP(LEV)) >*/
	pgsclp_(&clp[lev - 1]);
/*<           LEV = LEV-1 >*/
	--lev;
/*<       END IF >*/
    }
/*<       RETURN      >*/
    return 0;
/*<       END >*/
} /* pgsave_ */

/* Subroutine */ int pgsave_()
{
    return pgsave_0_(0);
    }

/* Subroutine */ int pgunsa_()
{
    return pgsave_0_(1);
    }

