/* /work2/ssa/pgplot/src/pgscrn.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;
static integer c__2 = 2;

/* *PGSCRN -- set color representation by name */
/* %void cpgscrn(int ci, const char *name, int *ier); */
/* + */
/*<       SUBROUTINE PGSCRN(CI, NAME, IER) >*/
/* Subroutine */ int pgscrn_(ci, name__, ier, name_len)
integer *ci;
char *name__;
integer *ier;
ftnlen name_len;
{
    /* Initialized data */

    static integer ncol = 0;

    /* System generated locals */
    address a__1[2];
    integer i__1, i__2[2];
    char ch__1[282];
    cllist cl__1;

    /* Builtin functions */
    integer s_rsfe(), do_fio(), e_rsfe(), f_clos(), s_cmp();
    /* Subroutine */ int s_cat();

    /* Local variables */
    static char creq[20];
    static integer unit;
    static char text[255];
    static integer i__, j, l;
    static char cname[20*1000];
    extern /* Subroutine */ int pgscr_();
    static integer ib, ig;
    static real rb[1000], rg[1000];
    static integer ir;
    static real rr[1000];
    extern /* Subroutine */ int grgfil_();
    extern integer grctoi_();
    extern /* Subroutine */ int grskpb_(), grflun_(), grglun_(), grwarn_();
    extern integer grtrim_();
    extern /* Subroutine */ int grtoup_();
    extern integer groptx_();
    static integer ios;

    /* Fortran I/O blocks */
    static cilist io___7 = { 1, 0, 1, "(A)", 0 };


/*<       INTEGER CI >*/
/*<       CHARACTER*(*) NAME >*/
/*<       INTEGER IER >*/

/* Set color representation: i.e., define the color to be */
/* associated with a color index.  Ignored for devices which do not */
/* support variable color or intensity.  This is an alternative to */
/* routine PGSCR. The color representation is defined by name instead */
/* of (R,G,B) components. */

/* Color names are defined in an external file which is read the first */
/* time that PGSCRN is called. The name of the external file is */
/* found as follows: */
/* 1. if environment variable (logical name) PGPLOT_RGB is defined, */
/*    its value is used as the file name; */
/* 2. otherwise, if environment variable PGPLOT_DIR is defined, a */
/*    file "rgb.txt" in the directory named by this environment */
/*    variable is used; */
/* 3. otherwise, file "rgb.txt" in the current directory is used. */
/* If all of these fail to find a file, an error is reported and */
/* the routine does nothing. */

/* Each line of the file */
/* defines one color, with four blank- or tab-separated fields per */
/* line. The first three fields are the R, G, B components, which */
/* are integers in the range 0 (zero intensity) to 255 (maximum */
/* intensity). The fourth field is the color name. The color name */
/* may include embedded blanks. Example: */

/* 255   0   0 red */
/* 255 105 180 hot pink */
/* 255 255 255 white */
/*   0   0   0 black */

/* Arguments: */
/*  CI     (input)  : the color index to be defined, in the range 0-max. */
/*                    If the color index greater than the device */
/*                    maximum is specified, the call is ignored. Color */
/*                    index 0 applies to the background color. */
/*  NAME   (input)  : the name of the color to be associated with */
/*                    this color index. This name must be in the */
/*                    external file. The names are not case-sensitive. */
/*                    If the color is not listed in the file, the */
/*                    color representation is not changed. */
/*  IER    (output) : returns 0 if the routine was successful, 1 */
/*                    if an error occurred (either the external file */
/*                    could not be read, or the requested color was */
/*                    not defined in the file). */
/* -- */
/* 12-Oct-1992 [TJP] */
/* 31-May-1993 [TJP] use GROPTX to open file. */
/*  7-Nov-1994 [TJP] better error messages. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MAXCOL >*/
/*<       PARAMETER (MAXCOL=1000) >*/
/*<       INTEGER I, IR, IG, IB, J, L, NCOL, UNIT, IOS >*/
/*<       INTEGER GRCTOI, GROPTX, GRTRIM >*/
/*<       REAL RR(MAXCOL), RG(MAXCOL), RB(MAXCOL) >*/
/*<       CHARACTER*20 CREQ, CNAME(MAXCOL) >*/
/*<       CHARACTER*255 TEXT >*/
/*<       SAVE NCOL, CNAME, RR, RG, RB >*/
/*<       DATA NCOL/0/ >*/

/* On first call, read the database. */

/*<       IF (NCOL.EQ.0) THEN >*/
    if (ncol == 0) {
/*<           CALL GRGFIL('RGB', TEXT) >*/
	grgfil_("RGB", text, (ftnlen)3, (ftnlen)255);
/*<           L = GRTRIM(TEXT) >*/
	l = grtrim_(text, (ftnlen)255);
/*<           IF (L.LT.1) L = 1 >*/
	if (l < 1) {
	    l = 1;
	}
/*<           CALL GRGLUN(UNIT) >*/
	grglun_(&unit);
/*<           IOS = GROPTX(UNIT, TEXT(1:L), 'rgb.txt', 0) >*/
	ios = groptx_(&unit, text, "rgb.txt", &c__0, l, (ftnlen)7);
/*<           IF (IOS.NE.0) GOTO 40 >*/
	if (ios != 0) {
	    goto L40;
	}
/*<           DO 10 I=1,MAXCOL >*/
	for (i__ = 1; i__ <= 1000; ++i__) {
/*<               READ (UNIT, '(A)', ERR=15, END=15) TEXT >*/
	    io___7.ciunit = unit;
	    i__1 = s_rsfe(&io___7);
	    if (i__1 != 0) {
		goto L15;
	    }
	    i__1 = do_fio(&c__1, text, (ftnlen)255);
	    if (i__1 != 0) {
		goto L15;
	    }
	    i__1 = e_rsfe();
	    if (i__1 != 0) {
		goto L15;
	    }
/*<               J = 1 >*/
	    j = 1;
/*<               CALL GRSKPB(TEXT, J) >*/
	    grskpb_(text, &j, (ftnlen)255);
/*<               IR = GRCTOI(TEXT, J) >*/
	    ir = grctoi_(text, &j, (ftnlen)255);
/*<               CALL GRSKPB(TEXT, J) >*/
	    grskpb_(text, &j, (ftnlen)255);
/*<               IG = GRCTOI(TEXT, J) >*/
	    ig = grctoi_(text, &j, (ftnlen)255);
/*<               CALL GRSKPB(TEXT, J) >*/
	    grskpb_(text, &j, (ftnlen)255);
/*<               IB = GRCTOI(TEXT, J) >*/
	    ib = grctoi_(text, &j, (ftnlen)255);
/*<               CALL GRSKPB(TEXT, J) >*/
	    grskpb_(text, &j, (ftnlen)255);
/*<               NCOL = NCOL+1 >*/
	    ++ncol;
/*<               CALL GRTOUP(CNAME(NCOL), TEXT(J:)) >*/
	    grtoup_(cname + (ncol - 1) * 20, text + (j - 1), (ftnlen)20, 255 
		    - (j - 1));
/*<               RR(NCOL) = IR/255.0 >*/
	    rr[ncol - 1] = ir / (float)255.;
/*<               RG(NCOL) = IG/255.0 >*/
	    rg[ncol - 1] = ig / (float)255.;
/*<               RB(NCOL) = IB/255.0 >*/
	    rb[ncol - 1] = ib / (float)255.;
/*<    10     CONTINUE >*/
/* L10: */
	}
/*<    15     CLOSE (UNIT) >*/
L15:
	cl__1.cerr = 0;
	cl__1.cunit = unit;
	cl__1.csta = 0;
	f_clos(&cl__1);
/*<           CALL GRFLUN(UNIT) >*/
	grflun_(&unit);
/*<       END IF >*/
    }

/* Look up requested color and set color representation if found. */

/*<       CALL GRTOUP(CREQ, NAME) >*/
    grtoup_(creq, name__, (ftnlen)20, name_len);
/*<       DO 20 I=1,NCOL >*/
    i__1 = ncol;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           IF (CREQ.EQ.CNAME(I)) THEN >*/
	if (s_cmp(creq, cname + (i__ - 1) * 20, (ftnlen)20, (ftnlen)20) == 0) 
		{
/*<               CALL PGSCR(CI, RR(I), RG(I), RB(I)) >*/
	    pgscr_(ci, &rr[i__ - 1], &rg[i__ - 1], &rb[i__ - 1]);
/*<               IER = 0 >*/
	    *ier = 0;
/*<               RETURN >*/
	    return 0;
/*<           END IF >*/
	}
/*<    20 CONTINUE >*/
/* L20: */
    }

/* Color not found. */

/*<       IER = 1 >*/
    *ier = 1;
/*<       TEXT = 'Color not found: '//NAME >*/
/* Writing concatenation */
    i__2[0] = 17, a__1[0] = "Color not found: ";
    i__2[1] = name_len, a__1[1] = name__;
    s_cat(text, a__1, i__2, &c__2, (ftnlen)255);
/*<       CALL GRWARN(TEXT) >*/
    grwarn_(text, (ftnlen)255);
/*<       RETURN >*/
    return 0;

/* Database not found. */

/*<    40 IER = 1 >*/
L40:
    *ier = 1;
/*<       NCOL = -1 >*/
    ncol = -1;
/*<       CALL GRFLUN(UNIT) >*/
    grflun_(&unit);
/*<       CALL GRWARN('Unable to read color file: '//TEXT(1:L)) >*/
/* Writing concatenation */
    i__2[0] = 27, a__1[0] = "Unable to read color file: ";
    i__2[1] = l, a__1[1] = text;
    s_cat(ch__1, a__1, i__2, &c__2, (ftnlen)282);
    grwarn_(ch__1, l + 27);
/*<    >*/
    grwarn_("Use environment variable PGPLOT_RGB to specify the location of \
the PGPLOT rgb.txt file.", (ftnlen)87);
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgscrn_ */

