/* /work2/ssa/pgplot/drivers/psdriv.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__2 = 2;
static integer c__0 = 0;
static integer c__50 = 50;
static integer c__5 = 5;

/* *PSDRIV -- PGPLOT PostScript drivers */
/* + */
/*<       SUBROUTINE PSDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE) >*/
/* Subroutine */ int psdriv_(ifunc, rbuf, nbuf, chr, lchr, mode, chr_len)
integer *ifunc;
real *rbuf;
integer *nbuf;
char *chr;
integer *lchr, *mode;
ftnlen chr_len;
{
    /* Initialized data */

    static char hexdig[1*16+1] = "0123456789ABCDEF";
    static real shade[16] = { (float)1.,(float)0.,(float)0.,(float)0.,(float)
	    0.,(float)0.,(float)0.,(float)0.,(float)0.,(float)0.,(float)0.,(
	    float)0.,(float)0.,(float)0.,(float).33,(float).67 };
    static real rinit[16] = { (float)1.,(float)0.,(float)1.,(float)0.,(float)
	    0.,(float)0.,(float)1.,(float)1.,(float)1.,(float).5,(float)0.,(
	    float)0.,(float).5,(float)1.,(float).33,(float).67 };
    static real ginit[16] = { (float)1.,(float)0.,(float)0.,(float)1.,(float)
	    0.,(float)1.,(float)0.,(float)1.,(float).5,(float)1.,(float)1.,(
	    float).5,(float)0.,(float)0.,(float).33,(float).67 };
    static real binit[16] = { (float)1.,(float)0.,(float)0.,(float)0.,(float)
	    1.,(float)1.,(float)1.,(float)0.,(float)0.,(float)0.,(float).5,(
	    float)1.,(float)1.,(float).5,(float).33,(float).67 };
    static integer rad[32] = { 6,1,7,6,7,5,6,8,7,7,9,10,9,8,6,8,4,5,9,12,2,4,
	    5,7,11,17,22,41,9,9,9,9 };
    static integer state = 0;

    /* System generated locals */
    address a__1[2], a__2[5];
    integer i__1[2], i__2, i__3, i__4, i__5, i__6[5];
    real r__1, r__2, r__3, r__4;
    char ch__1[127], ch__2[136], ch__3[265], ch__4[285], ch__5[69];
    cllist cl__1;
    inlist ioin__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer i_len(), s_cmp();
    /* Subroutine */ int s_cat();
    integer f_inqu(), i_nint(), f_clos(), s_wsfi(), do_fio(), e_wsfi();

    /* Local variables */
    static real mfac;
    static integer high, offh, bbox[4], nseg;
    static char obuf[132];
    static integer kmax, offw, xlen, ylen, unit, xorg, yorg, posn, npts, nsym,
	     i__, k, l, n;
    static char fname[255];
    static integer npage;
    extern /* Subroutine */ int grfao_();
    static char sdate[20];
    static integer lobuf, lasti, lastj;
    static logical color;
    static integer width, ioerr;
    extern /* Subroutine */ int grps02_(), grps03_();
    static integer i0, j0, i1, j1;
    static logical start;
    static char instr[120], suser[20];
    static integer ci, ld, ll, lu, lfname;
    static real lw;
    static logical landsc;
    extern /* Subroutine */ int grdate_();
    static integer height;
    static real bvalue[256], bbxmin, bbymin, bbxmax, bbymax, gvalue[256];
    static integer marker[32], bb1, bb2, bb3, bb4;
    extern integer grctoi_();
    extern /* Subroutine */ int grgenv_(), grflun_();
    static real rvalue[256];
    extern /* Subroutine */ int grglun_(), grwarn_(), gruser_(), grtoup_();
    static logical stdout;
    extern integer groptx_();
    static integer rgb[3], ier;
    static char msg[120];
    static integer low, nxp, nyp;

    /* Fortran I/O blocks */
    static icilist io___58 = { 0, instr, 0, "(F6.2,' LW')", 120, 1 };
    static icilist io___66 = { 0, instr, 0, "(6(1PE10.3, 1X), ']')", 120, 1 };
    static icilist io___73 = { 0, instr, 0, "('/MFAC ',F10.3,' def')", 120, 1 
	    };
    static icilist io___74 = { 0, msg, 0, "('Unimplemented function in PS de\
vice driver: ',I10)", 120, 1 };


/*<       INTEGER IFUNC, NBUF, LCHR, MODE >*/
/*<       REAL    RBUF(*) >*/
/*<       CHARACTER*(*) CHR >*/

/* PGPLOT driver for PostScript devices. */

/* Version 1.2  - 1987 Aug  5 - T. J. Pearson. */
/* Version 1.3  - 1987 Nov 16 - add "bind" commands to prolog - TJP. */
/* Version 1.4  - 1988 Jan 28 - change dimensions so whole field can be */
/*                              plotted - TJP. */
/* Version 1.5  - 1988 Oct 27 - make EOF characters optional - TJP. */
/* Version 1.6  - 1988 Dec 15 - standard Fortran - TJP. */
/* Version 1.7  - 1989 Jul  5 - change color indices so most colors */
/*                              are black - TJP. */
/* Version 2.0  - 1990 Sep 10 - parameterize dimensions; correct */
/*                              bounding box; add color support (from */
/*                              D. Meier's CPdriver) - TJP. */
/* Version 2.1  - 1991 Nov 29 - update Document Structuring Conventions */
/*                              to version 3.0. */
/* Version 3.0  - 1992 Sep 22 - add marker support; add CPS and VCPS */
/*                              modes - TJP. */
/* Version 3.1  - 1992 Nov 12 - up to 256 colors. */
/* Version 3.2  - 1993 May 26 - correct error in marker support. */
/* Version 4.0  - 1993 Sep 20 - trap Fortran I/O errors. */
/* Version 4.1  - 1994 Aug  4 - make marker support optional. */
/* Version 5.0  - 1994 Aug 30 - support for images. */
/* Version 5.1  - 1994 Sep  7 - support for PGQCR. */
/* Version 5.2  - 1994 Oct 12 - add IDENT option. */
/* Version 5.3  - 1995 May  8 - recognise '-' as standard output; keep */
/*                              track of bounding box; use upper case */
/*                              for all defined commands; move */
/*                              showpage outside save/restore. */
/* Version 5.4  - 1995 Aug 19 - correct usage of PS_BBOX. */
/* Version 6.0  - 1995 Dec 28 - reject concurrent access. */
/* Version 6.1  - 1996 Apr 29 - decode environment variables using GRCTOI. */
/* Version 6.2  - 1996 Oct  7 - correct bounding-box error (K-G Adams); */
/*                              correct error in use of GCTOI (G Gonczi); */
/*                              suppress <0 0 C> commands (R Scharroo); */
/*                              allow arbitrary page size. */
/* Version 6.3  - 1997 Nov 14 - shorter commands for setrgbcolor and setgray. */
/* Version 6.4  - 1997 Nov 19 - workaround a Ghostscript bug: split long */
/*                              polylines into shorter segments. */
/* Version 6.5  - 1998 Feb 23 - support for real linewidth. */
/* Version 6.6  - 1998 Nov 10 - provide easy way to convert color to grey. */
/* Version 6.7  - 1998 Dec 12 - added #copies to header. */

/* Supported device: */
/*   Any printer that accepts the PostScript page description language, */
/*   eg, the LaserWriter (Apple Computer, Inc.). */
/*   PostScript is a trademark of Adobe Systems Incorporated. */

/* Device type code: */
/*   /PS (monochrome landscape mode, long edge of paper horizontal). */
/*   /CPS (color landscape mode, long edge of paper horizontal). */
/*   /VPS (monochrome portrait mode, short edge of paper horizontal). */
/*   /VCPS (color portrait mode, short edge of paper horizontal). */

/* Default file name: */
/*   pgplot.ps */

/* Default view surface dimensions: */
/*   10.5 inches horizontal x  7.8 inches vertical (landscape mode), */
/*    7.8 inches horizontal x 10.5 inches vertical (portrait mode). */
/*   These dimensions can be changed with environment variables. */

/* Resolution: */
/*   The driver uses coordinate increments of 0.001 inch, giving an */
/*   ``apparent'' resolution of 1000 pixels/inch. The true resolution is */
/*   device-dependent; eg, on an Apple LaserWriter it is 300 pixels/inch */
/*   (in both dimensions). */

/* Color capability (monochrome mode): */
/*   Color indices 0-255 are supported. Color index 0 is white (erase */
/*   or background color), indices 1-13 are black, 14 is light grey, */
/*   and 15 is dark grey. */

/* Color capability (color mode): */
/*   Color indices 0-255 are supported. Color index 0 is white (erase */
/*   or background color), index 1 is black, and indices 2-15 have the */
/*   standard PGPLOT color assignments. */

/* Input capability: none. */

/* File format: the file contains variable length records (maximum 132 */
/* characters) containing PostScript commands. The commands use only */
/* printable ASCII characters, and the file can be examined or modified */
/* with a text editor. */

/* Obtaining hardcopy: use the operating system print or copy command to */
/* send the file to a suitable device. */

/* Environment variables: */

/*  PGPLOT_PS_WIDTH      default  7800 */
/*  PGPLOT_PS_HEIGHT     default 10500 */
/*  PGPLOT_PS_HOFFSET    default   350 */
/*  PGPLOT_PS_VOFFSET    default   250 */
/* These variables tell PGPLOT how big an image to produce. The defaults */
/* are appropriate for 8.5 x 11-inch paper. The maximum dimensions of */
/* a PGPLOT image are WIDTH by HEIGHT, with the lower left corner offset */
/* by HOFFSET horizontally and VOFFSET vertically from the lower left */
/* corner of the paper. The units are milli-inches. The "top" of the */
/* paper is the edge that comes out of the printer first. */

/*  PGPLOT_IDENT */
/* If this variable is set, the user name, date and time are written */
/* in the bottom right corner of each page. */

/*  PGPLOT_PS_BBOX */
/* If this variable has value MAX, PGPLOT puts standard (full-page) */
/* bounding-box information in the header of the PostScript file. If */
/* the variable is unset or has some other value, PGPLOT puts the */
/* correct (smallest) bounding box information in the trailer of the */
/* PostScript file. */

/*  PGPLOT_PS_EOF */
/* Normally the output file does not contain special end-of-file */
/* characters. But if environment variable PGPLOT_PS_EOF is defined */
/* (with any value) PGPLOT writes a control-D job-separator character at */
/* the beginning and at the end of the file. This is appropriate for */
/* Apple LaserWriters using the serial interface, but it may not be */
/* appropriate for other PostScript devices. */

/*  PGPLOT_PS_MARKERS */
/* Specify "NO" to suppress use of a PostScript font for the graph */
/* markers; markers are then emulated by line-drawing. */

/* Document Structuring Conventions: */

/*  The PostScript files conform to Version 3.0 of the Adobe Document */
/*  Structuring Conventions (see ref.3) and to version 3.0 of the */
/*  encapsulated PostScript file (EPSF) format. This should allow */
/*  the files to be read by other programs that accept the EPSF format. */
/*  Note, though, that multi-page plots are not valid EPSF files. The */
/*  files do not contain a screen preview section. */

/* References: */

/* (1) Adobe Systems, Inc.: PostScript Language Reference Manual. */
/* Addison-Wesley, Reading, Massachusetts, 1985. */
/* (2) Adobe Systems, Inc.: PostScript Language Tutorial and Cookbook. */
/* Addison-Wesley, Reading, Massachusetts, 1985. */
/* (3) Adobe Systems, Inc.: PostScript Language Reference Manual, Second */
/* Edition. Addison-Wesley, Reading, Massachusetts, 1990. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER DWD, DHT, DOFFW, DOFFH >*/
/*<       CHARACTER*(*) PTYPE, LTYPE, CPTYPE, CLTYPE, DEFNAM >*/
/*<    >*/
/*     PARAMETER (PTYPE='VPS', LTYPE='PS', CPTYPE='VCPS', CLTYPE='CPS') */
/*<       PARAMETER (DEFNAM='pgplot.ps') >*/
/* -- printable paper area: in milli-inches; (WIDTH, HEIGHT) are */
/*    the dimensions of the printable area; OFFW, OFFH the offset from */
/*    the lower left corner of the paper */
/*<       PARAMETER (DWD=7800, DHT=10500, DOFFW=350, DOFFH=250) >*/

/*<       INTEGER WIDTH, HEIGHT, OFFW, OFFH >*/
/*<       SAVE    WIDTH, HEIGHT, OFFW, OFFH >*/
/*<       INTEGER  IER, I0, J0, I1, J1, L, LL, LASTI, LASTJ, UNIT, LOBUF >*/
/*<       SAVE                                 LASTI, LASTJ, UNIT, LOBUF >*/
/*<       INTEGER  CI, NPTS, NPAGE, IOERR, LFNAME >*/
/*<       SAVE         NPTS, NPAGE, IOERR, LFNAME >*/
/*<       INTEGER  STATE, NSEG >*/
/*<       SAVE     STATE, NSEG >*/
/*<       INTEGER  NXP, NYP, XORG, YORG, XLEN, YLEN, N, RGB(3) >*/
/*<       INTEGER  HIGH, LOW, I, K, KMAX, POSN, LD, LU >*/
/*<       INTEGER  BBOX(4), BB1, BB2, BB3, BB4 >*/
/*<       SAVE     BBOX >*/
/*<       INTEGER  GROPTX, GRCTOI >*/
/*<       LOGICAL  START, LANDSC, COLOR, STDOUT >*/
/*<       SAVE     START,         COLOR, STDOUT >*/
/*<       REAL     LW >*/
/*<       SAVE     LW >*/
/*<       REAL     BBXMIN, BBXMAX, BBYMIN, BBYMAX >*/
/*<       SAVE     BBXMIN, BBXMAX, BBYMIN, BBYMAX >*/
/*<       REAL     RVALUE(0:255), GVALUE(0:255), BVALUE(0:255) >*/
/*<       SAVE     RVALUE,        GVALUE,        BVALUE >*/
/*<       CHARACTER*20  SUSER, SDATE >*/
/*<       CHARACTER*120 INSTR, MSG >*/
/*<       CHARACTER*132 OBUF >*/
/*<       SAVE          OBUF >*/
/*<       CHARACTER*255 FNAME >*/
/*<       SAVE          FNAME >*/
/*<       INTEGER       MARKER(0:31), NSYM, RAD(0:31) >*/
/*<       SAVE          MARKER, RAD >*/
/*<       REAL          MFAC >*/
/*<       SAVE          MFAC >*/
/*<       REAL          SHADE(0:15), RINIT(0:15), GINIT(0:15), BINIT(0:15) >*/
/*<       SAVE          SHADE,       RINIT,       GINIT,       BINIT >*/
/*<       CHARACTER*1   HEXDIG(0:15) >*/
/*<    >*/
    /* Parameter adjustments */
    --rbuf;

    /* Function Body */
/*<       DATA SHADE /1.00, 13*0.00, 0.33, 0.67/ >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<       DATA STATE/0/ >*/
/* ----------------------------------------------------------------------- */

/*<    >*/
    switch ((int)*ifunc) {
	case 1:  goto L10;
	case 2:  goto L20;
	case 3:  goto L30;
	case 4:  goto L40;
	case 5:  goto L50;
	case 6:  goto L60;
	case 7:  goto L70;
	case 8:  goto L80;
	case 9:  goto L90;
	case 10:  goto L100;
	case 11:  goto L110;
	case 12:  goto L120;
	case 13:  goto L130;
	case 14:  goto L140;
	case 15:  goto L150;
	case 16:  goto L160;
	case 17:  goto L170;
	case 18:  goto L180;
	case 19:  goto L190;
	case 20:  goto L200;
	case 21:  goto L210;
	case 22:  goto L220;
	case 23:  goto L230;
	case 24:  goto L900;
	case 25:  goto L900;
	case 26:  goto L260;
	case 27:  goto L900;
	case 28:  goto L280;
	case 29:  goto L290;
    }
/*<       GOTO 900 >*/
    goto L900;

/* --- IFUNC = 1, Return device name.------------------------------------- */

/*<    10 IF (MODE.EQ.1) THEN >*/
L10:
    if (*mode == 1) {
/*         -- landscape, monochrome */
/*<           CHR = LTYPE >*/
	s_copy(chr, "PS    (PostScript file, landscape orientation)", chr_len,
		 (ftnlen)46);
/*<           LCHR = LEN(LTYPE) >*/
	*lchr = i_len("PS    (PostScript file, landscape orientation)", (
		ftnlen)46);
/*<       ELSE IF (MODE.EQ.2) THEN >*/
    } else if (*mode == 2) {
/*         -- portrait, monochrome */
/*<           CHR = PTYPE >*/
	s_copy(chr, "VPS   (PostScript file, portrait orientation)", chr_len, 
		(ftnlen)45);
/*<           LCHR = LEN(PTYPE) >*/
	*lchr = i_len("VPS   (PostScript file, portrait orientation)", (
		ftnlen)45);
/*<       ELSE IF (MODE.EQ.3) THEN >*/
    } else if (*mode == 3) {
/*         -- landscape, color */
/*<           CHR = CLTYPE >*/
	s_copy(chr, "CPS   (Colour PostScript file, landscape orientation)", 
		chr_len, (ftnlen)53);
/*<           LCHR = LEN(CLTYPE) >*/
	*lchr = i_len("CPS   (Colour PostScript file, landscape orientation)",
		 (ftnlen)53);
/*<       ELSE >*/
    } else {
/*         -- portrait, color */
/*<           CHR = CPTYPE >*/
	s_copy(chr, "VCPS  (Colour PostScript file, portrait orientation)", 
		chr_len, (ftnlen)52);
/*<           LCHR = LEN(CPTYPE) >*/
	*lchr = i_len("VCPS  (Colour PostScript file, portrait orientation)", 
		(ftnlen)52);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 2, Return physical min and max for plot device, and range */
/*               of color indices.--------------------------------------- */

/*<    20 RBUF(1) = 0 >*/
L20:
    rbuf[1] = (float)0.;
/*<       RBUF(2) = -1 >*/
    rbuf[2] = (float)-1.;
/*<       RBUF(3) = 0 >*/
    rbuf[3] = (float)0.;
/*<       RBUF(4) = -1 >*/
    rbuf[4] = (float)-1.;
/*<       RBUF(5) = 0 >*/
    rbuf[5] = (float)0.;
/*<       RBUF(6) = 255 >*/
    rbuf[6] = (float)255.;
/*<       NBUF = 6 >*/
    *nbuf = 6;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 3, Return device resolution. ------------------------------ */

/*<    30 RBUF(1) = 1000.0 >*/
L30:
    rbuf[1] = (float)1e3;
/*<       RBUF(2) = 1000.0 >*/
    rbuf[2] = (float)1e3;
/*<       RBUF(3) = 5 >*/
    rbuf[3] = (float)5.;
/*<       NBUF = 3 >*/
    *nbuf = 3;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 4, Return misc device info. ------------------------------- */
/*    (This device is Hardcopy, No cursor, No dashed lines, Area fill, */
/*    Thick lines, QCR, Markers [optional]) */

/*<    40 CONTINUE >*/
L40:
/*<       CHR = 'HNNATNQNYM' >*/
    s_copy(chr, "HNNATNQNYM", chr_len, (ftnlen)10);
/*     -- Marker support suppressed? */
/*<       CALL GRGENV('PS_MARKERS', INSTR, L) >*/
    grgenv_("PS_MARKERS", instr, &l, (ftnlen)10, (ftnlen)120);
/*<       IF (L.GE.2) THEN >*/
    if (l >= 2) {
/*<          IF (INSTR(1:L).EQ.'NO' .OR. INSTR(1:L).EQ.'no') THEN >*/
	if (s_cmp(instr, "NO", l, (ftnlen)2) == 0 || s_cmp(instr, "no", l, (
		ftnlen)2) == 0) {
/*<             CHR(10:10) = 'N' >*/
	    *(unsigned char *)&chr[9] = 'N';
/*<          END IF >*/
	}
/*<       END IF >*/
    }
/*<       LCHR = 10 >*/
    *lchr = 10;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 5, Return default file name. ------------------------------ */

/*<    50 CHR = DEFNAM >*/
L50:
    s_copy(chr, "pgplot.ps", chr_len, (ftnlen)9);
/*<       LCHR = LEN(DEFNAM) >*/
    *lchr = i_len("pgplot.ps", (ftnlen)9);
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 6, Return default physical size of plot. ------------------ */

/*<    60 RBUF(1) = 0 >*/
L60:
    rbuf[1] = (float)0.;
/*<       RBUF(3) = 0 >*/
    rbuf[3] = (float)0.;
/*<       LANDSC = MODE.EQ.1 .OR. MODE.EQ.3 >*/
    landsc = *mode == 1 || *mode == 3;
/*<       IF (LANDSC) THEN >*/
    if (landsc) {
/*<           RBUF(2) = HEIGHT-1 >*/
	rbuf[2] = (real) (height - 1);
/*<           RBUF(4) = WIDTH-1 >*/
	rbuf[4] = (real) (width - 1);
/*<       ELSE >*/
    } else {
/*<           RBUF(2) = WIDTH-1 >*/
	rbuf[2] = (real) (width - 1);
/*<           RBUF(4) = HEIGHT-1 >*/
	rbuf[4] = (real) (height - 1);
/*<       END IF >*/
    }
/*<       NBUF = 4 >*/
    *nbuf = 4;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 7, Return misc defaults. ---------------------------------- */

/*<    70 RBUF(1) = 8 >*/
L70:
    rbuf[1] = (float)8.;
/*<       NBUF = 1 >*/
    *nbuf = 1;
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 8, Select plot. ------------------------------------------- */

/*<    80 CONTINUE >*/
L80:
/*<       RETURN >*/
    return 0;

/* --- IFUNC = 9, Open workstation. -------------------------------------- */

/*<    90 CONTINUE >*/
L90:
/*     -- check for concurrent access */
/*<       IF (STATE.EQ.1) THEN >*/
    if (state == 1) {
/*<          CALL GRWARN('a PGPLOT PostScript file is already open') >*/
	grwarn_("a PGPLOT PostScript file is already open", (ftnlen)40);
/*<          RBUF(1) = 0 >*/
	rbuf[1] = (float)0.;
/*<          RBUF(2) = 0 >*/
	rbuf[2] = (float)0.;
/*<          RETURN >*/
	return 0;
/*<       END IF >*/
    }
/*     -- Color mode? */
/*<       CALL GRGENV('PS_COLOR', INSTR, L) >*/
    grgenv_("PS_COLOR", instr, &l, (ftnlen)8, (ftnlen)120);
/*<       COLOR = L.GT.0 .OR. MODE.EQ.3 .OR. MODE.EQ.4 >*/
    color = l > 0 || *mode == 3 || *mode == 4;
/*<       IF (COLOR) THEN >*/
    if (color) {
/*<          DO 91 CI=0,15 >*/
	for (ci = 0; ci <= 15; ++ci) {
/*<             RVALUE(CI) = RINIT(CI) >*/
	    rvalue[ci] = rinit[ci];
/*<             GVALUE(CI) = GINIT(CI) >*/
	    gvalue[ci] = ginit[ci];
/*<             BVALUE(CI) = BINIT(CI) >*/
	    bvalue[ci] = binit[ci];
/*<  91      CONTINUE >*/
/* L91: */
	}
/*<       ELSE >*/
    } else {
/*<          DO 92 CI=0,15 >*/
	for (ci = 0; ci <= 15; ++ci) {
/*<             RVALUE(CI) = SHADE(CI) >*/
	    rvalue[ci] = shade[ci];
/*<             GVALUE(CI) = SHADE(CI) >*/
	    gvalue[ci] = shade[ci];
/*<             BVALUE(CI) = SHADE(CI) >*/
	    bvalue[ci] = shade[ci];
/*<  92      CONTINUE >*/
/* L92: */
	}
/*<       END IF >*/
    }
/*<       DO 93 CI=16,255 >*/
    for (ci = 16; ci <= 255; ++ci) {
/*<          RVALUE(CI) = 0.0 >*/
	rvalue[ci] = (float)0.;
/*<          GVALUE(CI) = 0.0 >*/
	gvalue[ci] = (float)0.;
/*<          BVALUE(CI) = 0.0 >*/
	bvalue[ci] = (float)0.;
/*<  93   CONTINUE >*/
/* L93: */
    }
/*     -- Device dimensions */
/*<       WIDTH = DWD >*/
    width = 7800;
/*<       HEIGHT = DHT >*/
    height = 10500;
/*<       OFFW = DOFFW >*/
    offw = 350;
/*<       OFFH = DOFFH >*/
    offh = 250;
/*<       CALL GRGENV('PS_WIDTH', INSTR, L) >*/
    grgenv_("PS_WIDTH", instr, &l, (ftnlen)8, (ftnlen)120);
/*<       LL = 1 >*/
    ll = 1;
/*<       IF (L.GT.0) WIDTH = GRCTOI(INSTR(:L),LL) >*/
    if (l > 0) {
	width = grctoi_(instr, &ll, l);
    }
/*<       CALL GRGENV('PS_HEIGHT', INSTR, L) >*/
    grgenv_("PS_HEIGHT", instr, &l, (ftnlen)9, (ftnlen)120);
/*<       LL = 1 >*/
    ll = 1;
/*<       IF (L.GT.0) HEIGHT = GRCTOI(INSTR(:L),LL) >*/
    if (l > 0) {
	height = grctoi_(instr, &ll, l);
    }
/*<       CALL GRGENV('PS_HOFFSET', INSTR, L) >*/
    grgenv_("PS_HOFFSET", instr, &l, (ftnlen)10, (ftnlen)120);
/*<       LL = 1 >*/
    ll = 1;
/*<       IF (L.GT.0) OFFW = GRCTOI(INSTR(:L),LL) >*/
    if (l > 0) {
	offw = grctoi_(instr, &ll, l);
    }
/*<       CALL GRGENV('PS_VOFFSET', INSTR, L) >*/
    grgenv_("PS_VOFFSET", instr, &l, (ftnlen)10, (ftnlen)120);
/*<       LL = 1 >*/
    ll = 1;
/*<       IF (L.GT.0) OFFH = GRCTOI(INSTR(:L),LL) >*/
    if (l > 0) {
	offh = grctoi_(instr, &ll, l);
    }
/*<       STDOUT =CHR(1:LCHR).EQ.'-' >*/
    stdout = s_cmp(chr, "-", (*lchr), (ftnlen)1) == 0;
/*<       IF (STDOUT) THEN >*/
    if (stdout) {
/*<          UNIT = 6 >*/
	unit = 6;
/*        -- machine-dependent! */
/*<       ELSE >*/
    } else {
/*<          CALL GRGLUN(UNIT) >*/
	grglun_(&unit);
/*<       END IF >*/
    }
/*<       NBUF = 2 >*/
    *nbuf = 2;
/*<       RBUF(1) = UNIT >*/
    rbuf[1] = (real) unit;
/*<       IF (.NOT.STDOUT) THEN >*/
    if (! stdout) {
/*<          IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1) >*/
	ier = groptx_(&unit, chr, "pgplot.ps", &c__1, (*lchr), (ftnlen)9);
/*<          IF (IER.NE.0) THEN >*/
	if (ier != 0) {
/*<    >*/
/* Writing concatenation */
	    i__1[0] = 45, a__1[0] = "Cannot open output file for PostScript \
plot: ";
	    i__1[1] = *lchr, a__1[1] = chr;
	    s_cat(msg, a__1, i__1, &c__2, (ftnlen)120);
/*<             CALL GRWARN(MSG) >*/
	    grwarn_(msg, (ftnlen)120);
/*<             RBUF(2) = 0 >*/
	    rbuf[2] = (float)0.;
/*<             CALL GRFLUN(UNIT) >*/
	    grflun_(&unit);
/*<             RETURN >*/
	    return 0;
/*<          ELSE >*/
	} else {
/*<             INQUIRE (UNIT=UNIT, NAME=CHR) >*/
	    ioin__1.inerr = 0;
	    ioin__1.inunit = unit;
	    ioin__1.infile = 0;
	    ioin__1.inex = 0;
	    ioin__1.inopen = 0;
	    ioin__1.innum = 0;
	    ioin__1.innamed = 0;
	    ioin__1.innamlen = chr_len;
	    ioin__1.inname = chr;
	    ioin__1.inacc = 0;
	    ioin__1.inseq = 0;
	    ioin__1.indir = 0;
	    ioin__1.infmt = 0;
	    ioin__1.inform = 0;
	    ioin__1.inunf = 0;
	    ioin__1.inrecl = 0;
	    ioin__1.innrec = 0;
	    ioin__1.inblank = 0;
	    f_inqu(&ioin__1);
/*<             LCHR = LEN(CHR) >*/
	    *lchr = i_len(chr, chr_len);
/*<  94         IF (CHR(LCHR:LCHR).EQ.' ') THEN >*/
L94:
	    if (*(unsigned char *)&chr[*lchr - 1] == ' ') {
/*<                LCHR = LCHR-1 >*/
		--(*lchr);
/*<                GOTO 94 >*/
		goto L94;
/*<             END IF >*/
	    }
/*<             RBUF(2) = 1 >*/
	    rbuf[2] = (float)1.;
/*<             FNAME = CHR(:LCHR) >*/
	    s_copy(fname, chr, (ftnlen)255, (*lchr));
/*<             LFNAME = LCHR >*/
	    lfname = *lchr;
/*<          END IF >*/
	}
/*<       ELSE >*/
    } else {
/*<          RBUF(2) = 1 >*/
	rbuf[2] = (float)1.;
/*<          FNAME = '-' >*/
	s_copy(fname, "-", (ftnlen)255, (ftnlen)1);
/*<          LFNAME= 1 >*/
	lfname = 1;
/*<       END IF >*/
    }
/*<       STATE = 1 >*/
    state = 1;
/*<       IOERR = 0 >*/
    ioerr = 0;
/*<       LOBUF = 0 >*/
    lobuf = 0;
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       LASTJ = -1 >*/
    lastj = -1;
/*<       LW = 1 >*/
    lw = (float)1.;
/*<       NPTS = 0 >*/
    npts = 0;
/*<       CALL GRGENV('PS_EOF', INSTR, L) >*/
    grgenv_("PS_EOF", instr, &l, (ftnlen)6, (ftnlen)120);
/*<       IF (L.GT.0) CALL GRPS02(IOERR, UNIT, CHAR(4)) >*/
    if (l > 0) {
	grps02_(&ioerr, &unit, "\004", (ftnlen)1);
    }
/*<       CALL GRPS02(IOERR, UNIT, '%!PS-Adobe-3.0 EPSF-3.0') >*/
    grps02_(&ioerr, &unit, "%!PS-Adobe-3.0 EPSF-3.0", (ftnlen)23);
/*<       CALL GRUSER(INSTR, L) >*/
    gruser_(instr, &l, (ftnlen)120);
/*<       IF (L.GT.0) CALL GRPS02(IOERR, UNIT, '%%For: '//INSTR(1:L)) >*/
    if (l > 0) {
/* Writing concatenation */
	i__1[0] = 7, a__1[0] = "%%For: ";
	i__1[1] = l, a__1[1] = instr;
	s_cat(ch__1, a__1, i__1, &c__2, (ftnlen)127);
	grps02_(&ioerr, &unit, ch__1, l + 7);
    }
/*<       CALL GRPS02(IOERR, UNIT, '%%Title: PGPLOT PostScript plot') >*/
    grps02_(&ioerr, &unit, "%%Title: PGPLOT PostScript plot", (ftnlen)31);
/*<       CALL GRPS02(IOERR, UNIT, '%%Creator: PGPLOT [PSDRIV 6.6]') >*/
    grps02_(&ioerr, &unit, "%%Creator: PGPLOT [PSDRIV 6.6]", (ftnlen)30);
/*<       CALL GRDATE(INSTR, L) >*/
    grdate_(instr, &l, (ftnlen)120);
/*<    >*/
    if (l > 0) {
/* Writing concatenation */
	i__1[0] = 16, a__1[0] = "%%CreationDate: ";
	i__1[1] = l, a__1[1] = instr;
	s_cat(ch__2, a__1, i__1, &c__2, (ftnlen)136);
	grps02_(&ioerr, &unit, ch__2, l + 16);
    }
/*<       CALL GRGENV('PS_BBOX', INSTR, L) >*/
    grgenv_("PS_BBOX", instr, &l, (ftnlen)7, (ftnlen)120);
/*<       CALL GRTOUP(INSTR(1:3), INSTR(1:3)) >*/
    grtoup_(instr, instr, (ftnlen)3, (ftnlen)3);
/*<       IF (INSTR(1:3).EQ.'MAX') THEN >*/
    if (s_cmp(instr, "MAX", (ftnlen)3, (ftnlen)3) == 0) {
/*        -- bounding box is based on maximum plot dimensions, not */
/*           actual dimensions */
/*<    >*/
	r__1 = offw * (float).072;
	i__2 = i_nint(&r__1);
	r__2 = offh * (float).072;
	i__3 = i_nint(&r__2);
	r__3 = (width + offw) * (float).072;
	i__4 = i_nint(&r__3);
	r__4 = (height + offh) * (float).072;
	i__5 = i_nint(&r__4);
	grfao_("%%BoundingBox: # # # #", &l, instr, &i__2, &i__3, &i__4, &
		i__5, (ftnlen)22, (ftnlen)120);
/*<          CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<       ELSE >*/
    } else {
/*<          CALL GRPS02(IOERR, UNIT, '%%BoundingBox: (atend)') >*/
	grps02_(&ioerr, &unit, "%%BoundingBox: (atend)", (ftnlen)22);
/*<       END IF >*/
    }
/*<       CALL GRPS02(IOERR, UNIT, '%%DocumentFonts: (atend)') >*/
    grps02_(&ioerr, &unit, "%%DocumentFonts: (atend)", (ftnlen)24);
/*<       CALL GRPS02(IOERR, UNIT, '%%LanguageLevel: 1') >*/
    grps02_(&ioerr, &unit, "%%LanguageLevel: 1", (ftnlen)18);
/*<       LANDSC = MODE.EQ.1 .OR. MODE.EQ.3 >*/
    landsc = *mode == 1 || *mode == 3;
/*<       IF (LANDSC) THEN >*/
    if (landsc) {
/*<           CALL GRPS02(IOERR, UNIT, '%%Orientation: Landscape') >*/
	grps02_(&ioerr, &unit, "%%Orientation: Landscape", (ftnlen)24);
/*<       ELSE >*/
    } else {
/*<           CALL GRPS02(IOERR, UNIT, '%%Orientation: Portrait') >*/
	grps02_(&ioerr, &unit, "%%Orientation: Portrait", (ftnlen)23);
/*<       END IF >*/
    }
/*<       CALL GRPS02(IOERR, UNIT, '%%Pages: (atend)') >*/
    grps02_(&ioerr, &unit, "%%Pages: (atend)", (ftnlen)16);
/*<       CALL GRPS02(IOERR, UNIT, '%%EndComments') >*/
    grps02_(&ioerr, &unit, "%%EndComments", (ftnlen)13);
/*<       CALL GRPS02(IOERR, UNIT, '%%BeginProlog') >*/
    grps02_(&ioerr, &unit, "%%BeginProlog", (ftnlen)13);
/*<    >*/
    grps02_(&ioerr, &unit, "/L {moveto rlineto currentpoint stroke moveto} b\
ind def", (ftnlen)55);
/*<    >*/
    grps02_(&ioerr, &unit, "/C {rlineto currentpoint stroke moveto} bind def",
	     (ftnlen)48);
/*<    >*/
    grps02_(&ioerr, &unit, "/D {moveto 0 0 rlineto currentpoint stroke movet\
o} bind def", (ftnlen)59);
/*<       CALL GRPS02(IOERR, UNIT, '/LW {5 mul setlinewidth} bind def') >*/
    grps02_(&ioerr, &unit, "/LW {5 mul setlinewidth} bind def", (ftnlen)33);
/*<       CALL GRPS02(IOERR, UNIT, '/BP {newpath moveto} bind def') >*/
    grps02_(&ioerr, &unit, "/BP {newpath moveto} bind def", (ftnlen)29);
/*<       CALL GRPS02(IOERR, UNIT, '/LP /rlineto load def') >*/
    grps02_(&ioerr, &unit, "/LP /rlineto load def", (ftnlen)21);
/*<    >*/
    grps02_(&ioerr, &unit, "/EP {rlineto closepath eofill} bind def", (ftnlen)
	    39);
/*<    >*/
    grps02_(&ioerr, &unit, "/MB {gsave translate MFAC dup scale 1 setlinewid\
th 2 setlinecap 0 setlinejoin newpath} bind def", (ftnlen)95);
/*<       CALL GRPS02(IOERR, UNIT, '/ME /grestore load def') >*/
    grps02_(&ioerr, &unit, "/ME /grestore load def", (ftnlen)22);
/*<       CALL GRPS02(IOERR, UNIT, '/CC {0 360 arc stroke} bind def') >*/
    grps02_(&ioerr, &unit, "/CC {0 360 arc stroke} bind def", (ftnlen)31);
/*<       CALL GRPS02(IOERR, UNIT, '/FC {0 360 arc fill} bind def') >*/
    grps02_(&ioerr, &unit, "/FC {0 360 arc fill} bind def", (ftnlen)29);
/*<       CALL GRPS02(IOERR, UNIT, '/G {1024 div setgray} bind def') >*/
    grps02_(&ioerr, &unit, "/G {1024 div setgray} bind def", (ftnlen)30);
/*<    >*/
    grps02_(&ioerr, &unit, "/K {3 -1 roll 1024 div 3 -1 roll 1024 div 3 -1 r\
oll 1024 div setrgbcolor} bind def", (ftnlen)82);
/*<    >*/
    grps02_(&ioerr, &unit, "% Uncomment next line to convert color to grey s\
hades", (ftnlen)53);
/*<    >*/
    grps02_(&ioerr, &unit, "%/K {3 -1 roll 3413 div 3 -1 roll 1739 div 3 -1 \
roll 9309 div add add setgray} bind def", (ftnlen)87);
/*<       CALL GRGENV('IDENT', INSTR, L) >*/
    grgenv_("IDENT", instr, &l, (ftnlen)5, (ftnlen)120);
/*<       IF (L.GT.0) THEN >*/
    if (l > 0) {
/*<    >*/
	grps02_(&ioerr, &unit, "/RS{findfont exch scalefont setfont moveto d\
up stringwidth neg exch neg exch rmoveto show} bind def", (ftnlen)99);
/*<       END IF >*/
    }
/*<       CALL GRPS02(IOERR, UNIT, '%%EndProlog') >*/
    grps02_(&ioerr, &unit, "%%EndProlog", (ftnlen)11);
/*<       CALL GRPS02(IOERR, UNIT, '%%BeginSetup') >*/
    grps02_(&ioerr, &unit, "%%BeginSetup", (ftnlen)12);
/*<       CALL GRPS02(IOERR, UNIT, '/#copies 1 def') >*/
    grps02_(&ioerr, &unit, "/#copies 1 def", (ftnlen)14);
/*<       CALL GRPS02(IOERR, UNIT, '%%EndSetup') >*/
    grps02_(&ioerr, &unit, "%%EndSetup", (ftnlen)10);
/*<       NPAGE = 0 >*/
    npage = 0;
/*<       RETURN >*/
    return 0;

/* --- IFUNC=10, Close workstation. -------------------------------------- */

/*<   100 CONTINUE >*/
L100:
/*<       CALL GRPS02(IOERR, UNIT, ' ') >*/
    grps02_(&ioerr, &unit, " ", (ftnlen)1);
/*<       CALL GRPS02(IOERR, UNIT, '%%Trailer') >*/
    grps02_(&ioerr, &unit, "%%Trailer", (ftnlen)9);
/*<       CALL GRGENV('PS_BBOX', INSTR, L) >*/
    grgenv_("PS_BBOX", instr, &l, (ftnlen)7, (ftnlen)120);
/*<       CALL GRTOUP(INSTR(1:3), INSTR(1:3)) >*/
    grtoup_(instr, instr, (ftnlen)3, (ftnlen)3);
/*<       IF (INSTR(1:3).NE.'MAX') THEN >*/
    if (s_cmp(instr, "MAX", (ftnlen)3, (ftnlen)3) != 0) {
/*<    >*/
	grfao_("%%BoundingBox: # # # #", &l, instr, bbox, &bbox[1], &bbox[2], 
		&bbox[3], (ftnlen)22, (ftnlen)120);
/*<          CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<       END IF >*/
    }
/*<       CALL GRPS02(IOERR, UNIT, '%%DocumentFonts: ') >*/
    grps02_(&ioerr, &unit, "%%DocumentFonts: ", (ftnlen)17);
/*<       CALL GRFAO('%%Pages: #', L, INSTR, NPAGE, 0, 0, 0) >*/
    grfao_("%%Pages: #", &l, instr, &npage, &c__0, &c__0, &c__0, (ftnlen)10, (
	    ftnlen)120);
/*<       CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
    grps02_(&ioerr, &unit, instr, l);
/*<       CALL GRPS02(IOERR, UNIT, '%%EOF') >*/
    grps02_(&ioerr, &unit, "%%EOF", (ftnlen)5);
/*<       CALL GRGENV('PS_EOF', INSTR, L) >*/
    grgenv_("PS_EOF", instr, &l, (ftnlen)6, (ftnlen)120);
/*<       IF (L.GT.0) CALL GRPS02(IOERR, UNIT, CHAR(4)) >*/
    if (l > 0) {
	grps02_(&ioerr, &unit, "\004", (ftnlen)1);
    }
/*<       IF (IOERR.NE.0) THEN >*/
    if (ioerr != 0) {
/*<    >*/
	grwarn_("++WARNING++ Error writing PostScript file: file is incomple\
te", (ftnlen)61);
/*<           CALL GRWARN('Check for device full or quota exceeded') >*/
	grwarn_("Check for device full or quota exceeded", (ftnlen)39);
/*<           CALL GRWARN('Filename: '//FNAME(:LFNAME)) >*/
/* Writing concatenation */
	i__1[0] = 10, a__1[0] = "Filename: ";
	i__1[1] = lfname, a__1[1] = fname;
	s_cat(ch__3, a__1, i__1, &c__2, (ftnlen)265);
	grwarn_(ch__3, lfname + 10);
/*<       END IF >*/
    }
/*<       IF (.NOT.STDOUT) THEN >*/
    if (! stdout) {
/*<          CLOSE (UNIT, IOSTAT=IOERR) >*/
	cl__1.cerr = 1;
	cl__1.cunit = unit;
	cl__1.csta = 0;
	ioerr = f_clos(&cl__1);
/*<          IF (IOERR.NE.0) THEN >*/
	if (ioerr != 0) {
/*<            CALL GRWARN('Error closing PostScript file '//FNAME(:LFNAME)) >*/
/* Writing concatenation */
	    i__1[0] = 30, a__1[0] = "Error closing PostScript file ";
	    i__1[1] = lfname, a__1[1] = fname;
	    s_cat(ch__4, a__1, i__1, &c__2, (ftnlen)285);
	    grwarn_(ch__4, lfname + 30);
/*<          END IF >*/
	}
/*<          CALL GRFLUN(UNIT) >*/
	grflun_(&unit);
/*<       END IF >*/
    }
/*<       STATE = 0 >*/
    state = 0;
/*<       RETURN >*/
    return 0;

/* --- IFUNC=11, Begin picture. ------------------------------------------ */

/*<   110 CONTINUE >*/
L110:
/*<       LANDSC = MODE.EQ.1 .OR. MODE.EQ.3 >*/
    landsc = *mode == 1 || *mode == 3;
/*<       IF (LANDSC) THEN >*/
    if (landsc) {
/*<          HEIGHT = RBUF(1) >*/
	height = rbuf[1];
/*<          WIDTH = RBUF(2) >*/
	width = rbuf[2];
/*<       ELSE >*/
    } else {
/*<          WIDTH = RBUF(1) >*/
	width = rbuf[1];
/*<          HEIGHT = RBUF(2) >*/
	height = rbuf[2];
/*<       END IF >*/
    }
/*<       NPAGE = NPAGE+1 >*/
    ++npage;
/*<       CALL GRPS02(IOERR, UNIT, ' ') >*/
    grps02_(&ioerr, &unit, " ", (ftnlen)1);
/*<       CALL GRFAO('%%Page: # #', L, INSTR, NPAGE, NPAGE, 0, 0) >*/
    grfao_("%%Page: # #", &l, instr, &npage, &npage, &c__0, &c__0, (ftnlen)11,
	     (ftnlen)120);
/*<       CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
    grps02_(&ioerr, &unit, instr, l);
/*<       CALL GRPS02(IOERR, UNIT, '%%BeginPageSetup') >*/
    grps02_(&ioerr, &unit, "%%BeginPageSetup", (ftnlen)16);
/*<       CALL GRPS02(IOERR, UNIT, '/PGPLOT save def') >*/
    grps02_(&ioerr, &unit, "/PGPLOT save def", (ftnlen)16);
/*<       CALL GRPS02(IOERR, UNIT, '0.072 0.072 scale') >*/
    grps02_(&ioerr, &unit, "0.072 0.072 scale", (ftnlen)17);
/*<       LANDSC = MODE.EQ.1 .OR. MODE.EQ.3 >*/
    landsc = *mode == 1 || *mode == 3;
/*<       IF (LANDSC) THEN >*/
    if (landsc) {
/*<    >*/
	i__2 = width + offw;
	grfao_("# # translate 90 rotate", &l, instr, &i__2, &offh, &c__0, &
		c__0, (ftnlen)23, (ftnlen)120);
/*<       ELSE >*/
    } else {
/*<           CALL GRFAO('# # translate', L, INSTR, OFFW, OFFH, 0, 0) >*/
	grfao_("# # translate", &l, instr, &offw, &offh, &c__0, &c__0, (
		ftnlen)13, (ftnlen)120);
/*<       END IF >*/
    }
/*<       CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
    grps02_(&ioerr, &unit, instr, l);
/*<       CALL GRPS02(IOERR, UNIT, '1 setlinejoin 1 setlinecap 1 LW 1') >*/
    grps02_(&ioerr, &unit, "1 setlinejoin 1 setlinecap 1 LW 1", (ftnlen)33);
/*<       CALL GRPS02(IOERR, UNIT, '%%EndPageSetup') >*/
    grps02_(&ioerr, &unit, "%%EndPageSetup", (ftnlen)14);
/*<       CALL GRPS02(IOERR, UNIT, '%%PageBoundingBox: (atend)') >*/
    grps02_(&ioerr, &unit, "%%PageBoundingBox: (atend)", (ftnlen)26);
/*<       DO 111 NSYM=0,31 >*/
    for (nsym = 0; nsym <= 31; ++nsym) {
/*<           MARKER(NSYM) = 0 >*/
	marker[nsym] = 0;
/*<   111 CONTINUE >*/
/* L111: */
    }
/*<       MFAC = 0.0 >*/
    mfac = (float)0.;
/*<       BBXMIN = WIDTH >*/
    bbxmin = (real) width;
/*<       BBYMIN = HEIGHT >*/
    bbymin = (real) height;
/*<       BBXMAX = 0.0 >*/
    bbxmax = (float)0.;
/*<       BBYMAX = 0.0 >*/
    bbymax = (float)0.;
/*<       RETURN >*/
    return 0;

/* --- IFUNC=12, Draw line. ---------------------------------------------- */

/*<   120 CONTINUE >*/
L120:
/*<       I0 = NINT(RBUF(1)) >*/
    i0 = i_nint(&rbuf[1]);
/*<       J0 = NINT(RBUF(2)) >*/
    j0 = i_nint(&rbuf[2]);
/*<       I1 = NINT(RBUF(3)) >*/
    i1 = i_nint(&rbuf[3]);
/*<       J1 = NINT(RBUF(4)) >*/
    j1 = i_nint(&rbuf[4]);
/*<       IF (I0.EQ.LASTI .AND. J0.EQ.LASTJ) THEN >*/
    if (i0 == lasti && j0 == lastj) {
/*        -- suppress zero-length continuation segment */
/*<          IF (I0.EQ.I1 .AND. J0.EQ.J1) RETURN >*/
	if (i0 == i1 && j0 == j1) {
	    return 0;
	}
/*<          CALL GRFAO('# # C', L, INSTR, (I1-I0), (J1-J0), 0, 0) >*/
	i__2 = i1 - i0;
	i__3 = j1 - j0;
	grfao_("# # C", &l, instr, &i__2, &i__3, &c__0, &c__0, (ftnlen)5, (
		ftnlen)120);
/*<          NSEG = NSEG+1 >*/
	++nseg;
/*<       ELSE >*/
    } else {
/*<          NSEG = 1 >*/
	nseg = 1;
/*<          CALL GRFAO('# # # # L', L, INSTR, (I1-I0), (J1-J0), I0, J0) >*/
	i__2 = i1 - i0;
	i__3 = j1 - j0;
	grfao_("# # # # L", &l, instr, &i__2, &i__3, &i0, &j0, (ftnlen)9, (
		ftnlen)120);
/*<       END IF >*/
    }
/*<       LASTI = I1 >*/
    lasti = i1;
/*<       IF (NSEG.GT.200) LASTI = -1 >*/
    if (nseg > 200) {
	lasti = -1;
    }
/*<       LASTJ = J1 >*/
    lastj = j1;
/*<       BBXMIN = MIN(BBXMIN, I0-LW*5.0, I1-LW*5.0) >*/
/* Computing MIN */
    r__1 = bbxmin, r__2 = i0 - lw * (float)5., r__1 = min(r__1,r__2), r__2 = 
	    i1 - lw * (float)5.;
    bbxmin = dmin(r__1,r__2);
/*<       BBXMAX = MAX(BBXMAX, I0+LW*5.0, I1+LW*5.0) >*/
/* Computing MAX */
    r__1 = bbxmax, r__2 = i0 + lw * (float)5., r__1 = max(r__1,r__2), r__2 = 
	    i1 + lw * (float)5.;
    bbxmax = dmax(r__1,r__2);
/*<       BBYMIN = MIN(BBYMIN, J0-LW*5.0, J1-LW*5.0) >*/
/* Computing MIN */
    r__1 = bbymin, r__2 = j0 - lw * (float)5., r__1 = min(r__1,r__2), r__2 = 
	    j1 - lw * (float)5.;
    bbymin = dmin(r__1,r__2);
/*<       BBYMAX = MAX(BBYMAX, J0+LW*5.0, J1+LW*5.0) >*/
/* Computing MAX */
    r__1 = bbymax, r__2 = j0 + lw * (float)5., r__1 = max(r__1,r__2), r__2 = 
	    j1 + lw * (float)5.;
    bbymax = dmax(r__1,r__2);
/*<       GOTO 800 >*/
    goto L800;

/* --- IFUNC=13, Draw dot. ----------------------------------------------- */

/*<   130 CONTINUE >*/
L130:
/*<       I1 = NINT(RBUF(1)) >*/
    i1 = i_nint(&rbuf[1]);
/*<       J1 = NINT(RBUF(2)) >*/
    j1 = i_nint(&rbuf[2]);
/*<       CALL GRFAO('# # D', L, INSTR, I1, J1, 0, 0) >*/
    grfao_("# # D", &l, instr, &i1, &j1, &c__0, &c__0, (ftnlen)5, (ftnlen)120)
	    ;
/*<       LASTI = I1 >*/
    lasti = i1;
/*<       LASTJ = J1 >*/
    lastj = j1;
/*<       BBXMIN = MIN(BBXMIN, I1-LW*5.0) >*/
/* Computing MIN */
    r__1 = bbxmin, r__2 = i1 - lw * (float)5.;
    bbxmin = dmin(r__1,r__2);
/*<       BBXMAX = MAX(BBXMAX, I1+LW*5.0) >*/
/* Computing MAX */
    r__1 = bbxmax, r__2 = i1 + lw * (float)5.;
    bbxmax = dmax(r__1,r__2);
/*<       BBYMIN = MIN(BBYMIN, J1-LW*5.0) >*/
/* Computing MIN */
    r__1 = bbymin, r__2 = j1 - lw * (float)5.;
    bbymin = dmin(r__1,r__2);
/*<       BBYMAX = MAX(BBYMAX, J1+LW*5.0) >*/
/* Computing MAX */
    r__1 = bbymax, r__2 = j1 + lw * (float)5.;
    bbymax = dmax(r__1,r__2);
/*<       GOTO 800 >*/
    goto L800;

/* --- IFUNC=14, End picture. -------------------------------------------- */

/*<   140 CONTINUE >*/
L140:
/*<       IF (LOBUF.NE.0) THEN >*/
    if (lobuf != 0) {
/*<           CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF)) >*/
	grps02_(&ioerr, &unit, obuf, lobuf);
/*<           LOBUF = 0 >*/
	lobuf = 0;
/*<       END IF >*/
    }
/*<       LANDSC = MODE.EQ.1 .OR. MODE.EQ.3 >*/
    landsc = *mode == 1 || *mode == 3;
/*     -- optionally write identification */
/*<       CALL GRGENV('IDENT', INSTR, L) >*/
    grgenv_("IDENT", instr, &l, (ftnlen)5, (ftnlen)120);
/*<       IF (L.GT.0) THEN >*/
    if (l > 0) {
/*<          CALL GRUSER(SUSER, LU) >*/
	gruser_(suser, &lu, (ftnlen)20);
/*<          CALL GRDATE(SDATE, LD) >*/
	grdate_(sdate, &ld, (ftnlen)20);
/*<          POSN = WIDTH - 1 >*/
	posn = width - 1;
/*<          IF (LANDSC) POSN = HEIGHT - 1 >*/
	if (landsc) {
	    posn = height - 1;
	}
/*<    >*/
/* Writing concatenation */
	i__6[0] = 1, a__2[0] = "(";
	i__6[1] = lu, a__2[1] = suser;
	i__6[2] = 1, a__2[2] = " ";
	i__6[3] = ld, a__2[3] = sdate;
	i__6[4] = 27, a__2[4] = " [#]) # # 100 /Helvetica RS";
	s_cat(ch__5, a__2, i__6, &c__5, (ftnlen)69);
	grfao_(ch__5, &l, instr, &npage, &posn, &c__50, &c__0, lu + 2 + ld + 
		27, (ftnlen)120);
/*<          CALL GRPS02(IOERR, UNIT, '0 G') >*/
	grps02_(&ioerr, &unit, "0 G", (ftnlen)3);
/*<          CALL GRPS02(IOERR, UNIT, INSTR(1:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<       END IF >*/
    }
/*     -- optionally draw bounding box */
/*<       CALL GRGENV('PS_DRAW_BBOX', INSTR, L) >*/
    grgenv_("PS_DRAW_BBOX", instr, &l, (ftnlen)12, (ftnlen)120);
/*<       IF (L.GT.0) THEN >*/
    if (l > 0) {
/*<    >*/
	i__2 = i_nint(&bbxmin);
	i__3 = i_nint(&bbymin);
	grfao_("0 G 0 LW newpath # # moveto", &l, instr, &i__2, &i__3, &c__0, 
		&c__0, (ftnlen)27, (ftnlen)120);
/*<          CALL GRPS02(IOERR, UNIT, INSTR(1:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<    >*/
	i__2 = i_nint(&bbxmin);
	i__3 = i_nint(&bbymax);
	i__4 = i_nint(&bbxmax);
	i__5 = i_nint(&bbymax);
	grfao_("# # lineto # # lineto", &l, instr, &i__2, &i__3, &i__4, &i__5,
		 (ftnlen)21, (ftnlen)120);
/*<          CALL GRPS02(IOERR, UNIT, INSTR(1:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<    >*/
	i__2 = i_nint(&bbxmax);
	i__3 = i_nint(&bbymin);
	grfao_("# # lineto closepath stroke", &l, instr, &i__2, &i__3, &c__0, 
		&c__0, (ftnlen)27, (ftnlen)120);
/*<          CALL GRPS02(IOERR, UNIT, INSTR(1:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<       END IF >*/
    }
/*<       CALL GRPS02(IOERR, UNIT, 'PGPLOT restore showpage') >*/
    grps02_(&ioerr, &unit, "PGPLOT restore showpage", (ftnlen)23);
/*<       CALL GRPS02(IOERR, UNIT, '%%PageTrailer') >*/
    grps02_(&ioerr, &unit, "%%PageTrailer", (ftnlen)13);
/*<       IF (LANDSC) THEN >*/
    if (landsc) {
/*<          BB1 = INT((WIDTH-BBYMAX+OFFW)*0.072) >*/
	bb1 = (integer) ((width - bbymax + offw) * (float).072);
/*<          BB2 = INT((BBXMIN+OFFH)*0.072) >*/
	bb2 = (integer) ((bbxmin + offh) * (float).072);
/*<          BB3 = 1+INT((WIDTH-BBYMIN+OFFW)*0.072) >*/
	bb3 = (integer) ((width - bbymin + offw) * (float).072) + 1;
/*<          BB4 = 1+INT((BBXMAX+OFFH)*0.072) >*/
	bb4 = (integer) ((bbxmax + offh) * (float).072) + 1;
/*<       ELSE >*/
    } else {
/*<          BB1 = INT((BBXMIN+OFFW)*0.072) >*/
	bb1 = (integer) ((bbxmin + offw) * (float).072);
/*<          BB2 = INT((BBYMIN+OFFH)*0.072) >*/
	bb2 = (integer) ((bbymin + offh) * (float).072);
/*<          BB3 = 1+INT((BBXMAX+OFFW)*0.072) >*/
	bb3 = (integer) ((bbxmax + offw) * (float).072) + 1;
/*<          BB4 = 1+INT((BBYMAX+OFFH)*0.072) >*/
	bb4 = (integer) ((bbymax + offh) * (float).072) + 1;
/*<       END IF >*/
    }
/*<    >*/
    grfao_("%%PageBoundingBox: # # # #", &l, instr, &bb1, &bb2, &bb3, &bb4, (
	    ftnlen)26, (ftnlen)120);
/*<       CALL GRPS02(IOERR, UNIT, INSTR(1:L)) >*/
    grps02_(&ioerr, &unit, instr, l);
/*<       IF (NPAGE.EQ.1) THEN >*/
    if (npage == 1) {
/*<          BBOX(1) = BB1 >*/
	bbox[0] = bb1;
/*<          BBOX(2) = BB2 >*/
	bbox[1] = bb2;
/*<          BBOX(3) = BB3 >*/
	bbox[2] = bb3;
/*<          BBOX(4) = BB4 >*/
	bbox[3] = bb4;
/*<       ELSE >*/
    } else {
/*<          BBOX(1) = MIN(BBOX(1),BB1) >*/
	bbox[0] = min(bbox[0],bb1);
/*<          BBOX(2) = MIN(BBOX(2),BB2) >*/
	bbox[1] = min(bbox[1],bb2);
/*<          BBOX(3) = MAX(BBOX(3),BB3) >*/
	bbox[2] = max(bbox[2],bb3);
/*<          BBOX(4) = MAX(BBOX(4),BB4) >*/
	bbox[3] = max(bbox[3],bb4);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=15, Select color index. ------------------------------------- */

/*<   150 CONTINUE >*/
L150:
/*<       CI = NINT(RBUF(1)) >*/
    ci = i_nint(&rbuf[1]);
/*<       IF (COLOR) THEN >*/
    if (color) {
/*<    >*/
	r__1 = rvalue[ci] * (float)1024.;
	i__2 = i_nint(&r__1);
	r__2 = gvalue[ci] * (float)1024.;
	i__3 = i_nint(&r__2);
	r__3 = bvalue[ci] * (float)1024.;
	i__4 = i_nint(&r__3);
	grfao_("# # # K", &l, instr, &i__2, &i__3, &i__4, &c__0, (ftnlen)7, (
		ftnlen)120);
/*<       ELSE >*/
    } else {
/*<          CALL GRFAO('# G', L, INSTR, NINT(1024.*RVALUE(CI)), 0, 0, 0) >*/
	r__1 = rvalue[ci] * (float)1024.;
	i__2 = i_nint(&r__1);
	grfao_("# G", &l, instr, &i__2, &c__0, &c__0, &c__0, (ftnlen)3, (
		ftnlen)120);
/*<       END IF >*/
    }
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       GOTO 800 >*/
    goto L800;

/* --- IFUNC=16, Flush buffer. ------------------------------------------- */

/*<   160 CONTINUE >*/
L160:
/*<       IF (LOBUF.NE.0) THEN >*/
    if (lobuf != 0) {
/*<           CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF)) >*/
	grps02_(&ioerr, &unit, obuf, lobuf);
/*<           LOBUF = 0 >*/
	lobuf = 0;
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=17, Read cursor. -------------------------------------------- */
/*    (Not implemented: should not be called.) */

/*<   170 GOTO 900 >*/
L170:
    goto L900;

/* --- IFUNC=18, Erase alpha screen. ------------------------------------- */
/*    (Null operation: there is no alpha screen.) */

/*<   180 CONTINUE >*/
L180:
/*<       RETURN >*/
    return 0;

/* --- IFUNC=19, Set line style. ----------------------------------------- */
/*    (Not implemented: should not be called.) */

/*<   190 GOTO 900 >*/
L190:
    goto L900;

/* --- IFUNC=20, Polygon fill. ------------------------------------------- */

/*<   200 CONTINUE >*/
L200:
/*<       IF (NPTS.EQ.0) THEN >*/
    if (npts == 0) {
/*<           NPTS = RBUF(1) >*/
	npts = rbuf[1];
/*<           START = .TRUE. >*/
	start = TRUE_;
/*<           RETURN >*/
	return 0;
/*<       ELSE >*/
    } else {
/*<           NPTS = NPTS-1 >*/
	--npts;
/*<           I0 = NINT(RBUF(1)) >*/
	i0 = i_nint(&rbuf[1]);
/*<           J0 = NINT(RBUF(2)) >*/
	j0 = i_nint(&rbuf[2]);
/*<           IF (START) THEN >*/
	if (start) {
/*<               CALL GRFAO('# # BP', L, INSTR, I0, J0, 0, 0) >*/
	    grfao_("# # BP", &l, instr, &i0, &j0, &c__0, &c__0, (ftnlen)6, (
		    ftnlen)120);
/*<               START = .FALSE. >*/
	    start = FALSE_;
/*<               LASTI = I0 >*/
	    lasti = i0;
/*<               LASTJ = J0 >*/
	    lastj = j0;
/*<           ELSE IF (NPTS.EQ.0) THEN >*/
	} else if (npts == 0) {
/*<    >*/
	    i__2 = i0 - lasti;
	    i__3 = j0 - lastj;
	    grfao_("# # EP", &l, instr, &i__2, &i__3, &c__0, &c__0, (ftnlen)6,
		     (ftnlen)120);
/*<               LASTI = -1 >*/
	    lasti = -1;
/*<               LASTJ = -1 >*/
	    lastj = -1;
/*<           ELSE >*/
	} else {
/*<    >*/
	    i__2 = i0 - lasti;
	    i__3 = j0 - lastj;
	    grfao_("# # LP", &l, instr, &i__2, &i__3, &c__0, &c__0, (ftnlen)6,
		     (ftnlen)120);
/*<               LASTI = I0 >*/
	    lasti = i0;
/*<               LASTJ = J0 >*/
	    lastj = j0;
/*<           END IF >*/
	}
/*<           BBXMIN = MIN(BBXMIN, I0-LW*5.0) >*/
/* Computing MIN */
	r__1 = bbxmin, r__2 = i0 - lw * (float)5.;
	bbxmin = dmin(r__1,r__2);
/*<           BBXMAX = MAX(BBXMAX, I0+LW*5.0) >*/
/* Computing MAX */
	r__1 = bbxmax, r__2 = i0 + lw * (float)5.;
	bbxmax = dmax(r__1,r__2);
/*<           BBYMIN = MIN(BBYMIN, J0-LW*5.0) >*/
/* Computing MIN */
	r__1 = bbymin, r__2 = j0 - lw * (float)5.;
	bbymin = dmin(r__1,r__2);
/*<           BBYMAX = MAX(BBYMAX, J0+LW*5.0) >*/
/* Computing MAX */
	r__1 = bbymax, r__2 = j0 + lw * (float)5.;
	bbymax = dmax(r__1,r__2);
/*<           GOTO 800 >*/
	goto L800;
/*<       END IF >*/
    }

/* --- IFUNC=21, Set color representation. ------------------------------- */

/*<   210 CONTINUE >*/
L210:
/*<       IF (COLOR) THEN >*/
    if (color) {
/*<           CI = RBUF(1) >*/
	ci = rbuf[1];
/*<           RVALUE(CI) = RBUF(2) >*/
	rvalue[ci] = rbuf[2];
/*<           GVALUE(CI) = RBUF(3) >*/
	gvalue[ci] = rbuf[3];
/*<           BVALUE(CI) = RBUF(4) >*/
	bvalue[ci] = rbuf[4];
/*<       ELSE >*/
    } else {
/*<           CI = RBUF(1) >*/
	ci = rbuf[1];
/*<           RVALUE(CI) = 0.30*RBUF(2) + 0.59*RBUF(3) + 0.11*RBUF(4) >*/
	rvalue[ci] = rbuf[2] * (float).3 + rbuf[3] * (float).59 + rbuf[4] * (
		float).11;
/*<           GVALUE(CI) = RVALUE(CI) >*/
	gvalue[ci] = rvalue[ci];
/*<           BVALUE(CI) = RVALUE(CI) >*/
	bvalue[ci] = rvalue[ci];
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=22, Set line width. ----------------------------------------- */

/*<   220 CONTINUE >*/
L220:
/*<       LW = RBUF(1) >*/
    lw = rbuf[1];
/*<       IF (INT(LW).EQ.LW) THEN >*/
    if ((real) ((integer) lw) == lw) {
/*<          CALL GRFAO('# LW', L, INSTR, INT(LW), 0, 0, 0) >*/
	i__2 = (integer) lw;
	grfao_("# LW", &l, instr, &i__2, &c__0, &c__0, &c__0, (ftnlen)4, (
		ftnlen)120);
/*<       ELSE >*/
    } else {
/*<          WRITE (INSTR,'(F6.2,'' LW'')') LW >*/
	s_wsfi(&io___58);
	do_fio(&c__1, (char *)&lw, (ftnlen)sizeof(real));
	e_wsfi();
/*<          L = 9 >*/
	l = 9;
/*<       END IF >*/
    }
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       GOTO 800 >*/
    goto L800;

/* --- IFUNC=23, Escape. ------------------------------------------------- */

/*<   230 CONTINUE >*/
L230:
/*<       IF (LOBUF.NE.0) THEN >*/
    if (lobuf != 0) {
/*         -- flush buffer first */
/*<           CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF)) >*/
	grps02_(&ioerr, &unit, obuf, lobuf);
/*<           LOBUF = 0 >*/
	lobuf = 0;
/*<       END IF >*/
    }
/*<       CALL GRPS02(IOERR, UNIT, CHR(:LCHR)) >*/
    grps02_(&ioerr, &unit, chr, (*lchr));
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       RETURN >*/
    return 0;

/* --- IFUNC=26, Image.--------------------------------------------------- */

/*<   260 CONTINUE >*/
L260:
/*<       N = RBUF(1) >*/
    n = rbuf[1];
/*<       IF (N.EQ.0) THEN >*/
    if (n == 0) {
/*         -- First: setup for image */
/*         -- Set clipping region (RBUF(2...5)) */
/*<           NXP = RBUF(2) >*/
	nxp = rbuf[2];
/*<           NYP = RBUF(3) >*/
	nyp = rbuf[3];
/*<           XORG = RBUF(4) >*/
	xorg = rbuf[4];
/*<           XLEN = RBUF(5) - RBUF(4) >*/
	xlen = rbuf[5] - rbuf[4];
/*<           YORG = RBUF(6)  >*/
	yorg = rbuf[6];
/*<           YLEN = RBUF(7) - RBUF(6) >*/
	ylen = rbuf[7] - rbuf[6];
/*<           BBXMIN = MIN(BBXMIN, RBUF(4), RBUF(5)) >*/
/* Computing MIN */
	r__1 = min(bbxmin,rbuf[4]);
	bbxmin = dmin(r__1,rbuf[5]);
/*<           BBXMAX = MAX(BBXMAX, RBUF(4), RBUF(5)) >*/
/* Computing MAX */
	r__1 = max(bbxmax,rbuf[4]);
	bbxmax = dmax(r__1,rbuf[5]);
/*<           BBYMIN = MIN(BBYMIN, RBUF(6), RBUF(7)) >*/
/* Computing MIN */
	r__1 = min(bbymin,rbuf[6]);
	bbymin = dmin(r__1,rbuf[7]);
/*<           BBYMAX = MAX(BBYMAX, RBUF(6), RBUF(7)) >*/
/* Computing MAX */
	r__1 = max(bbymax,rbuf[6]);
	bbymax = dmax(r__1,rbuf[7]);

/*<           CALL GRPS02(IOERR, UNIT, 'gsave newpath') >*/
	grps02_(&ioerr, &unit, "gsave newpath", (ftnlen)13);
/*<    >*/
	grfao_("# # moveto # 0 rlineto 0 # rlineto", &l, instr, &xorg, &yorg, 
		&xlen, &ylen, (ftnlen)34, (ftnlen)120);
/*<           CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<    >*/
	i__2 = -xlen;
	grfao_("# 0 rlineto closepath clip", &l, instr, &i__2, &c__0, &c__0, &
		c__0, (ftnlen)26, (ftnlen)120);
/*<           CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*         -- */
/*<           CALL GRFAO('/picstr # string def', L, INSTR, NXP, 0, 0, 0) >*/
	grfao_("/picstr # string def", &l, instr, &nxp, &c__0, &c__0, &c__0, (
		ftnlen)20, (ftnlen)120);
/*<           CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<           CALL GRFAO('# # 8 [', L, INSTR, NXP, NYP, 0, 0) >*/
	grfao_("# # 8 [", &l, instr, &nxp, &nyp, &c__0, &c__0, (ftnlen)7, (
		ftnlen)120);
/*<           CALL GRPS02(IOERR, UNIT, INSTR(:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<           WRITE (INSTR, '(6(1PE10.3, 1X), '']'')') (RBUF(I),I=8,13) >*/
	s_wsfi(&io___66);
	for (i__ = 8; i__ <= 13; ++i__) {
	    do_fio(&c__1, (char *)&rbuf[i__], (ftnlen)sizeof(real));
	}
	e_wsfi();
/*<           CALL GRPS02(IOERR, UNIT, INSTR(:67)) >*/
	grps02_(&ioerr, &unit, instr, (ftnlen)67);
/*<           IF (COLOR) THEN >*/
	if (color) {
/*<    >*/
	    grps02_(&ioerr, &unit, "{currentfile picstr readhexstring pop} f\
alse 3 colorimage", (ftnlen)57);
/*<           ELSE >*/
	} else {
/*<    >*/
	    grps02_(&ioerr, &unit, "{currentfile picstr readhexstring pop} i\
mage", (ftnlen)44);
/*<           END IF >*/
	}
/*<       ELSE IF (N.EQ.-1) THEN >*/
    } else if (n == -1) {
/*         -- Last: terminate image */
/*<           CALL GRPS02(IOERR, UNIT, 'grestore') >*/
	grps02_(&ioerr, &unit, "grestore", (ftnlen)8);
/*<       ELSE  >*/
    } else {
/*         -- Middle: write N image pixels; each pixel uses 6 chars */
/*            in INSTR, so N must be <= 20. */
/*<           L = 0 >*/
	l = 0;
/*<           KMAX = 1 >*/
	kmax = 1;
/*<           IF (COLOR) KMAX = 3 >*/
	if (color) {
	    kmax = 3;
	}
/*<           DO 262 I=1,N >*/
	i__2 = n;
	for (i__ = 1; i__ <= i__2; ++i__) {
/*<               CI = RBUF(I+1) >*/
	    ci = rbuf[i__ + 1];
/*<               RGB(1) = NINT(255.0*RVALUE(CI)) >*/
	    r__1 = rvalue[ci] * (float)255.;
	    rgb[0] = i_nint(&r__1);
/*<               RGB(2) = NINT(255.0*GVALUE(CI)) >*/
	    r__1 = gvalue[ci] * (float)255.;
	    rgb[1] = i_nint(&r__1);
/*<               RGB(3) = NINT(255.0*BVALUE(CI)) >*/
	    r__1 = bvalue[ci] * (float)255.;
	    rgb[2] = i_nint(&r__1);
/*<               DO 261 K=1,KMAX >*/
	    i__3 = kmax;
	    for (k = 1; k <= i__3; ++k) {
/*<                   HIGH = RGB(K)/16 >*/
		high = rgb[k - 1] / 16;
/*<                   LOW  = RGB(K)-16*HIGH >*/
		low = rgb[k - 1] - (high << 4);
/*<                   L = L+1 >*/
		++l;
/*<                   INSTR(L:L) = HEXDIG(HIGH) >*/
		*(unsigned char *)&instr[l - 1] = *(unsigned char *)&hexdig[
			high];
/*<                   L = L+1 >*/
		++l;
/*<                   INSTR(L:L) = HEXDIG(LOW) >*/
		*(unsigned char *)&instr[l - 1] = *(unsigned char *)&hexdig[
			low];
/*<  261          CONTINUE >*/
/* L261: */
	    }
/*<  262      CONTINUE >*/
/* L262: */
	}
/*<           CALL GRPS02(IOERR, UNIT, INSTR(1:L)) >*/
	grps02_(&ioerr, &unit, instr, l);
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;

/* --- IFUNC=28, Marker.-------------------------------------------------- */

/*<   280 CONTINUE >*/
L280:
/*<       NSYM = NINT(RBUF(1)) >*/
    nsym = i_nint(&rbuf[1]);
/*     -- Output code for this marker if necessary */
/*<       IF (MARKER(NSYM).EQ.0) THEN >*/
    if (marker[nsym] == 0) {
/*<           IF (LOBUF.GT.0) CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF)) >*/
	if (lobuf > 0) {
	    grps02_(&ioerr, &unit, obuf, lobuf);
	}
/*<           LOBUF = 0 >*/
	lobuf = 0;
/*<           CALL GRPS03(IOERR, NSYM, UNIT) >*/
	grps03_(&ioerr, &nsym, &unit);
/*<           MARKER(NSYM) = 1 >*/
	marker[nsym] = 1;
/*<       END IF >*/
    }
/*     -- Output scale factor */
/*<       IF (RBUF(4).NE.MFAC) THEN >*/
    if (rbuf[4] != mfac) {
/*<           IF (LOBUF.GT.0) CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF)) >*/
	if (lobuf > 0) {
	    grps02_(&ioerr, &unit, obuf, lobuf);
	}
/*<           LOBUF = 0 >*/
	lobuf = 0;
/*<           MFAC = RBUF(4) >*/
	mfac = rbuf[4];
/*<           WRITE (INSTR, '(''/MFAC '',F10.3,'' def'')') MFAC >*/
	s_wsfi(&io___73);
	do_fio(&c__1, (char *)&mfac, (ftnlen)sizeof(real));
	e_wsfi();
/*<           CALL GRPS02(IOERR, UNIT, INSTR(1:24)) >*/
	grps02_(&ioerr, &unit, instr, (ftnlen)24);
/*<       END IF >*/
    }
/*     -- Output an instruction to draw one marker */
/*<       I1 = NINT(RBUF(2)) >*/
    i1 = i_nint(&rbuf[2]);
/*<       J1 = NINT(RBUF(3)) >*/
    j1 = i_nint(&rbuf[3]);
/*<       CALL GRFAO('# # M#', L, INSTR, I1, J1, NSYM, 0) >*/
    grfao_("# # M#", &l, instr, &i1, &j1, &nsym, &c__0, (ftnlen)6, (ftnlen)
	    120);
/*<       LASTI = -1 >*/
    lasti = -1;
/*<       BBXMIN = MIN(BBXMIN, I1-MFAC*RAD(NSYM)) >*/
/* Computing MIN */
    r__1 = bbxmin, r__2 = i1 - mfac * rad[nsym];
    bbxmin = dmin(r__1,r__2);
/*<       BBXMAX = MAX(BBXMAX, I1+MFAC*RAD(NSYM)) >*/
/* Computing MAX */
    r__1 = bbxmax, r__2 = i1 + mfac * rad[nsym];
    bbxmax = dmax(r__1,r__2);
/*<       BBYMIN = MIN(BBYMIN, J1-MFAC*RAD(NSYM)) >*/
/* Computing MIN */
    r__1 = bbymin, r__2 = j1 - mfac * rad[nsym];
    bbymin = dmin(r__1,r__2);
/*<       BBYMAX = MAX(BBYMAX, J1+MFAC*RAD(NSYM)) >*/
/* Computing MAX */
    r__1 = bbymax, r__2 = j1 + mfac * rad[nsym];
    bbymax = dmax(r__1,r__2);
/*<       GOTO 800 >*/
    goto L800;

/* --- IFUNC=29, Query color representation.------------------------------ */

/*<  290  CONTINUE >*/
L290:
/*<       CI = NINT(RBUF(1)) >*/
    ci = i_nint(&rbuf[1]);
/*<       NBUF = 4 >*/
    *nbuf = 4;
/*<       RBUF(2) = RVALUE(CI) >*/
    rbuf[2] = rvalue[ci];
/*<       RBUF(3) = GVALUE(CI) >*/
    rbuf[3] = gvalue[ci];
/*<       RBUF(4) = BVALUE(CI) >*/
    rbuf[4] = bvalue[ci];
/*<       RETURN >*/
    return 0;

/* ----------------------------------------------------------------------- */
/* Buffer output if possible. */

/*<   800 IF ( (LOBUF+L+1). GT. 132) THEN >*/
L800:
    if (lobuf + l + 1 > 132) {
/*<           CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF)) >*/
	grps02_(&ioerr, &unit, obuf, lobuf);
/*<           OBUF(1:L) = INSTR(1:L) >*/
	s_copy(obuf, instr, l, l);
/*<           LOBUF = L >*/
	lobuf = l;
/*<       ELSE >*/
    } else {
/*<           IF (LOBUF.GT.1) THEN >*/
	if (lobuf > 1) {
/*<               LOBUF = LOBUF+1 >*/
	    ++lobuf;
/*<               OBUF(LOBUF:LOBUF) = ' ' >*/
	    *(unsigned char *)&obuf[lobuf - 1] = ' ';
/*<           END IF >*/
	}
/*<           OBUF(LOBUF+1:LOBUF+L) = INSTR(1:L) >*/
	i__2 = lobuf;
	s_copy(obuf + i__2, instr, lobuf + l - i__2, l);
/*<           LOBUF = LOBUF+L >*/
	lobuf += l;
/*<       END IF >*/
    }
/*<       RETURN >*/
    return 0;
/* ----------------------------------------------------------------------- */
/* Error: unimplemented function. */

/*<    >*/
L900:
    s_wsfi(&io___74);
    do_fio(&c__1, (char *)&(*ifunc), (ftnlen)sizeof(integer));
    e_wsfi();
/*<       CALL GRWARN(MSG) >*/
    grwarn_(msg, (ftnlen)120);
/*<       NBUF = -1 >*/
    *nbuf = -1;
/*<       RETURN >*/
    return 0;
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* psdriv_ */

/* *GRPS03 -- PGPLOT PostScript driver, marker support */
/* + */
/*<       SUBROUTINE GRPS03(IOERR, NSYM, UNIT) >*/
/* Subroutine */ int grps03_(ioerr, nsym, unit)
integer *ioerr, *nsym, *unit;
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy();

    /* Local variables */
    static integer i__, n;
    static char t[80*6];
    extern /* Subroutine */ int grps02_();

/*<       INTEGER IOERR, NSYM, UNIT >*/

/* Write PostScript instructions for drawing graph marker number NSYM */
/* on Fortran unit UNIT. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*80 T(6) >*/
/*<       INTEGER I, N >*/

/*<       IF (NSYM.LT.0 .OR. NSYM.GT.31) RETURN >*/
    if (*nsym < 0 || *nsym > 31) {
	return 0;
    }
/*<    >*/
    switch ((int)(*nsym + 1)) {
	case 1:  goto L100;
	case 2:  goto L101;
	case 3:  goto L102;
	case 4:  goto L103;
	case 5:  goto L104;
	case 6:  goto L105;
	case 7:  goto L106;
	case 8:  goto L107;
	case 9:  goto L108;
	case 10:  goto L109;
	case 11:  goto L110;
	case 12:  goto L111;
	case 13:  goto L112;
	case 14:  goto L113;
	case 15:  goto L114;
	case 16:  goto L115;
	case 17:  goto L116;
	case 18:  goto L117;
	case 19:  goto L118;
	case 20:  goto L119;
	case 21:  goto L120;
	case 22:  goto L121;
	case 23:  goto L122;
	case 24:  goto L123;
	case 25:  goto L124;
	case 26:  goto L125;
	case 27:  goto L126;
	case 28:  goto L127;
	case 29:  goto L128;
	case 30:  goto L129;
	case 31:  goto L130;
	case 32:  goto L131;
    }

/*<   100 T(1)='/M0 {MB -6 -6 moveto 0 12 rlineto 12 0 rlineto' >*/
L100:
    s_copy(t, "/M0 {MB -6 -6 moveto 0 12 rlineto 12 0 rlineto", (ftnlen)80, (
	    ftnlen)46);
/*<       T(2)='0 -12 rlineto closepath stroke ME} bind def' >*/
    s_copy(t + 80, "0 -12 rlineto closepath stroke ME} bind def", (ftnlen)80, 
	    (ftnlen)43);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   101 T(1)='/M1 {MB 0 0 1 FC ME} bind def' >*/
L101:
    s_copy(t, "/M1 {MB 0 0 1 FC ME} bind def", (ftnlen)80, (ftnlen)29);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   102 T(1)='/M2 {MB 0 7 moveto 0 -14 rlineto -7 0 moveto' >*/
L102:
    s_copy(t, "/M2 {MB 0 7 moveto 0 -14 rlineto -7 0 moveto", (ftnlen)80, (
	    ftnlen)44);
/*<       T(2)='14 0 rlineto stroke ME} bind def' >*/
    s_copy(t + 80, "14 0 rlineto stroke ME} bind def", (ftnlen)80, (ftnlen)32)
	    ;
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   103 T(1)='/M3 {MB 0 6 moveto 0 -6 lineto -5 3 moveto 5 -3 lineto' >*/
L103:
    s_copy(t, "/M3 {MB 0 6 moveto 0 -6 lineto -5 3 moveto 5 -3 lineto", (
	    ftnlen)80, (ftnlen)54);
/*<       T(2)='5 3 moveto -5 -3 lineto stroke ME} bind def' >*/
    s_copy(t + 80, "5 3 moveto -5 -3 lineto stroke ME} bind def", (ftnlen)80, 
	    (ftnlen)43);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   104 T(1)='/M4 {MB 0 0 7 CC ME} bind def' >*/
L104:
    s_copy(t, "/M4 {MB 0 0 7 CC ME} bind def", (ftnlen)80, (ftnlen)29);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   105 T(1)='/M5 {MB -5 -5 moveto 10 10 rlineto -5 5 moveto' >*/
L105:
    s_copy(t, "/M5 {MB -5 -5 moveto 10 10 rlineto -5 5 moveto", (ftnlen)80, (
	    ftnlen)46);
/*<       T(2)='10 -10 rlineto stroke ME} bind def' >*/
    s_copy(t + 80, "10 -10 rlineto stroke ME} bind def", (ftnlen)80, (ftnlen)
	    34);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   106 T(1)='/M6 {MB -6 -6 moveto 0 12 rlineto 12 0 rlineto' >*/
L106:
    s_copy(t, "/M6 {MB -6 -6 moveto 0 12 rlineto 12 0 rlineto", (ftnlen)80, (
	    ftnlen)46);
/*<       T(2)='0 -12 rlineto closepath stroke ME} bind def' >*/
    s_copy(t + 80, "0 -12 rlineto closepath stroke ME} bind def", (ftnlen)80, 
	    (ftnlen)43);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   107 T(1)='/M7 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath' >*/
L107:
    s_copy(t, "/M7 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath", (
	    ftnlen)80, (ftnlen)53);
/*<       T(2)='stroke ME} bind def' >*/
    s_copy(t + 80, "stroke ME} bind def", (ftnlen)80, (ftnlen)19);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200  >*/
    goto L200;
/*<   108 T(1)='/M8 {MB 0 7 moveto 0 -14 rlineto -7 0 moveto 14 0 rlineto' >*/
L108:
    s_copy(t, "/M8 {MB 0 7 moveto 0 -14 rlineto -7 0 moveto 14 0 rlineto", (
	    ftnlen)80, (ftnlen)57);
/*<       T(2)='stroke 0 0 7 CC ME} bind def' >*/
    s_copy(t + 80, "stroke 0 0 7 CC ME} bind def", (ftnlen)80, (ftnlen)28);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   109 T(1)='/M9 {MB 0 0 1 FC 0 0 7 CC ME} bind def' >*/
L109:
    s_copy(t, "/M9 {MB 0 0 1 FC 0 0 7 CC ME} bind def", (ftnlen)80, (ftnlen)
	    38);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   110 T(1)='/M10 {MB -9 9 moveto -8 7 lineto -7 3 lineto -7 -3 lineto' >*/
L110:
    s_copy(t, "/M10 {MB -9 9 moveto -8 7 lineto -7 3 lineto -7 -3 lineto", (
	    ftnlen)80, (ftnlen)57);
/*<       T(2)='-8 -7 lineto -9 -9 lineto -7 -8 lineto -3 -7 lineto' >*/
    s_copy(t + 80, "-8 -7 lineto -9 -9 lineto -7 -8 lineto -3 -7 lineto", (
	    ftnlen)80, (ftnlen)51);
/*<       T(3)='3 -7 lineto 7 -8 lineto 9 -9 lineto 8 -7 lineto' >*/
    s_copy(t + 160, "3 -7 lineto 7 -8 lineto 9 -9 lineto 8 -7 lineto", (
	    ftnlen)80, (ftnlen)47);
/*<       T(4)='7 -3 lineto 7 3 lineto 8 7 lineto 9 9 lineto 7 8 lineto' >*/
    s_copy(t + 240, "7 -3 lineto 7 3 lineto 8 7 lineto 9 9 lineto 7 8 lineto",
	     (ftnlen)80, (ftnlen)55);
/*<       T(5)='3 7 lineto -3 7 lineto  -7 8 lineto closepath stroke' >*/
    s_copy(t + 320, "3 7 lineto -3 7 lineto  -7 8 lineto closepath stroke", (
	    ftnlen)80, (ftnlen)52);
/*<       T(6)='ME} bind def' >*/
    s_copy(t + 400, "ME} bind def", (ftnlen)80, (ftnlen)12);
/*<       N=6 >*/
    n = 6;
/*<       GOTO 200 >*/
    goto L200;
/*<   111 T(1)='/M11 {MB 0 10 moveto -6 0 lineto 0 -10 lineto 6 0 lineto' >*/
L111:
    s_copy(t, "/M11 {MB 0 10 moveto -6 0 lineto 0 -10 lineto 6 0 lineto", (
	    ftnlen)80, (ftnlen)56);
/*<       T(2)='closepath stroke ME} bind def' >*/
    s_copy(t + 80, "closepath stroke ME} bind def", (ftnlen)80, (ftnlen)29);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   112 T(1)='/M12 {MB 0 9 moveto -2 3 lineto -8 3 lineto -3 -1 lineto' >*/
L112:
    s_copy(t, "/M12 {MB 0 9 moveto -2 3 lineto -8 3 lineto -3 -1 lineto", (
	    ftnlen)80, (ftnlen)56);
/*<       T(2)='-5 -7 lineto 0 -3 lineto 5 -7 lineto 3 -1 lineto 8 3' >*/
    s_copy(t + 80, "-5 -7 lineto 0 -3 lineto 5 -7 lineto 3 -1 lineto 8 3", (
	    ftnlen)80, (ftnlen)52);
/*<       T(3)='lineto 2 3 lineto closepath stroke ME} bind def' >*/
    s_copy(t + 160, "lineto 2 3 lineto closepath stroke ME} bind def", (
	    ftnlen)80, (ftnlen)47);
/*<       N=3 >*/
    n = 3;
/*<       GOTO 200 >*/
    goto L200;
/*<   113 T(1)='/M13 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath' >*/
L113:
    s_copy(t, "/M13 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath", (
	    ftnlen)80, (ftnlen)54);
/*<       T(2)='fill ME} bind def' >*/
    s_copy(t + 80, "fill ME} bind def", (ftnlen)80, (ftnlen)17);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   114 T(1)='/M14 {MB -2 6 moveto -2 2 lineto -6 2 lineto -6 -2 lineto' >*/
L114:
    s_copy(t, "/M14 {MB -2 6 moveto -2 2 lineto -6 2 lineto -6 -2 lineto", (
	    ftnlen)80, (ftnlen)57);
/*<       T(2)='-2 -2 lineto -2 -6 lineto 2 -6 lineto 2 -2 lineto' >*/
    s_copy(t + 80, "-2 -2 lineto -2 -6 lineto 2 -6 lineto 2 -2 lineto", (
	    ftnlen)80, (ftnlen)49);
/*<       T(3)='6 -2 lineto 6 2 lineto 2 2 lineto 2 6 lineto closepath' >*/
    s_copy(t + 160, "6 -2 lineto 6 2 lineto 2 2 lineto 2 6 lineto closepath", 
	    (ftnlen)80, (ftnlen)54);
/*<       T(4)='stroke ME} bind def' >*/
    s_copy(t + 240, "stroke ME} bind def", (ftnlen)80, (ftnlen)19);
/*<       N=4 >*/
    n = 4;
/*<       GOTO 200 >*/
    goto L200;
/*<   115 T(1)='/M15 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath' >*/
L115:
    s_copy(t, "/M15 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath", (
	    ftnlen)80, (ftnlen)54);
/*<       T(2)='0 -8 moveto 7 4 lineto -7 4 lineto closepath stroke ME}' >*/
    s_copy(t + 80, "0 -8 moveto 7 4 lineto -7 4 lineto closepath stroke ME}", 
	    (ftnlen)80, (ftnlen)55);
/*<       T(3)='bind def' >*/
    s_copy(t + 160, "bind def", (ftnlen)80, (ftnlen)8);
/*<       N=3 >*/
    n = 3;
/*<       GOTO 200 >*/
    goto L200;
/*<   116 T(1)='/M16 {MB -4 -4 moveto 0 8 rlineto 8 0 rlineto 0 -8' >*/
L116:
    s_copy(t, "/M16 {MB -4 -4 moveto 0 8 rlineto 8 0 rlineto 0 -8", (ftnlen)
	    80, (ftnlen)50);
/*<       T(2)='rlineto closepath fill ME} bind def' >*/
    s_copy(t + 80, "rlineto closepath fill ME} bind def", (ftnlen)80, (ftnlen)
	    35);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   117 T(1)='/M17 {MB 0 0 4.5 FC ME} bind def' >*/
L117:
    s_copy(t, "/M17 {MB 0 0 4.5 FC ME} bind def", (ftnlen)80, (ftnlen)32);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   118 T(1)='/M18 {MB 0 9 moveto -2 3 lineto -8 3 lineto -3 -1 lineto' >*/
L118:
    s_copy(t, "/M18 {MB 0 9 moveto -2 3 lineto -8 3 lineto -3 -1 lineto", (
	    ftnlen)80, (ftnlen)56);
/*<       T(2)=' -5 -7 lineto 0 -3 lineto 5 -7 lineto 3 -1 lineto 8 3' >*/
    s_copy(t + 80, " -5 -7 lineto 0 -3 lineto 5 -7 lineto 3 -1 lineto 8 3", (
	    ftnlen)80, (ftnlen)53);
/*<       T(3)='lineto 2 3 lineto closepath fill ME} bind def' >*/
    s_copy(t + 160, "lineto 2 3 lineto closepath fill ME} bind def", (ftnlen)
	    80, (ftnlen)45);
/*<       N=3 >*/
    n = 3;
/*<       GOTO 200 >*/
    goto L200;
/*<   119 T(1)='/M19 {MB -12 -12 moveto 0 24 rlineto 24 0 rlineto 0 -24' >*/
L119:
    s_copy(t, "/M19 {MB -12 -12 moveto 0 24 rlineto 24 0 rlineto 0 -24", (
	    ftnlen)80, (ftnlen)55);
/*<       T(2)='rlineto closepath stroke ME} bind def' >*/
    s_copy(t + 80, "rlineto closepath stroke ME} bind def", (ftnlen)80, (
	    ftnlen)37);
/*<       N=2 >*/
    n = 2;
/*<       GOTO 200 >*/
    goto L200;
/*<   120 T(1)='/M20 {MB 0 0 2 CC ME} bind def' >*/
L120:
    s_copy(t, "/M20 {MB 0 0 2 CC ME} bind def", (ftnlen)80, (ftnlen)30);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   121 T(1)='/M21 {MB 0 0 4 CC ME} bind def' >*/
L121:
    s_copy(t, "/M21 {MB 0 0 4 CC ME} bind def", (ftnlen)80, (ftnlen)30);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   122 T(1)='/M22 {MB 0 0 5 CC ME} bind def' >*/
L122:
    s_copy(t, "/M22 {MB 0 0 5 CC ME} bind def", (ftnlen)80, (ftnlen)30);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   123 T(1)='/M23 {MB 0 0 7 CC ME} bind def' >*/
L123:
    s_copy(t, "/M23 {MB 0 0 7 CC ME} bind def", (ftnlen)80, (ftnlen)30);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   124 T(1)='/M24 {MB 0 0 11 CC ME} bind def' >*/
L124:
    s_copy(t, "/M24 {MB 0 0 11 CC ME} bind def", (ftnlen)80, (ftnlen)31);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   125 T(1)='/M25 {MB 0 0 17 CC ME} bind def' >*/
L125:
    s_copy(t, "/M25 {MB 0 0 17 CC ME} bind def", (ftnlen)80, (ftnlen)31);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   126 T(1)='/M26 {MB 0 0 22 CC ME} bind def' >*/
L126:
    s_copy(t, "/M26 {MB 0 0 22 CC ME} bind def", (ftnlen)80, (ftnlen)31);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   127 T(1)='/M27 {MB 0 0 41 CC ME} bind def' >*/
L127:
    s_copy(t, "/M27 {MB 0 0 41 CC ME} bind def", (ftnlen)80, (ftnlen)31);
/*<       N=1 >*/
    n = 1;
/*<       GOTO 200 >*/
    goto L200;
/*<   128 T(1)='/M28 {MB -6 2 moveto -9 0 lineto -6 -2 lineto -3 5' >*/
L128:
    s_copy(t, "/M28 {MB -6 2 moveto -9 0 lineto -6 -2 lineto -3 5", (ftnlen)
	    80, (ftnlen)50);
/*<       T(2)='moveto -8 0 lineto -3 -5 lineto -8 0 moveto 9 0 lineto' >*/
    s_copy(t + 80, "moveto -8 0 lineto -3 -5 lineto -8 0 moveto 9 0 lineto", (
	    ftnlen)80, (ftnlen)54);
/*<       T(3)='stroke ME} bind def' >*/
    s_copy(t + 160, "stroke ME} bind def", (ftnlen)80, (ftnlen)19);
/*<       N=3 >*/
    n = 3;
/*<       GOTO 200 >*/
    goto L200;
/*<   129 T(1)='/M29 {MB 6 2 moveto 9 0 lineto 6 -2 lineto 3 5 moveto' >*/
L129:
    s_copy(t, "/M29 {MB 6 2 moveto 9 0 lineto 6 -2 lineto 3 5 moveto", (
	    ftnlen)80, (ftnlen)53);
/*<       T(2)='8 0 lineto 3 -5 lineto 8 0 moveto -9 0 lineto stroke ME}' >*/
    s_copy(t + 80, "8 0 lineto 3 -5 lineto 8 0 moveto -9 0 lineto stroke ME}",
	     (ftnlen)80, (ftnlen)56);
/*<       T(3)='bind def' >*/
    s_copy(t + 160, "bind def", (ftnlen)80, (ftnlen)8);
/*<       N=3 >*/
    n = 3;
/*<       GOTO 200 >*/
    goto L200;
/*<   130 T(1)='/M30 {MB 2 6 moveto 0 9 lineto -2 6 lineto 5 3 moveto' >*/
L130:
    s_copy(t, "/M30 {MB 2 6 moveto 0 9 lineto -2 6 lineto 5 3 moveto", (
	    ftnlen)80, (ftnlen)53);
/*<       T(2)='0 8 lineto -5 3 lineto 0 8 moveto 0 -9 lineto stroke ME}' >*/
    s_copy(t + 80, "0 8 lineto -5 3 lineto 0 8 moveto 0 -9 lineto stroke ME}",
	     (ftnlen)80, (ftnlen)56);
/*<       T(3)='bind def' >*/
    s_copy(t + 160, "bind def", (ftnlen)80, (ftnlen)8);
/*<       N=3 >*/
    n = 3;
/*<       GOTO 200 >*/
    goto L200;
/*<   131 T(1)='/M31 {MB 2 -6 moveto 0 -9 lineto -2 -6 lineto 5 -3' >*/
L131:
    s_copy(t, "/M31 {MB 2 -6 moveto 0 -9 lineto -2 -6 lineto 5 -3", (ftnlen)
	    80, (ftnlen)50);
/*<       T(2)='moveto 0 -8 lineto -5 -3 lineto 0 -8 moveto 0 9 lineto' >*/
    s_copy(t + 80, "moveto 0 -8 lineto -5 -3 lineto 0 -8 moveto 0 9 lineto", (
	    ftnlen)80, (ftnlen)54);
/*<       T(3)='stroke ME} bind def' >*/
    s_copy(t + 160, "stroke ME} bind def", (ftnlen)80, (ftnlen)19);
/*<       N=3 >*/
    n = 3;
/*<       GOTO 200 >*/
    goto L200;

/*<   200 DO 210 I=1,N >*/
L200:
    i__1 = n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           CALL GRPS02(IOERR, UNIT, T(I)) >*/
	grps02_(ioerr, unit, t + (i__ - 1) * 80, (ftnlen)80);
/*<   210 CONTINUE >*/
/* L210: */
    }

/*<       END >*/
} /* grps03_ */

/* *GRPS02 -- PGPLOT PostScript driver, copy buffer to file */
/* + */
/*<       SUBROUTINE GRPS02 (IER, UNIT, S) >*/
/* Subroutine */ int grps02_(ier, unit, s, s_len)
integer *ier, *unit;
char *s;
ftnlen s_len;
{
    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe();

    /* Local variables */
    extern /* Subroutine */ int grwarn_();

    /* Fortran I/O blocks */
    static cilist io___78 = { 1, 0, 0, "(A)", 0 };



/* Support routine for PSdriver: write character string S on */
/* specified Fortran unit. */

/* Error handling: if IER is not 0 on input, the routine returns */
/* immediately. Otherwise IER receives the I/O status from the Fortran */
/* write (0 => success). */
/* ----------------------------------------------------------------------- */
/*<       INTEGER IER, UNIT >*/
/*<       CHARACTER*(*) S >*/

/*<       IF (IER.EQ.0) THEN >*/
    if (*ier == 0) {
/*<           WRITE (UNIT, '(A)', IOSTAT=IER) S >*/
	io___78.ciunit = *unit;
	*ier = s_wsfe(&io___78);
	if (*ier != 0) {
	    goto L100001;
	}
	*ier = do_fio(&c__1, s, s_len);
	if (*ier != 0) {
	    goto L100001;
	}
	*ier = e_wsfe();
L100001:
/*<    >*/
	if (*ier != 0) {
	    grwarn_("++WARNING++ Error writing PostScript file", (ftnlen)41);
	}
/*<       END IF >*/
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grps02_ */

